diff -pruN 1.195/CHANGES 1.195ubuntu1/CHANGES
--- 1.195/CHANGES	2020-03-26 13:34:12.000000000 +0000
+++ 1.195ubuntu1/CHANGES	2020-05-21 00:17:51.000000000 +0000
@@ -1,3 +1,91 @@
+console-setup (1.195ubuntu1) groovy; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - debian/clean: Delete Keyboard/tree-keymaps/ on clean
+    - Add an apport hook.
+    - If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+      on kFreeBSD; otherwise restore the previous behaviour from before the
+      kFreeBSD port of using UTF-8 in that case.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.service, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Handle unattended upgrades without breaking plymouth when updating
+      console fonts.
+    - Tolerate absence of setupcon in postinst scripts.  Should be fixed by
+      refactoring to not have a keyboard-configuration package that needs to
+      call setupcon without depending on it.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Added templates for keyboard detection.
+    - debian/control: drop freebsd-specific packages.
+    - debian/control: we also need xkb-data-i18n as a Build-Depends-Indep to
+      build a complete set of translated keyboard layout/variant names.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - keyboard-configuration.config: While sourcing config files to re-seed
+      debconf, treat missing XKBOPTIONS as empty.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - debian/keyboard-configuration.config: lower the priority for the layout
+      question.
+    - Map ppc64el/* to XKBMODEL=pc105.
+    - Set default layout for Kurdish to tr(ku).
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - debian/keyboard-configuration.config: Drop the xkb-keymap bits once
+      again as we're not ready for those yet, as it's currently causing an
+      invalid default layout in the installer.
+    - keyboard-configuration.{config,templates}: There is no good default
+      for layout toggling, stop pretending there is.  Console users can set
+      one with dpkg-reconfigure or editing /etc/defaults/keyboard
+    - keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+    - debian/preprocessor: revert the removal of keyboard names (for size) of
+      console-setup-udeb: we do need those, since we don't use the simplified
+      xkb-keymap template from Debian just yet: this way we can still show
+      country/language names when selecting a keyboard, layout or variant.
+    - debian/rules: revert hard-coding of a list of "debconf-selectable"
+      layouts for the udebs, since we don't use this debconf question in Ubuntu
+      and all layouts are selectable.
+    - Make COPYRIGHT a symlink to debian/copyright.
+    - Don't cat over the keymaps; they're already moved to the right place.
+    - Add Keyboard/Makefile rule to build pc105.tree.
+    - Include pc105.tree for ubiquity; make sure it gets built.
+    - Fix command injection in ckbcomp.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - Keyboard/Makefile: make sure KeyboardNames.pl is built with accurate data
+      from xkb-data.
+    - xmlreader, KeyboardNames.pl: Added model entry to skip model selection.
+    - Make sure we give a meaningful name to ch layouts: "Switzerland" instead
+      of "German (Switzerland), since it includes French too.
+    - setupcon:
+      - use only /run for tempfiles with /tmp as a non-root fallback.
+      - handle compressed console maps and font files.
+      - Map XKBMODEL=SKIP to '' for compatibility with existing
+        configs.
+      - the variables are taken from a config file which, if changed,
+        invalidates the cache.
+      - there is only ever one keyboard map per system.
+      - the system should not have to resolve filenames to find the keymap
+        cache on boot.
+      - Explicitly exit 0, so that postinsts don't fail in the event that
+        loadkeys can't find a console.
+    - debian/control: Build depend on keymapper
+    - debian/keyboard-configuration.config:
+      - change back the french default layout to be fr+oss and not fr+latin9
+        the change was dropped by error in a previous merge
+  * Dropped changes, included in Debian:
+    - keyboard-configuration.config:
+      replace not intuitive second lt(us) layout with us(altgr-intl),
+      which contains Euro (€) and other symbols, often used in Lithuania.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 20 May 2020 17:17:51 -0700
+
 console-setup (1.195) unstable; urgency=medium
 
   [ Mantas Kriaučiūnas ]
@@ -12,6 +100,107 @@ console-setup (1.195) unstable; urgency=
 
  -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 26 Mar 2020 13:34:12 +0000
 
+console-setup (1.194ubuntu3) focal; urgency=medium
+
+  [ Mantas Kriaučiūnas ]
+  * keyboard-configuration.config:: 
+    replace not intuitive second lt(us) layout with us(altgr-intl),
+    which contains Euro (€) and other symbols, often used in Lithuania.
+    (lp: #1863001)
+
+ -- Sebastien Bacher <seb128@ubuntu.com>  Fri, 27 Mar 2020 11:10:06 +0100
+
+console-setup (1.194ubuntu2) focal; urgency=medium
+
+  * debian/keyboard-configuration.config:
+    - change back the french default layout to be fr+oss and not fr+latin9
+      the change was dropped by error in a previous merge
+
+ -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 05 Dec 2019 15:09:57 +0100
+
+console-setup (1.194ubuntu1) focal; urgency=medium
+
+  * Merge from Debian unstable.  Remaining changes:
+    - debian/clean: Delete Keyboard/tree-keymaps/ on clean
+    - Add an apport hook.
+    - If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+      on kFreeBSD; otherwise restore the previous behaviour from before the
+      kFreeBSD port of using UTF-8 in that case.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.service, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Handle unattended upgrades without breaking plymouth when updating
+      console fonts.
+    - Tolerate absence of setupcon in postinst scripts.  Should be fixed by
+      refactoring to not have a keyboard-configuration package that needs to
+      call setupcon without depending on it.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Added templates for keyboard detection.
+    - debian/control: drop freebsd-specific packages.
+    - debian/control: we also need xkb-data-i18n as a Build-Depends-Indep to
+      build a complete set of translated keyboard layout/variant names.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - keyboard-configuration.config: While sourcing config files to re-seed
+      debconf, treat missing XKBOPTIONS as empty.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - debian/keyboard-configuration.config: lower the priority for the layout
+      question.
+    - Map ppc64el/* to XKBMODEL=pc105.
+    - Set default layout for Kurdish to tr(ku).
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - debian/keyboard-configuration.config: Drop the xkb-keymap bits once
+      again as we're not ready for those yet, as it's currently causing an
+      invalid default layout in the installer.
+    - keyboard-configuration.{config,templates}: There is no good default
+      for layout toggling, stop pretending there is.  Console users can set
+      one with dpkg-reconfigure or editing /etc/defaults/keyboard
+    - keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+    - debian/preprocessor: revert the removal of keyboard names (for size) of
+      console-setup-udeb: we do need those, since we don't use the simplified
+      xkb-keymap template from Debian just yet: this way we can still show
+      country/language names when selecting a keyboard, layout or variant.
+    - debian/rules: revert hard-coding of a list of "debconf-selectable"
+      layouts for the udebs, since we don't use this debconf question in Ubuntu
+      and all layouts are selectable.
+    - Make COPYRIGHT a symlink to debian/copyright.
+    - Don't cat over the keymaps; they're already moved to the right place.
+    - Add Keyboard/Makefile rule to build pc105.tree.
+    - Include pc105.tree for ubiquity; make sure it gets built.
+    - Fix command injection in ckbcomp.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - Keyboard/Makefile: make sure KeyboardNames.pl is built with accurate data
+      from xkb-data.
+    - xmlreader, KeyboardNames.pl: Added model entry to skip model selection.
+    - Make sure we give a meaningful name to ch layouts: "Switzerland" instead
+      of "German (Switzerland), since it includes French too.
+    - setupcon:
+      - use only /run for tempfiles with /tmp as a non-root fallback.
+      - handle compressed console maps and font files.
+      - Map XKBMODEL=SKIP to '' for compatibility with existing
+        configs.
+      - the variables are taken from a config file which, if changed,
+        invalidates the cache.
+      - there is only ever one keyboard map per system.
+      - the system should not have to resolve filenames to find the keymap
+        cache on boot.
+      - Explicitly exit 0, so that postinsts don't fail in the event that
+        loadkeys can't find a console.
+  * Dropped changes:
+    - kbdnames-maker: Call `{bind,}textdomain` after switching locale.
+  * debian/control: Build depend on keymapper
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Wed, 27 Nov 2019 15:34:42 +0100
+
 console-setup (1.194) unstable; urgency=medium
 
   * Team upload
@@ -45,6 +234,109 @@ console-setup (1.192) unstable; urgency=
 
  -- Cyril Brulebois <kibi@debian.org>  Thu, 04 Jul 2019 17:41:47 +0200
 
+console-setup (1.191ubuntu3) eoan; urgency=medium
+
+  * No change rebuild to include all previous changes
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Tue, 23 Apr 2019 13:38:57 +0200
+
+console-setup (1.191ubuntu2) eoan; urgency=medium
+
+  * Call setupcon --force only when debian-installer is active
+    and always redirect output to /dev/null to not block. (LP: #520546)
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Tue, 23 Apr 2019 13:08:17 +0200
+
+console-setup (1.191ubuntu1) eoan; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - debian/clean: Delete Keyboard/tree-keymaps/ on clean
+    - Add an apport hook.
+    - If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+      on kFreeBSD; otherwise restore the previous behaviour from before the
+      kFreeBSD port of using UTF-8 in that case.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.service, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Handle unattended upgrades without breaking plymouth when updating
+      console fonts.
+    - Tolerate absence of setupcon in postinst scripts.  Should be fixed by
+      refactoring to not have a keyboard-configuration package that needs to
+      call setupcon without depending on it.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Added templates for keyboard detection.
+    - debian/control: drop freebsd-specific packages.
+    - debian/control: we also need xkb-data-i18n as a Build-Depends-Indep to
+      build a complete set of translated keyboard layout/variant names.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - keyboard-configuration.config: While sourcing config files to re-seed
+      debconf, treat missing XKBOPTIONS as empty.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - debian/keyboard-configuration.config: lower the priority for the layout
+      question.
+    - Map ppc64el/* to XKBMODEL=pc105.
+    - Set default layout for Kurdish to tr(ku).
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - debian/keyboard-configuration.config: Drop the xkb-keymap bits once
+      again as we're not ready for those yet, as it's currently causing an
+      invalid default layout in the installer.
+    - keyboard-configuration.{config,templates}: There is no good default
+      for layout toggling, stop pretending there is.  Console users can set
+      one with dpkg-reconfigure or editing /etc/defaults/keyboard
+    - keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+    - debian/preprocessor: revert the removal of keyboard names (for size) of
+      console-setup-udeb: we do need those, since we don't use the simplified
+      xkb-keymap template from Debian just yet: this way we can still show
+      country/language names when selecting a keyboard, layout or variant.
+    - debian/rules: revert hard-coding of a list of "debconf-selectable"
+      layouts for the udebs, since we don't use this debconf question in Ubuntu
+      and all layouts are selectable.
+    - Make COPYRIGHT a symlink to debian/copyright.
+    - Don't cat over the keymaps; they're already moved to the right place.
+    - Add Keyboard/Makefile rule to build pc105.tree.
+    - Include pc105.tree for ubiquity; make sure it gets built.
+    - Fix command injection in ckbcomp.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - kbdnames-maker: Call `{bind,}textdomain` after switching locale.
+    - Keyboard/Makefile: make sure KeyboardNames.pl is built with accurate data
+      from xkb-data.
+    - xmlreader, KeyboardNames.pl: Added model entry to skip model selection.
+    - Make sure we give a meaningful name to ch layouts: "Switzerland" instead
+      of "German (Switzerland), since it includes French too.
+    - setupcon:
+      - use only /run for tempfiles with /tmp as a non-root fallback.
+      - handle compressed console maps and font files.
+      - Map XKBMODEL=SKIP to '' for compatibility with existing
+        configs.
+      - the variables are taken from a config file which, if changed,
+        invalidates the cache.
+      - there is only ever one keyboard map per system.
+      - the system should not have to resolve filenames to find the keymap
+        cache on boot.
+      - Explicitly exit 0, so that postinsts don't fail in the event that
+        loadkeys can't find a console.
+  * Dropped changes:
+    - drop handling of obsolete upstart jobs, not needed post-18.04.
+    - drop breaks/replaces on ancient keyboard-configuration package.
+    - keyboard-configuration.config: drop layout migration code, which
+      definitely predates bionic.
+  * debian/console-setup.initramfs-top: only ever initialize /dev/tty1.  We
+    do not ever use more than 1 VT in the initramfs, and we reinitialize
+    anyway from the rootfs so this saves us no time (and in fact wastes a
+    lot of time in some configurations).  LP: #1823327.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 22 Apr 2019 07:27:25 -0700
+
 console-setup (1.191) unstable; urgency=medium
 
   * Team upload
@@ -228,6 +520,184 @@ console-setup (1.179) unstable; urgency=
 
  -- Christian Perrier <bubulle@debian.org>  Mon, 12 Mar 2018 19:12:28 +0100
 
+console-setup (1.178ubuntu12) disco; urgency=medium
+
+  * setupcon: use /run for tempfiles (and dump the various unnecessary
+    fallback paths), since /run is always mountable rw at least as early as
+    /tmp is and is guaranteed to be safe from tmpcleaners at boot.  Only keep
+    /tmp as a fallback in case we have access to write to /tmp and to a
+    console, but not to /run.  LP: #1824227.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 10 Apr 2019 12:51:56 -0700
+
+console-setup (1.178ubuntu11) disco; urgency=medium
+
+  * kbdnames-maker: Call `{bind,}textdomain` after switching locale.
+    There's a change in perl 5.28 to use `uselocale()` & friends instead of
+    gettext directly, to support thread safety. Apparently this causes the
+    results of `gettext()` calls to be cached now where they weren't before,
+    and this breaks our keyboard name generation. For example, we have
+    `en_GB*model*sun_type6_jp*Sun Type 6 (Japonesa)` instead of
+    `en_GB*model*sun_type6_jp*Sun Type 6 (Japanese)`, and many many other
+    examples.  Calling `bindtextdomain()` and then `textdomain()` after
+    changing locale causes the cache to be invalidated and we get correct
+    results again. LP: #1817453
+
+ -- Iain Lane <iain@orangesquash.org.uk>  Fri, 15 Mar 2019 12:34:06 +0000
+
+console-setup (1.178ubuntu10) disco; urgency=medium
+
+  * No-change rebuild to pick up any new keyboard data. Resolves crash
+    in Ubiquity KDE front end on non English language selection. (LP: #1810647)
+
+ -- Rik Mills <rikmills@kubuntu.org>  Wed, 23 Jan 2019 07:34:00 +0000
+
+console-setup (1.178ubuntu9) cosmic; urgency=medium
+
+  * keyboard-configuration.config: Fix exit/return thinko (LP: #1788597)
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Thu, 23 Aug 2018 16:32:45 -0600
+
+console-setup (1.178ubuntu8) cosmic; urgency=medium
+
+  * keyboard-configuration.config: Only treat missing XKBOPTIONS as empty.
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Wed, 08 Aug 2018 17:32:23 -0600
+
+console-setup (1.178ubuntu7) cosmic; urgency=medium
+
+  * keyboard-configuration.config: While sourcing config files to re-seed
+    debconf, load missing variables as empty values of same (LP: #1762952)
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Wed, 08 Aug 2018 16:50:48 -0600
+
+console-setup (1.178ubuntu6) cosmic; urgency=medium
+
+  * keyboard-configuration.{config,templates}: There is no good default for
+    layout toggling, stop pretending there is.  Console users can set one
+    with dpkg-reconfigure or editing /etc/defaults/keyboard (LP: #1762952)
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Wed, 25 Jul 2018 05:50:59 -0600
+
+console-setup (1.178ubuntu5) cosmic; urgency=medium
+
+  * Revert to 1.178ubuntu2, as 1.178ubuntu[34] caused an installer regression.
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Tue, 24 Jul 2018 19:34:59 -0600
+
+console-setup (1.178ubuntu4) cosmic; urgency=medium
+
+  * debian/console-setup-udeb.postinst: Guard the dpkg call in the postinst,
+    so it isn't attempted in the debian-installer environment (LP: #1782835)
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Fri, 20 Jul 2018 14:22:45 -0600
+
+console-setup (1.178ubuntu3) cosmic; urgency=medium
+
+  * debian/keyboard-configuration.postinst:
+    - Don't change /etc/default/keyboard at package upgrades on
+      desktops, since it may conflict with how desktops deal with
+      keyboard configuration (LP: #1762952).
+
+ -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Tue, 15 May 2018 01:12:00 +0200
+
+console-setup (1.178ubuntu2) bionic; urgency=medium
+
+  * debian/keyboard-configuration.config:
+    - Drop the xkb-keymap bits once again as we're not ready for those yet, as
+      it's currently causing an invalid default layout in the installer.
+      (LP: #1758647)
+
+ -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 19 Apr 2018 08:53:32 +0200
+
+console-setup (1.178ubuntu1) bionic; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - Add an apport hook.
+    - If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+      on kFreeBSD; otherwise restore the previous behaviour from before the
+      kFreeBSD port of using UTF-8 in that case.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.service, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Tolerate absence of setupcon in postinst scripts.
+    - Added templates for keyboard detection.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - Map ppc64el/* to XKBMODEL=pc105.
+    - keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+    - debian/preprocessor: revert the removal of keyboard names (for size) of
+      console-setup-udeb: we do need those, since we don't use the simplified
+      xkb-keymap template from Debian just yet: this way we can still show
+      country/language names when selecting a keyboard, layout or variant.
+    - Don't make debian/copyright a symlink to COPYRIGHT, this is disallowed
+      by the Ubuntu archive installer.
+    - Include pc105.tree for ubiquity; make sure it gets built.
+    - Add Keyboard/Makefile rule to build pc105.tree.
+    - Fix command injection in ckbcomp.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - xmlreader, KeyboardNames.pl: Added model entry to skip model selection.
+    - setupcon:
+      - the variables are taken from a config file which, if changed,
+        invalidates the cache.
+      - there is only ever one keyboard map per system.
+      - the system should not have to resolve filenames to find the keymap cache
+        on boot.
+      - Map XKBMODEL=SKIP to '' for compatibility with existing
+        configs.
+      - Explicitly exit 0, so that postinsts don't fail in the event that
+        loadkeys can't find a console.
+    - Handle unattended upgrades without breaking plymouth when updating
+      console fonts.
+    - debian/rules: revert hard-coding of a list of "debconf-selectable"
+      layouts for the udebs, since we don't use this debconf question in Ubuntu
+      and all layouts are selectable.
+    - Make sure we give a meaningful name to ch layouts: "Switzerland" instead
+      of "German (Switzerland), since it includes French too.
+    - Add console-setup-tty and the udev rule that uses it to set Unicode, font,
+      and keyboard mode at early boot.
+    - Keyboard/Makefile: make sure KeyboardNames.pl is built with accurate data
+      from xkb-data.
+    - Don't cat over the keymaps; they're already moved to the right place.
+    - debian/console-setup.postinst: Replace the checking of fgconsole in [1-6]
+      with checking if fgconsole is a tty according to logind. The previous
+      assumption was that a graphical environment would be on vt7, which isn't
+      true with gnome-shell any more.
+    - debian/console-setup.postinst, debian/keyboard-configuration.postinst:
+      Don't call setupcon --force -k any more - it breaks wayland sessions.
+      (LP: #1710637)
+    - debian/control: drop console-setup-freebsd: we don't keep it around since
+      it's uninstallable because vidcontrol/kbdcontrol.
+    - debian/keyboard-configuration.config: re-lower the priority for the layout
+      question that got garbled in the merge.
+    - Don't use console-setup-tty or its udev rule. This dates back to lucid and
+      now systemd is apparently able to handle this correctly. It's now actively
+      breaking graphical sessions. (LP: #1710637) 
+    - debian/control: we also need xkb-data-i18n as a Build-Depends-Indep to
+      build a complete set of translated keyboard layout/variant names.
+    - Drop dependency from console-setup to initramfs-tools |
+      linux-initramfs-tool; this was a versioned dependency used for upgrades,
+      now long obsolete.
+  * Fix previous patches:
+    - Correctly setup console in initramfs again (LP: #1719612)
+    - Make COPYRIGHT a symlink to debian/copyright, and keep various
+      other symlinks in place that were dropped in earlier uploads.
+    - Do some extra work to disable kfreebsd, dh was complaining about
+      unknown packages and failing.
+    - debian/clean: Delete Keyboard/tree-keymaps/ on clean
+
+ -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 19 Feb 2018 09:29:02 +0100
+
 console-setup (1.178) unstable; urgency=medium
 
   [ Updated translations ]
@@ -327,6 +797,122 @@ console-setup (1.167) unstable; urgency=
 
  -- Christian Perrier <bubulle@debian.org>  Fri, 15 Sep 2017 06:16:35 +0200
 
+console-setup (1.166ubuntu7) artful; urgency=medium
+
+  * Drop dependency from console-setup to initramfs-tools |
+    linux-initramfs-tool; this was a versioned dependency used for upgrades,
+    now long obsolete.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 05 Oct 2017 12:04:08 -0700
+
+console-setup (1.166ubuntu6) artful; urgency=medium
+
+  * debian/control: we also need xkb-data-i18n as a Build-Depends-Indep to
+    build a complete set of translated keyboard layout/variant names.
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 28 Sep 2017 17:46:56 -0400
+
+console-setup (1.166ubuntu5) artful; urgency=medium
+
+  * Don't use console-setup-tty or its udev rule. This dates back to lucid and
+    now systemd is apparently able to handle this correctly. It's now actively
+    breaking graphical sessions. (LP: #1710637) 
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 18 Sep 2017 16:36:50 -0400
+
+console-setup (1.166ubuntu4) artful; urgency=medium
+
+  * Keyboard/Makefile: Add a rule to make KeyboardNames.pl, needed by ubiquity
+    (see Debian Bug#874474)
+
+ -- Iain Lane <iain@orangesquash.org.uk>  Wed, 06 Sep 2017 13:39:01 +0100
+
+console-setup (1.166ubuntu3) artful; urgency=medium
+
+  * debian/keyboard-configuration.config: re-lower the priority for the layout
+    question that got garbled in the merge.
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 05 Sep 2017 14:58:49 -0400
+
+console-setup (1.166ubuntu2) artful; urgency=medium
+
+  * debian/control: drop console-setup-freebsd: we don't keep it around since
+    it's uninstallable because vidcontrol/kbdcontrol.
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 23 Aug 2017 19:06:27 -0400
+
+console-setup (1.166ubuntu1) artful; urgency=medium
+
+  [ Mathieu Trudel-Lapierre ]
+  * Merge from Debian unstable; remaining changes:
+    - Add an apport hook.
+    - If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+      on kFreeBSD; otherwise restore the previous behaviour from before the
+      kFreeBSD port of using UTF-8 in that case.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.service, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Tolerate absence of setupcon in postinst scripts.
+    - Added templates for keyboard detection.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - Map ppc64el/* to XKBMODEL=pc105.
+    - keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+    - debian/preprocessor: revert the removal of keyboard names (for size) of
+      console-setup-udeb: we do need those, since we don't use the simplified
+      xkb-keymap template from Debian just yet: this way we can still show
+      country/language names when selecting a keyboard, layout or variant.
+    - Don't make debian/copyright a symlink to COPYRIGHT, this is disallowed
+      by the Ubuntu archive installer.
+    - Include pc105.tree for ubiquity; make sure it gets built.
+    - Add Keyboard/Makefile rule to build pc105.tree.
+    - Fix command injection in ckbcomp.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - xmlreader, KeyboardNames.pl: Added model entry to skip model selection.
+    - setupcon:
+      - the variables are taken from a config file which, if changed,
+        invalidates the cache.
+      - there is only ever one keyboard map per system.
+      - the system should not have to resolve filenames to find the keymap cache
+        on boot.
+      - Map XKBMODEL=SKIP to '' for compatibility with existing
+        configs.
+      - Explicitly exit 0, so that postinsts don't fail in the event that
+        loadkeys can't find a console.
+    - Handle unattended upgrades without breaking plymouth when updating
+      console fonts.
+    - debian/rules: revert hard-coding of a list of "debconf-selectable"
+      layouts for the udebs, since we don't use this debconf question in Ubuntu
+      and all layouts are selectable.
+    - Make sure we give a meaningful name to ch layouts: "Switzerland" instead
+      of "German (Switzerland), since it includes French too.
+    - Add console-setup-tty and the udev rule that uses it to set Unicode, font,
+      and keyboard mode at early boot.
+  * Keyboard/Makefile: make sure KeyboardNames.pl is built with accurate data
+    from xkb-data.
+  * Don't cat over the keymaps; they're already moved to the right place.
+
+  [ Iain Lane ]
+  * debian/console-setup.postinst: Replace the checking of fgconsole in [1-6]
+    with checking if fgconsole is a tty according to logind. The previous
+    assumption was that a graphical environment would be on vt7, which isn't
+    true with gnome-shell any more.
+  * debian/console-setup.postinst, debian/keyboard-configuration.postinst:
+    Don't call setupcon --force -k any more - it breaks wayland sessions.
+    (LP: #1710637)
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 10 Aug 2017 15:06:17 -0400
+
 console-setup (1.166) unstable; urgency=medium
 
   [ Updated translations ]
@@ -534,6 +1120,209 @@ console-setup (1.143) unstable; urgency=
 
  -- Christian Perrier <bubulle@debian.org>  Sun, 22 May 2016 08:47:29 +0200
 
+console-setup (1.142ubuntu8) artful; urgency=medium
+
+  * Drop upstart system jobs.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 21 Aug 2017 16:15:49 +0100
+
+console-setup (1.142ubuntu7) artful; urgency=medium
+
+  * Do the same as ubuntu6 in Keyboard/compose_translator too.
+  * Cherry-pick b887014dc243d3966bbb6bda975803798df7c33f from Samuel Thibaut
+    and 6800af170ff5017b67b7e0b85b61a6176eb56361 from Gregor Hermann, as well
+    as fixing Keyboard/kbdnames - perl doesn't look at `.' any more.
+
+ -- Iain Lane <iain@orangesquash.org.uk>  Mon, 21 Aug 2017 10:48:31 +0100
+
+console-setup (1.142ubuntu6) artful; urgency=medium
+
+  * Use pragma utf8 instead of the deprecated encoding pragma. Shamelessly
+    copied from Debian's 1.143 change by Anton Zinoviev.
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 04 Aug 2017 15:23:53 -0400
+
+console-setup (1.142ubuntu5) yakkety; urgency=medium
+
+  * debian/console-setup-linux.setvtrgb.service: add condition to only
+    execute when /dev/tty0 exists. This is the same condition as used by
+    getty@.service unit to prevent attempting setting up VT when none are
+    present. This is a common case on serial only architectures and
+    virtual machines. Resolves degraded boots on s390x/ppc64el.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 26 Sep 2016 13:31:08 +0100
+
+console-setup (1.142ubuntu4) yakkety; urgency=medium
+
+  * debian/keyboard-configuration.postinst: we shouldn't fail if
+    dpkg-maintscript-helpers can't figure out the package for removal of
+    console-setup and keyboard-setup init scripts -- in ubiquity we won't have
+    the outer checked directory /lib/debian-installer.d; and we won't have any
+    files to remove on account of likely being a new install. (LP: #1578285)
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 08 Jun 2016 14:39:12 -0400
+
+console-setup (1.142ubuntu3) yakkety; urgency=medium
+
+  * Replace initscripts dependency with init-system-helpers (>= 1.29~), to
+    allow dropping initscripts at some point. (Closes: #804988)
+
+ -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 30 May 2016 08:15:32 +0200
+
+console-setup (1.142ubuntu2) yakkety; urgency=medium
+
+  * Unbreak my last console-setup upload:
+    - debian/control: We want the locales package, not locales-all.
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+  * debian/rules: enable the setvtrgb.service correctly.
+  * debian/rules: remove keyboard-configuration trying to install console-setup
+    since it's now in console-setup.
+  * debian/keyboard-configuration.links: removed.
+  * debian/control: fix Breaks/Replaces so the initscript move to the
+    console-setup-linux package from keyboard-configuration goes smoothly.
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 29 Apr 2016 23:38:34 -0400
+
+console-setup (1.142ubuntu1) yakkety; urgency=medium
+
+  * Merge from Debian unstable; remaining changes:
+    - Don't gzip font or ACM files in /etc/console-setup/.  The space saving
+      is negligible, and it's more efficient not to need to uncompress them
+      at boot time.
+    - Include pc105.tree for ubiquity.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - Add an apport hook.
+    - Depend on kbd (>= 1.15-1ubuntu3) for a valuable loadkeys improvement.
+    - Include support for translated keyboard names.
+    - Depend on debconf instead of pre-depending, because pre-depends have
+      no effect on config scripts.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.upstart, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Make setupcon explicitly exit 0, so that postinsts don't fail in the
+      event that loadkeys can't find a console.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default variant for French to oss.
+    - Set default layout for Simplified Chinese to 'cn'.
+    - Don't use the default keyboard variant if the layout is overridden by
+      preseeding.
+    - If keyboard-configuration/layoutcode is preseeded but not marked as
+      seen, then set the default layout but don't lower the layout question
+      priority or preseed console-setup/ask_detect.
+    - Use the default keyboard model if an existing configuration file sets
+      XKBMODEL="".
+    - Go back to always asking layout before variant.
+    - Fix keyboard layout detection to set the layout properly.
+    - Reset keyboard-configuration/toggle to the default if it's set to "No
+      toggling" and you select a non-Latin layout.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Load the new keyboard configuration immediately when running
+      'dpkg-reconfigure keyboard-configuration' in an installed system.
+    - Don't fail to configure keyboard-configuration if setxkbmap fails to
+      talk to the X display.
+    - Tolerate absence of setupcon in keyboard-configuration.postinst.
+    - Drop the simplified keyboard-configuration/xkb-keymap question.
+    - Fix command injection in ckbcomp.
+    - debian/console-setup.console-font.upstart: Add Upstart job that sets up
+      console font when plymouth-splash is starting.
+    - Override description of the ch layout from "German (Switzerland)" to
+      just "Switzerland".
+    - Map ppc64el/* to XKBMODEL=pc105.
+    - setupcon: Map XKBMODEL=SKIP to '' for compatibility with existing
+      configs.
+    - debian/rules: revert hard-coding of a list of "debconf-selectable"
+      layouts for the udebs, since we don't use this debconf question in Ubuntu
+      and all layouts are selectable.
+    - setupcon: revert ridiculous upstream twiddling of keymap cache filenames:
+      - the variables are taken from a config file which, if changed,
+        invalidates the cache.
+      - there is only ever one keyboard map per system.
+      - the system should not have to resolve filenames to find the keymap cache
+        on boot.
+    - Move vtrgb handling to console-setup-linux package, since this is clearly
+      Linux-specific.
+    - Add missing console-setup-linux.prerm to remove /etc/vtrgb alternatives
+    - Keyboard/kbdcompiler: fix bug in filtering of unsupported variants that
+      breaks generation of the pc105.tree for d-i keyboard detection.
+    - debian/keyboard-configuration.postinst: udpkg is not part of an installed
+      Debian system; don't fail to configure if it's absent and the script is
+      called outside of an installer context.
+    - Don't make debian/copyright a symlink to COPYRIGHT, this is disallowed
+      by the Ubuntu archive installer.
+    - debian/keyboard-configuration.config: fix typo in model check for SKIP;
+      even when looking up the layout/variant, we need to check for the model
+      as XKBMODEL, since $model doesn't exist.
+    - debian/preprocessor: revert the removal of keyboard names (for size) of
+      console-setup-udeb: we do need those, since we don't use the simplified
+      xkb-keymap template from Debian just yet: this way we can still show
+      country/language names when selecting a keyboard, layout or variant.
+    - Properly handle settings CODESET and FONSIZE when they equals 'guess' or
+      are unset.
+    - keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+    - debian/keyboard-configuration.config: run grep with -a (to deal with files
+      as ASCII data) when searching for keyboard, locale, and layout names.
+    - Add ConditionPathExists=/dev/tty0 to the console-setup.service, to
+      avoid running the unit on platforms without virtual consoles
+    - debian/rules: Drop obsolete and no-op dh_installinit --upstart-only
+      option.
+    - Add debian/keyboard-configuration.links to (statically) enable
+      console-setup.service. It is not being pulled in by plymouth any more, and
+      doing so was brittle and unexpected.
+    - console-setup.service: Set RemainAfterExit.
+    - If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+      on kFreeBSD; otherwise restore the previous behaviour from before the
+      kFreeBSD port of using UTF-8 in that case.
+    - debian/control: allow dracut to be installable by adding an alternate
+      depends on linux-initramfs-tool for console-setup.
+    - Reinstate checking for XKBLAYOUT being in the config file: this handles
+      the cases where installs done with ubiquity don't have their debconf seen
+      flag set for model/layout questions. If layout is already configure, lower
+      the corresponding question's priority to medium so we don't ask it again.
+    - Add systemd unit for console-setup. That avoids waiting for $remote_fs
+      during early boot. (Note: there is no need to enable it, it gets pulled
+      in through systemd-vconsole-setup.service)
+    - Drop console-setup-freebsd; it's useless and uninstallable given that we
+      don't have a freebsd port.
+    - Make debian/keyboard-configuration.console-setup.init do the same as the
+      corresponding .upstart: I. e. just call loadkeys instead of setupcon, and
+      don't check the current console. (Font loading is already done via udev
+      rules).
+  * Dropped changes, included in Debian:
+    - Stop running debconf-updatepo on clean.
+    - Update for new layouts and variants for Montenegro and Serbia, and
+      migrate configuration files from the old layouts.
+  * Dropped changes, no longer needed:
+    - Move boot tasks to a combination of two udev rules and a single
+      Upstart job, ensuring that they're run at points when we are able to
+      satisfy the constraints on the relevant ioctls.
+    - Replace usplash detection code with Plymouth detection code.
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+  * debian/console-setup-linux.setvtrgb.service: port our vtrgb upstart job to
+    a systemd unit service so we can again apply the right color scheme.
+  * Fonts/Makefile: sort BDFS_TO_DOUBLE; this will avoid unnecessary delta
+    showing on every upload just because the fonts are not in the same order.
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 29 Apr 2016 11:36:58 -0400
+
 console-setup (1.142) unstable; urgency=medium
 
   [ Updated translations ]
@@ -895,6 +1684,253 @@ console-setup (1.109) unstable; urgency=
 
  -- Christian Perrier <bubulle@debian.org>  Sat, 26 Jul 2014 08:52:31 +0200
 
+console-setup (1.108ubuntu15) xenial; urgency=medium
+
+  * Properly handle settings CODESET and FONSIZE when they equals 'guess' or are unset.
+    - console-setup-tty, debian/console-setup.initramfs-hook,
+      debian/console-setup.initramfs-top
+    (LP: #1565542) 
+
+ -- Evgeniy Yanyuk <eugenenuke@gmail.com>  Tue, 19 Apr 2016 15:22:17 -0400
+
+console-setup (1.108ubuntu14) xenial; urgency=medium
+
+  * keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Tue, 12 Apr 2016 13:15:05 -0600
+
+console-setup (1.108ubuntu13) xenial; urgency=medium
+
+  * debian/keyboard-configuration.config: run grep with -a (to deal with files
+    as ASCII data) when searching for keyboard, locale, and layout names.
+    (LP: #1549529)
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 04 Apr 2016 13:47:04 -0400
+
+console-setup (1.108ubuntu12) xenial; urgency=medium
+
+  * No-change rebuild to properly generate console-setup-udeb's list of
+    valid keyboard layouts and variants.
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Thu, 24 Mar 2016 10:50:39 -0400
+
+console-setup (1.108ubuntu11) xenial; urgency=medium
+
+  * Add ConditionPathExists=/dev/tty0 to the console-setup.service, to
+    avoid running the unit on platforms without virtual consoles,
+    e.g. s390x. LP: #1552733
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 03 Mar 2016 14:41:05 +0000
+
+console-setup (1.108ubuntu10) xenial; urgency=medium
+
+  * debian/rules: Drop obsolete and no-op dh_installinit --upstart-only
+    option. (LP: #1519228)
+  * Add debian/keyboard-configuration.links to (statically) enable
+    console-setup.service. It is not being pulled in by plymouth any more, and
+    doing so was brittle and unexpected. (LP: #1531442)
+  * console-setup.service: Set RemainAfterExit.
+
+ -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 11 Jan 2016 15:02:09 +0100
+
+console-setup (1.108ubuntu9) wily; urgency=medium
+
+  * Cherry-pick fix from git for udpkg/Hurd noise in keyboard-configuration.
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Tue, 20 Oct 2015 12:51:36 +0100
+
+console-setup (1.108ubuntu8) wily; urgency=medium
+
+  * Properly handle setting XKBVARIANT when using keyboard detection.
+    (LP: #1506551)
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 19 Oct 2015 11:13:01 +0100
+
+console-setup (1.108ubuntu7) wily; urgency=medium
+
+  * Fix incorrect versioning change from last upload; initramfs-tools
+    0.85eubuntu12 looks wrong but was in fact correct.
+  * If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+    on kFreeBSD; otherwise restore the previous behaviour from before the
+    kFreeBSD port of using UTF-8 in that case (LP: #1484101).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 02 Oct 2015 11:18:04 +0100
+
+console-setup (1.108ubuntu6) wily; urgency=medium
+
+  * debian/control: allow dracut to be installable by adding an alternate
+    depends on linux-initramfs-tool for console-setup.
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 08 Sep 2015 22:36:52 -0400
+
+console-setup (1.108ubuntu5) vivid; urgency=medium
+
+  * Reinstate checking for XKBLAYOUT being in the config file: this handles
+    the cases where installs done with ubiquity don't have their debconf seen
+    flag set for model/layout questions. If layout is already configure, lower
+    the corresponding question's priority to medium so we don't ask it again.
+    (LP: #1446231)
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 21 Apr 2015 17:19:21 -0400
+
+console-setup (1.108ubuntu4) vivid; urgency=medium
+
+  * Add systemd unit for console-setup. That avoids waiting for $remote_fs
+    during early boot. (Note: there is no need to enable it, it gets pulled
+    in through systemd-vconsole-setup.service) (LP: #1430280)
+
+ -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 11 Mar 2015 15:33:49 +0100
+
+console-setup (1.108ubuntu3) vivid; urgency=medium
+
+  * Drop console-setup-freebsd; it's useless and uninstallable given that we
+    don't have a freebsd port.
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 03 Mar 2015 10:15:31 -0500
+
+console-setup (1.108ubuntu2) vivid; urgency=medium
+
+  * Fix the mess I made with the previous upload:
+  * Reinstate changelog entry from 1.70ubuntu10; the changes aren't necessary
+    as keyboard-configuration does get the translated names of keyboards.
+  * Reinstate changes from 1.70ubuntu11:
+    - Make debian/keyboard-configuration.console-setup.init do the same as the
+      corresponding .upstart: I. e. just call loadkeys instead of setupcon, and
+      don't check the current console. (Font loading is already done via udev
+      rules).
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 02 Mar 2015 17:55:46 -0500
+
+console-setup (1.108ubuntu1) vivid; urgency=medium
+
+  [ Steve Langasek ]
+  * Merge from Debian unstable, remaining changes: (LP: #1426721)
+    - Don't gzip font or ACM files in /etc/console-setup/.  The space saving
+      is negligible, and it's more efficient not to need to uncompress them
+      at boot time.
+    - Include pc105.tree for ubiquity.
+    - Move boot tasks to a combination of two udev rules and a single
+      Upstart job, ensuring that they're run at points when we are able to
+      satisfy the constraints on the relevant ioctls.
+    - Stop running debconf-updatepo on clean.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - Add an apport hook.
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - Depend on kbd (>= 1.15-1ubuntu3) for a valuable loadkeys improvement.
+    - Include support for translated keyboard names.
+    - Depend on debconf instead of pre-depending, because pre-depends have
+      no effect on config scripts.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.upstart, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Make setupcon explicitly exit 0, so that postinsts don't fail in the
+      event that loadkeys can't find a console.
+    - Update for new layouts and variants for Montenegro and Serbia, and
+      migrate configuration files from the old layouts.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default variant for French to oss.
+    - Set default layout for Simplified Chinese to 'cn'.
+    - Don't use the default keyboard variant if the layout is overridden by
+      preseeding.
+    - If keyboard-configuration/layoutcode is preseeded but not marked as
+      seen, then set the default layout but don't lower the layout question
+      priority or preseed console-setup/ask_detect.
+    - Use the default keyboard model if an existing configuration file sets
+      XKBMODEL="".
+    - Go back to always asking layout before variant.
+    - Fix keyboard layout detection to set the layout properly.
+    - Reset keyboard-configuration/toggle to the default if it's set to "No
+      toggling" and you select a non-Latin layout.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Replace usplash detection code with Plymouth detection code.
+    - Load the new keyboard configuration immediately when running
+      'dpkg-reconfigure keyboard-configuration' in an installed system.
+    - Don't fail to configure keyboard-configuration if setxkbmap fails to
+      talk to the X display.
+    - Tolerate absence of setupcon in keyboard-configuration.postinst.
+    - Drop the simplified keyboard-configuration/xkb-keymap question.
+    - Fix command injection in ckbcomp.
+    - debian/console-setup.console-font.upstart: Add Upstart job that sets up
+      console font when plymouth-splash is starting.
+    - Override description of the ch layout from "German (Switzerland)" to
+      just "Switzerland".
+    - Map ppc64el/* to XKBMODEL=pc105.
+  * Dropped changes, included in Debian:
+    - "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by keyboard-configuration/modelcode=SKIP: this is now
+      supported upstream with either "unknown" or an empty string as the
+      model.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Include Terminus font in the compiled packages.  Do not depend, but
+      conflict/provide/replace console-terminus.  New upstream version of
+      the Terminus font (4.32).
+    - Explicitly build-depend on liblocale-gettext-perl for kbdnames-maker,
+      and likewise have keyboard-configuration depend on
+      liblocale-gettext-perl.
+    - Make keyboard-configuration replace old console-setup/console-setup-mini
+      versions as well as conflicting with them.
+    - Weaken test for whether /usr is mounted; testing for /usr/share is
+      sufficient, and fixes operation in d-i.
+    - Set default layout for Kurdish to tr(ku).
+  * Dropped changes, no longer needed:
+    - Cope with systems installed with console-setup-udeb (<< 1.53) (which
+      predates Ubuntu 12.04 and Debian wheezy).
+    - Drop ancient handling of an empty codeset in the config file.
+    - Drop vtrgb upgrade handling from natty
+    - Drop upstart job transition from lucid
+  * setupcon: Map XKBMODEL=SKIP to '' for compatibility with existing
+    configs.
+  * debian/rules: revert hard-coding of a list of "debconf-selectable"
+    layouts for the udebs, since we don't use this debconf question in Ubuntu
+    and all layouts are selectable.
+  * setupcon: revert ridiculous upstream twiddling of keymap cache filenames:
+    - the variables are taken from a config file which, if changed,
+      invalidates the cache.
+    - there is only ever one keyboard map per system.
+    - the system should not have to resolve filenames to find the keymap cache
+      on boot.
+  * Move vtrgb handling to console-setup-linux package, since this is clearly
+    Linux-specific.
+  * Add missing console-setup-linux.prerm to remove /etc/vtrgb alternatives
+  * Keyboard/kbdcompiler: fix bug in filtering of unsupported variants that
+    breaks generation of the pc105.tree for d-i keyboard detection.
+  * debian/keyboard-configuration.postinst: udpkg is not part of an installed
+    Debian system; don't fail to configure if it's absent and the script is
+    called outside of an installer context.
+  * Don't make debian/copyright a symlink to COPYRIGHT, this is disallowed
+    by the Ubuntu archive installer.
+
+  [ Mathieu Trudel-Lapierre ]
+  * debian/keyboard-configuration.config: fix typo in model check for SKIP;
+    even when looking up the layout/variant, we need to check for the model
+    as XKBMODEL, since $model doesn't exist.
+  * debian/preprocessor: revert the removal of keyboard names (for size) of
+    console-setup-udeb: we do need those, since we don't use the simplified
+    xkb-keymap template from Debian just yet: this way we can still show
+    country/language names when selecting a keyboard, layout or variant.
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Fri, 27 Feb 2015 16:36:52 -0500
+
 console-setup (1.108) unstable; urgency=low
 
   [ Updated translations ]
@@ -1462,6 +2498,179 @@ console-setup (1.71) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Mon, 21 Mar 2011 07:08:43 +0200
 
+console-setup (1.70ubuntu11) vivid; urgency=medium
+
+  * Make debian/keyboard-configuration.console-setup.init do the same as the
+    corresponding .upstart: I. e. just call loadkeys instead of setupcon, and
+    don't check the current console. (Font loading is already done via udev
+    rules). (LP: #1400393)
+
+ -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 17 Dec 2014 07:55:34 +0100
+
+console-setup (1.70ubuntu10) vivid; urgency=medium
+
+  * Add all language-packs as build dependencies, to get translated names
+    of keyboard names in the DEBIAN/config of keyboard-setup package.
+
+ -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Sun, 30 Nov 2014 22:21:38 +0000
+
+console-setup (1.70ubuntu9) utopic; urgency=high
+
+  * No change rebuild against new dh_installinit, to call update-rc.d at
+    postinst.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 28 May 2014 10:39:17 +0100
+
+console-setup (1.70ubuntu8) trusty; urgency=medium
+
+  * Map ppc64el/* to XKBMODEL=pc105.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 29 Jan 2014 13:14:53 +0000
+
+console-setup (1.70ubuntu7) raring; urgency=low
+
+  * Override description of the ch layout from "German (Switzerland)" to
+    just "Switzerland" (LP: #869825).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 13 Mar 2013 16:35:47 +0000
+
+console-setup (1.70ubuntu6) quantal; urgency=low
+
+  * debian/console-setup.console-font.upstart: Add Upstart job that sets up
+    console font when plymouth-splash is starting, to work around a possible
+    udev/plymouth race that would otherwise prevent the font being set
+    (thanks, Ahmed El-Mahmoudy and Andrey Bondarenko; LP: #632382).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 09 Oct 2012 01:50:48 +0100
+
+console-setup (1.70ubuntu5) precise-proposed; urgency=low
+
+  * Update Ubuntu-specific translations from Launchpad (LP: #985605).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 19 Apr 2012 16:03:16 +0100
+
+console-setup (1.70ubuntu4) precise; urgency=low
+
+  * Add definitions for four (ignored) dead-keys: dead_belowcomma,
+    dead_currency, dead_doublegrave, and dead_invertedbreve.  Cherrypick
+    from Debian git.
+    (LP: #738314)
+  * Fix command injection in ckbcomp (thanks to Emanuel Bronshtein)
+    (LP: #782705)
+
+ -- Bryce Harrington <bryce@ubuntu.com>  Mon, 19 Mar 2012 21:13:39 -0700
+
+console-setup (1.70ubuntu3) precise; urgency=low
+
+  * No change rebuild for new xkb-data. (LP: #953328)
+
+ -- StÃ©phane Graber <stgraber@ubuntu.com>  Thu, 15 Mar 2012 11:48:58 -0400
+
+console-setup (1.70ubuntu2) precise; urgency=low
+
+  * Drop the simplified keyboard-configuration/xkb-keymap question; it
+    breaks existing preseeding, might confuse Ubiquity, and people are
+    already used to the layout/variant questions in Ubuntu (LP: #894187).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 24 Nov 2011 15:05:27 +0000
+
+console-setup (1.70ubuntu1) precise; urgency=low
+
+  * Merge from Debian testing, remaining changes:
+    - Include Terminus font in the compiled packages.  Do not depend, but
+      conflict/provide/replace console-terminus.  New upstream version of
+      the Terminus font (4.32).
+    - Add a "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by keyboard-configuration/modelcode=SKIP.
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - Update for new layouts and variants for Montenegro and Serbia, and
+      migrate configuration files from the old layouts.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - Move boot tasks to a combination of two udev rules and a single
+      Upstart job, ensuring that they're run at points when we are able to
+      satisfy the constraints on the relevant ioctls.
+    - Don't gzip font or ACM files in /etc/console-setup/.  The space saving
+      is negligible, and it's more efficient not to need to uncompress them
+      at boot time.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Add an apport hook.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - Don't try to call update-rc.d if it doesn't exist, such as in d-i.
+    - debian/vtrgb, debian/vtrgb.vga, debian/console-setup.setvtrgb.upstart,
+      debian/rules, debian/console-setup.postinst: use Ubuntu's virtual
+      terminal color scheme by default, with a VGA color scheme available
+      as an alternative.
+    - Explicitly build-depend on liblocale-gettext-perl for kbdnames-maker,
+      and likewise have keyboard-configuration depend on
+      liblocale-gettext-perl.
+    - Depend on debconf instead of pre-depending, because pre-depends have
+      no effect on config scripts.
+    - Make keyboard-configuration replace old console-setup/console-setup-mini
+      versions as well as conflicting with them.
+    - Depend on kbd (>= 1.15-1ubuntu3) for a valuable loadkeys improvement.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Kurdish to tr(ku).
+    - Set default layout for Vietnam to 'us'.
+    - Set default variant for French to oss.
+    - Set default layout for Simplified Chinese to 'cn'.
+    - Don't use the default keyboard variant if the layout is overridden by
+      preseeding.
+    - If keyboard-configuration/layoutcode is preseeded but not marked as
+      seen, then set the default layout but don't lower the layout question
+      priority or preseed console-setup/ask_detect.
+    - Use the default keyboard model if an existing configuration file sets
+      XKBMODEL="".
+    - console-setup-udeb (<< 1.53) didn't set the seen flag in the installed
+      system.  Cope with this and avoid asking the layout and variant
+      questions again if the default debconf priority is at least high.
+      (squeeze has >> 1.53, so this can be dropped after 12.04.)
+    - Go back to always asking layout before variant.
+    - Fix keyboard layout detection to set the layout properly.
+    - Reset keyboard-configuration/toggle to the default if it's set to "No
+      toggling" and you select a non-Latin layout.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Replace usplash detection code with Plymouth detection code.
+    - Load the new keyboard configuration immediately when running
+      'dpkg-reconfigure keyboard-configuration' in an installed system.
+    - Don't fail to configure keyboard-configuration if setxkbmap fails to
+      talk to the X display.
+    - Tolerate absence of setupcon in keyboard-configuration.postinst.
+    - Move keyboard detection templates from console-setup.templates to
+      keyboard-configuration.templates.
+    - Stop running debconf-updatepo on clean.
+    - Include pc105.tree for ubiquity.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Weaken test for whether /usr is mounted; testing for /usr/share is
+      sufficient, and fixes operation in d-i.
+    - Make setupcon explicitly exit 0, so that postinsts don't fail in the
+      event that loadkeys can't find a console.
+  * Dropped changes:
+    - Special KPDL handling: rewritten upstream in version 1.24.
+    - Upgrade handling for broken 1.57ubuntu1-1.57ubuntu4: prerelease
+      versions from natty, code dropped.
+    - Allow underscores in rules variables: included upstream.
+  * Restore plugin-detect-keyboard handling code, accidentally dropped in
+    a previous merge; keyboard detecting code was probably broken in the gtk
+    frontend by this.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 08 Nov 2011 09:34:02 -0800
+
 console-setup (1.70) unstable; urgency=low
 
   * ckbcomp: permit '_' in all identifiers.  Thanks to Jonny, Javier
@@ -1676,6 +2885,277 @@ console-setup (1.58) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Sat, 23 Oct 2010 10:14:45 +0300
 
+console-setup (1.57ubuntu27) oneiric; urgency=low
+
+  * Update Greek, Persian, Hebrew, Punjabi, and Traditional Chinese
+    translations from console-setup 1.68, fixing encoding problems
+    (LP: #860562).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 28 Sep 2011 15:58:32 +0100
+
+console-setup (1.57ubuntu26) oneiric; urgency=low
+
+  * Backport translations from console-setup 1.63, without which
+    keyboard-configuration is completely untranslated (and, indeed,
+    untranslatable).  LP: #838669.
+  * Bump dependency on debconf as well, to make sure we can parse sr@latin
+    translation templates.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 26 Sep 2011 15:44:41 +0100
+
+console-setup (1.57ubuntu25) oneiric; urgency=low
+
+  * Backport from upstream (Anton Zinoviev):
+    - Include Terminus font in the compiled packages.  Do not depend, but
+      conflict/provide/replace console-terminus.  New upstream version of
+      the Terminus font (4.32).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 23 Aug 2011 13:53:08 +0100
+
+console-setup (1.57ubuntu24) oneiric; urgency=low
+
+  * Fix default keyboard selection for language/country combinations lacking
+    a proper combined locale (LP: #814448).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 19 Aug 2011 15:13:13 +0100
+
+console-setup (1.57ubuntu23) oneiric; urgency=low
+
+  * Explicitly build-depend on liblocale-gettext-perl for kbdnames-maker,
+    and likewise have keyboard-configuration depend on
+    liblocale-gettext-perl.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 12 Aug 2011 16:55:54 +0100
+
+console-setup (1.57ubuntu22) oneiric; urgency=low
+
+  * Fix keyboard layout detection to set the layout properly (LP: #820554).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 12 Aug 2011 16:11:59 +0100
+
+console-setup (1.57ubuntu21) oneiric; urgency=low
+
+  * Rebuild against xkb-data 2.2.1 (LP: #791883).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sat, 25 Jun 2011 05:08:24 +0100
+
+console-setup (1.57ubuntu20) natty; urgency=low
+
+  * Weaken test for whether /usr is mounted; testing for /usr/share is
+    sufficient, and fixes operation in d-i.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 20 Apr 2011 15:29:46 +0100
+
+console-setup (1.57ubuntu19) natty; urgency=low
+
+  * Don't copy keyboard-configuration questions to /target in OEM mode.
+    oem-config will ask them later, and copying these confuses it
+    (LP: #741304).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 15 Apr 2011 12:43:41 +0100
+
+console-setup (1.57ubuntu18) natty; urgency=low
+
+  * Don't use the default keyboard variant if the layout is overridden by
+    preseeding (LP: #758584).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 12 Apr 2011 15:21:11 +0100
+
+console-setup (1.57ubuntu17) natty; urgency=low
+
+  * debian/vtrgb: Design team wanted a slightly different grey; more contrast
+    when white on grey
+  * debian/console-setup.postinst: fix failure to find file to md5sum;
+    go back to installing the original vtrgb as a lower priority alternative
+
+ -- Dustin Kirkland <kirkland@ubuntu.com>  Mon, 21 Mar 2011 21:38:00 -0500
+
+console-setup (1.57ubuntu16) natty; urgency=low
+
+  * debian/console-setup.postinst: don't add the vtrgb.vga 
+    alternate to update-alternatives;  let other packages or humans do this;
+    otherwise, every time this package upgrades, it would overwrite others'
+    overiding choices
+
+ -- Dustin Kirkland <kirkland@ubuntu.com>  Sun, 20 Mar 2011 17:54:21 -0500
+
+console-setup (1.57ubuntu15) natty; urgency=low
+
+  * debian/vtrgb.vga, debian/rules, debian/console-setup.postinst:
+    - install a vga configuration, for easy reference by others who want to go
+      back to legacy mode
+    - relocate the stock vtrgb from /usr to /etc, such that it can be edited
+      by an admin, LP: #738992
+
+ -- Dustin Kirkland <kirkland@ubuntu.com>  Sun, 20 Mar 2011 17:19:34 -0500
+
+console-setup (1.57ubuntu14) natty; urgency=low
+
+  * Install setvtrgb job with --no-start --upstart-only (LP: #738159).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sat, 19 Mar 2011 12:07:57 +0000
+
+console-setup (1.57ubuntu13) natty; urgency=low
+
+  * debian/rules, debian/console-setup.postinst: use update-alternatives
+    to allow other packages to install different console color values,
+    LP: #737948
+
+ -- Dustin Kirkland <kirkland@ubuntu.com>  Fri, 18 Mar 2011 22:02:12 -0500
+
+console-setup (1.57ubuntu12) natty; urgency=low
+
+  * Tolerate absence of setupcon in keyboard-configuration.postinst
+    (LP: #733497).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 18 Mar 2011 11:28:34 +0000
+
+console-setup (1.57ubuntu11) natty; urgency=low
+
+  * Address console-setup portion of LP: #730672, by installing
+    the conffile and applying it at upstart
+    - debian/vtrgb: Ubuntu's virtual terminal color scheme
+    - debian/console-setup.setvtrgb.upstart: run setvtrgb during upstart
+
+ -- Dustin Kirkland <kirkland@ubuntu.com>  Thu, 17 Mar 2011 17:10:50 -0500
+
+console-setup (1.57ubuntu10) natty; urgency=low
+
+  * Don't fail to configure keyboard-configuration if setxkbmap fails to
+    talk to the X display (LP: #728764).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 04 Mar 2011 13:40:49 +0000
+
+console-setup (1.57ubuntu9) natty; urgency=low
+
+  * The console-setup udev rule accidentally went missing in 1.57ubuntu1.
+    Reinstall it, this time in keyboard-configuration (LP: #713746).
+  * Load the new keyboard configuration immediately when running
+    'dpkg-reconfigure keyboard-configuration' in an installed system
+    (LP: #713062).
+  * Make setupcon explicitly exit 0, so that postinsts don't fail in the
+    event that loadkeys can't find a console.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 03 Mar 2011 16:14:06 +0000
+
+console-setup (1.57ubuntu8) natty; urgency=low
+
+  * Move keyboard detection templates from console-setup.templates to
+    keyboard-configuration.templates.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 28 Feb 2011 19:21:18 +0000
+
+console-setup (1.57ubuntu7) natty; urgency=low
+
+  * No change build to pick up xkeyboard-config 2.1-1ubuntu3.
+
+ -- Evan Dandrea <ev@ubuntu.com>  Tue, 08 Feb 2011 15:05:54 +0000
+
+console-setup (1.57ubuntu6) natty; urgency=low
+
+  * Allow underscores in rules variables ($sun_t6_custom).
+
+ -- Evan Dandrea <ev@ubuntu.com>  Mon, 07 Feb 2011 15:14:44 +0000
+
+console-setup (1.57ubuntu5) natty; urgency=low
+
+  * Drop misguided Ubuntu-specific code to migrate from console-setup/* to
+    keyboard-configuration/* question names.  This is already handled on
+    upgrade by reading the old /etc/default/console-setup file
+    (LP: #698263).
+  * console-setup-udeb (<< 1.53) didn't set the seen flag in the installed
+    system.  Cope with this and avoid asking the layout and variant
+    questions again if the default debconf priority is at least high
+    (LP: #705883).
+  * If we detect the above breakage (upgrading from anything between
+    1.57ubuntu1 and 1.57ubuntu4 inclusive, and the XKB* values in
+    /etc/default/keyboard differ from the commented-out values in
+    /etc/default/console-setup), reset to the commented-out values in
+    /etc/default/console-setup.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 28 Jan 2011 12:19:42 +0000
+
+console-setup (1.57ubuntu4) natty; urgency=low
+
+  * Include pc105.tree for ubiquity.
+
+ -- Evan Dandrea <ev@ubuntu.com>  Mon, 24 Jan 2011 16:53:59 +0000
+
+console-setup (1.57ubuntu3) natty; urgency=low
+
+  * Correct fix for LP: #634402: explicitly check readability of
+    /etc/default/keyboard and /etc/default/console-setup in initramfs hooks,
+    rather than trying to guard '.' with '||' which doesn't work
+    (LP: #701954).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 20 Jan 2011 20:55:01 +0000
+
+console-setup (1.57ubuntu2) natty; urgency=low
+
+  * Make keyboard-configuration replace old console-setup/console-setup-mini
+    versions as well as conflicting with them (thanks, Martin Pitt).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 06 Jan 2011 12:24:45 +0000
+
+console-setup (1.57ubuntu1) natty; urgency=low
+
+  * Resynchronise with Debian.  Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Reset keyboard-configuration/toggle to the default if it's set to "No
+      toggling" and you select a non-Latin layout.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - Set default variant for French to oss.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default layout for Kurdish to tr(ku).
+    - Stop running debconf-updatepo on clean.
+    - Update for new layouts and variants for Montenegro and Serbia, and
+      migrate configuration files from the old layouts.
+    - Add a "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by keyboard-configuration/modelcode=SKIP.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Honour OVERRIDE_ALLOW_PRESEEDING environment variable when deciding
+      whether to allow preseeding, which is ordinarily only allowed in d-i.
+    - If keyboard-configuration/layoutcode is preseeded but not marked as
+      seen, then set the default layout but don't lower the layout question
+      priority or preseed console-setup/ask_detect.
+    - Add an apport hook.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - Replace usplash detection code with Plymouth detection code.
+    - Move boot tasks to a combination of two udev rules and a single
+      Upstart job, ensuring that they're run at points when we are able to
+      satisfy the constraints on the relevant ioctls.
+    - Depend on kbd (>= 1.15-1ubuntu3) for a valuable loadkeys improvement.
+    - Don't try to call update-rc.d if it doesn't exist, such as in d-i.
+    - Don't gzip font or ACM files in /etc/console-setup/.  The space saving
+      is negligible, and it's more efficient not to need to uncompress them
+      at boot time.
+    - Remove iconv transliteration.  We don't use non-UTF-8 locales, and it
+      breaks ubiquity as we haven't generated the configured locale by the
+      time we hit console-setup.
+  * Go back to always asking layout before variant.
+  * Migrate from old console-setup/* to new keyboard-configuration/*
+    question names.
+  * Use the default keyboard model if an existing configuration file sets
+    XKBMODEL="".
+  * Exit cleanly from initramfs hook if /etc/default/keyboard or
+    /etc/default/console-setup don't exist for some reason (LP: #634402).
+  * Fix description of upstart job to not incorrectly claim that it sets the
+    font (LP: #632366).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 05 Jan 2011 17:02:40 +0000
+
 console-setup (1.57) unstable; urgency=low
 
   * udeb: properly preseed system based on installer values.
@@ -2201,6 +3681,181 @@ console-setup (1.35) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Thu, 14 May 2009 21:42:14 +0300
 
+console-setup (1.34ubuntu15) lucid; urgency=low
+
+  * Make /usr/share/initramfs-tools/scripts/panic/console_setup executable.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 23 Apr 2010 23:23:50 +0100
+
+console-setup (1.34ubuntu14) lucid; urgency=low
+
+  * Update Ubuntu-specific translations from Launchpad.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 15 Apr 2010 00:08:23 +0100
+
+console-setup (1.34ubuntu13) lucid; urgency=low
+
+  * Remove iconv transliteration.  We don't use non-UTF-8 locales, and
+    it breaks ubiquity as we haven't generated the configured locale by
+    the time we hit console-setup (LP: #542310).
+
+ -- Evan Dandrea <evand@ubuntu.com>  Fri, 26 Mar 2010 12:50:50 +0000
+
+console-setup (1.34ubuntu12) lucid; urgency=low
+
+  * console-setup-tty: Only call setfont once, for both font and ACM.
+  * Don't try to call update-rc.d if it doesn't exist, such as in d-i
+    (LP: #540835).
+  * Don't gzip font or ACM files in /etc/console-setup/.  The space saving
+    is negligible, and it's more efficient not to need to uncompress them at
+    boot time.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 19 Mar 2010 11:08:58 +0000
+
+console-setup (1.34ubuntu11) lucid; urgency=low
+
+  * Move boot tasks to a combination of two udev rules and a single Upstart
+    job, ensuring that they're run at points when we are able to satisfy the
+    constraints on the relevant ioctls.  This may not work optimally with
+    vgacon, but you have to go to special effort to use that with Ubuntu
+    now, and it at least shouldn't break (LP: #524439).
+  * Set default layout for Guernsey, Jersey, and the Isle of Man to gb
+    (LP: #533003).
+  * Fix incorrect FONT and ACM tests in initramfs script.
+  * Depend on kbd (>= 1.15-1ubuntu3) for a valuable loadkeys improvement.
+    This was previously a recommends, but the udev rule won't work without
+    kbd or console-tools anyway, I'm not really interested in supporting a
+    system without either installed, and console-tools is thoroughly
+    obsolete now.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sat, 13 Mar 2010 12:56:30 +0000
+
+console-setup (1.34ubuntu10) lucid; urgency=low
+
+  * debian/console-setup.console-setup.init,
+    debian/console-setup.keyboard-setup.init: Replace the usplash detection
+    code with Plymouth detection code, since the same problem applies. 
+
+ -- Scott James Remnant <scott@ubuntu.com>  Wed, 17 Feb 2010 13:14:32 +0000
+
+console-setup (1.34ubuntu9) lucid; urgency=low
+
+  * Generate a locale locally for translating keyboard names in
+    kbnames-maker.
+
+ -- Evan Dandrea <evand@ubuntu.com>  Thu, 04 Feb 2010 15:48:25 -0800
+
+console-setup (1.34ubuntu8) lucid; urgency=low
+
+  * Put kbdnames.gz in console-setup-udeb as well.
+  * Don't filter out models from kbdnames as we still ask the model
+    question.
+
+ -- Evan Dandrea <evand@ubuntu.com>  Wed, 27 Jan 2010 17:22:19 +0000
+
+console-setup (1.34ubuntu7) lucid; urgency=low
+
+  * Merge support for translated keyboard names from Debian.
+  * Update ckb/rules/base.xml to point at the new location.
+
+ -- Evan Dandrea <evand@ubuntu.com>  Wed, 20 Jan 2010 15:22:34 +0000
+
+console-setup (1.34ubuntu6) lucid; urgency=low
+
+  * debian/console-setup.initramfs-hook: There's no harm having the hook
+    run in the non-framebuffer case, it just copies things into the
+    initramfs which may be useful.
+  * debian/rules: That means we can copy the hook into scripts/panic as
+    well (stripping the OPTION from it), so when we need a shell, we'll
+    load the keymap.
+
+ -- Scott James Remnant <scott@ubuntu.com>  Fri, 18 Dec 2009 14:56:03 +0000
+
+console-setup (1.34ubuntu5) lucid; urgency=low
+
+  * We don't need the initramfs hooks if the initramfs doesn't load the
+    framebuffer or splash screen.
+
+ -- Scott James Remnant <scott@ubuntu.com>  Tue, 15 Dec 2009 14:56:59 +0000
+
+console-setup (1.34ubuntu4) karmic; urgency=low
+
+  * Fix backports of Asturian and Catalan changes in 1.34ubuntu3.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 01 Oct 2009 20:27:35 +0100
+
+console-setup (1.34ubuntu3) karmic; urgency=low
+
+  [ LoÃ¯c Minier ]
+  * Use `dpkg --print-architecture` instead of the obsolete
+    --print-installation-architecture in debian/config.proto (LP: #403316).
+
+  [ Colin Watson ]
+  * Forbid Unicode keysyms in the range 0xf000-0xffff, as kbd 1.15-1 rejects
+    the entire keymap if it contains any keysyms in that range (LP:
+    #416949).
+  * Add default codeset/layout/variant for Asturian.
+  * Backport from trunk (Jordi Mallach):
+    - Set XKBVARIANT to "cat" for Catalan.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 01 Oct 2009 20:21:57 +0100
+
+console-setup (1.34ubuntu2) karmic; urgency=low
+
+  * Add an apport hook.
+  * Update translations from Launchpad.
+  * Backport from trunk (Anton Zinoviev, LP: #390292):
+    - Do not issue warnings for unknown keycodes with AT keyboards (these
+      are multimedia keys and they are unnecessary on the console).  Thanks
+      to Anders LagerÃ¥s, closes: #531292.
+
+ -- Colin Watson <cjwatson@debian.org>  Tue, 01 Sep 2009 11:49:34 +0100
+
+console-setup (1.34ubuntu1) karmic; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default layout for Kurdish to tr(ku).
+    - Fix handling of commas in layout and variant names.
+    - debian/config.proto: Set sparc default model to pc105.
+    - Remove 'exit 0' from the end of debian/config.proto; this will be
+      sourced from the postinst in the installer, and exiting in the
+      successful case means that /etc/default/console-setup never gets
+      generated.
+    - Stop running debconf-updatepo on clean.
+    - Update for new layouts and variants for Japan, Montenegro, and Serbia,
+      and migrate configuration files from the old layouts.
+    - Add a "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by console-setup/modelcode=SKIP.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Honour OVERRIDE_ALLOW_PRESEEDING environment variable when deciding
+      whether to allow preseeding, which is ordinarily only allowed in d-i.
+    - If console-setup/layoutcode is preseeded but not marked as seen, then
+      set the default layout but don't lower the layout question priority or
+      preseed console-setup/ask_detect.
+    - Treat the Kazakhstan layout (kz) as non-Latin.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 05 May 2009 20:51:20 +0100
+
 console-setup (1.34) unstable; urgency=medium
 
   [ Colin Watson ]
@@ -2350,6 +4005,113 @@ console-setup (1.29) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Tue, 24 Mar 2009 20:53:51 +0200
 
+console-setup (1.28ubuntu8) jaunty; urgency=low
+
+  * Update Ubuntu-specific strings from Launchpad.
+  * Treat the Kazakhstan layout (kz) as non-Latin (LP: #356816).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 09 Apr 2009 01:15:09 +0100
+
+console-setup (1.28ubuntu7) jaunty; urgency=low
+
+  * Raise priority to critical for questions preseeded with a nonexistent
+    code (LP: #328078).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 27 Mar 2009 11:45:13 +0000
+
+console-setup (1.28ubuntu6) jaunty; urgency=low
+
+  * Don't escape '(' and ')' when decoding/encoding the codeset, as the
+    pattern is passed to grep and this causes parentheses to be interpreted
+    as regular expression groups (thanks to Dmitry Agafonov for pointing out
+    the problem).
+  * If reading a user configuration file, disable --save, and don't use
+    /etc/console-setup/boottime.kmap.gz (LP: #332728).
+  * Update Keyboard/KeyboardNames.pl based on xkb-data 1.5-2ubuntu5.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 02 Mar 2009 16:30:50 +0000
+
+console-setup (1.28ubuntu5) jaunty; urgency=low
+
+  * Backport from trunk:
+    - Sort the null variant to the top of the choices list rather than to the
+      bottom.
+  * Set and check a flag on console-setup/dont_ask_layout to make sure that
+    it's only asked at most once per package installation (LP: #320374).
+  * Update Keyboard/KeyboardNames.pl based on xkb-data 1.4-1ubuntu3.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sat, 31 Jan 2009 12:07:37 +0000
+
+console-setup (1.28ubuntu4) jaunty; urgency=low
+
+  * Set plain or shifted PrintScreen key to generate VoidSymbol rather than
+    Ctrl-backslash (LP: #279973).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Dec 2008 10:09:28 +0000
+
+console-setup (1.28ubuntu3) jaunty; urgency=low
+
+  * Create /dev/tty[1-6] in our initramfs script before trying to operate on
+    them (LP: #130444).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 26 Nov 2008 12:15:12 +0000
+
+console-setup (1.28ubuntu2) jaunty; urgency=low
+
+  * Default console-setup/ask_detect to false, since it's hard to back up
+    out of the detection widget once you've entered it.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 25 Nov 2008 16:48:28 +0000
+
+console-setup (1.28ubuntu1) jaunty; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default layout for Kurdish to tr(ku).
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - debian/config.proto: Set sparc default model to pc105.
+    - Remove 'exit 0' from the end of debian/config.proto; this will be
+      sourced from the postinst in the installer, and exiting in the
+      successful case means that /etc/default/console-setup never gets
+      generated.
+    - Stop running debconf-updatepo on clean.
+    - Update for new layouts and variants for Japan, Montenegro, and Serbia,
+      and migrate configuration files from the old layouts.
+    - Add a "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by console-setup/modelcode=SKIP.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Honour OVERRIDE_ALLOW_PRESEEDING environment variable when deciding
+      whether to allow preseeding, which is ordinarily only allowed in d-i.
+    - If console-setup/layoutcode is preseeded but not marked as seen, then
+      set the default layout but don't lower the layout question priority or
+      preseed console-setup/ask_detect.
+    - Fix property counts in Goha and legacy BDF fonts.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 06 Nov 2008 14:36:26 +0000
+
 console-setup (1.28) unstable; urgency=low
 
   [ Debconf translations ]
@@ -2388,6 +4150,67 @@ console-setup (1.26) unstable; urgency=l
 
  -- Christian Perrier <bubulle@debian.org>  Tue, 08 Jul 2008 20:40:35 +0200
 
+console-setup (1.25ubuntu3) intrepid; urgency=low
+
+  * Fix property counts in Goha and legacy BDF fonts.
+  * Switch from console-tools-udeb to kbd-udeb, in line with Debian.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 28 Aug 2008 00:09:48 +0100
+
+console-setup (1.25ubuntu2) intrepid; urgency=low
+
+  * If console-setup/layoutcode is preseeded but not marked as seen, then
+    set the default layout but don't lower the layout question priority or
+    preseed console-setup/ask_detect (LP: #64058).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 30 Jun 2008 23:49:31 +0100
+
+console-setup (1.25ubuntu1) intrepid; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default layout for Kurdish to tr(ku).
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - debian/config.proto: Set sparc default model to pc105.
+    - Remove 'exit 0' from the end of debian/config.proto; this will be
+      sourced from the postinst in the installer, and exiting in the
+      successful case means that /etc/default/console-setup never gets
+      generated.
+    - Switch back to console-tools-udeb for now.
+    - Stop running debconf-updatepo on clean.
+    - Update for new layouts and variants for Japan, Montenegro, and Serbia,
+      and migrate configuration files from the old layouts.
+    - Add a "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by console-setup/modelcode=SKIP.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Honour OVERRIDE_ALLOW_PRESEEDING environment variable when deciding
+      whether to allow preseeding, which is ordinarily only allowed in d-i.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 24 Jun 2008 02:39:34 +0100
+
 console-setup (1.25) unstable; urgency=low
 
   [ Anton Zinoviev ]
@@ -2405,6 +4228,52 @@ console-setup (1.25) unstable; urgency=l
 
  -- Christian Perrier <bubulle@debian.org>  Wed, 18 Jun 2008 20:24:01 +0200
 
+console-setup (1.24ubuntu1) intrepid; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default layout for Kurdish to tr(ku).
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - debian/config.proto: Set sparc default model to pc105.
+    - Remove 'exit 0' from the end of debian/config.proto; this will be
+      sourced from the postinst in the installer, and exiting in the
+      successful case means that /etc/default/console-setup never gets
+      generated.
+    - Switch back to console-tools-udeb for now.
+    - Stop running debconf-updatepo on clean.
+    - Update for new layouts and variants for Japan, Montenegro, and Serbia,
+      and migrate configuration files from the old layouts.
+    - Add a "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by console-setup/modelcode=SKIP.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Honour OVERRIDE_ALLOW_PRESEEDING environment variable when deciding
+      whether to allow preseeding, which is ordinarily only allowed in d-i.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 11 Jun 2008 22:32:10 +0100
+
 console-setup (1.24) unstable; urgency=medium
 
   [ Anton Zinoviev ]
@@ -2479,6 +4348,100 @@ console-setup (1.22) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Fri, 04 Apr 2008 22:41:21 +0300
 
+console-setup (1.21ubuntu8) hardy; urgency=low
+
+  * Rebuild against xkeyboard-config 1.1~cvs.20080104.1-1ubuntu6.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 21 Apr 2008 20:40:40 +0100
+
+console-setup (1.21ubuntu7) hardy; urgency=low
+
+  * Honour OVERRIDE_ALLOW_PRESEEDING environment variable when deciding
+    whether to allow preseeding, which is ordinarily only allowed in d-i
+    (LP: #188492).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 14 Apr 2008 11:49:55 +0100
+
+console-setup (1.21ubuntu6) hardy; urgency=low
+
+  * Handle some special cases for the KPDL key (LP: #189529).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 02 Apr 2008 00:06:25 +0100
+
+console-setup (1.21ubuntu5) hardy; urgency=low
+
+  * Silence error messages for keycodes 214, 215, 216, and 217, which are
+    various special keys in the default X.org PC keyboard map that we don't
+    need to handle.
+  * Map dead_stroke to U+002D HYPHEN-MINUS.
+  * Add a "Do not configure keyboard; keep kernel keymap" model option,
+    preseedable by console-setup/modelcode=SKIP (LP: #59889).
+  * Drop the layout/variant priority to high on fresh installs
+    (LP: #205959).
+  * Support rules with multiple consequents (thanks, Adam Simpkins;
+    LP: #139710).
+  * Allow specifying alternate rules using XKBRULES (thanks, Adam Simpkins;
+    LP: #139712).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 31 Mar 2008 14:33:25 +0100
+
+console-setup (1.21ubuntu4) hardy; urgency=low
+
+  * Set default layout for Kurdish to tr(ku) (LP: #28683).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 03 Mar 2008 13:46:06 +0000
+
+console-setup (1.21ubuntu3) hardy; urgency=low
+
+  * Set default layout for Vietnam to 'us' (LP: #191451).
+  * Treat 'any' as a synonym for 'NoSymbol' in XKB input files (LP: #93077).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 26 Feb 2008 14:05:12 +0000
+
+console-setup (1.21ubuntu2) hardy; urgency=low
+
+  * Set default for Dutch to us(intl), not just us (LP: #129982).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 29 Jan 2008 00:14:54 +0000
+
+console-setup (1.21ubuntu1) hardy; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - debian/config.proto: Set sparc default model to pc105.
+    - Remove 'exit 0' from the end of debian/config.proto; this will be
+      sourced from the postinst in the installer, and exiting in the
+      successful case means that /etc/default/console-setup never gets
+      generated.
+    - Switch back to console-tools-udeb for now.
+    - Stop running debconf-updatepo on clean.
+  * Update for new layouts and variants for Japan, Montenegro, and Serbia,
+    and migrate configuration files from the old layouts.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 28 Jan 2008 23:01:31 +0000
+
 console-setup (1.21) unstable; urgency=low
 
   * Silently ignore 'vendor' tag in xorg.xml.
@@ -2537,6 +4500,69 @@ console-setup (1.20) unstable; urgency=l
 
  -- Christian Perrier <bubulle@debian.org>  Sat, 05 Jan 2008 09:04:03 +0100
 
+console-setup (1.19ubuntu3) hardy; urgency=low
+
+  * Set default layout for Dutch to 'us' (LP: #129982).
+  * Set default layout for Simplified Chinese to 'cn'.
+  * Set default layout for Morocco to 'ma'.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 28 Jan 2008 17:11:21 +0000
+
+console-setup (1.19ubuntu2) hardy; urgency=low
+
+  * Handle an empty codeset in the configuration file gracefully (a remnant
+    of a previous bug, perhaps Debian #420802?), and re-ask the question on
+    upgrade (LP: #91399).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 11 Jan 2008 00:30:07 +0000
+
+console-setup (1.19ubuntu1) hardy; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Only default to Canadian layout for fr_CA; use U.S. English for other
+      *_CA locales.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - debian/config.proto: Set sparc default model to pc105.
+    - Remove 'exit 0' from the end of debian/config.proto; this will be
+      sourced from the postinst in the installer, and exiting in the
+      successful case means that /etc/default/console-setup never gets
+      generated.
+    - Set default model to pc105 on powerpc/ps3 systems.
+  * Switch back to console-tools-udeb for now; we'd like to use kbd for
+    Hardy, but Alpha 1 is looming ...
+  * Stop running debconf-updatepo on clean; this is not standard in d-i and
+    should be done manually where necessary in Ubuntu.
+  * Backport from trunk:
+    - Run setupcon with --save in the postinst to ensure that required data
+      is copied to /etc.
+    - Load the saved keymap in /etc/console-setup/boottime.kmap.gz if
+      available rather than running ckbcomp (which is slow), unless we're
+      being called with --save or --save-only.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 27 Nov 2007 15:05:15 +0000
+
 console-setup (1.19) unstable; urgency=low
 
   [ Jérémy Bobbio ]
@@ -2584,6 +4610,85 @@ console-setup (1.17) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Sun, 15 Jul 2007 16:35:55 +0300
 
+console-setup (1.16ubuntu5) gutsy; urgency=low
+
+  * Rebuild against xkb-data 0.9-4ubuntu2.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 24 Sep 2007 12:53:36 +0100
+
+console-setup (1.16ubuntu4) gutsy; urgency=low
+
+  * Set default model to pc105 on powerpc/ps3 systems.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 08 Jun 2007 14:12:20 +0100
+
+console-setup (1.16ubuntu3) gutsy; urgency=low
+
+  * Remove 'exit 0' from the end of debian/config.proto; this will be
+    sourced from the postinst in the installer, and exiting in the
+    successful case means that /etc/default/console-setup never gets
+    generated (thanks, Evan Dandrea).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 04 Jun 2007 22:53:23 +0100
+
+console-setup (1.16ubuntu2) gutsy; urgency=low
+
+  * Make Keyboard/keymaptree executable again.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sun, 03 Jun 2007 21:30:57 +0100
+
+console-setup (1.16ubuntu1) gutsy; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Only default to Canadian layout for fr_CA; use U.S. English for other
+      *_CA locales.
+    - Set default charmap for d-i to UTF-8.
+    - Remove unhelpful defaults for several questions.
+    - Allow preseeding of console-setup/modelcode, console-setup/layoutcode,
+      console-setup/variantcode, console-setup/optionscode, and
+      console-setup/fontsize.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Add a few bits of installer integration to console-setup-udeb borrowed
+      from kbd-chooser.
+    - console-setup Depends: perl; something in ckbcomp is causing perl to
+      'use utf8' implicitly, and some of the necessary modules aren't in
+      perl-base.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Use 'setupcon --save-only' to make sure the font is available on the
+      root filesystem for the next boot but not to load it immediately,
+      avoiding console manipulation when X or usplash is running.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - debian/config.proto: Set sparc default model to pc105.
+    - debian/control: Remove outdated note about loadkeys in
+      console-setup-udeb's description.
+  * Allow kbd's initramfs hook as an alternative to that provided by
+    console-tools.
+  * Don't run 'setupcon -k' from rcS if usplash is running, as that means
+    the console will be in raw mode and loadkeys will do confusing things to
+    the keymap (LP: #84156).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sun, 03 Jun 2007 14:53:42 +0100
+
 console-setup (1.16) unstable; urgency=low
 
   * Update ckbconf with the most recent list of xkeysyms.
@@ -2633,6 +4738,73 @@ console-setup (1.16) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Tue,  1 May 2007 23:48:12 +0300
 
+console-setup (1.15ubuntu1) gutsy; urgency=low
+
+  * Resynchronise with Debian (LP: #94177). Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Ship MyKeyboardNames.pl (as KeyboardNames.pl) and kbdnames-maker in
+      /usr/share/console-setup.
+    - Only default to Canadian layout for fr_CA; use U.S. English for other
+      *_CA locales.
+    - Fix default layout for Bosnian and default variant for Hindi.
+    - Set default charmap for d-i to UTF-8.
+    - Remove unhelpful defaults for several questions.
+    - Adjust the default keyboard model for Brazilian and Japanese layouts.
+    - Allow preseeding of console-setup/modelcode, console-setup/layoutcode,
+      console-setup/variantcode, console-setup/optionscode, and
+      console-setup/fontsize.
+    - Use jp(latin),jp rather than us,jp by default for Japanese.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Add a few bits of installer integration to console-setup-udeb borrowed
+      from kbd-chooser.
+    - console-setup Depends: perl; something in ckbcomp is causing perl to
+      'use utf8' implicitly, and some of the necessary modules aren't in
+      perl-base.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Map fr_CH to ch(fr) (Swiss French).
+    - Fix codeset question priority for Esperanto.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Add a --save-only option to setupcon, to save the keyboard/font on the
+      root filesystem but not actually tell the kernel to set it up. Use it
+      to make sure the font is available on the root filesystem for the next
+      boot but not to load it immediately, avoiding console manipulation
+      when X or usplash is running.
+    - Set keymap and font in the initramfs if possible.
+    - Add lt to list of non-Latin keymaps.
+    - Set default variant for French to oss.
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - Source debconf confmodule earlier in postinst.
+    - Fix horrible confusion if the locale has no supported default codeset.
+    - Fix console-setup/codeset default to be one of the available choices.
+    - Don't set an AltGr key by default for US layouts.
+    - Add amiga, ataritt, sun4, and sun5 models, since they are used as
+      defaults on certain architectures.
+    - Map keycode 133 to AT scancode 124 for Japanese.
+  * debian/config.proto: Set sparc default model to pc105 (LP: #105595).
+  * debian/control: Multiply Installer-Menu-Item number by 100.
+  * debian/control: Remove outdated note about loadkeys in
+    console-setup-udeb's description.
+  * debian/console-setup.postinst: Drop font fixups for upgrades from
+    development versions of Edgy.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 25 Apr 2007 11:52:52 +0100
+
 console-setup (1.15) unstable; urgency=low
 
   * Updated Georgian letters for Fixed16 and Fixed14.  Thanks to Vladimer
@@ -2651,6 +4823,171 @@ console-setup (1.14) unstable; urgency=l
 
  -- Christian Perrier <bubulle@debian.org>  Sun,  4 Mar 2007 19:54:11 +0100
 
+console-setup (1.13ubuntu13) feisty; urgency=low
+
+  * debian/console-setup.console-setup.init: Don't break if fgconsole fails.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 10 Apr 2007 16:16:08 +0100
+
+console-setup (1.13ubuntu12) feisty; urgency=low
+
+  * Map keycode 133 to AT scancode 124 for Japanese (thanks, Jun Kobayashi;
+    LP: #97466).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed,  4 Apr 2007 16:48:15 +0100
+
+console-setup (1.13ubuntu11) feisty; urgency=low
+
+  * Add amiga, ataritt, sun4, and sun5 models, since they are used as
+    defaults on certain architectures (LP: #97225).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed,  4 Apr 2007 10:11:03 +0100
+
+console-setup (1.13ubuntu10) feisty; urgency=low
+
+  * Source debconf confmodule earlier in postinst (it should always be
+    sourced as early as possible, as it re-executes the calling script).
+  * Fix horrible confusion if the locale has no supported default codeset
+    (LP: #84401).
+  * Fix console-setup/codeset default to be one of the available choices.
+  * Try harder to ensure that we aren't running under X when deciding
+    whether to run setupcon on upgrade (thanks to Kurt J. Bosch for
+    suggestions; LP: #93338).
+  * Don't set an AltGr key by default for US layouts (LP: #76901).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sun,  1 Apr 2007 16:49:02 +0100
+
+console-setup (1.13ubuntu9) feisty; urgency=low
+
+  * Keyboard/kbdcompiler: Fix keymap reduction not to try to express keymap
+    A in terms of keymap B when B includes keys not mapped by A, fixing a
+    number of incorrectly-reduced keymaps (LP: #74375).
+  * Keyboard/kbdcompiler: Update handling of jp to match
+    debian/config.proto.
+  * Keyboard/keymaptree.use: Remove jp; we cannot detect it correctly
+    without further intelligence, as it's designed for jp106 keyboard
+    models.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sat, 17 Mar 2007 10:06:05 +0000
+
+console-setup (1.13ubuntu8) feisty; urgency=low
+
+  * Fix handling of commas in layout and variant names.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri,  9 Mar 2007 20:05:00 +0000
+
+console-setup (1.13ubuntu7) feisty; urgency=low
+
+  * Add lt to list of non-Latin keymaps (LP: #38931).
+  * Map Caps Lock to Shift Lock for Turkish layouts.
+  * Build keymap tree from MyKeyboardNames.pl rather than KeyboardNames.pl.
+  * Add fr:oss to keymap tree.
+  * Set default variant for French to oss (LP: #89835).
+  * Remove Keyboard/*.tree on clean.
+  * Fix six files in debian/ that were supposed to be symlinks.
+  * Move console-setup-udeb's post-base-installer script to be a
+    base-installer script instead, so that console-setup will be configured
+    properly along with the initramfs during debootstrap.
+  * Set Maintainer to me.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue,  6 Mar 2007 12:09:57 +0000
+
+console-setup (1.13ubuntu6) feisty; urgency=low
+
+  * Set keymap and font in the initramfs if possible. Setting these as early
+    as possible is a good thing; we can't set up the font correctly once
+    usplash is running; and setting up the font between usplash and X
+    requires an ugly mode switch.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 22 Jan 2007 14:21:24 +0000
+
+console-setup (1.13ubuntu5) feisty; urgency=low
+
+  * Add a --save-only option to setupcon, to save the keyboard/font on the
+    root filesystem but not actually tell the kernel to set it up.
+  * Back out part of setup-console-under-usplash changes: attempts to change
+    the font must be guarded against being run while on an X display or
+    while usplash is running, because some kernel console drivers (at least
+    vgacon) are fundamentally unable to change the font only on some virtual
+    consoles, and will corrupt video memory if you try (LP: #73955). We now
+    use setupcon --save-only to make sure the font is available on the root
+    filesystem for the next boot but don't load it immediately.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Jan 2007 20:08:33 +0000
+
+console-setup (1.13ubuntu4) feisty; urgency=low
+
+  * Include ro(std) in keymap tree, after talking with Eddy PetriÅor.
+  * Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+    non-ASCII letters; the cure is worse than the disease because it makes
+    Caps Lock equivalent to Shift Lock (LP: #69725).
+  * Install MyKeyboardNames.pl (built from /usr/share/X11/xkb) rather than
+    KeyboardNames.pl (built from the out-of-date copy in Keyboard/ckb) as
+    /usr/share/console-setup/KeyboardNames.pl (LP: #71864).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri,  5 Jan 2007 14:15:04 +0000
+
+console-setup (1.13ubuntu3) feisty; urgency=low
+
+  * Remove ch(fr) from keymap tree again; it's not distinguishable from ch
+    without checking shift key state, which keymapper currently doesn't do.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 29 Nov 2006 11:28:48 +0000
+
+console-setup (1.13ubuntu2) feisty; urgency=low
+
+  * Make Keyboard/keymaptree executable again.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 28 Nov 2006 20:09:22 +0000
+
+console-setup (1.13ubuntu1) feisty; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Ship KeyboardNames.pl and kbdnames-maker in /usr/share/console-setup.
+    - Only default to Canadian layout for fr_CA; use U.S. English for other
+      *_CA locales.
+    - Fix default layout for Bosnian and default variant for Hindi.
+    - Set default charmap for d-i to UTF-8.
+    - Remove unhelpful defaults for several questions.
+    - Adjust the default keyboard model for Brazilian and Japanese layouts.
+    - Allow preseeding of console-setup/modelcode, console-setup/layoutcode,
+      console-setup/variantcode, console-setup/optionscode, and
+      console-setup/fontsize.
+    - Use jp(latin),jp rather than us,jp by default for Japanese.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Skip now-unnecessary console check in init scripts.
+    - Fix up font face and size on upgrading from old versions in Edgy.
+    - Add a few bits of installer integration to console-setup-udeb borrowed
+      from kbd-chooser.
+    - console-setup Depends: perl; something in ckbcomp is causing perl to
+      'use utf8' implicitly, and some of the necessary modules aren't in
+      perl-base.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+  * Restore udeb generation.
+
+  * Map fr_CH to ch(fr) (Swiss French).
+  * Include ch(fr) in keymap tree.
+  * Fix codeset question priority for Esperanto.
+  * Remove X and usplash checks in keyboard-setup and console-setup init
+    scripts, since neither are needed following the fix in console-setup
+    1.7ubuntu19.
+  * Allow setupcon to be run on install again, for the same reason.
+  * Automatically save the font and keymap to /etc in
+    /etc/init.d/console-setup if it isn't being run from init; this allows
+    us to tolerate XKB data being moved to /usr. Similarly, ensure that the
+    font and keymap are saved to /etc during initial installation.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 24 Nov 2006 18:09:32 +0000
+
 console-setup (1.13) unstable; urgency=low
 
   * Unfuzzy the translations.
@@ -2736,6 +5073,202 @@ console-setup (1.8) unstable; urgency=lo
 
  -- Anton Zinoviev <zinoviev@debian.org>  Tue, 19 Sep 2006 11:56:15 +0300
 
+console-setup (1.7ubuntu19) edgy; urgency=low
+
+  * If upgrading from an older version than this one, check for the Terminus
+    font face and change it to VGA (if you do like it, you can change it
+    back and it won't be touched again). If Terminus was in use, also check
+    for the 12x6 font size and change it to 16, since that was apparently
+    selected due to a strange use-of-debconf bug.
+  * Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+    tty, since the current tty might belong to X and changing X's tty out of
+    raw mode is a very bad idea (closes: Malone #66929; requires kbd 1.12-15
+    or console-tools 1:0.2.3dbs-62ubuntu10).
+  * Adjust the default keyboard model for Brazilian (closes: Malone #66774)
+    and Japanese (closes: Malone #66719) layouts.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 20 Oct 2006 20:16:09 +0100
+
+console-setup (1.7ubuntu18) edgy; urgency=low
+
+  * Change the default font to VGA where supported; Terminus does not seem
+    to have widespread aesthetic appeal.
+  * Use jp(latin),jp rather than us,jp by default for Japanese, and set the
+    model to jp106 (closes: Malone #63915).
+  * Build-depend on keymapper (>= 0.5.3-7) for improved Alt-handling logic.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 12 Oct 2006 02:42:15 +0100
+
+console-setup (1.7ubuntu17) edgy; urgency=low
+
+  * Only default to Canadian layout for fr_CA; use U.S. English for other
+    *_CA locales (closes: Malone #64418).
+  * Install kbdnames-maker in /usr/share/console-setup, to make it easier
+    for non-Perl programs to use KeyboardNames.pl.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 11 Oct 2006 12:52:36 +0100
+
+console-setup (1.7ubuntu16) edgy; urgency=low
+
+  * Backport from trunk (Anton Zinoviev, closes: Malone #63921):
+    - New mini-font georgian16.bdf to be used for the Georgian letters in
+      Fixed16, author: Gia Shervashidze.  Thanks to Vladimer Sichinava.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed,  4 Oct 2006 11:37:15 +0100
+
+console-setup (1.7ubuntu15) edgy; urgency=low
+
+  * Fix build failure caused by wrong path to KeyboardNames.pl.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue,  3 Oct 2006 15:44:59 +0100
+
+console-setup (1.7ubuntu14) edgy; urgency=low
+
+  * Ship KeyboardNames.pl in /usr/share/console-setup.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue,  3 Oct 2006 11:09:27 +0100
+
+console-setup (1.7ubuntu13) edgy; urgency=low
+
+  * Remove obsolete XORGCONFIGFILE variable.
+  * Reset console-setup/toggle to the default if it's set to "No toggling"
+    and you select a non-Latin layout (closes: Malone #63178).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon,  2 Oct 2006 14:47:58 +0100
+
+console-setup (1.7ubuntu12) edgy; urgency=low
+
+  * Don't run the init script (and thereby setupcon) on upgrade; just print
+    a message telling you to run setupcon from a virtual console if you want
+    to update your console configuration (closes: Malone #61723).
+  * Update debian-installer/keymap handling from trunk (Anton Zinoviev).
+    Drop /etc/X11/xorg.conf upgrade handling, also per trunk, as I've been
+    convinced that that is much less safe due to the prevalence of GNOME/KDE
+    keymap overrides, and furthermore it made it more difficult to have
+    ubiquity tell console-setup just to guess a default from the locale.
+  * Drop the priority of the model and layout questions to medium if a
+    configuration file already exists, since they'll have been asked at
+    medium first time round and if we then ask them at critical the second
+    time round they will be unexpectedly shown (closes: Malone #59883).
+  * Backport from trunk:
+    - config.proto: Handle properly the case when the user backs up from the
+      first Debconf question.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sat, 23 Sep 2006 00:40:48 +0100
+
+console-setup (1.7ubuntu11) edgy; urgency=low
+
+  * Fix default layout for Bosnian and default variant for Hindi.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 22 Sep 2006 15:57:23 +0100
+
+console-setup (1.7ubuntu10) edgy; urgency=low
+
+  * console-setup Depends: perl; something in ckbcomp is causing perl to
+    'use utf8' implicitly, and some of the necessary modules aren't in
+    perl-base (closes: Malone #60203).
+  * Allow preseeding of console-setup/modelcode, console-setup/layoutcode,
+    console-setup/variantcode, console-setup/optionscode, and
+    console-setup/fontsize.
+  * Don't set up the console font at boot time if usplash is running, since
+    that seems to trigger a kernel bug that corrupts the usplash display
+    (closes: Malone #60483).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 21 Sep 2006 01:01:54 +0100
+
+console-setup (1.7ubuntu9) edgy; urgency=low
+
+  * Switch build-dependency and dependency back to xkb-data, now that it's
+    fixed. Make the dependencies versioned until after Edgy is released to
+    avoid problems with partially-upgraded systems where only the broken
+    xkb-data is installed.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 13 Sep 2006 10:24:20 +0100
+
+console-setup (1.7ubuntu8) edgy; urgency=low
+
+  * Add setupcon --force option and use it in postinst (Anton Zinoviev,
+    http://lists.alioth.debian.org/pipermail/pkg-kbd-devel/2006-August/000278.html).
+  * Check $DISPLAY rather than /proc/self/fd/2 in /etc/init.d/keyboard-setup
+    and /etc/init.d/console-setup; use setupcon --force.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 11 Sep 2006 09:47:36 +0100
+
+console-setup (1.7ubuntu7) edgy; urgency=low
+
+  * Handle debian-installer/locale not being available (closes: Malone
+    #59718).
+  * Remove stray Keyboard/amiga.ekmap in source package.
+  * Fix a potential infinite loop in the config script while moving past the
+    variant question with an unsupported layout.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sun, 10 Sep 2006 12:07:53 +0100
+
+console-setup (1.7ubuntu6) edgy; urgency=low
+
+  * If there's no console-setup configuration when console-setup.config
+    runs, then:
+    - If there is an xorg.conf, set the defaults from there.
+    - Failing that, if debian-installer/keymap is set, try to guess correct
+      defaults from that using the same algorithm as formerly applied by
+      xserver-xorg.config. The only serious change I made to the algorithm
+      is that it now maps (mac-usb-)uk to plain gb, not gb(intl), since
+      that's closer to what UK keyboard users generally expect.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri,  8 Sep 2006 00:13:26 +0100
+
+console-setup (1.7ubuntu5) edgy; urgency=low
+
+  * Only call setupcon from postinst script if /lib/debian-installer exists,
+    to make sure we're really in d-i. (Calling setupcon from X appears to
+    make things rather messy.)
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu,  7 Sep 2006 17:11:12 +0100
+
+console-setup (1.7ubuntu4) edgy; urgency=low
+
+  * Remove cs from the list of non-Latin layouts, as it has special
+    per-variant handling.
+  * Fix syntax error in config script.
+  * Don't try to use the detect-keyboard plugin if running noninteractively.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu,  7 Sep 2006 15:39:38 +0100
+
+console-setup (1.7ubuntu3) edgy; urgency=low
+
+  * Use keymapper to generate decision trees for a restricted subset of the
+    pc105 model. (I tried building trees for the whole model, but this took
+    far too long.)
+  * If the detect-keyboard debconf plugin is available
+    (cdebconf-newt-detect-keys in the installer), then offer to use it to
+    detect the keyboard layout.
+  * Fix debian/po/POTFILES.in to point to console-setup.templates.
+  * Make console-setup-udeb depend on console-setup-fonts-udeb, at least for
+    now.
+  * Convert init script to LSB logging functions.
+  * Add a few bits of installer integration to console-setup-udeb borrowed
+    from kbd-chooser (/lib/debian-installer.d/S55console-setup,
+    post-base-installer hook).
+  * Temporarily build-depend and depend on just xkeyboard-config to work
+    around Malone #59220.
+  * Set default charmap for d-i to UTF-8.
+  * Remove unhelpful "none" defaults for several questions.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu,  7 Sep 2006 09:18:42 +0100
+
+console-setup (1.7ubuntu2) edgy; urgency=low
+
+  * Make console-setup-udeb depend on console-tools-udeb.
+
+ -- Tollef Fog Heen <tfheen@ubuntu.com>  Wed, 23 Aug 2006 14:36:58 +0200
+
+console-setup (1.7ubuntu1) edgy; urgency=low
+
+  * Call setupcon with input and output from /dev/tty in postinst and make
+    sure setupcon understands that properly.
+
+ -- Tollef Fog Heen <tfheen@ubuntu.com>  Wed, 23 Aug 2006 12:54:27 +0200
+
 console-setup (1.7) unstable; urgency=low
 
   [ Christian Perrier ]
@@ -2843,3 +5376,4 @@ console-setup (1.0) unstable; urgency=lo
     and pointing few typos).
 
  -- Anton Zinoviev <zinoviev@debian.org>  Sat, 14 Jan 2006 16:20:35 +0200
+
diff -pruN 1.195/debian/changelog 1.195ubuntu1/debian/changelog
--- 1.195/debian/changelog	2020-03-26 13:34:12.000000000 +0000
+++ 1.195ubuntu1/debian/changelog	2020-05-21 00:17:51.000000000 +0000
@@ -1,3 +1,91 @@
+console-setup (1.195ubuntu1) groovy; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - debian/clean: Delete Keyboard/tree-keymaps/ on clean
+    - Add an apport hook.
+    - If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+      on kFreeBSD; otherwise restore the previous behaviour from before the
+      kFreeBSD port of using UTF-8 in that case.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.service, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Handle unattended upgrades without breaking plymouth when updating
+      console fonts.
+    - Tolerate absence of setupcon in postinst scripts.  Should be fixed by
+      refactoring to not have a keyboard-configuration package that needs to
+      call setupcon without depending on it.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Added templates for keyboard detection.
+    - debian/control: drop freebsd-specific packages.
+    - debian/control: we also need xkb-data-i18n as a Build-Depends-Indep to
+      build a complete set of translated keyboard layout/variant names.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - keyboard-configuration.config: While sourcing config files to re-seed
+      debconf, treat missing XKBOPTIONS as empty.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - debian/keyboard-configuration.config: lower the priority for the layout
+      question.
+    - Map ppc64el/* to XKBMODEL=pc105.
+    - Set default layout for Kurdish to tr(ku).
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - debian/keyboard-configuration.config: Drop the xkb-keymap bits once
+      again as we're not ready for those yet, as it's currently causing an
+      invalid default layout in the installer.
+    - keyboard-configuration.{config,templates}: There is no good default
+      for layout toggling, stop pretending there is.  Console users can set
+      one with dpkg-reconfigure or editing /etc/defaults/keyboard
+    - keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+    - debian/preprocessor: revert the removal of keyboard names (for size) of
+      console-setup-udeb: we do need those, since we don't use the simplified
+      xkb-keymap template from Debian just yet: this way we can still show
+      country/language names when selecting a keyboard, layout or variant.
+    - debian/rules: revert hard-coding of a list of "debconf-selectable"
+      layouts for the udebs, since we don't use this debconf question in Ubuntu
+      and all layouts are selectable.
+    - Make COPYRIGHT a symlink to debian/copyright.
+    - Don't cat over the keymaps; they're already moved to the right place.
+    - Add Keyboard/Makefile rule to build pc105.tree.
+    - Include pc105.tree for ubiquity; make sure it gets built.
+    - Fix command injection in ckbcomp.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - Keyboard/Makefile: make sure KeyboardNames.pl is built with accurate data
+      from xkb-data.
+    - xmlreader, KeyboardNames.pl: Added model entry to skip model selection.
+    - Make sure we give a meaningful name to ch layouts: "Switzerland" instead
+      of "German (Switzerland), since it includes French too.
+    - setupcon:
+      - use only /run for tempfiles with /tmp as a non-root fallback.
+      - handle compressed console maps and font files.
+      - Map XKBMODEL=SKIP to '' for compatibility with existing
+        configs.
+      - the variables are taken from a config file which, if changed,
+        invalidates the cache.
+      - there is only ever one keyboard map per system.
+      - the system should not have to resolve filenames to find the keymap
+        cache on boot.
+      - Explicitly exit 0, so that postinsts don't fail in the event that
+        loadkeys can't find a console.
+    - debian/control: Build depend on keymapper
+    - debian/keyboard-configuration.config:
+      - change back the french default layout to be fr+oss and not fr+latin9
+        the change was dropped by error in a previous merge
+  * Dropped changes, included in Debian:
+    - keyboard-configuration.config:
+      replace not intuitive second lt(us) layout with us(altgr-intl),
+      which contains Euro (€) and other symbols, often used in Lithuania.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 20 May 2020 17:17:51 -0700
+
 console-setup (1.195) unstable; urgency=medium
 
   [ Mantas Kriaučiūnas ]
@@ -12,6 +100,107 @@ console-setup (1.195) unstable; urgency=
 
  -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 26 Mar 2020 13:34:12 +0000
 
+console-setup (1.194ubuntu3) focal; urgency=medium
+
+  [ Mantas Kriaučiūnas ]
+  * keyboard-configuration.config:: 
+    replace not intuitive second lt(us) layout with us(altgr-intl),
+    which contains Euro (€) and other symbols, often used in Lithuania.
+    (lp: #1863001)
+
+ -- Sebastien Bacher <seb128@ubuntu.com>  Fri, 27 Mar 2020 11:10:06 +0100
+
+console-setup (1.194ubuntu2) focal; urgency=medium
+
+  * debian/keyboard-configuration.config:
+    - change back the french default layout to be fr+oss and not fr+latin9
+      the change was dropped by error in a previous merge
+
+ -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 05 Dec 2019 15:09:57 +0100
+
+console-setup (1.194ubuntu1) focal; urgency=medium
+
+  * Merge from Debian unstable.  Remaining changes:
+    - debian/clean: Delete Keyboard/tree-keymaps/ on clean
+    - Add an apport hook.
+    - If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+      on kFreeBSD; otherwise restore the previous behaviour from before the
+      kFreeBSD port of using UTF-8 in that case.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.service, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Handle unattended upgrades without breaking plymouth when updating
+      console fonts.
+    - Tolerate absence of setupcon in postinst scripts.  Should be fixed by
+      refactoring to not have a keyboard-configuration package that needs to
+      call setupcon without depending on it.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Added templates for keyboard detection.
+    - debian/control: drop freebsd-specific packages.
+    - debian/control: we also need xkb-data-i18n as a Build-Depends-Indep to
+      build a complete set of translated keyboard layout/variant names.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - keyboard-configuration.config: While sourcing config files to re-seed
+      debconf, treat missing XKBOPTIONS as empty.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - debian/keyboard-configuration.config: lower the priority for the layout
+      question.
+    - Map ppc64el/* to XKBMODEL=pc105.
+    - Set default layout for Kurdish to tr(ku).
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - debian/keyboard-configuration.config: Drop the xkb-keymap bits once
+      again as we're not ready for those yet, as it's currently causing an
+      invalid default layout in the installer.
+    - keyboard-configuration.{config,templates}: There is no good default
+      for layout toggling, stop pretending there is.  Console users can set
+      one with dpkg-reconfigure or editing /etc/defaults/keyboard
+    - keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+    - debian/preprocessor: revert the removal of keyboard names (for size) of
+      console-setup-udeb: we do need those, since we don't use the simplified
+      xkb-keymap template from Debian just yet: this way we can still show
+      country/language names when selecting a keyboard, layout or variant.
+    - debian/rules: revert hard-coding of a list of "debconf-selectable"
+      layouts for the udebs, since we don't use this debconf question in Ubuntu
+      and all layouts are selectable.
+    - Make COPYRIGHT a symlink to debian/copyright.
+    - Don't cat over the keymaps; they're already moved to the right place.
+    - Add Keyboard/Makefile rule to build pc105.tree.
+    - Include pc105.tree for ubiquity; make sure it gets built.
+    - Fix command injection in ckbcomp.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - Keyboard/Makefile: make sure KeyboardNames.pl is built with accurate data
+      from xkb-data.
+    - xmlreader, KeyboardNames.pl: Added model entry to skip model selection.
+    - Make sure we give a meaningful name to ch layouts: "Switzerland" instead
+      of "German (Switzerland), since it includes French too.
+    - setupcon:
+      - use only /run for tempfiles with /tmp as a non-root fallback.
+      - handle compressed console maps and font files.
+      - Map XKBMODEL=SKIP to '' for compatibility with existing
+        configs.
+      - the variables are taken from a config file which, if changed,
+        invalidates the cache.
+      - there is only ever one keyboard map per system.
+      - the system should not have to resolve filenames to find the keymap
+        cache on boot.
+      - Explicitly exit 0, so that postinsts don't fail in the event that
+        loadkeys can't find a console.
+  * Dropped changes:
+    - kbdnames-maker: Call `{bind,}textdomain` after switching locale.
+  * debian/control: Build depend on keymapper
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Wed, 27 Nov 2019 15:34:42 +0100
+
 console-setup (1.194) unstable; urgency=medium
 
   * Team upload
@@ -45,6 +234,109 @@ console-setup (1.192) unstable; urgency=
 
  -- Cyril Brulebois <kibi@debian.org>  Thu, 04 Jul 2019 17:41:47 +0200
 
+console-setup (1.191ubuntu3) eoan; urgency=medium
+
+  * No change rebuild to include all previous changes
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Tue, 23 Apr 2019 13:38:57 +0200
+
+console-setup (1.191ubuntu2) eoan; urgency=medium
+
+  * Call setupcon --force only when debian-installer is active
+    and always redirect output to /dev/null to not block. (LP: #520546)
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Tue, 23 Apr 2019 13:08:17 +0200
+
+console-setup (1.191ubuntu1) eoan; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - debian/clean: Delete Keyboard/tree-keymaps/ on clean
+    - Add an apport hook.
+    - If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+      on kFreeBSD; otherwise restore the previous behaviour from before the
+      kFreeBSD port of using UTF-8 in that case.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.service, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Handle unattended upgrades without breaking plymouth when updating
+      console fonts.
+    - Tolerate absence of setupcon in postinst scripts.  Should be fixed by
+      refactoring to not have a keyboard-configuration package that needs to
+      call setupcon without depending on it.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Added templates for keyboard detection.
+    - debian/control: drop freebsd-specific packages.
+    - debian/control: we also need xkb-data-i18n as a Build-Depends-Indep to
+      build a complete set of translated keyboard layout/variant names.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - keyboard-configuration.config: While sourcing config files to re-seed
+      debconf, treat missing XKBOPTIONS as empty.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - debian/keyboard-configuration.config: lower the priority for the layout
+      question.
+    - Map ppc64el/* to XKBMODEL=pc105.
+    - Set default layout for Kurdish to tr(ku).
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - debian/keyboard-configuration.config: Drop the xkb-keymap bits once
+      again as we're not ready for those yet, as it's currently causing an
+      invalid default layout in the installer.
+    - keyboard-configuration.{config,templates}: There is no good default
+      for layout toggling, stop pretending there is.  Console users can set
+      one with dpkg-reconfigure or editing /etc/defaults/keyboard
+    - keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+    - debian/preprocessor: revert the removal of keyboard names (for size) of
+      console-setup-udeb: we do need those, since we don't use the simplified
+      xkb-keymap template from Debian just yet: this way we can still show
+      country/language names when selecting a keyboard, layout or variant.
+    - debian/rules: revert hard-coding of a list of "debconf-selectable"
+      layouts for the udebs, since we don't use this debconf question in Ubuntu
+      and all layouts are selectable.
+    - Make COPYRIGHT a symlink to debian/copyright.
+    - Don't cat over the keymaps; they're already moved to the right place.
+    - Add Keyboard/Makefile rule to build pc105.tree.
+    - Include pc105.tree for ubiquity; make sure it gets built.
+    - Fix command injection in ckbcomp.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - kbdnames-maker: Call `{bind,}textdomain` after switching locale.
+    - Keyboard/Makefile: make sure KeyboardNames.pl is built with accurate data
+      from xkb-data.
+    - xmlreader, KeyboardNames.pl: Added model entry to skip model selection.
+    - Make sure we give a meaningful name to ch layouts: "Switzerland" instead
+      of "German (Switzerland), since it includes French too.
+    - setupcon:
+      - use only /run for tempfiles with /tmp as a non-root fallback.
+      - handle compressed console maps and font files.
+      - Map XKBMODEL=SKIP to '' for compatibility with existing
+        configs.
+      - the variables are taken from a config file which, if changed,
+        invalidates the cache.
+      - there is only ever one keyboard map per system.
+      - the system should not have to resolve filenames to find the keymap
+        cache on boot.
+      - Explicitly exit 0, so that postinsts don't fail in the event that
+        loadkeys can't find a console.
+  * Dropped changes:
+    - drop handling of obsolete upstart jobs, not needed post-18.04.
+    - drop breaks/replaces on ancient keyboard-configuration package.
+    - keyboard-configuration.config: drop layout migration code, which
+      definitely predates bionic.
+  * debian/console-setup.initramfs-top: only ever initialize /dev/tty1.  We
+    do not ever use more than 1 VT in the initramfs, and we reinitialize
+    anyway from the rootfs so this saves us no time (and in fact wastes a
+    lot of time in some configurations).  LP: #1823327.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 22 Apr 2019 07:27:25 -0700
+
 console-setup (1.191) unstable; urgency=medium
 
   * Team upload
@@ -228,6 +520,184 @@ console-setup (1.179) unstable; urgency=
 
  -- Christian Perrier <bubulle@debian.org>  Mon, 12 Mar 2018 19:12:28 +0100
 
+console-setup (1.178ubuntu12) disco; urgency=medium
+
+  * setupcon: use /run for tempfiles (and dump the various unnecessary
+    fallback paths), since /run is always mountable rw at least as early as
+    /tmp is and is guaranteed to be safe from tmpcleaners at boot.  Only keep
+    /tmp as a fallback in case we have access to write to /tmp and to a
+    console, but not to /run.  LP: #1824227.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 10 Apr 2019 12:51:56 -0700
+
+console-setup (1.178ubuntu11) disco; urgency=medium
+
+  * kbdnames-maker: Call `{bind,}textdomain` after switching locale.
+    There's a change in perl 5.28 to use `uselocale()` & friends instead of
+    gettext directly, to support thread safety. Apparently this causes the
+    results of `gettext()` calls to be cached now where they weren't before,
+    and this breaks our keyboard name generation. For example, we have
+    `en_GB*model*sun_type6_jp*Sun Type 6 (Japonesa)` instead of
+    `en_GB*model*sun_type6_jp*Sun Type 6 (Japanese)`, and many many other
+    examples.  Calling `bindtextdomain()` and then `textdomain()` after
+    changing locale causes the cache to be invalidated and we get correct
+    results again. LP: #1817453
+
+ -- Iain Lane <iain@orangesquash.org.uk>  Fri, 15 Mar 2019 12:34:06 +0000
+
+console-setup (1.178ubuntu10) disco; urgency=medium
+
+  * No-change rebuild to pick up any new keyboard data. Resolves crash
+    in Ubiquity KDE front end on non English language selection. (LP: #1810647)
+
+ -- Rik Mills <rikmills@kubuntu.org>  Wed, 23 Jan 2019 07:34:00 +0000
+
+console-setup (1.178ubuntu9) cosmic; urgency=medium
+
+  * keyboard-configuration.config: Fix exit/return thinko (LP: #1788597)
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Thu, 23 Aug 2018 16:32:45 -0600
+
+console-setup (1.178ubuntu8) cosmic; urgency=medium
+
+  * keyboard-configuration.config: Only treat missing XKBOPTIONS as empty.
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Wed, 08 Aug 2018 17:32:23 -0600
+
+console-setup (1.178ubuntu7) cosmic; urgency=medium
+
+  * keyboard-configuration.config: While sourcing config files to re-seed
+    debconf, load missing variables as empty values of same (LP: #1762952)
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Wed, 08 Aug 2018 16:50:48 -0600
+
+console-setup (1.178ubuntu6) cosmic; urgency=medium
+
+  * keyboard-configuration.{config,templates}: There is no good default for
+    layout toggling, stop pretending there is.  Console users can set one
+    with dpkg-reconfigure or editing /etc/defaults/keyboard (LP: #1762952)
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Wed, 25 Jul 2018 05:50:59 -0600
+
+console-setup (1.178ubuntu5) cosmic; urgency=medium
+
+  * Revert to 1.178ubuntu2, as 1.178ubuntu[34] caused an installer regression.
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Tue, 24 Jul 2018 19:34:59 -0600
+
+console-setup (1.178ubuntu4) cosmic; urgency=medium
+
+  * debian/console-setup-udeb.postinst: Guard the dpkg call in the postinst,
+    so it isn't attempted in the debian-installer environment (LP: #1782835)
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Fri, 20 Jul 2018 14:22:45 -0600
+
+console-setup (1.178ubuntu3) cosmic; urgency=medium
+
+  * debian/keyboard-configuration.postinst:
+    - Don't change /etc/default/keyboard at package upgrades on
+      desktops, since it may conflict with how desktops deal with
+      keyboard configuration (LP: #1762952).
+
+ -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Tue, 15 May 2018 01:12:00 +0200
+
+console-setup (1.178ubuntu2) bionic; urgency=medium
+
+  * debian/keyboard-configuration.config:
+    - Drop the xkb-keymap bits once again as we're not ready for those yet, as
+      it's currently causing an invalid default layout in the installer.
+      (LP: #1758647)
+
+ -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 19 Apr 2018 08:53:32 +0200
+
+console-setup (1.178ubuntu1) bionic; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - Add an apport hook.
+    - If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+      on kFreeBSD; otherwise restore the previous behaviour from before the
+      kFreeBSD port of using UTF-8 in that case.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.service, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Tolerate absence of setupcon in postinst scripts.
+    - Added templates for keyboard detection.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - Map ppc64el/* to XKBMODEL=pc105.
+    - keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+    - debian/preprocessor: revert the removal of keyboard names (for size) of
+      console-setup-udeb: we do need those, since we don't use the simplified
+      xkb-keymap template from Debian just yet: this way we can still show
+      country/language names when selecting a keyboard, layout or variant.
+    - Don't make debian/copyright a symlink to COPYRIGHT, this is disallowed
+      by the Ubuntu archive installer.
+    - Include pc105.tree for ubiquity; make sure it gets built.
+    - Add Keyboard/Makefile rule to build pc105.tree.
+    - Fix command injection in ckbcomp.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - xmlreader, KeyboardNames.pl: Added model entry to skip model selection.
+    - setupcon:
+      - the variables are taken from a config file which, if changed,
+        invalidates the cache.
+      - there is only ever one keyboard map per system.
+      - the system should not have to resolve filenames to find the keymap cache
+        on boot.
+      - Map XKBMODEL=SKIP to '' for compatibility with existing
+        configs.
+      - Explicitly exit 0, so that postinsts don't fail in the event that
+        loadkeys can't find a console.
+    - Handle unattended upgrades without breaking plymouth when updating
+      console fonts.
+    - debian/rules: revert hard-coding of a list of "debconf-selectable"
+      layouts for the udebs, since we don't use this debconf question in Ubuntu
+      and all layouts are selectable.
+    - Make sure we give a meaningful name to ch layouts: "Switzerland" instead
+      of "German (Switzerland), since it includes French too.
+    - Add console-setup-tty and the udev rule that uses it to set Unicode, font,
+      and keyboard mode at early boot.
+    - Keyboard/Makefile: make sure KeyboardNames.pl is built with accurate data
+      from xkb-data.
+    - Don't cat over the keymaps; they're already moved to the right place.
+    - debian/console-setup.postinst: Replace the checking of fgconsole in [1-6]
+      with checking if fgconsole is a tty according to logind. The previous
+      assumption was that a graphical environment would be on vt7, which isn't
+      true with gnome-shell any more.
+    - debian/console-setup.postinst, debian/keyboard-configuration.postinst:
+      Don't call setupcon --force -k any more - it breaks wayland sessions.
+      (LP: #1710637)
+    - debian/control: drop console-setup-freebsd: we don't keep it around since
+      it's uninstallable because vidcontrol/kbdcontrol.
+    - debian/keyboard-configuration.config: re-lower the priority for the layout
+      question that got garbled in the merge.
+    - Don't use console-setup-tty or its udev rule. This dates back to lucid and
+      now systemd is apparently able to handle this correctly. It's now actively
+      breaking graphical sessions. (LP: #1710637) 
+    - debian/control: we also need xkb-data-i18n as a Build-Depends-Indep to
+      build a complete set of translated keyboard layout/variant names.
+    - Drop dependency from console-setup to initramfs-tools |
+      linux-initramfs-tool; this was a versioned dependency used for upgrades,
+      now long obsolete.
+  * Fix previous patches:
+    - Correctly setup console in initramfs again (LP: #1719612)
+    - Make COPYRIGHT a symlink to debian/copyright, and keep various
+      other symlinks in place that were dropped in earlier uploads.
+    - Do some extra work to disable kfreebsd, dh was complaining about
+      unknown packages and failing.
+    - debian/clean: Delete Keyboard/tree-keymaps/ on clean
+
+ -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 19 Feb 2018 09:29:02 +0100
+
 console-setup (1.178) unstable; urgency=medium
 
   [ Updated translations ]
@@ -327,6 +797,122 @@ console-setup (1.167) unstable; urgency=
 
  -- Christian Perrier <bubulle@debian.org>  Fri, 15 Sep 2017 06:16:35 +0200
 
+console-setup (1.166ubuntu7) artful; urgency=medium
+
+  * Drop dependency from console-setup to initramfs-tools |
+    linux-initramfs-tool; this was a versioned dependency used for upgrades,
+    now long obsolete.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 05 Oct 2017 12:04:08 -0700
+
+console-setup (1.166ubuntu6) artful; urgency=medium
+
+  * debian/control: we also need xkb-data-i18n as a Build-Depends-Indep to
+    build a complete set of translated keyboard layout/variant names.
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 28 Sep 2017 17:46:56 -0400
+
+console-setup (1.166ubuntu5) artful; urgency=medium
+
+  * Don't use console-setup-tty or its udev rule. This dates back to lucid and
+    now systemd is apparently able to handle this correctly. It's now actively
+    breaking graphical sessions. (LP: #1710637) 
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 18 Sep 2017 16:36:50 -0400
+
+console-setup (1.166ubuntu4) artful; urgency=medium
+
+  * Keyboard/Makefile: Add a rule to make KeyboardNames.pl, needed by ubiquity
+    (see Debian Bug#874474)
+
+ -- Iain Lane <iain@orangesquash.org.uk>  Wed, 06 Sep 2017 13:39:01 +0100
+
+console-setup (1.166ubuntu3) artful; urgency=medium
+
+  * debian/keyboard-configuration.config: re-lower the priority for the layout
+    question that got garbled in the merge.
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 05 Sep 2017 14:58:49 -0400
+
+console-setup (1.166ubuntu2) artful; urgency=medium
+
+  * debian/control: drop console-setup-freebsd: we don't keep it around since
+    it's uninstallable because vidcontrol/kbdcontrol.
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 23 Aug 2017 19:06:27 -0400
+
+console-setup (1.166ubuntu1) artful; urgency=medium
+
+  [ Mathieu Trudel-Lapierre ]
+  * Merge from Debian unstable; remaining changes:
+    - Add an apport hook.
+    - If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+      on kFreeBSD; otherwise restore the previous behaviour from before the
+      kFreeBSD port of using UTF-8 in that case.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.service, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Tolerate absence of setupcon in postinst scripts.
+    - Added templates for keyboard detection.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - Map ppc64el/* to XKBMODEL=pc105.
+    - keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+    - debian/preprocessor: revert the removal of keyboard names (for size) of
+      console-setup-udeb: we do need those, since we don't use the simplified
+      xkb-keymap template from Debian just yet: this way we can still show
+      country/language names when selecting a keyboard, layout or variant.
+    - Don't make debian/copyright a symlink to COPYRIGHT, this is disallowed
+      by the Ubuntu archive installer.
+    - Include pc105.tree for ubiquity; make sure it gets built.
+    - Add Keyboard/Makefile rule to build pc105.tree.
+    - Fix command injection in ckbcomp.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - xmlreader, KeyboardNames.pl: Added model entry to skip model selection.
+    - setupcon:
+      - the variables are taken from a config file which, if changed,
+        invalidates the cache.
+      - there is only ever one keyboard map per system.
+      - the system should not have to resolve filenames to find the keymap cache
+        on boot.
+      - Map XKBMODEL=SKIP to '' for compatibility with existing
+        configs.
+      - Explicitly exit 0, so that postinsts don't fail in the event that
+        loadkeys can't find a console.
+    - Handle unattended upgrades without breaking plymouth when updating
+      console fonts.
+    - debian/rules: revert hard-coding of a list of "debconf-selectable"
+      layouts for the udebs, since we don't use this debconf question in Ubuntu
+      and all layouts are selectable.
+    - Make sure we give a meaningful name to ch layouts: "Switzerland" instead
+      of "German (Switzerland), since it includes French too.
+    - Add console-setup-tty and the udev rule that uses it to set Unicode, font,
+      and keyboard mode at early boot.
+  * Keyboard/Makefile: make sure KeyboardNames.pl is built with accurate data
+    from xkb-data.
+  * Don't cat over the keymaps; they're already moved to the right place.
+
+  [ Iain Lane ]
+  * debian/console-setup.postinst: Replace the checking of fgconsole in [1-6]
+    with checking if fgconsole is a tty according to logind. The previous
+    assumption was that a graphical environment would be on vt7, which isn't
+    true with gnome-shell any more.
+  * debian/console-setup.postinst, debian/keyboard-configuration.postinst:
+    Don't call setupcon --force -k any more - it breaks wayland sessions.
+    (LP: #1710637)
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 10 Aug 2017 15:06:17 -0400
+
 console-setup (1.166) unstable; urgency=medium
 
   [ Updated translations ]
@@ -534,6 +1120,209 @@ console-setup (1.143) unstable; urgency=
 
  -- Christian Perrier <bubulle@debian.org>  Sun, 22 May 2016 08:47:29 +0200
 
+console-setup (1.142ubuntu8) artful; urgency=medium
+
+  * Drop upstart system jobs.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 21 Aug 2017 16:15:49 +0100
+
+console-setup (1.142ubuntu7) artful; urgency=medium
+
+  * Do the same as ubuntu6 in Keyboard/compose_translator too.
+  * Cherry-pick b887014dc243d3966bbb6bda975803798df7c33f from Samuel Thibaut
+    and 6800af170ff5017b67b7e0b85b61a6176eb56361 from Gregor Hermann, as well
+    as fixing Keyboard/kbdnames - perl doesn't look at `.' any more.
+
+ -- Iain Lane <iain@orangesquash.org.uk>  Mon, 21 Aug 2017 10:48:31 +0100
+
+console-setup (1.142ubuntu6) artful; urgency=medium
+
+  * Use pragma utf8 instead of the deprecated encoding pragma. Shamelessly
+    copied from Debian's 1.143 change by Anton Zinoviev.
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 04 Aug 2017 15:23:53 -0400
+
+console-setup (1.142ubuntu5) yakkety; urgency=medium
+
+  * debian/console-setup-linux.setvtrgb.service: add condition to only
+    execute when /dev/tty0 exists. This is the same condition as used by
+    getty@.service unit to prevent attempting setting up VT when none are
+    present. This is a common case on serial only architectures and
+    virtual machines. Resolves degraded boots on s390x/ppc64el.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 26 Sep 2016 13:31:08 +0100
+
+console-setup (1.142ubuntu4) yakkety; urgency=medium
+
+  * debian/keyboard-configuration.postinst: we shouldn't fail if
+    dpkg-maintscript-helpers can't figure out the package for removal of
+    console-setup and keyboard-setup init scripts -- in ubiquity we won't have
+    the outer checked directory /lib/debian-installer.d; and we won't have any
+    files to remove on account of likely being a new install. (LP: #1578285)
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 08 Jun 2016 14:39:12 -0400
+
+console-setup (1.142ubuntu3) yakkety; urgency=medium
+
+  * Replace initscripts dependency with init-system-helpers (>= 1.29~), to
+    allow dropping initscripts at some point. (Closes: #804988)
+
+ -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 30 May 2016 08:15:32 +0200
+
+console-setup (1.142ubuntu2) yakkety; urgency=medium
+
+  * Unbreak my last console-setup upload:
+    - debian/control: We want the locales package, not locales-all.
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+  * debian/rules: enable the setvtrgb.service correctly.
+  * debian/rules: remove keyboard-configuration trying to install console-setup
+    since it's now in console-setup.
+  * debian/keyboard-configuration.links: removed.
+  * debian/control: fix Breaks/Replaces so the initscript move to the
+    console-setup-linux package from keyboard-configuration goes smoothly.
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 29 Apr 2016 23:38:34 -0400
+
+console-setup (1.142ubuntu1) yakkety; urgency=medium
+
+  * Merge from Debian unstable; remaining changes:
+    - Don't gzip font or ACM files in /etc/console-setup/.  The space saving
+      is negligible, and it's more efficient not to need to uncompress them
+      at boot time.
+    - Include pc105.tree for ubiquity.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - Add an apport hook.
+    - Depend on kbd (>= 1.15-1ubuntu3) for a valuable loadkeys improvement.
+    - Include support for translated keyboard names.
+    - Depend on debconf instead of pre-depending, because pre-depends have
+      no effect on config scripts.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.upstart, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Make setupcon explicitly exit 0, so that postinsts don't fail in the
+      event that loadkeys can't find a console.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default variant for French to oss.
+    - Set default layout for Simplified Chinese to 'cn'.
+    - Don't use the default keyboard variant if the layout is overridden by
+      preseeding.
+    - If keyboard-configuration/layoutcode is preseeded but not marked as
+      seen, then set the default layout but don't lower the layout question
+      priority or preseed console-setup/ask_detect.
+    - Use the default keyboard model if an existing configuration file sets
+      XKBMODEL="".
+    - Go back to always asking layout before variant.
+    - Fix keyboard layout detection to set the layout properly.
+    - Reset keyboard-configuration/toggle to the default if it's set to "No
+      toggling" and you select a non-Latin layout.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Load the new keyboard configuration immediately when running
+      'dpkg-reconfigure keyboard-configuration' in an installed system.
+    - Don't fail to configure keyboard-configuration if setxkbmap fails to
+      talk to the X display.
+    - Tolerate absence of setupcon in keyboard-configuration.postinst.
+    - Drop the simplified keyboard-configuration/xkb-keymap question.
+    - Fix command injection in ckbcomp.
+    - debian/console-setup.console-font.upstart: Add Upstart job that sets up
+      console font when plymouth-splash is starting.
+    - Override description of the ch layout from "German (Switzerland)" to
+      just "Switzerland".
+    - Map ppc64el/* to XKBMODEL=pc105.
+    - setupcon: Map XKBMODEL=SKIP to '' for compatibility with existing
+      configs.
+    - debian/rules: revert hard-coding of a list of "debconf-selectable"
+      layouts for the udebs, since we don't use this debconf question in Ubuntu
+      and all layouts are selectable.
+    - setupcon: revert ridiculous upstream twiddling of keymap cache filenames:
+      - the variables are taken from a config file which, if changed,
+        invalidates the cache.
+      - there is only ever one keyboard map per system.
+      - the system should not have to resolve filenames to find the keymap cache
+        on boot.
+    - Move vtrgb handling to console-setup-linux package, since this is clearly
+      Linux-specific.
+    - Add missing console-setup-linux.prerm to remove /etc/vtrgb alternatives
+    - Keyboard/kbdcompiler: fix bug in filtering of unsupported variants that
+      breaks generation of the pc105.tree for d-i keyboard detection.
+    - debian/keyboard-configuration.postinst: udpkg is not part of an installed
+      Debian system; don't fail to configure if it's absent and the script is
+      called outside of an installer context.
+    - Don't make debian/copyright a symlink to COPYRIGHT, this is disallowed
+      by the Ubuntu archive installer.
+    - debian/keyboard-configuration.config: fix typo in model check for SKIP;
+      even when looking up the layout/variant, we need to check for the model
+      as XKBMODEL, since $model doesn't exist.
+    - debian/preprocessor: revert the removal of keyboard names (for size) of
+      console-setup-udeb: we do need those, since we don't use the simplified
+      xkb-keymap template from Debian just yet: this way we can still show
+      country/language names when selecting a keyboard, layout or variant.
+    - Properly handle settings CODESET and FONSIZE when they equals 'guess' or
+      are unset.
+    - keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+    - debian/keyboard-configuration.config: run grep with -a (to deal with files
+      as ASCII data) when searching for keyboard, locale, and layout names.
+    - Add ConditionPathExists=/dev/tty0 to the console-setup.service, to
+      avoid running the unit on platforms without virtual consoles
+    - debian/rules: Drop obsolete and no-op dh_installinit --upstart-only
+      option.
+    - Add debian/keyboard-configuration.links to (statically) enable
+      console-setup.service. It is not being pulled in by plymouth any more, and
+      doing so was brittle and unexpected.
+    - console-setup.service: Set RemainAfterExit.
+    - If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+      on kFreeBSD; otherwise restore the previous behaviour from before the
+      kFreeBSD port of using UTF-8 in that case.
+    - debian/control: allow dracut to be installable by adding an alternate
+      depends on linux-initramfs-tool for console-setup.
+    - Reinstate checking for XKBLAYOUT being in the config file: this handles
+      the cases where installs done with ubiquity don't have their debconf seen
+      flag set for model/layout questions. If layout is already configure, lower
+      the corresponding question's priority to medium so we don't ask it again.
+    - Add systemd unit for console-setup. That avoids waiting for $remote_fs
+      during early boot. (Note: there is no need to enable it, it gets pulled
+      in through systemd-vconsole-setup.service)
+    - Drop console-setup-freebsd; it's useless and uninstallable given that we
+      don't have a freebsd port.
+    - Make debian/keyboard-configuration.console-setup.init do the same as the
+      corresponding .upstart: I. e. just call loadkeys instead of setupcon, and
+      don't check the current console. (Font loading is already done via udev
+      rules).
+  * Dropped changes, included in Debian:
+    - Stop running debconf-updatepo on clean.
+    - Update for new layouts and variants for Montenegro and Serbia, and
+      migrate configuration files from the old layouts.
+  * Dropped changes, no longer needed:
+    - Move boot tasks to a combination of two udev rules and a single
+      Upstart job, ensuring that they're run at points when we are able to
+      satisfy the constraints on the relevant ioctls.
+    - Replace usplash detection code with Plymouth detection code.
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+  * debian/console-setup-linux.setvtrgb.service: port our vtrgb upstart job to
+    a systemd unit service so we can again apply the right color scheme.
+  * Fonts/Makefile: sort BDFS_TO_DOUBLE; this will avoid unnecessary delta
+    showing on every upload just because the fonts are not in the same order.
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 29 Apr 2016 11:36:58 -0400
+
 console-setup (1.142) unstable; urgency=medium
 
   [ Updated translations ]
@@ -895,6 +1684,253 @@ console-setup (1.109) unstable; urgency=
 
  -- Christian Perrier <bubulle@debian.org>  Sat, 26 Jul 2014 08:52:31 +0200
 
+console-setup (1.108ubuntu15) xenial; urgency=medium
+
+  * Properly handle settings CODESET and FONSIZE when they equals 'guess' or are unset.
+    - console-setup-tty, debian/console-setup.initramfs-hook,
+      debian/console-setup.initramfs-top
+    (LP: #1565542) 
+
+ -- Evgeniy Yanyuk <eugenenuke@gmail.com>  Tue, 19 Apr 2016 15:22:17 -0400
+
+console-setup (1.108ubuntu14) xenial; urgency=medium
+
+  * keyboard_present.sh: Quiet config/postinst when we have no USB devices.
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Tue, 12 Apr 2016 13:15:05 -0600
+
+console-setup (1.108ubuntu13) xenial; urgency=medium
+
+  * debian/keyboard-configuration.config: run grep with -a (to deal with files
+    as ASCII data) when searching for keyboard, locale, and layout names.
+    (LP: #1549529)
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 04 Apr 2016 13:47:04 -0400
+
+console-setup (1.108ubuntu12) xenial; urgency=medium
+
+  * No-change rebuild to properly generate console-setup-udeb's list of
+    valid keyboard layouts and variants.
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Thu, 24 Mar 2016 10:50:39 -0400
+
+console-setup (1.108ubuntu11) xenial; urgency=medium
+
+  * Add ConditionPathExists=/dev/tty0 to the console-setup.service, to
+    avoid running the unit on platforms without virtual consoles,
+    e.g. s390x. LP: #1552733
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 03 Mar 2016 14:41:05 +0000
+
+console-setup (1.108ubuntu10) xenial; urgency=medium
+
+  * debian/rules: Drop obsolete and no-op dh_installinit --upstart-only
+    option. (LP: #1519228)
+  * Add debian/keyboard-configuration.links to (statically) enable
+    console-setup.service. It is not being pulled in by plymouth any more, and
+    doing so was brittle and unexpected. (LP: #1531442)
+  * console-setup.service: Set RemainAfterExit.
+
+ -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 11 Jan 2016 15:02:09 +0100
+
+console-setup (1.108ubuntu9) wily; urgency=medium
+
+  * Cherry-pick fix from git for udpkg/Hurd noise in keyboard-configuration.
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Tue, 20 Oct 2015 12:51:36 +0100
+
+console-setup (1.108ubuntu8) wily; urgency=medium
+
+  * Properly handle setting XKBVARIANT when using keyboard detection.
+    (LP: #1506551)
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 19 Oct 2015 11:13:01 +0100
+
+console-setup (1.108ubuntu7) wily; urgency=medium
+
+  * Fix incorrect versioning change from last upload; initramfs-tools
+    0.85eubuntu12 looks wrong but was in fact correct.
+  * If the locale is C during configuration, only set CHARMAP to ISO-8859-15
+    on kFreeBSD; otherwise restore the previous behaviour from before the
+    kFreeBSD port of using UTF-8 in that case (LP: #1484101).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 02 Oct 2015 11:18:04 +0100
+
+console-setup (1.108ubuntu6) wily; urgency=medium
+
+  * debian/control: allow dracut to be installable by adding an alternate
+    depends on linux-initramfs-tool for console-setup.
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 08 Sep 2015 22:36:52 -0400
+
+console-setup (1.108ubuntu5) vivid; urgency=medium
+
+  * Reinstate checking for XKBLAYOUT being in the config file: this handles
+    the cases where installs done with ubiquity don't have their debconf seen
+    flag set for model/layout questions. If layout is already configure, lower
+    the corresponding question's priority to medium so we don't ask it again.
+    (LP: #1446231)
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 21 Apr 2015 17:19:21 -0400
+
+console-setup (1.108ubuntu4) vivid; urgency=medium
+
+  * Add systemd unit for console-setup. That avoids waiting for $remote_fs
+    during early boot. (Note: there is no need to enable it, it gets pulled
+    in through systemd-vconsole-setup.service) (LP: #1430280)
+
+ -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 11 Mar 2015 15:33:49 +0100
+
+console-setup (1.108ubuntu3) vivid; urgency=medium
+
+  * Drop console-setup-freebsd; it's useless and uninstallable given that we
+    don't have a freebsd port.
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 03 Mar 2015 10:15:31 -0500
+
+console-setup (1.108ubuntu2) vivid; urgency=medium
+
+  * Fix the mess I made with the previous upload:
+  * Reinstate changelog entry from 1.70ubuntu10; the changes aren't necessary
+    as keyboard-configuration does get the translated names of keyboards.
+  * Reinstate changes from 1.70ubuntu11:
+    - Make debian/keyboard-configuration.console-setup.init do the same as the
+      corresponding .upstart: I. e. just call loadkeys instead of setupcon, and
+      don't check the current console. (Font loading is already done via udev
+      rules).
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 02 Mar 2015 17:55:46 -0500
+
+console-setup (1.108ubuntu1) vivid; urgency=medium
+
+  [ Steve Langasek ]
+  * Merge from Debian unstable, remaining changes: (LP: #1426721)
+    - Don't gzip font or ACM files in /etc/console-setup/.  The space saving
+      is negligible, and it's more efficient not to need to uncompress them
+      at boot time.
+    - Include pc105.tree for ubiquity.
+    - Move boot tasks to a combination of two udev rules and a single
+      Upstart job, ensuring that they're run at points when we are able to
+      satisfy the constraints on the relevant ioctls.
+    - Stop running debconf-updatepo on clean.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - Add an apport hook.
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - Depend on kbd (>= 1.15-1ubuntu3) for a valuable loadkeys improvement.
+    - Include support for translated keyboard names.
+    - Depend on debconf instead of pre-depending, because pre-depends have
+      no effect on config scripts.
+    - debian/vtrgb, debian/vtrgb.vga,
+      debian/console-setup-linux.setvtrgb.upstart, debian/rules,
+      debian/console-setup-linux.postinst: use Ubuntu's virtual terminal color
+      scheme by default, with a VGA color scheme available as an alternative.
+    - Make setupcon explicitly exit 0, so that postinsts don't fail in the
+      event that loadkeys can't find a console.
+    - Update for new layouts and variants for Montenegro and Serbia, and
+      migrate configuration files from the old layouts.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default variant for French to oss.
+    - Set default layout for Simplified Chinese to 'cn'.
+    - Don't use the default keyboard variant if the layout is overridden by
+      preseeding.
+    - If keyboard-configuration/layoutcode is preseeded but not marked as
+      seen, then set the default layout but don't lower the layout question
+      priority or preseed console-setup/ask_detect.
+    - Use the default keyboard model if an existing configuration file sets
+      XKBMODEL="".
+    - Go back to always asking layout before variant.
+    - Fix keyboard layout detection to set the layout properly.
+    - Reset keyboard-configuration/toggle to the default if it's set to "No
+      toggling" and you select a non-Latin layout.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Replace usplash detection code with Plymouth detection code.
+    - Load the new keyboard configuration immediately when running
+      'dpkg-reconfigure keyboard-configuration' in an installed system.
+    - Don't fail to configure keyboard-configuration if setxkbmap fails to
+      talk to the X display.
+    - Tolerate absence of setupcon in keyboard-configuration.postinst.
+    - Drop the simplified keyboard-configuration/xkb-keymap question.
+    - Fix command injection in ckbcomp.
+    - debian/console-setup.console-font.upstart: Add Upstart job that sets up
+      console font when plymouth-splash is starting.
+    - Override description of the ch layout from "German (Switzerland)" to
+      just "Switzerland".
+    - Map ppc64el/* to XKBMODEL=pc105.
+  * Dropped changes, included in Debian:
+    - "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by keyboard-configuration/modelcode=SKIP: this is now
+      supported upstream with either "unknown" or an empty string as the
+      model.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Include Terminus font in the compiled packages.  Do not depend, but
+      conflict/provide/replace console-terminus.  New upstream version of
+      the Terminus font (4.32).
+    - Explicitly build-depend on liblocale-gettext-perl for kbdnames-maker,
+      and likewise have keyboard-configuration depend on
+      liblocale-gettext-perl.
+    - Make keyboard-configuration replace old console-setup/console-setup-mini
+      versions as well as conflicting with them.
+    - Weaken test for whether /usr is mounted; testing for /usr/share is
+      sufficient, and fixes operation in d-i.
+    - Set default layout for Kurdish to tr(ku).
+  * Dropped changes, no longer needed:
+    - Cope with systems installed with console-setup-udeb (<< 1.53) (which
+      predates Ubuntu 12.04 and Debian wheezy).
+    - Drop ancient handling of an empty codeset in the config file.
+    - Drop vtrgb upgrade handling from natty
+    - Drop upstart job transition from lucid
+  * setupcon: Map XKBMODEL=SKIP to '' for compatibility with existing
+    configs.
+  * debian/rules: revert hard-coding of a list of "debconf-selectable"
+    layouts for the udebs, since we don't use this debconf question in Ubuntu
+    and all layouts are selectable.
+  * setupcon: revert ridiculous upstream twiddling of keymap cache filenames:
+    - the variables are taken from a config file which, if changed,
+      invalidates the cache.
+    - there is only ever one keyboard map per system.
+    - the system should not have to resolve filenames to find the keymap cache
+      on boot.
+  * Move vtrgb handling to console-setup-linux package, since this is clearly
+    Linux-specific.
+  * Add missing console-setup-linux.prerm to remove /etc/vtrgb alternatives
+  * Keyboard/kbdcompiler: fix bug in filtering of unsupported variants that
+    breaks generation of the pc105.tree for d-i keyboard detection.
+  * debian/keyboard-configuration.postinst: udpkg is not part of an installed
+    Debian system; don't fail to configure if it's absent and the script is
+    called outside of an installer context.
+  * Don't make debian/copyright a symlink to COPYRIGHT, this is disallowed
+    by the Ubuntu archive installer.
+
+  [ Mathieu Trudel-Lapierre ]
+  * debian/keyboard-configuration.config: fix typo in model check for SKIP;
+    even when looking up the layout/variant, we need to check for the model
+    as XKBMODEL, since $model doesn't exist.
+  * debian/preprocessor: revert the removal of keyboard names (for size) of
+    console-setup-udeb: we do need those, since we don't use the simplified
+    xkb-keymap template from Debian just yet: this way we can still show
+    country/language names when selecting a keyboard, layout or variant.
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Fri, 27 Feb 2015 16:36:52 -0500
+
 console-setup (1.108) unstable; urgency=low
 
   [ Updated translations ]
@@ -1462,6 +2498,179 @@ console-setup (1.71) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Mon, 21 Mar 2011 07:08:43 +0200
 
+console-setup (1.70ubuntu11) vivid; urgency=medium
+
+  * Make debian/keyboard-configuration.console-setup.init do the same as the
+    corresponding .upstart: I. e. just call loadkeys instead of setupcon, and
+    don't check the current console. (Font loading is already done via udev
+    rules). (LP: #1400393)
+
+ -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 17 Dec 2014 07:55:34 +0100
+
+console-setup (1.70ubuntu10) vivid; urgency=medium
+
+  * Add all language-packs as build dependencies, to get translated names
+    of keyboard names in the DEBIAN/config of keyboard-setup package.
+
+ -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Sun, 30 Nov 2014 22:21:38 +0000
+
+console-setup (1.70ubuntu9) utopic; urgency=high
+
+  * No change rebuild against new dh_installinit, to call update-rc.d at
+    postinst.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 28 May 2014 10:39:17 +0100
+
+console-setup (1.70ubuntu8) trusty; urgency=medium
+
+  * Map ppc64el/* to XKBMODEL=pc105.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 29 Jan 2014 13:14:53 +0000
+
+console-setup (1.70ubuntu7) raring; urgency=low
+
+  * Override description of the ch layout from "German (Switzerland)" to
+    just "Switzerland" (LP: #869825).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 13 Mar 2013 16:35:47 +0000
+
+console-setup (1.70ubuntu6) quantal; urgency=low
+
+  * debian/console-setup.console-font.upstart: Add Upstart job that sets up
+    console font when plymouth-splash is starting, to work around a possible
+    udev/plymouth race that would otherwise prevent the font being set
+    (thanks, Ahmed El-Mahmoudy and Andrey Bondarenko; LP: #632382).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 09 Oct 2012 01:50:48 +0100
+
+console-setup (1.70ubuntu5) precise-proposed; urgency=low
+
+  * Update Ubuntu-specific translations from Launchpad (LP: #985605).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 19 Apr 2012 16:03:16 +0100
+
+console-setup (1.70ubuntu4) precise; urgency=low
+
+  * Add definitions for four (ignored) dead-keys: dead_belowcomma,
+    dead_currency, dead_doublegrave, and dead_invertedbreve.  Cherrypick
+    from Debian git.
+    (LP: #738314)
+  * Fix command injection in ckbcomp (thanks to Emanuel Bronshtein)
+    (LP: #782705)
+
+ -- Bryce Harrington <bryce@ubuntu.com>  Mon, 19 Mar 2012 21:13:39 -0700
+
+console-setup (1.70ubuntu3) precise; urgency=low
+
+  * No change rebuild for new xkb-data. (LP: #953328)
+
+ -- StÃ©phane Graber <stgraber@ubuntu.com>  Thu, 15 Mar 2012 11:48:58 -0400
+
+console-setup (1.70ubuntu2) precise; urgency=low
+
+  * Drop the simplified keyboard-configuration/xkb-keymap question; it
+    breaks existing preseeding, might confuse Ubiquity, and people are
+    already used to the layout/variant questions in Ubuntu (LP: #894187).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 24 Nov 2011 15:05:27 +0000
+
+console-setup (1.70ubuntu1) precise; urgency=low
+
+  * Merge from Debian testing, remaining changes:
+    - Include Terminus font in the compiled packages.  Do not depend, but
+      conflict/provide/replace console-terminus.  New upstream version of
+      the Terminus font (4.32).
+    - Add a "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by keyboard-configuration/modelcode=SKIP.
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - Update for new layouts and variants for Montenegro and Serbia, and
+      migrate configuration files from the old layouts.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - Move boot tasks to a combination of two udev rules and a single
+      Upstart job, ensuring that they're run at points when we are able to
+      satisfy the constraints on the relevant ioctls.
+    - Don't gzip font or ACM files in /etc/console-setup/.  The space saving
+      is negligible, and it's more efficient not to need to uncompress them
+      at boot time.
+    - Don't copy keyboard-configuration questions to /target in OEM mode.
+      oem-config will ask them later, and copying these confuses it.
+    - Add an apport hook.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - Don't try to call update-rc.d if it doesn't exist, such as in d-i.
+    - debian/vtrgb, debian/vtrgb.vga, debian/console-setup.setvtrgb.upstart,
+      debian/rules, debian/console-setup.postinst: use Ubuntu's virtual
+      terminal color scheme by default, with a VGA color scheme available
+      as an alternative.
+    - Explicitly build-depend on liblocale-gettext-perl for kbdnames-maker,
+      and likewise have keyboard-configuration depend on
+      liblocale-gettext-perl.
+    - Depend on debconf instead of pre-depending, because pre-depends have
+      no effect on config scripts.
+    - Make keyboard-configuration replace old console-setup/console-setup-mini
+      versions as well as conflicting with them.
+    - Depend on kbd (>= 1.15-1ubuntu3) for a valuable loadkeys improvement.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Fix default keyboard selection for language/country combinations
+      lacking a proper combined locale.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Kurdish to tr(ku).
+    - Set default layout for Vietnam to 'us'.
+    - Set default variant for French to oss.
+    - Set default layout for Simplified Chinese to 'cn'.
+    - Don't use the default keyboard variant if the layout is overridden by
+      preseeding.
+    - If keyboard-configuration/layoutcode is preseeded but not marked as
+      seen, then set the default layout but don't lower the layout question
+      priority or preseed console-setup/ask_detect.
+    - Use the default keyboard model if an existing configuration file sets
+      XKBMODEL="".
+    - console-setup-udeb (<< 1.53) didn't set the seen flag in the installed
+      system.  Cope with this and avoid asking the layout and variant
+      questions again if the default debconf priority is at least high.
+      (squeeze has >> 1.53, so this can be dropped after 12.04.)
+    - Go back to always asking layout before variant.
+    - Fix keyboard layout detection to set the layout properly.
+    - Reset keyboard-configuration/toggle to the default if it's set to "No
+      toggling" and you select a non-Latin layout.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Replace usplash detection code with Plymouth detection code.
+    - Load the new keyboard configuration immediately when running
+      'dpkg-reconfigure keyboard-configuration' in an installed system.
+    - Don't fail to configure keyboard-configuration if setxkbmap fails to
+      talk to the X display.
+    - Tolerate absence of setupcon in keyboard-configuration.postinst.
+    - Move keyboard detection templates from console-setup.templates to
+      keyboard-configuration.templates.
+    - Stop running debconf-updatepo on clean.
+    - Include pc105.tree for ubiquity.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Weaken test for whether /usr is mounted; testing for /usr/share is
+      sufficient, and fixes operation in d-i.
+    - Make setupcon explicitly exit 0, so that postinsts don't fail in the
+      event that loadkeys can't find a console.
+  * Dropped changes:
+    - Special KPDL handling: rewritten upstream in version 1.24.
+    - Upgrade handling for broken 1.57ubuntu1-1.57ubuntu4: prerelease
+      versions from natty, code dropped.
+    - Allow underscores in rules variables: included upstream.
+  * Restore plugin-detect-keyboard handling code, accidentally dropped in
+    a previous merge; keyboard detecting code was probably broken in the gtk
+    frontend by this.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 08 Nov 2011 09:34:02 -0800
+
 console-setup (1.70) unstable; urgency=low
 
   * ckbcomp: permit '_' in all identifiers.  Thanks to Jonny, Javier
@@ -1676,6 +2885,277 @@ console-setup (1.58) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Sat, 23 Oct 2010 10:14:45 +0300
 
+console-setup (1.57ubuntu27) oneiric; urgency=low
+
+  * Update Greek, Persian, Hebrew, Punjabi, and Traditional Chinese
+    translations from console-setup 1.68, fixing encoding problems
+    (LP: #860562).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 28 Sep 2011 15:58:32 +0100
+
+console-setup (1.57ubuntu26) oneiric; urgency=low
+
+  * Backport translations from console-setup 1.63, without which
+    keyboard-configuration is completely untranslated (and, indeed,
+    untranslatable).  LP: #838669.
+  * Bump dependency on debconf as well, to make sure we can parse sr@latin
+    translation templates.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 26 Sep 2011 15:44:41 +0100
+
+console-setup (1.57ubuntu25) oneiric; urgency=low
+
+  * Backport from upstream (Anton Zinoviev):
+    - Include Terminus font in the compiled packages.  Do not depend, but
+      conflict/provide/replace console-terminus.  New upstream version of
+      the Terminus font (4.32).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 23 Aug 2011 13:53:08 +0100
+
+console-setup (1.57ubuntu24) oneiric; urgency=low
+
+  * Fix default keyboard selection for language/country combinations lacking
+    a proper combined locale (LP: #814448).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 19 Aug 2011 15:13:13 +0100
+
+console-setup (1.57ubuntu23) oneiric; urgency=low
+
+  * Explicitly build-depend on liblocale-gettext-perl for kbdnames-maker,
+    and likewise have keyboard-configuration depend on
+    liblocale-gettext-perl.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 12 Aug 2011 16:55:54 +0100
+
+console-setup (1.57ubuntu22) oneiric; urgency=low
+
+  * Fix keyboard layout detection to set the layout properly (LP: #820554).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 12 Aug 2011 16:11:59 +0100
+
+console-setup (1.57ubuntu21) oneiric; urgency=low
+
+  * Rebuild against xkb-data 2.2.1 (LP: #791883).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sat, 25 Jun 2011 05:08:24 +0100
+
+console-setup (1.57ubuntu20) natty; urgency=low
+
+  * Weaken test for whether /usr is mounted; testing for /usr/share is
+    sufficient, and fixes operation in d-i.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 20 Apr 2011 15:29:46 +0100
+
+console-setup (1.57ubuntu19) natty; urgency=low
+
+  * Don't copy keyboard-configuration questions to /target in OEM mode.
+    oem-config will ask them later, and copying these confuses it
+    (LP: #741304).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 15 Apr 2011 12:43:41 +0100
+
+console-setup (1.57ubuntu18) natty; urgency=low
+
+  * Don't use the default keyboard variant if the layout is overridden by
+    preseeding (LP: #758584).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 12 Apr 2011 15:21:11 +0100
+
+console-setup (1.57ubuntu17) natty; urgency=low
+
+  * debian/vtrgb: Design team wanted a slightly different grey; more contrast
+    when white on grey
+  * debian/console-setup.postinst: fix failure to find file to md5sum;
+    go back to installing the original vtrgb as a lower priority alternative
+
+ -- Dustin Kirkland <kirkland@ubuntu.com>  Mon, 21 Mar 2011 21:38:00 -0500
+
+console-setup (1.57ubuntu16) natty; urgency=low
+
+  * debian/console-setup.postinst: don't add the vtrgb.vga 
+    alternate to update-alternatives;  let other packages or humans do this;
+    otherwise, every time this package upgrades, it would overwrite others'
+    overiding choices
+
+ -- Dustin Kirkland <kirkland@ubuntu.com>  Sun, 20 Mar 2011 17:54:21 -0500
+
+console-setup (1.57ubuntu15) natty; urgency=low
+
+  * debian/vtrgb.vga, debian/rules, debian/console-setup.postinst:
+    - install a vga configuration, for easy reference by others who want to go
+      back to legacy mode
+    - relocate the stock vtrgb from /usr to /etc, such that it can be edited
+      by an admin, LP: #738992
+
+ -- Dustin Kirkland <kirkland@ubuntu.com>  Sun, 20 Mar 2011 17:19:34 -0500
+
+console-setup (1.57ubuntu14) natty; urgency=low
+
+  * Install setvtrgb job with --no-start --upstart-only (LP: #738159).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sat, 19 Mar 2011 12:07:57 +0000
+
+console-setup (1.57ubuntu13) natty; urgency=low
+
+  * debian/rules, debian/console-setup.postinst: use update-alternatives
+    to allow other packages to install different console color values,
+    LP: #737948
+
+ -- Dustin Kirkland <kirkland@ubuntu.com>  Fri, 18 Mar 2011 22:02:12 -0500
+
+console-setup (1.57ubuntu12) natty; urgency=low
+
+  * Tolerate absence of setupcon in keyboard-configuration.postinst
+    (LP: #733497).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 18 Mar 2011 11:28:34 +0000
+
+console-setup (1.57ubuntu11) natty; urgency=low
+
+  * Address console-setup portion of LP: #730672, by installing
+    the conffile and applying it at upstart
+    - debian/vtrgb: Ubuntu's virtual terminal color scheme
+    - debian/console-setup.setvtrgb.upstart: run setvtrgb during upstart
+
+ -- Dustin Kirkland <kirkland@ubuntu.com>  Thu, 17 Mar 2011 17:10:50 -0500
+
+console-setup (1.57ubuntu10) natty; urgency=low
+
+  * Don't fail to configure keyboard-configuration if setxkbmap fails to
+    talk to the X display (LP: #728764).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 04 Mar 2011 13:40:49 +0000
+
+console-setup (1.57ubuntu9) natty; urgency=low
+
+  * The console-setup udev rule accidentally went missing in 1.57ubuntu1.
+    Reinstall it, this time in keyboard-configuration (LP: #713746).
+  * Load the new keyboard configuration immediately when running
+    'dpkg-reconfigure keyboard-configuration' in an installed system
+    (LP: #713062).
+  * Make setupcon explicitly exit 0, so that postinsts don't fail in the
+    event that loadkeys can't find a console.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 03 Mar 2011 16:14:06 +0000
+
+console-setup (1.57ubuntu8) natty; urgency=low
+
+  * Move keyboard detection templates from console-setup.templates to
+    keyboard-configuration.templates.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 28 Feb 2011 19:21:18 +0000
+
+console-setup (1.57ubuntu7) natty; urgency=low
+
+  * No change build to pick up xkeyboard-config 2.1-1ubuntu3.
+
+ -- Evan Dandrea <ev@ubuntu.com>  Tue, 08 Feb 2011 15:05:54 +0000
+
+console-setup (1.57ubuntu6) natty; urgency=low
+
+  * Allow underscores in rules variables ($sun_t6_custom).
+
+ -- Evan Dandrea <ev@ubuntu.com>  Mon, 07 Feb 2011 15:14:44 +0000
+
+console-setup (1.57ubuntu5) natty; urgency=low
+
+  * Drop misguided Ubuntu-specific code to migrate from console-setup/* to
+    keyboard-configuration/* question names.  This is already handled on
+    upgrade by reading the old /etc/default/console-setup file
+    (LP: #698263).
+  * console-setup-udeb (<< 1.53) didn't set the seen flag in the installed
+    system.  Cope with this and avoid asking the layout and variant
+    questions again if the default debconf priority is at least high
+    (LP: #705883).
+  * If we detect the above breakage (upgrading from anything between
+    1.57ubuntu1 and 1.57ubuntu4 inclusive, and the XKB* values in
+    /etc/default/keyboard differ from the commented-out values in
+    /etc/default/console-setup), reset to the commented-out values in
+    /etc/default/console-setup.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 28 Jan 2011 12:19:42 +0000
+
+console-setup (1.57ubuntu4) natty; urgency=low
+
+  * Include pc105.tree for ubiquity.
+
+ -- Evan Dandrea <ev@ubuntu.com>  Mon, 24 Jan 2011 16:53:59 +0000
+
+console-setup (1.57ubuntu3) natty; urgency=low
+
+  * Correct fix for LP: #634402: explicitly check readability of
+    /etc/default/keyboard and /etc/default/console-setup in initramfs hooks,
+    rather than trying to guard '.' with '||' which doesn't work
+    (LP: #701954).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 20 Jan 2011 20:55:01 +0000
+
+console-setup (1.57ubuntu2) natty; urgency=low
+
+  * Make keyboard-configuration replace old console-setup/console-setup-mini
+    versions as well as conflicting with them (thanks, Martin Pitt).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 06 Jan 2011 12:24:45 +0000
+
+console-setup (1.57ubuntu1) natty; urgency=low
+
+  * Resynchronise with Debian.  Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Reset keyboard-configuration/toggle to the default if it's set to "No
+      toggling" and you select a non-Latin layout.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Set keymap and font in the initramfs if possible and sensible.
+    - Set default variant for French to oss.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default layout for Kurdish to tr(ku).
+    - Stop running debconf-updatepo on clean.
+    - Update for new layouts and variants for Montenegro and Serbia, and
+      migrate configuration files from the old layouts.
+    - Add a "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by keyboard-configuration/modelcode=SKIP.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Honour OVERRIDE_ALLOW_PRESEEDING environment variable when deciding
+      whether to allow preseeding, which is ordinarily only allowed in d-i.
+    - If keyboard-configuration/layoutcode is preseeded but not marked as
+      seen, then set the default layout but don't lower the layout question
+      priority or preseed console-setup/ask_detect.
+    - Add an apport hook.
+    - Generate a locale locally for translating keyboard names in
+      kbdnames-maker.
+    - Replace usplash detection code with Plymouth detection code.
+    - Move boot tasks to a combination of two udev rules and a single
+      Upstart job, ensuring that they're run at points when we are able to
+      satisfy the constraints on the relevant ioctls.
+    - Depend on kbd (>= 1.15-1ubuntu3) for a valuable loadkeys improvement.
+    - Don't try to call update-rc.d if it doesn't exist, such as in d-i.
+    - Don't gzip font or ACM files in /etc/console-setup/.  The space saving
+      is negligible, and it's more efficient not to need to uncompress them
+      at boot time.
+    - Remove iconv transliteration.  We don't use non-UTF-8 locales, and it
+      breaks ubiquity as we haven't generated the configured locale by the
+      time we hit console-setup.
+  * Go back to always asking layout before variant.
+  * Migrate from old console-setup/* to new keyboard-configuration/*
+    question names.
+  * Use the default keyboard model if an existing configuration file sets
+    XKBMODEL="".
+  * Exit cleanly from initramfs hook if /etc/default/keyboard or
+    /etc/default/console-setup don't exist for some reason (LP: #634402).
+  * Fix description of upstart job to not incorrectly claim that it sets the
+    font (LP: #632366).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 05 Jan 2011 17:02:40 +0000
+
 console-setup (1.57) unstable; urgency=low
 
   * udeb: properly preseed system based on installer values.
@@ -2201,6 +3681,181 @@ console-setup (1.35) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Thu, 14 May 2009 21:42:14 +0300
 
+console-setup (1.34ubuntu15) lucid; urgency=low
+
+  * Make /usr/share/initramfs-tools/scripts/panic/console_setup executable.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 23 Apr 2010 23:23:50 +0100
+
+console-setup (1.34ubuntu14) lucid; urgency=low
+
+  * Update Ubuntu-specific translations from Launchpad.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 15 Apr 2010 00:08:23 +0100
+
+console-setup (1.34ubuntu13) lucid; urgency=low
+
+  * Remove iconv transliteration.  We don't use non-UTF-8 locales, and
+    it breaks ubiquity as we haven't generated the configured locale by
+    the time we hit console-setup (LP: #542310).
+
+ -- Evan Dandrea <evand@ubuntu.com>  Fri, 26 Mar 2010 12:50:50 +0000
+
+console-setup (1.34ubuntu12) lucid; urgency=low
+
+  * console-setup-tty: Only call setfont once, for both font and ACM.
+  * Don't try to call update-rc.d if it doesn't exist, such as in d-i
+    (LP: #540835).
+  * Don't gzip font or ACM files in /etc/console-setup/.  The space saving
+    is negligible, and it's more efficient not to need to uncompress them at
+    boot time.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 19 Mar 2010 11:08:58 +0000
+
+console-setup (1.34ubuntu11) lucid; urgency=low
+
+  * Move boot tasks to a combination of two udev rules and a single Upstart
+    job, ensuring that they're run at points when we are able to satisfy the
+    constraints on the relevant ioctls.  This may not work optimally with
+    vgacon, but you have to go to special effort to use that with Ubuntu
+    now, and it at least shouldn't break (LP: #524439).
+  * Set default layout for Guernsey, Jersey, and the Isle of Man to gb
+    (LP: #533003).
+  * Fix incorrect FONT and ACM tests in initramfs script.
+  * Depend on kbd (>= 1.15-1ubuntu3) for a valuable loadkeys improvement.
+    This was previously a recommends, but the udev rule won't work without
+    kbd or console-tools anyway, I'm not really interested in supporting a
+    system without either installed, and console-tools is thoroughly
+    obsolete now.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sat, 13 Mar 2010 12:56:30 +0000
+
+console-setup (1.34ubuntu10) lucid; urgency=low
+
+  * debian/console-setup.console-setup.init,
+    debian/console-setup.keyboard-setup.init: Replace the usplash detection
+    code with Plymouth detection code, since the same problem applies. 
+
+ -- Scott James Remnant <scott@ubuntu.com>  Wed, 17 Feb 2010 13:14:32 +0000
+
+console-setup (1.34ubuntu9) lucid; urgency=low
+
+  * Generate a locale locally for translating keyboard names in
+    kbnames-maker.
+
+ -- Evan Dandrea <evand@ubuntu.com>  Thu, 04 Feb 2010 15:48:25 -0800
+
+console-setup (1.34ubuntu8) lucid; urgency=low
+
+  * Put kbdnames.gz in console-setup-udeb as well.
+  * Don't filter out models from kbdnames as we still ask the model
+    question.
+
+ -- Evan Dandrea <evand@ubuntu.com>  Wed, 27 Jan 2010 17:22:19 +0000
+
+console-setup (1.34ubuntu7) lucid; urgency=low
+
+  * Merge support for translated keyboard names from Debian.
+  * Update ckb/rules/base.xml to point at the new location.
+
+ -- Evan Dandrea <evand@ubuntu.com>  Wed, 20 Jan 2010 15:22:34 +0000
+
+console-setup (1.34ubuntu6) lucid; urgency=low
+
+  * debian/console-setup.initramfs-hook: There's no harm having the hook
+    run in the non-framebuffer case, it just copies things into the
+    initramfs which may be useful.
+  * debian/rules: That means we can copy the hook into scripts/panic as
+    well (stripping the OPTION from it), so when we need a shell, we'll
+    load the keymap.
+
+ -- Scott James Remnant <scott@ubuntu.com>  Fri, 18 Dec 2009 14:56:03 +0000
+
+console-setup (1.34ubuntu5) lucid; urgency=low
+
+  * We don't need the initramfs hooks if the initramfs doesn't load the
+    framebuffer or splash screen.
+
+ -- Scott James Remnant <scott@ubuntu.com>  Tue, 15 Dec 2009 14:56:59 +0000
+
+console-setup (1.34ubuntu4) karmic; urgency=low
+
+  * Fix backports of Asturian and Catalan changes in 1.34ubuntu3.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 01 Oct 2009 20:27:35 +0100
+
+console-setup (1.34ubuntu3) karmic; urgency=low
+
+  [ LoÃ¯c Minier ]
+  * Use `dpkg --print-architecture` instead of the obsolete
+    --print-installation-architecture in debian/config.proto (LP: #403316).
+
+  [ Colin Watson ]
+  * Forbid Unicode keysyms in the range 0xf000-0xffff, as kbd 1.15-1 rejects
+    the entire keymap if it contains any keysyms in that range (LP:
+    #416949).
+  * Add default codeset/layout/variant for Asturian.
+  * Backport from trunk (Jordi Mallach):
+    - Set XKBVARIANT to "cat" for Catalan.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 01 Oct 2009 20:21:57 +0100
+
+console-setup (1.34ubuntu2) karmic; urgency=low
+
+  * Add an apport hook.
+  * Update translations from Launchpad.
+  * Backport from trunk (Anton Zinoviev, LP: #390292):
+    - Do not issue warnings for unknown keycodes with AT keyboards (these
+      are multimedia keys and they are unnecessary on the console).  Thanks
+      to Anders LagerÃ¥s, closes: #531292.
+
+ -- Colin Watson <cjwatson@debian.org>  Tue, 01 Sep 2009 11:49:34 +0100
+
+console-setup (1.34ubuntu1) karmic; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Fixed to VGA for Lat15; while it's not
+      entirely complete, it looks better and is largely good enough.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default layout for Kurdish to tr(ku).
+    - Fix handling of commas in layout and variant names.
+    - debian/config.proto: Set sparc default model to pc105.
+    - Remove 'exit 0' from the end of debian/config.proto; this will be
+      sourced from the postinst in the installer, and exiting in the
+      successful case means that /etc/default/console-setup never gets
+      generated.
+    - Stop running debconf-updatepo on clean.
+    - Update for new layouts and variants for Japan, Montenegro, and Serbia,
+      and migrate configuration files from the old layouts.
+    - Add a "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by console-setup/modelcode=SKIP.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Honour OVERRIDE_ALLOW_PRESEEDING environment variable when deciding
+      whether to allow preseeding, which is ordinarily only allowed in d-i.
+    - If console-setup/layoutcode is preseeded but not marked as seen, then
+      set the default layout but don't lower the layout question priority or
+      preseed console-setup/ask_detect.
+    - Treat the Kazakhstan layout (kz) as non-Latin.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 05 May 2009 20:51:20 +0100
+
 console-setup (1.34) unstable; urgency=medium
 
   [ Colin Watson ]
@@ -2350,6 +4005,113 @@ console-setup (1.29) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Tue, 24 Mar 2009 20:53:51 +0200
 
+console-setup (1.28ubuntu8) jaunty; urgency=low
+
+  * Update Ubuntu-specific strings from Launchpad.
+  * Treat the Kazakhstan layout (kz) as non-Latin (LP: #356816).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 09 Apr 2009 01:15:09 +0100
+
+console-setup (1.28ubuntu7) jaunty; urgency=low
+
+  * Raise priority to critical for questions preseeded with a nonexistent
+    code (LP: #328078).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 27 Mar 2009 11:45:13 +0000
+
+console-setup (1.28ubuntu6) jaunty; urgency=low
+
+  * Don't escape '(' and ')' when decoding/encoding the codeset, as the
+    pattern is passed to grep and this causes parentheses to be interpreted
+    as regular expression groups (thanks to Dmitry Agafonov for pointing out
+    the problem).
+  * If reading a user configuration file, disable --save, and don't use
+    /etc/console-setup/boottime.kmap.gz (LP: #332728).
+  * Update Keyboard/KeyboardNames.pl based on xkb-data 1.5-2ubuntu5.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 02 Mar 2009 16:30:50 +0000
+
+console-setup (1.28ubuntu5) jaunty; urgency=low
+
+  * Backport from trunk:
+    - Sort the null variant to the top of the choices list rather than to the
+      bottom.
+  * Set and check a flag on console-setup/dont_ask_layout to make sure that
+    it's only asked at most once per package installation (LP: #320374).
+  * Update Keyboard/KeyboardNames.pl based on xkb-data 1.4-1ubuntu3.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sat, 31 Jan 2009 12:07:37 +0000
+
+console-setup (1.28ubuntu4) jaunty; urgency=low
+
+  * Set plain or shifted PrintScreen key to generate VoidSymbol rather than
+    Ctrl-backslash (LP: #279973).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Dec 2008 10:09:28 +0000
+
+console-setup (1.28ubuntu3) jaunty; urgency=low
+
+  * Create /dev/tty[1-6] in our initramfs script before trying to operate on
+    them (LP: #130444).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 26 Nov 2008 12:15:12 +0000
+
+console-setup (1.28ubuntu2) jaunty; urgency=low
+
+  * Default console-setup/ask_detect to false, since it's hard to back up
+    out of the detection widget once you've entered it.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 25 Nov 2008 16:48:28 +0000
+
+console-setup (1.28ubuntu1) jaunty; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default layout for Kurdish to tr(ku).
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - debian/config.proto: Set sparc default model to pc105.
+    - Remove 'exit 0' from the end of debian/config.proto; this will be
+      sourced from the postinst in the installer, and exiting in the
+      successful case means that /etc/default/console-setup never gets
+      generated.
+    - Stop running debconf-updatepo on clean.
+    - Update for new layouts and variants for Japan, Montenegro, and Serbia,
+      and migrate configuration files from the old layouts.
+    - Add a "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by console-setup/modelcode=SKIP.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Honour OVERRIDE_ALLOW_PRESEEDING environment variable when deciding
+      whether to allow preseeding, which is ordinarily only allowed in d-i.
+    - If console-setup/layoutcode is preseeded but not marked as seen, then
+      set the default layout but don't lower the layout question priority or
+      preseed console-setup/ask_detect.
+    - Fix property counts in Goha and legacy BDF fonts.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 06 Nov 2008 14:36:26 +0000
+
 console-setup (1.28) unstable; urgency=low
 
   [ Debconf translations ]
@@ -2388,6 +4150,67 @@ console-setup (1.26) unstable; urgency=l
 
  -- Christian Perrier <bubulle@debian.org>  Tue, 08 Jul 2008 20:40:35 +0200
 
+console-setup (1.25ubuntu3) intrepid; urgency=low
+
+  * Fix property counts in Goha and legacy BDF fonts.
+  * Switch from console-tools-udeb to kbd-udeb, in line with Debian.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 28 Aug 2008 00:09:48 +0100
+
+console-setup (1.25ubuntu2) intrepid; urgency=low
+
+  * If console-setup/layoutcode is preseeded but not marked as seen, then
+    set the default layout but don't lower the layout question priority or
+    preseed console-setup/ask_detect (LP: #64058).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 30 Jun 2008 23:49:31 +0100
+
+console-setup (1.25ubuntu1) intrepid; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default layout for Kurdish to tr(ku).
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - debian/config.proto: Set sparc default model to pc105.
+    - Remove 'exit 0' from the end of debian/config.proto; this will be
+      sourced from the postinst in the installer, and exiting in the
+      successful case means that /etc/default/console-setup never gets
+      generated.
+    - Switch back to console-tools-udeb for now.
+    - Stop running debconf-updatepo on clean.
+    - Update for new layouts and variants for Japan, Montenegro, and Serbia,
+      and migrate configuration files from the old layouts.
+    - Add a "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by console-setup/modelcode=SKIP.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Honour OVERRIDE_ALLOW_PRESEEDING environment variable when deciding
+      whether to allow preseeding, which is ordinarily only allowed in d-i.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 24 Jun 2008 02:39:34 +0100
+
 console-setup (1.25) unstable; urgency=low
 
   [ Anton Zinoviev ]
@@ -2405,6 +4228,52 @@ console-setup (1.25) unstable; urgency=l
 
  -- Christian Perrier <bubulle@debian.org>  Wed, 18 Jun 2008 20:24:01 +0200
 
+console-setup (1.24ubuntu1) intrepid; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Set default for Dutch to us(intl), not just us.
+    - Set default layout for Vietnam to 'us'.
+    - Set default layout for Kurdish to tr(ku).
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - debian/config.proto: Set sparc default model to pc105.
+    - Remove 'exit 0' from the end of debian/config.proto; this will be
+      sourced from the postinst in the installer, and exiting in the
+      successful case means that /etc/default/console-setup never gets
+      generated.
+    - Switch back to console-tools-udeb for now.
+    - Stop running debconf-updatepo on clean.
+    - Update for new layouts and variants for Japan, Montenegro, and Serbia,
+      and migrate configuration files from the old layouts.
+    - Add a "Do not configure keyboard; keep kernel keymap" model option,
+      preseedable by console-setup/modelcode=SKIP.
+    - Drop the layout/variant priority to high on fresh installs.
+    - Honour OVERRIDE_ALLOW_PRESEEDING environment variable when deciding
+      whether to allow preseeding, which is ordinarily only allowed in d-i.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 11 Jun 2008 22:32:10 +0100
+
 console-setup (1.24) unstable; urgency=medium
 
   [ Anton Zinoviev ]
@@ -2479,6 +4348,100 @@ console-setup (1.22) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Fri, 04 Apr 2008 22:41:21 +0300
 
+console-setup (1.21ubuntu8) hardy; urgency=low
+
+  * Rebuild against xkeyboard-config 1.1~cvs.20080104.1-1ubuntu6.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 21 Apr 2008 20:40:40 +0100
+
+console-setup (1.21ubuntu7) hardy; urgency=low
+
+  * Honour OVERRIDE_ALLOW_PRESEEDING environment variable when deciding
+    whether to allow preseeding, which is ordinarily only allowed in d-i
+    (LP: #188492).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 14 Apr 2008 11:49:55 +0100
+
+console-setup (1.21ubuntu6) hardy; urgency=low
+
+  * Handle some special cases for the KPDL key (LP: #189529).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 02 Apr 2008 00:06:25 +0100
+
+console-setup (1.21ubuntu5) hardy; urgency=low
+
+  * Silence error messages for keycodes 214, 215, 216, and 217, which are
+    various special keys in the default X.org PC keyboard map that we don't
+    need to handle.
+  * Map dead_stroke to U+002D HYPHEN-MINUS.
+  * Add a "Do not configure keyboard; keep kernel keymap" model option,
+    preseedable by console-setup/modelcode=SKIP (LP: #59889).
+  * Drop the layout/variant priority to high on fresh installs
+    (LP: #205959).
+  * Support rules with multiple consequents (thanks, Adam Simpkins;
+    LP: #139710).
+  * Allow specifying alternate rules using XKBRULES (thanks, Adam Simpkins;
+    LP: #139712).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 31 Mar 2008 14:33:25 +0100
+
+console-setup (1.21ubuntu4) hardy; urgency=low
+
+  * Set default layout for Kurdish to tr(ku) (LP: #28683).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 03 Mar 2008 13:46:06 +0000
+
+console-setup (1.21ubuntu3) hardy; urgency=low
+
+  * Set default layout for Vietnam to 'us' (LP: #191451).
+  * Treat 'any' as a synonym for 'NoSymbol' in XKB input files (LP: #93077).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 26 Feb 2008 14:05:12 +0000
+
+console-setup (1.21ubuntu2) hardy; urgency=low
+
+  * Set default for Dutch to us(intl), not just us (LP: #129982).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 29 Jan 2008 00:14:54 +0000
+
+console-setup (1.21ubuntu1) hardy; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - debian/config.proto: Set sparc default model to pc105.
+    - Remove 'exit 0' from the end of debian/config.proto; this will be
+      sourced from the postinst in the installer, and exiting in the
+      successful case means that /etc/default/console-setup never gets
+      generated.
+    - Switch back to console-tools-udeb for now.
+    - Stop running debconf-updatepo on clean.
+  * Update for new layouts and variants for Japan, Montenegro, and Serbia,
+    and migrate configuration files from the old layouts.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 28 Jan 2008 23:01:31 +0000
+
 console-setup (1.21) unstable; urgency=low
 
   * Silently ignore 'vendor' tag in xorg.xml.
@@ -2537,6 +4500,69 @@ console-setup (1.20) unstable; urgency=l
 
  -- Christian Perrier <bubulle@debian.org>  Sat, 05 Jan 2008 09:04:03 +0100
 
+console-setup (1.19ubuntu3) hardy; urgency=low
+
+  * Set default layout for Dutch to 'us' (LP: #129982).
+  * Set default layout for Simplified Chinese to 'cn'.
+  * Set default layout for Morocco to 'ma'.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 28 Jan 2008 17:11:21 +0000
+
+console-setup (1.19ubuntu2) hardy; urgency=low
+
+  * Handle an empty codeset in the configuration file gracefully (a remnant
+    of a previous bug, perhaps Debian #420802?), and re-ask the question on
+    upgrade (LP: #91399).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 11 Jan 2008 00:30:07 +0000
+
+console-setup (1.19ubuntu1) hardy; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Only default to Canadian layout for fr_CA; use U.S. English for other
+      *_CA locales.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - debian/config.proto: Set sparc default model to pc105.
+    - Remove 'exit 0' from the end of debian/config.proto; this will be
+      sourced from the postinst in the installer, and exiting in the
+      successful case means that /etc/default/console-setup never gets
+      generated.
+    - Set default model to pc105 on powerpc/ps3 systems.
+  * Switch back to console-tools-udeb for now; we'd like to use kbd for
+    Hardy, but Alpha 1 is looming ...
+  * Stop running debconf-updatepo on clean; this is not standard in d-i and
+    should be done manually where necessary in Ubuntu.
+  * Backport from trunk:
+    - Run setupcon with --save in the postinst to ensure that required data
+      is copied to /etc.
+    - Load the saved keymap in /etc/console-setup/boottime.kmap.gz if
+      available rather than running ckbcomp (which is slow), unless we're
+      being called with --save or --save-only.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 27 Nov 2007 15:05:15 +0000
+
 console-setup (1.19) unstable; urgency=low
 
   [ Jérémy Bobbio ]
@@ -2584,6 +4610,85 @@ console-setup (1.17) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Sun, 15 Jul 2007 16:35:55 +0300
 
+console-setup (1.16ubuntu5) gutsy; urgency=low
+
+  * Rebuild against xkb-data 0.9-4ubuntu2.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 24 Sep 2007 12:53:36 +0100
+
+console-setup (1.16ubuntu4) gutsy; urgency=low
+
+  * Set default model to pc105 on powerpc/ps3 systems.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 08 Jun 2007 14:12:20 +0100
+
+console-setup (1.16ubuntu3) gutsy; urgency=low
+
+  * Remove 'exit 0' from the end of debian/config.proto; this will be
+    sourced from the postinst in the installer, and exiting in the
+    successful case means that /etc/default/console-setup never gets
+    generated (thanks, Evan Dandrea).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 04 Jun 2007 22:53:23 +0100
+
+console-setup (1.16ubuntu2) gutsy; urgency=low
+
+  * Make Keyboard/keymaptree executable again.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sun, 03 Jun 2007 21:30:57 +0100
+
+console-setup (1.16ubuntu1) gutsy; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Only default to Canadian layout for fr_CA; use U.S. English for other
+      *_CA locales.
+    - Set default charmap for d-i to UTF-8.
+    - Remove unhelpful defaults for several questions.
+    - Allow preseeding of console-setup/modelcode, console-setup/layoutcode,
+      console-setup/variantcode, console-setup/optionscode, and
+      console-setup/fontsize.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Add a few bits of installer integration to console-setup-udeb borrowed
+      from kbd-chooser.
+    - console-setup Depends: perl; something in ckbcomp is causing perl to
+      'use utf8' implicitly, and some of the necessary modules aren't in
+      perl-base.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Use 'setupcon --save-only' to make sure the font is available on the
+      root filesystem for the next boot but not to load it immediately,
+      avoiding console manipulation when X or usplash is running.
+    - Set keymap and font in the initramfs if possible.
+    - Set default variant for French to oss.
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - debian/config.proto: Set sparc default model to pc105.
+    - debian/control: Remove outdated note about loadkeys in
+      console-setup-udeb's description.
+  * Allow kbd's initramfs hook as an alternative to that provided by
+    console-tools.
+  * Don't run 'setupcon -k' from rcS if usplash is running, as that means
+    the console will be in raw mode and loadkeys will do confusing things to
+    the keymap (LP: #84156).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sun, 03 Jun 2007 14:53:42 +0100
+
 console-setup (1.16) unstable; urgency=low
 
   * Update ckbconf with the most recent list of xkeysyms.
@@ -2633,6 +4738,73 @@ console-setup (1.16) unstable; urgency=l
 
  -- Anton Zinoviev <zinoviev@debian.org>  Tue,  1 May 2007 23:48:12 +0300
 
+console-setup (1.15ubuntu1) gutsy; urgency=low
+
+  * Resynchronise with Debian (LP: #94177). Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Ship MyKeyboardNames.pl (as KeyboardNames.pl) and kbdnames-maker in
+      /usr/share/console-setup.
+    - Only default to Canadian layout for fr_CA; use U.S. English for other
+      *_CA locales.
+    - Fix default layout for Bosnian and default variant for Hindi.
+    - Set default charmap for d-i to UTF-8.
+    - Remove unhelpful defaults for several questions.
+    - Adjust the default keyboard model for Brazilian and Japanese layouts.
+    - Allow preseeding of console-setup/modelcode, console-setup/layoutcode,
+      console-setup/variantcode, console-setup/optionscode, and
+      console-setup/fontsize.
+    - Use jp(latin),jp rather than us,jp by default for Japanese.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Add a few bits of installer integration to console-setup-udeb borrowed
+      from kbd-chooser.
+    - console-setup Depends: perl; something in ckbcomp is causing perl to
+      'use utf8' implicitly, and some of the necessary modules aren't in
+      perl-base.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+    - Map fr_CH to ch(fr) (Swiss French).
+    - Fix codeset question priority for Esperanto.
+    - Automatically save the font and keymap to /etc in
+      /etc/init.d/console-setup if it isn't being run from init. Similarly,
+      ensure that the font and keymap are saved to /etc during initial
+      installation.
+    - Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+      non-ASCII letters, except for Turkish layouts; the cure is worse than
+      the disease because it makes Caps Lock equivalent to Shift Lock.
+    - Add a --save-only option to setupcon, to save the keyboard/font on the
+      root filesystem but not actually tell the kernel to set it up. Use it
+      to make sure the font is available on the root filesystem for the next
+      boot but not to load it immediately, avoiding console manipulation
+      when X or usplash is running.
+    - Set keymap and font in the initramfs if possible.
+    - Add lt to list of non-Latin keymaps.
+    - Set default variant for French to oss.
+    - Fix handling of commas in layout and variant names.
+    - Fix keymap reduction not to try to express keymap A in terms of keymap
+      B when B includes keys not mapped by A.
+    - Source debconf confmodule earlier in postinst.
+    - Fix horrible confusion if the locale has no supported default codeset.
+    - Fix console-setup/codeset default to be one of the available choices.
+    - Don't set an AltGr key by default for US layouts.
+    - Add amiga, ataritt, sun4, and sun5 models, since they are used as
+      defaults on certain architectures.
+    - Map keycode 133 to AT scancode 124 for Japanese.
+  * debian/config.proto: Set sparc default model to pc105 (LP: #105595).
+  * debian/control: Multiply Installer-Menu-Item number by 100.
+  * debian/control: Remove outdated note about loadkeys in
+    console-setup-udeb's description.
+  * debian/console-setup.postinst: Drop font fixups for upgrades from
+    development versions of Edgy.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 25 Apr 2007 11:52:52 +0100
+
 console-setup (1.15) unstable; urgency=low
 
   * Updated Georgian letters for Fixed16 and Fixed14.  Thanks to Vladimer
@@ -2651,6 +4823,171 @@ console-setup (1.14) unstable; urgency=l
 
  -- Christian Perrier <bubulle@debian.org>  Sun,  4 Mar 2007 19:54:11 +0100
 
+console-setup (1.13ubuntu13) feisty; urgency=low
+
+  * debian/console-setup.console-setup.init: Don't break if fgconsole fails.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 10 Apr 2007 16:16:08 +0100
+
+console-setup (1.13ubuntu12) feisty; urgency=low
+
+  * Map keycode 133 to AT scancode 124 for Japanese (thanks, Jun Kobayashi;
+    LP: #97466).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed,  4 Apr 2007 16:48:15 +0100
+
+console-setup (1.13ubuntu11) feisty; urgency=low
+
+  * Add amiga, ataritt, sun4, and sun5 models, since they are used as
+    defaults on certain architectures (LP: #97225).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed,  4 Apr 2007 10:11:03 +0100
+
+console-setup (1.13ubuntu10) feisty; urgency=low
+
+  * Source debconf confmodule earlier in postinst (it should always be
+    sourced as early as possible, as it re-executes the calling script).
+  * Fix horrible confusion if the locale has no supported default codeset
+    (LP: #84401).
+  * Fix console-setup/codeset default to be one of the available choices.
+  * Try harder to ensure that we aren't running under X when deciding
+    whether to run setupcon on upgrade (thanks to Kurt J. Bosch for
+    suggestions; LP: #93338).
+  * Don't set an AltGr key by default for US layouts (LP: #76901).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sun,  1 Apr 2007 16:49:02 +0100
+
+console-setup (1.13ubuntu9) feisty; urgency=low
+
+  * Keyboard/kbdcompiler: Fix keymap reduction not to try to express keymap
+    A in terms of keymap B when B includes keys not mapped by A, fixing a
+    number of incorrectly-reduced keymaps (LP: #74375).
+  * Keyboard/kbdcompiler: Update handling of jp to match
+    debian/config.proto.
+  * Keyboard/keymaptree.use: Remove jp; we cannot detect it correctly
+    without further intelligence, as it's designed for jp106 keyboard
+    models.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sat, 17 Mar 2007 10:06:05 +0000
+
+console-setup (1.13ubuntu8) feisty; urgency=low
+
+  * Fix handling of commas in layout and variant names.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri,  9 Mar 2007 20:05:00 +0000
+
+console-setup (1.13ubuntu7) feisty; urgency=low
+
+  * Add lt to list of non-Latin keymaps (LP: #38931).
+  * Map Caps Lock to Shift Lock for Turkish layouts.
+  * Build keymap tree from MyKeyboardNames.pl rather than KeyboardNames.pl.
+  * Add fr:oss to keymap tree.
+  * Set default variant for French to oss (LP: #89835).
+  * Remove Keyboard/*.tree on clean.
+  * Fix six files in debian/ that were supposed to be symlinks.
+  * Move console-setup-udeb's post-base-installer script to be a
+    base-installer script instead, so that console-setup will be configured
+    properly along with the initramfs during debootstrap.
+  * Set Maintainer to me.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue,  6 Mar 2007 12:09:57 +0000
+
+console-setup (1.13ubuntu6) feisty; urgency=low
+
+  * Set keymap and font in the initramfs if possible. Setting these as early
+    as possible is a good thing; we can't set up the font correctly once
+    usplash is running; and setting up the font between usplash and X
+    requires an ugly mode switch.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 22 Jan 2007 14:21:24 +0000
+
+console-setup (1.13ubuntu5) feisty; urgency=low
+
+  * Add a --save-only option to setupcon, to save the keyboard/font on the
+    root filesystem but not actually tell the kernel to set it up.
+  * Back out part of setup-console-under-usplash changes: attempts to change
+    the font must be guarded against being run while on an X display or
+    while usplash is running, because some kernel console drivers (at least
+    vgacon) are fundamentally unable to change the font only on some virtual
+    consoles, and will corrupt video memory if you try (LP: #73955). We now
+    use setupcon --save-only to make sure the font is available on the root
+    filesystem for the next boot but don't load it immediately.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Jan 2007 20:08:33 +0000
+
+console-setup (1.13ubuntu4) feisty; urgency=low
+
+  * Include ro(std) in keymap tree, after talking with Eddy PetriÅor.
+  * Disable workaround in ckbcomp for the kernel not applying Caps Lock to
+    non-ASCII letters; the cure is worse than the disease because it makes
+    Caps Lock equivalent to Shift Lock (LP: #69725).
+  * Install MyKeyboardNames.pl (built from /usr/share/X11/xkb) rather than
+    KeyboardNames.pl (built from the out-of-date copy in Keyboard/ckb) as
+    /usr/share/console-setup/KeyboardNames.pl (LP: #71864).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri,  5 Jan 2007 14:15:04 +0000
+
+console-setup (1.13ubuntu3) feisty; urgency=low
+
+  * Remove ch(fr) from keymap tree again; it's not distinguishable from ch
+    without checking shift key state, which keymapper currently doesn't do.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 29 Nov 2006 11:28:48 +0000
+
+console-setup (1.13ubuntu2) feisty; urgency=low
+
+  * Make Keyboard/keymaptree executable again.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue, 28 Nov 2006 20:09:22 +0000
+
+console-setup (1.13ubuntu1) feisty; urgency=low
+
+  * Resynchronise with Debian. Remaining changes:
+    - Use keymapper to generate decision trees for a restricted subset of
+      the pc105 model.
+    - If the detect-keyboard debconf plugin is available
+      (cdebconf-newt-detect-keys in the installer), then offer to use it to
+      detect the keyboard layout.
+    - Ship KeyboardNames.pl and kbdnames-maker in /usr/share/console-setup.
+    - Only default to Canadian layout for fr_CA; use U.S. English for other
+      *_CA locales.
+    - Fix default layout for Bosnian and default variant for Hindi.
+    - Set default charmap for d-i to UTF-8.
+    - Remove unhelpful defaults for several questions.
+    - Adjust the default keyboard model for Brazilian and Japanese layouts.
+    - Allow preseeding of console-setup/modelcode, console-setup/layoutcode,
+      console-setup/variantcode, console-setup/optionscode, and
+      console-setup/fontsize.
+    - Use jp(latin),jp rather than us,jp by default for Japanese.
+    - Reset console-setup/toggle to the default if it's set to "No toggling"
+      and you select a non-Latin layout.
+    - Change the default font from Terminus to VGA where supported.
+    - Skip now-unnecessary console check in init scripts.
+    - Fix up font face and size on upgrading from old versions in Edgy.
+    - Add a few bits of installer integration to console-setup-udeb borrowed
+      from kbd-chooser.
+    - console-setup Depends: perl; something in ckbcomp is causing perl to
+      'use utf8' implicitly, and some of the necessary modules aren't in
+      perl-base.
+    - Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+      tty, since the current tty might belong to X and changing X's tty out
+      of raw mode is a very bad idea.
+  * Restore udeb generation.
+
+  * Map fr_CH to ch(fr) (Swiss French).
+  * Include ch(fr) in keymap tree.
+  * Fix codeset question priority for Esperanto.
+  * Remove X and usplash checks in keyboard-setup and console-setup init
+    scripts, since neither are needed following the fix in console-setup
+    1.7ubuntu19.
+  * Allow setupcon to be run on install again, for the same reason.
+  * Automatically save the font and keymap to /etc in
+    /etc/init.d/console-setup if it isn't being run from init; this allows
+    us to tolerate XKB data being moved to /usr. Similarly, ensure that the
+    font and keymap are saved to /etc during initial installation.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 24 Nov 2006 18:09:32 +0000
+
 console-setup (1.13) unstable; urgency=low
 
   * Unfuzzy the translations.
@@ -2736,6 +5073,202 @@ console-setup (1.8) unstable; urgency=lo
 
  -- Anton Zinoviev <zinoviev@debian.org>  Tue, 19 Sep 2006 11:56:15 +0300
 
+console-setup (1.7ubuntu19) edgy; urgency=low
+
+  * If upgrading from an older version than this one, check for the Terminus
+    font face and change it to VGA (if you do like it, you can change it
+    back and it won't be touched again). If Terminus was in use, also check
+    for the 12x6 font size and change it to 16, since that was apparently
+    selected due to a strange use-of-debconf bug.
+  * Run kbd_mode on each tty in ACTIVE_CONSOLES rather than on the current
+    tty, since the current tty might belong to X and changing X's tty out of
+    raw mode is a very bad idea (closes: Malone #66929; requires kbd 1.12-15
+    or console-tools 1:0.2.3dbs-62ubuntu10).
+  * Adjust the default keyboard model for Brazilian (closes: Malone #66774)
+    and Japanese (closes: Malone #66719) layouts.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 20 Oct 2006 20:16:09 +0100
+
+console-setup (1.7ubuntu18) edgy; urgency=low
+
+  * Change the default font to VGA where supported; Terminus does not seem
+    to have widespread aesthetic appeal.
+  * Use jp(latin),jp rather than us,jp by default for Japanese, and set the
+    model to jp106 (closes: Malone #63915).
+  * Build-depend on keymapper (>= 0.5.3-7) for improved Alt-handling logic.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 12 Oct 2006 02:42:15 +0100
+
+console-setup (1.7ubuntu17) edgy; urgency=low
+
+  * Only default to Canadian layout for fr_CA; use U.S. English for other
+    *_CA locales (closes: Malone #64418).
+  * Install kbdnames-maker in /usr/share/console-setup, to make it easier
+    for non-Perl programs to use KeyboardNames.pl.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 11 Oct 2006 12:52:36 +0100
+
+console-setup (1.7ubuntu16) edgy; urgency=low
+
+  * Backport from trunk (Anton Zinoviev, closes: Malone #63921):
+    - New mini-font georgian16.bdf to be used for the Georgian letters in
+      Fixed16, author: Gia Shervashidze.  Thanks to Vladimer Sichinava.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed,  4 Oct 2006 11:37:15 +0100
+
+console-setup (1.7ubuntu15) edgy; urgency=low
+
+  * Fix build failure caused by wrong path to KeyboardNames.pl.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue,  3 Oct 2006 15:44:59 +0100
+
+console-setup (1.7ubuntu14) edgy; urgency=low
+
+  * Ship KeyboardNames.pl in /usr/share/console-setup.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Tue,  3 Oct 2006 11:09:27 +0100
+
+console-setup (1.7ubuntu13) edgy; urgency=low
+
+  * Remove obsolete XORGCONFIGFILE variable.
+  * Reset console-setup/toggle to the default if it's set to "No toggling"
+    and you select a non-Latin layout (closes: Malone #63178).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon,  2 Oct 2006 14:47:58 +0100
+
+console-setup (1.7ubuntu12) edgy; urgency=low
+
+  * Don't run the init script (and thereby setupcon) on upgrade; just print
+    a message telling you to run setupcon from a virtual console if you want
+    to update your console configuration (closes: Malone #61723).
+  * Update debian-installer/keymap handling from trunk (Anton Zinoviev).
+    Drop /etc/X11/xorg.conf upgrade handling, also per trunk, as I've been
+    convinced that that is much less safe due to the prevalence of GNOME/KDE
+    keymap overrides, and furthermore it made it more difficult to have
+    ubiquity tell console-setup just to guess a default from the locale.
+  * Drop the priority of the model and layout questions to medium if a
+    configuration file already exists, since they'll have been asked at
+    medium first time round and if we then ask them at critical the second
+    time round they will be unexpectedly shown (closes: Malone #59883).
+  * Backport from trunk:
+    - config.proto: Handle properly the case when the user backs up from the
+      first Debconf question.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sat, 23 Sep 2006 00:40:48 +0100
+
+console-setup (1.7ubuntu11) edgy; urgency=low
+
+  * Fix default layout for Bosnian and default variant for Hindi.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri, 22 Sep 2006 15:57:23 +0100
+
+console-setup (1.7ubuntu10) edgy; urgency=low
+
+  * console-setup Depends: perl; something in ckbcomp is causing perl to
+    'use utf8' implicitly, and some of the necessary modules aren't in
+    perl-base (closes: Malone #60203).
+  * Allow preseeding of console-setup/modelcode, console-setup/layoutcode,
+    console-setup/variantcode, console-setup/optionscode, and
+    console-setup/fontsize.
+  * Don't set up the console font at boot time if usplash is running, since
+    that seems to trigger a kernel bug that corrupts the usplash display
+    (closes: Malone #60483).
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu, 21 Sep 2006 01:01:54 +0100
+
+console-setup (1.7ubuntu9) edgy; urgency=low
+
+  * Switch build-dependency and dependency back to xkb-data, now that it's
+    fixed. Make the dependencies versioned until after Edgy is released to
+    avoid problems with partially-upgraded systems where only the broken
+    xkb-data is installed.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Wed, 13 Sep 2006 10:24:20 +0100
+
+console-setup (1.7ubuntu8) edgy; urgency=low
+
+  * Add setupcon --force option and use it in postinst (Anton Zinoviev,
+    http://lists.alioth.debian.org/pipermail/pkg-kbd-devel/2006-August/000278.html).
+  * Check $DISPLAY rather than /proc/self/fd/2 in /etc/init.d/keyboard-setup
+    and /etc/init.d/console-setup; use setupcon --force.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Mon, 11 Sep 2006 09:47:36 +0100
+
+console-setup (1.7ubuntu7) edgy; urgency=low
+
+  * Handle debian-installer/locale not being available (closes: Malone
+    #59718).
+  * Remove stray Keyboard/amiga.ekmap in source package.
+  * Fix a potential infinite loop in the config script while moving past the
+    variant question with an unsupported layout.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sun, 10 Sep 2006 12:07:53 +0100
+
+console-setup (1.7ubuntu6) edgy; urgency=low
+
+  * If there's no console-setup configuration when console-setup.config
+    runs, then:
+    - If there is an xorg.conf, set the defaults from there.
+    - Failing that, if debian-installer/keymap is set, try to guess correct
+      defaults from that using the same algorithm as formerly applied by
+      xserver-xorg.config. The only serious change I made to the algorithm
+      is that it now maps (mac-usb-)uk to plain gb, not gb(intl), since
+      that's closer to what UK keyboard users generally expect.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Fri,  8 Sep 2006 00:13:26 +0100
+
+console-setup (1.7ubuntu5) edgy; urgency=low
+
+  * Only call setupcon from postinst script if /lib/debian-installer exists,
+    to make sure we're really in d-i. (Calling setupcon from X appears to
+    make things rather messy.)
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu,  7 Sep 2006 17:11:12 +0100
+
+console-setup (1.7ubuntu4) edgy; urgency=low
+
+  * Remove cs from the list of non-Latin layouts, as it has special
+    per-variant handling.
+  * Fix syntax error in config script.
+  * Don't try to use the detect-keyboard plugin if running noninteractively.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu,  7 Sep 2006 15:39:38 +0100
+
+console-setup (1.7ubuntu3) edgy; urgency=low
+
+  * Use keymapper to generate decision trees for a restricted subset of the
+    pc105 model. (I tried building trees for the whole model, but this took
+    far too long.)
+  * If the detect-keyboard debconf plugin is available
+    (cdebconf-newt-detect-keys in the installer), then offer to use it to
+    detect the keyboard layout.
+  * Fix debian/po/POTFILES.in to point to console-setup.templates.
+  * Make console-setup-udeb depend on console-setup-fonts-udeb, at least for
+    now.
+  * Convert init script to LSB logging functions.
+  * Add a few bits of installer integration to console-setup-udeb borrowed
+    from kbd-chooser (/lib/debian-installer.d/S55console-setup,
+    post-base-installer hook).
+  * Temporarily build-depend and depend on just xkeyboard-config to work
+    around Malone #59220.
+  * Set default charmap for d-i to UTF-8.
+  * Remove unhelpful "none" defaults for several questions.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Thu,  7 Sep 2006 09:18:42 +0100
+
+console-setup (1.7ubuntu2) edgy; urgency=low
+
+  * Make console-setup-udeb depend on console-tools-udeb.
+
+ -- Tollef Fog Heen <tfheen@ubuntu.com>  Wed, 23 Aug 2006 14:36:58 +0200
+
+console-setup (1.7ubuntu1) edgy; urgency=low
+
+  * Call setupcon with input and output from /dev/tty in postinst and make
+    sure setupcon understands that properly.
+
+ -- Tollef Fog Heen <tfheen@ubuntu.com>  Wed, 23 Aug 2006 12:54:27 +0200
+
 console-setup (1.7) unstable; urgency=low
 
   [ Christian Perrier ]
@@ -2843,3 +5376,4 @@ console-setup (1.0) unstable; urgency=lo
     and pointing few typos).
 
  -- Anton Zinoviev <zinoviev@debian.org>  Sat, 14 Jan 2006 16:20:35 +0200
+
diff -pruN 1.195/debian/clean 1.195ubuntu1/debian/clean
--- 1.195/debian/clean	1970-01-01 00:00:00.000000000 +0000
+++ 1.195ubuntu1/debian/clean	2019-11-27 14:34:42.000000000 +0000
@@ -0,0 +1 @@
+Keyboard/tree-keymaps/
diff -pruN 1.195/debian/console-setup.apport 1.195ubuntu1/debian/console-setup.apport
--- 1.195/debian/console-setup.apport	1970-01-01 00:00:00.000000000 +0000
+++ 1.195ubuntu1/debian/console-setup.apport	2019-11-27 14:34:42.000000000 +0000
@@ -0,0 +1,13 @@
+'''apport package hook for console-setup
+
+Copyright (C) 2009 Canonical Ltd.
+Author: Colin Watson <cjwatson@ubuntu.com>
+'''
+
+import apport.hookutils
+
+def add_info(report):
+    apport.hookutils.attach_file_if_exists(
+        report, '/etc/default/keyboard', 'Keyboard')
+    apport.hookutils.attach_file_if_exists(
+        report, '/etc/default/console-setup', 'ConsoleSetup')
diff -pruN 1.195/debian/console-setup.config 1.195ubuntu1/debian/console-setup.config
--- 1.195/debian/console-setup.config	2018-10-18 15:01:40.000000000 +0000
+++ 1.195ubuntu1/debian/console-setup.config	2020-03-27 14:41:07.000000000 +0000
@@ -215,7 +215,14 @@ else
 fi
 
 if [ "$locale" = C ]; then
-    CHARMAP=ISO-8859-15
+    case "$kernel" in
+	freebsd)
+	    CHARMAP=ISO-8859-15
+	    ;;
+	*)
+	    CHARMAP=UTF-8
+	    ;;
+    esac
     charmap_priority=high
 elif which locale 2>/dev/null >/dev/null; then
     CHARMAP=`locale charmap`
@@ -680,7 +687,7 @@ case "$CODESET" in
 	FONTFACE=Fixed
 	;;
     Lat15)
-	FONTFACE=Fixed
+	FONTFACE=VGA
 	;;
     Lat2)
 	FONTFACE=Fixed
diff -pruN 1.195/debian/console-setup.initramfs-hook 1.195ubuntu1/debian/console-setup.initramfs-hook
--- 1.195/debian/console-setup.initramfs-hook	1970-01-01 00:00:00.000000000 +0000
+++ 1.195ubuntu1/debian/console-setup.initramfs-hook	2019-11-27 14:34:42.000000000 +0000
@@ -0,0 +1,118 @@
+#! /bin/sh -e
+
+PREREQ="kbd|console_tools"
+
+prereqs () {
+	echo "$PREREQ"
+}
+
+case $1 in
+prereqs)
+	prereqs
+	exit 0
+	;;
+esac
+
+. /usr/share/initramfs-tools/hook-functions
+[ -r /etc/default/keyboard ] || exit 0
+[ -r /etc/default/console-setup ] || exit 0
+. /etc/default/console-setup # also sources /etc/default/keyboard
+
+# CODESET
+[ "$CODESET" != guess ] || CODESET=''
+if [ -z "$CODESET" ]; then
+    case "$CHARMAP" in
+        UTF-8)            CODESET=Uni2;;
+        ARMSCII-8)        CODESET=Armenian ;;
+        CP1251)           CODESET=CyrSlav ;;
+        CP1255)           CODESET=Hebrew ;;
+        CP1256)           CODESET=Arabic ;;
+        GEORGIAN-ACADEMY) CODESET=Georgian ;;
+        GEORGIAN-PS)      CODESET=Georgian ;;
+        IBM1133)          CODESET=Lao ;;
+        ISIRI-3342)       CODESET=Arabic ;;
+        ISO-8859-1)       CODESET=Lat15 ;;
+        ISO-8859-2)       CODESET=Lat2 ;;
+        ISO-8859-3)       CODESET=Lat38 ;;
+        ISO-8859-4)       CODESET=Lat7 ;; # sometimes Lat15
+        ISO-8859-5)       CODESET=CyrSlav ;;
+        ISO-8859-6)       CODESET=Arabic ;;
+        ISO-8859-7)       CODESET=Greek ;;
+        ISO-8859-8)       CODESET=Hebrew ;;
+        ISO-8859-9)       CODESET=Lat15 ;;
+        ISO-8859-10)      CODESET=Lat15 ;;
+        ISO-8859-11)      CODESET=Thai ;;
+        ISO-8859-13)      CODESET=Lat7 ;;
+        ISO-8859-14)      CODESET=Lat38 ;;
+        ISO-8859-15)      CODESET=Lat15 ;;
+        ISO-8859-16)      CODESET=Lat2 ;;
+        KOI8-R)           CODESET=CyrKoi ;;
+        KOI8-U)           CODESET=CyrKoi ;;
+        TIS-620)          CODESET=Thai ;;
+        VISCII)           CODESET=Vietnamese ;;
+        *)	            ;;
+    esac
+fi
+
+# FONTSIZE
+if [ -z "$FONTSIZE" -o "$FONTSIZE" = guess ]; then
+    FONTSIZE=16
+fi
+case "$FONTSIZE" in
+    8x*)
+        FONTSIZE=${FONTSIZE#*x}
+        ;;
+    *x8)
+        FONTSIZE=${FONTSIZE%x*}
+        ;;
+    *x*)
+        a=${FONTSIZE%x*}
+        b=${FONTSIZE#*x}
+        if [ "$a" -lt "$b" ]; then
+            FONTSIZE=${b}x${a}
+        fi
+        ;;
+esac
+
+# Copy console-setup configuration
+mkdir -p "$DESTDIR/etc/default"
+cp -p /etc/default/keyboard "$DESTDIR/etc/default"
+cp -p /etc/default/console-setup "$DESTDIR/etc/default"
+
+# Assume setupcon --save has been run
+if [ -f "$FONT" ]; then
+	FONT="/etc/console-setup/${FONT##*/}"
+	FONT="${FONT%.gz}"
+else
+	FONT="/etc/console-setup/$CODESET-$FONTFACE$FONTSIZE.psf"
+fi
+if [ -f "$FONT" ]; then
+	mkdir -p "$DESTDIR${FONT%/*}"
+	cp -p "$FONT" "$DESTDIR$FONT"
+fi
+if [ -f "$FONT.gz" ]; then
+	mkdir -p "$DESTDIR${FONT%/*}"
+	cp -p "$FONT.gz" "$DESTDIR$FONT.gz"
+fi
+if [ -f "$ACM" ]; then
+	ACM="/etc/console-setup/${ACM##*/}"
+	ACM="${ACM%.gz}"
+else
+	ACM="/etc/console-setup/$CHARMAP.acm"
+fi
+if [ -f "$ACM" ]; then
+	mkdir -p "$DESTDIR${ACM%/*}"
+	cp -p "$ACM" "$DESTDIR$ACM"
+fi
+if [ -f "$ACM.gz" ]; then
+	mkdir -p "$DESTDIR${ACM%/*}"
+	cp -p "$ACM.gz" "$DESTDIR$ACM.gz"
+fi
+if [ -f "/etc/console-setup/cached_${CHARMAP}_del.kmap.gz" ]; then
+	mkdir -p "$DESTDIR/etc/console-setup"
+	cp -p "/etc/console-setup/cached_${CHARMAP}_del.kmap.gz" \
+		"$DESTDIR/etc/console-setup/cached_${CHARMAP}_del.kmap.gz"
+fi
+
+exit 0
+a
diff -pruN 1.195/debian/console-setup.initramfs-top 1.195ubuntu1/debian/console-setup.initramfs-top
--- 1.195/debian/console-setup.initramfs-top	1970-01-01 00:00:00.000000000 +0000
+++ 1.195ubuntu1/debian/console-setup.initramfs-top	2019-11-27 14:34:42.000000000 +0000
@@ -0,0 +1,136 @@
+#! /bin/sh
+# A crude much-simplified clone of setupcon for use in the initramfs.
+
+OPTION=FRAMEBUFFER
+PREREQ="framebuffer"
+
+prereqs () {
+	echo "$PREREQ"
+}
+
+case $1 in
+prereqs)
+	prereqs
+	exit 0
+	;;
+esac
+
+[ -r /etc/default/console-setup ] || exit 0
+. /etc/default/console-setup
+
+[ "$ACTIVE_CONSOLES" ] || exit 0
+
+# CODESET
+[ "$CODESET" != guess ] || CODESET=''
+if [ -z "$CODESET" ]; then
+    case "$CHARMAP" in
+        UTF-8)            CODESET=Uni2;;
+        ARMSCII-8)        CODESET=Armenian ;;
+        CP1251)           CODESET=CyrSlav ;;
+        CP1255)           CODESET=Hebrew ;;
+        CP1256)           CODESET=Arabic ;;
+        GEORGIAN-ACADEMY) CODESET=Georgian ;;
+        GEORGIAN-PS)      CODESET=Georgian ;;
+        IBM1133)          CODESET=Lao ;;
+        ISIRI-3342)       CODESET=Arabic ;;
+        ISO-8859-1)       CODESET=Lat15 ;;
+        ISO-8859-2)       CODESET=Lat2 ;;
+        ISO-8859-3)       CODESET=Lat38 ;;
+        ISO-8859-4)       CODESET=Lat7 ;; # sometimes Lat15
+        ISO-8859-5)       CODESET=CyrSlav ;;
+        ISO-8859-6)       CODESET=Arabic ;;
+        ISO-8859-7)       CODESET=Greek ;;
+        ISO-8859-8)       CODESET=Hebrew ;;
+        ISO-8859-9)       CODESET=Lat15 ;;
+        ISO-8859-10)      CODESET=Lat15 ;;
+        ISO-8859-11)      CODESET=Thai ;;
+        ISO-8859-13)      CODESET=Lat7 ;;
+        ISO-8859-14)      CODESET=Lat38 ;;
+        ISO-8859-15)      CODESET=Lat15 ;;
+        ISO-8859-16)      CODESET=Lat2 ;;
+        KOI8-R)           CODESET=CyrKoi ;;
+        KOI8-U)           CODESET=CyrKoi ;;
+        TIS-620)          CODESET=Thai ;;
+        VISCII)           CODESET=Vietnamese ;;
+        *)	            ;;
+    esac
+fi
+
+# FONTSIZE
+if [ -z "$FONTSIZE" -o "$FONTSIZE" = guess ]; then
+    FONTSIZE=16
+fi
+case "$FONTSIZE" in
+    8x*)
+        FONTSIZE=${FONTSIZE#*x}
+        ;;
+    *x8)
+        FONTSIZE=${FONTSIZE%x*}
+        ;;
+    *x*)
+        a=${FONTSIZE%x*}
+        b=${FONTSIZE#*x}
+        if [ "$a" -lt "$b" ]; then
+            FONTSIZE=${b}x${a}
+        fi
+        ;;
+esac
+
+if [ "$VERBOSE_OUTPUT" = yes ]; then
+	verbose=
+else
+	verbose='>/dev/null 2>&1'
+fi
+
+[ -c /dev/tty1 ] || mknod /dev/tty1 c 4 1
+
+[ -w /dev/tty1 ] || continue
+
+if [ "$CHARMAP" = UTF-8 ] || [ -z "$ACM$CHARMAP" ]; then
+	printf '\033%%G' >/dev/tty1
+else
+	printf '\033%%@' >/dev/tty1
+fi
+
+if [ "$FONT" ]; then
+	FONT="/etc/console-setup/${FONT##*/}"
+	FONT="${FONT%.gz}"
+else
+	FONT="/etc/console-setup/$CODESET-$FONTFACE$FONTSIZE.psf"
+fi
+if [ -f "$FONT" ] || [ -f "$FONT.gz" ]; then
+	if type consolechars >/dev/null 2>&1; then
+		eval consolechars -v --tty=/dev/tty1 -f "$FONT" $verbose
+	elif type setfont >/dev/null 2>&1; then
+		eval setfont -v -C /dev/tty1 "$FONT" $verbose
+	fi
+fi
+
+if [ "$ACM" ]; then
+	ACM="/etc/console-setup/${ACM##*/}"
+	ACM="${ACM%.gz}"
+else
+	ACM="/etc/console-setup/$CHARMAP.acm"
+fi
+if [ -f "$ACM" ] || [ -f "$ACM.gz" ]; then
+	if type consolechars >/dev/null 2>&1; then
+		eval consolechars -v --tty=/dev/tty1 --acm "$ACM" \
+			$verbose
+	elif type setfont >/dev/null 2>&1; then
+		eval setfont -v -C "/dev/tty1" -m "$ACM" $verbose
+	fi
+fi
+
+if type kbd_mode >/dev/null 2>&1; then
+	if [ "$CHARMAP" = UTF-8 ] || [ -z "$ACM" ]; then
+		kbd_mode -u </dev/tty1
+	else
+		kbd_mode -a </dev/tty1
+	fi
+fi
+
+if [ -f "/etc/console-setup/cached_${CHARMAP}_del.kmap.gz" ] && type loadkeys >/dev/null; then
+	eval loadkeys "/etc/console-setup/cached_${CHARMAP}_del.kmap.gz" $verbose
+fi
+
+exit 0
diff -pruN 1.195/debian/console-setup-linux.postinst 1.195ubuntu1/debian/console-setup-linux.postinst
--- 1.195/debian/console-setup-linux.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 1.195ubuntu1/debian/console-setup-linux.postinst	2019-11-27 14:34:42.000000000 +0000
@@ -0,0 +1,11 @@
+#!/bin/sh
+
+set -e
+
+CONFIGDIR=/etc/console-setup
+
+update-alternatives --install /etc/vtrgb vtrgb "$CONFIGDIR/vtrgb" 50
+update-alternatives --install /etc/vtrgb vtrgb "$CONFIGDIR/vtrgb.vga" 20
+
+#DEBHELPER#
+
diff -pruN 1.195/debian/console-setup-linux.prerm 1.195ubuntu1/debian/console-setup-linux.prerm
--- 1.195/debian/console-setup-linux.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 1.195ubuntu1/debian/console-setup-linux.prerm	2019-11-27 14:34:42.000000000 +0000
@@ -0,0 +1,12 @@
+#!/bin/sh
+
+set -e
+
+CONFIGDIR=/etc/console-setup
+
+if [ "$1" = remove ]; then
+	update-alternatives --remove vtrgb "$CONFIGDIR/vtrgb"
+	update-alternatives --remove vtrgb "$CONFIGDIR/vtrgb.vga"
+fi
+
+#DEBHELPER#
diff -pruN 1.195/debian/console-setup-linux.setvtrgb.service 1.195ubuntu1/debian/console-setup-linux.setvtrgb.service
--- 1.195/debian/console-setup-linux.setvtrgb.service	1970-01-01 00:00:00.000000000 +0000
+++ 1.195ubuntu1/debian/console-setup-linux.setvtrgb.service	2019-11-27 14:34:42.000000000 +0000
@@ -0,0 +1,15 @@
+[Unit]
+Description=Set console scheme
+DefaultDependencies=no
+After=systemd-user-sessions.service plymouth-quit-wait.service
+Before=system-getty.slice
+ConditionPathExists=/sbin/setvtrgb
+ConditionPathExists=/dev/tty0
+
+[Service]
+Type=oneshot
+ExecStart=/sbin/setvtrgb /etc/vtrgb
+RemainAfterExit=yes
+
+[Install]
+WantedBy=sysinit.target
diff -pruN 1.195/debian/console-setup.postinst 1.195ubuntu1/debian/console-setup.postinst
--- 1.195/debian/console-setup.postinst	2018-10-18 15:01:40.000000000 +0000
+++ 1.195ubuntu1/debian/console-setup.postinst	2020-03-27 14:41:07.000000000 +0000
@@ -131,7 +131,25 @@ db_stop
 # We redirect the output so that postinst does not block when ScrollLock is on
 # This works even if we are not on the console
 setupcon --save-only >/dev/null 2>/dev/null || true
-# This will protest if we are not on the console
-setupcon >/dev/null 2>/dev/null || true
+if type plymouth >/dev/null && plymouth --ping; then
+    # setting the keymap breaks with plymouth in raw mode, and setting the
+    # font will currently also break if on vgacon
+    :
+elif [ -d /lib/debian-installer ]; then
+    setupcon --force >/dev/null 2>/dev/null || true
+else
+    if ! setupcon >/dev/null 2>/dev/null; then
+        cat >&2 <<EOF
+Your console font configuration will be updated the next time your system
+boots. If you want to update it now, run 'setupcon' from a virtual console.
+EOF
+    fi
+fi
 
 #DEBHELPER#
+
+if type update-initramfs >/dev/null 2>&1; then
+    update-initramfs -u
+fi
+
+exit 0
diff -pruN 1.195/debian/console-setup-udeb.base-installer 1.195ubuntu1/debian/console-setup-udeb.base-installer
--- 1.195/debian/console-setup-udeb.base-installer	2018-10-18 15:01:40.000000000 +0000
+++ 1.195ubuntu1/debian/console-setup-udeb.base-installer	2020-03-27 14:41:08.000000000 +0000
@@ -18,15 +18,16 @@ if keyboard_present; then
     cp -a /etc/default/keyboard /target/etc/default/
     LANG=C
     export LANG
-    # create the required templates
-    debconf-copydb -p "^keyboard-configuration/.*$" configdb target_configdb
+    if ! db_get oem-config/enable || [ "$RET" != true ]; then
+	# create the required templates
+	debconf-copydb -p "^keyboard-configuration/.*$" configdb target_configdb
 
-    # mark the questions as seen
-    for template in \
-## SEEN TEMPLATES ## all templates of keyb-conf except alerts and ctrl_alt_bksp
-    do
-	echo keyboard-configuration $template seen true
-    done | chroot /target debconf-set-selections
+	# mark the questions as seen
+	for template in \## SEEN TEMPLATES ## all templates of keyb-conf except alerts and ctrl_alt_bksp
+	do
+	    echo keyboard-configuration $template seen true
+	done | chroot /target debconf-set-selections
+    fi
 ######################################################################
 
     apt-install keyboard-configuration || true
diff -pruN 1.195/debian/console-setup-udeb.postinst 1.195ubuntu1/debian/console-setup-udeb.postinst
--- 1.195/debian/console-setup-udeb.postinst	2018-10-18 15:01:40.000000000 +0000
+++ 1.195ubuntu1/debian/console-setup-udeb.postinst	2020-03-27 14:41:07.000000000 +0000
@@ -79,21 +79,42 @@ if [ "$1" = "configure" -a ! -L "$CONFIG
     db_set keyboard-configuration/store_defaults_in_debconf_db true
 fi
 
-if \
-    [ -d /lib/debian-installer.d ] && keyboard_present
+if [ -d /lib/debian-installer ];
 then
     if [ "$DISPLAY" ] && which setxkbmap >/dev/null; then
-	setxkbmap -option '' -model "$model" "$layout" "$variant" "$options"
+	setxkbmap -option '' -model "$model" "$layout" "$variant" "$options" || true
+	# setting the font corrupts X
+	# setting up the keyboard breaks wayland
+	if type setupcon >/dev/null 2>&1; then
+	    # We redirect the output so that postinst does not block when ScrollLock is on
+	    setupcon --save-only >/dev/null 2>/dev/null || true
+	    cat >&2 <<EOF
+Your console font configuration will be updated the next time your system
+boots. If you want to update it now, run 'setupcon' from a virtual console.
+EOF
+	fi
     else
 	case "`uname`" in
 	    GNU)
 		[ ! -f /var/run/hurd-console.pid ] || kill `cat /var/run/hurd-console.pid`
 		;;
 	    *)
-		setupcon --force --save
+		if type setupcon >/dev/null 2>&1; then
+		    setupcon --force --save >/dev/null 2>/dev/null || true
+		fi
 		;;
 	esac
     fi
+else
+    # Setting the keymap breaks plymouth in raw mode, and setting the
+    # font will currently also break if on vgacon.
+    # Setting the font also corrupts X and postinst may be running with
+    # stripped environment thus we can't even detect X easily.
+    setupcon --save-only >/dev/null 2>/dev/null || true
+    cat >&2 <<EOF
+Your console font configuration will be updated the next time your system
+boots. If you want to update it now, run 'setupcon' from a virtual console.
+EOF
 fi
 
 if ! [ -d /lib/debian-installer.d ]; then
@@ -104,3 +125,9 @@ if ! [ -d /lib/debian-installer.d ]; the
 fi
 
 #DEBHELPER#
+
+if type update-initramfs >/dev/null 2>&1; then
+    update-initramfs -u
+fi
+
+exit 0
diff -pruN 1.195/debian/console-setup-udeb.templates 1.195ubuntu1/debian/console-setup-udeb.templates
--- 1.195/debian/console-setup-udeb.templates	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/console-setup-udeb.templates	2020-03-27 14:41:07.000000000 +0000
@@ -99,7 +99,7 @@ Template: keyboard-configuration/toggle
 Type: select
 # :sl1:
 __Choices: Caps Lock, Right Alt (AltGr), Right Control, Right Shift, Right Logo key, Menu key, Alt+Shift, Control+Shift, Control+Alt, Alt+Caps Lock, Left Control+Left Shift, Left Alt, Left Control, Left Shift, Left Logo key, Scroll Lock key, No toggling
-Default: Alt+Shift
+Default: No toggling
 # :sl1:
 _Description: Method for toggling between national and Latin mode:
  You will need a way to toggle the keyboard between the national
@@ -191,3 +191,23 @@ Template: keyboard-configuration/store_d
 Type: boolean
 Default: true
 Description: for internal use
+
+Template: console-setup/ask_detect
+Type: boolean
+Default: false
+_Description: Detect keyboard layout?
+ You can try to have your keyboard layout detected by pressing a series of
+ keys. If you do not want to do this, you will be able to select your
+ keyboard layout from a list.
+
+Template: console-setup/detect
+Type: detect-keyboard
+Choices: ${FILENAME}
+_Description: Detecting your keyboard layout
+
+Template: console-setup/detected
+Type: note
+_Description: Keyboard layout detection complete
+ Based on the keys you pressed, your keyboard layout appears to be
+ "${LAYOUT}". If this is not correct, you can go back and select your layout
+ from the full list instead.
diff -pruN 1.195/debian/control 1.195ubuntu1/debian/control
--- 1.195/debian/control	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/control	2020-03-27 14:41:07.000000000 +0000
@@ -1,13 +1,15 @@
 Source: console-setup
 Section: utils
 Priority: optional
-Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
 Uploaders: Anton Zinoviev <zinoviev@debian.org>
-Build-Depends-Indep: xkb-data (>= 1.6), locales-all, sharutils
+Build-Depends-Indep: xkb-data (>= 1.6), locales-all, sharutils, keymapper
 Build-Depends: perl, debhelper (>= 9), po-debconf, libxml-parser-perl, bdfresize, liblocale-gettext-perl, dh-systemd
 Standards-Version: 3.9.1
-Vcs-Browser: https://salsa.debian.org/installer-team/console-setup
-Vcs-Git: https://salsa.debian.org/installer-team/console-setup.git
+XS-Debian-Vcs-Browser: https://salsa.debian.org/installer-team/console-setup
+XS-Debian-Vcs-Git: https://salsa.debian.org/installer-team/console-setup.git
+Vcs-Bzr: http://bazaar.launchpad.net/~ubuntu-core-dev/console-setup/ubuntu
 
 Package: keyboard-configuration
 Section: utils
@@ -81,19 +83,6 @@ Description: Linux specific part of cons
  This package includes fonts in psf format and definitions of various
  8-bit charmaps.
 
-Package: console-setup-freebsd
-Section: utils
-Priority: optional
-Architecture: all
-Multi-Arch: foreign
-Depends: vidcontrol, kbdcontrol, keyboard-configuration (= ${source:Version}), ${misc:Depends}, init-system-helpers (>= 1.29~) | initscripts
-Suggests: console-setup
-Conflicts: console-setup-linux
-Breaks: console-setup (<< 1.71)
-Replaces: console-setup (<< 1.71)
-Description: FreeBSD specific part of console-setup
- This package includes raw, uuencoded fonts and various screen maps.
-
 Package: bdf2psf
 Section: utils
 Priority: optional
@@ -121,7 +110,7 @@ Description: font converter to generate
 Package: console-setup-udeb
 Section: debian-installer
 Priority: optional
-Depends: archdetect, cdebconf-udeb, kbd-udeb | kbdcontrol-udeb | hurd-udeb, ${misc:Depends}
+Depends: archdetect, cdebconf-udeb, kbd-udeb | kbdcontrol-udeb | hurd-udeb, cdebconf-newt-detect-keys, ${misc:Depends}
 Provides: keyboard-setup
 Architecture: all
 Description: Configure the keyboard
@@ -200,14 +189,6 @@ Architecture: all
 Description: Linux console fonts for Debian Installer
 Package-Type: udeb
 
-Package: console-setup-freebsd-fonts-udeb
-Section: debian-installer
-Priority: optional
-Depends: ${misc:Depends}
-Architecture: all
-Description: FreeBSD console fonts for Debian Installer
-Package-Type: udeb
-
 Package: console-setup-linux-charmaps-udeb
 Section: debian-installer
 Priority: optional
@@ -215,11 +196,3 @@ Depends: ${misc:Depends}
 Architecture: all
 Description: Linux 8-bit charmaps for console-setup-udeb
 Package-Type: udeb
-
-Package: console-setup-freebsd-charmaps-udeb
-Section: debian-installer
-Priority: optional
-Depends: ${misc:Depends}
-Architecture: all
-Description: FreeBSD 8-bit charmaps for console-setup-udeb
-Package-Type: udeb
diff -pruN 1.195/debian/keyboard-configuration.config 1.195ubuntu1/debian/keyboard-configuration.config
--- 1.195/debian/keyboard-configuration.config	2020-03-26 13:32:36.000000000 +0000
+++ 1.195ubuntu1/debian/keyboard-configuration.config	2020-05-21 00:17:51.000000000 +0000
@@ -78,6 +78,14 @@ XKBLAYOUT=''
 XKBVARIANT=''
 XKBOPTIONS=''
 
+CAPB="$RET"
+detect_keyboard=false
+case $CAPB in
+    *plugin-detect-keyboard*)
+	detect_keyboard=:
+	;;
+esac
+
 if [ -f /usr/share/console-setup/keyboard-configuration.config ]; then
     is_debian_installer=yes
     is_not_debian_installer=''
@@ -88,9 +96,20 @@ fi
 
 ######################################################################
 #   Define auxiliary the functions db_default, regex_excape,
-#    regex_pattern_escape and regex_unescape.
+#   regex_pattern_escape, regex_unescape, and read_config.
 ######################################################################
 
+read_config() {
+    [ -r $1 ] || return 0
+    . $1 || true
+    # Treat missing XKBOPTIONS as empty, other vars have sane defaults:
+    for var in XKBOPTIONS; do
+        if ! grep "^ *${var}=" $1 >/dev/null; then
+            eval ${var}=""
+        fi
+    done
+}
+
 which () {
     local IFS
     IFS=:
@@ -353,6 +372,16 @@ else
     locale=C
 fi
 
+langcountry="$locale"
+if ! type locale >/dev/null 2>&1 || [ "$OVERRIDE_USE_DEBCONF_LOCALE" ]; then
+    if db_get localechooser/languagelist && [ "$RET" ]; then
+	lang="$RET"
+	if db_get debian-installer/country && [ "$RET" ]; then
+	    langcountry="${lang}_$RET"
+	fi
+    fi
+fi
+
 if [ "$LC_MESSAGES"  -a "$LC_MESSAGES" != C ]; then
     messages=$LC_MESSAGES
 elif db_get debian-installer/locale && [ "$RET" ]; then
@@ -476,6 +505,10 @@ case "$arch" in
 	XKBMODEL=pc105
 	model_priority=medium
 	;;
+    ppc64el/*)
+	XKBMODEL=pc105
+	model_priority=medium
+	;;
     sparc*)
 	XKBMODEL=pc105 # sun4 or sun5 on older kernels
 	model_priority=medium
@@ -490,8 +523,8 @@ case "$arch" in
 	;;
 esac    
 
-layout_priority=critical
-case "$locale" in
+layout_priority=high
+case "$langcountry" in
     # Keyboards for countries
     *_AL*)
 	XKBLAYOUT=al  # Albania
@@ -637,8 +670,11 @@ case "$locale" in
     *_MK*)
 	XKBLAYOUT=us,mk  # Macedonia
 	;;
+# According to https://launchpad.net/bugs/129982, Dutch users prefer the US
+# intl keymap.
     *_NL*)
 	XKBLAYOUT=us  # Netherlands
+	XKBVARIANT=intl # International (with dead keys)
 	;;
     *_MM*)
 	XKBLAYOUT=us,mm  # Myanmar
@@ -696,6 +732,10 @@ case "$locale" in
 	XKBLAYOUT=us,th  # Thailand
 	layout_priority=critical
 	;;
+    ku_TR*)
+	XKBLAYOUT=tr  # Turkish
+	XKBVARIANT=ku # Kurdish, Latin Q
+	;;
     *_TR*)
 	XKBLAYOUT=tr  # Turkish
 	layout_priority=critical
@@ -706,8 +746,10 @@ case "$locale" in
     en_US*)
 	XKBLAYOUT=us  # U.S. English
 	;;
+# According to https://launchpad.net/bugs/191451, most keyboards in Vietnam
+# are in fact US keyboards.
     *_VN*)
-	XKBLAYOUT=vn  # Vietnam
+	XKBLAYOUT=us  # Vietnam
 	;;
     *_ZA*)
 	XKBLAYOUT=za  # South Africa
@@ -742,7 +784,7 @@ case "$locale" in
 	;;
     fr_*)
 	XKBLAYOUT=fr  # France
-	XKBVARIANT=latin9
+	XKBVARIANT=oss # Alternative
 	layout_priority=critical
 	;;
     gu_*)
@@ -847,20 +889,20 @@ esac
 ######################################################################
 
 # Get defaults from debconf, to allow preseeding in the udeb
-if db_get keyboard-configuration/xkb-keymap && [ "$RET" ]; then
-    keymap="$RET"
-    layout="${keymap%\(*}"
-    variant="${keymap#$layout}"
-    variant="${variant%\)}"
-    variant="${variant#\(}"
-    XKBLAYOUT="$layout"
-    XKBVARIANT="$variant"
-fi
 if db_get keyboard-configuration/modelcode && [ "$RET" ]; then
     XKBMODEL="$RET"
 fi
 if db_get keyboard-configuration/layoutcode && [ "$RET" ]; then
+    # Don't use the default variant if the layout is being overridden.
+    if [ "$RET" != "$XKBLAYOUT" ]; then
+	XKBVARIANT=''
+    fi
     XKBLAYOUT="$RET"
+    if db_fget keyboard-configuration/layoutcode seen && [ "$RET" = true ]; then
+	layout_priority=medium
+	db_set console-setup/ask_detect false
+	db_fset console-setup/ask_detect seen true
+    fi
 fi
 if db_get keyboard-configuration/variantcode && [ "$RET" ]; then
     XKBVARIANT="$RET"
@@ -1000,13 +1042,9 @@ xkb != "" && /^[ \t]*\"[^"]+\"[ \t]*$/ {
 fi
 
 # Load the config file, if it exists.  Overwrite the current values of
-# XKBMODEL, XKBLAYOUT, XKBVARIANT, etc. in the process.
-if [ -e $OLDCONFIGFILE ]; then
-    . $OLDCONFIGFILE || true
-fi
-if [ -e $CONFIGFILE ]; then
-    . $CONFIGFILE || true
-fi
+# XKBMODEL, XKBLAYOUT, XKBVARIANT, and XKBOPTIONS in the process.
+read_config $OLDCONFIGFILE
+read_config $CONFIGFILE
 
 XKBMODEL=$(echo $XKBMODEL | sed 's/ *//g')
 XKBLAYOUT=$(echo $XKBLAYOUT | sed 's/ *//g')
@@ -1042,7 +1080,7 @@ if ! keyboard_present; then
     db_set keyboard-configuration/variantcode "$XKBVARIANT"
     if [ -z "$XKBOPTIONS" -a ! -f $CONFIGFILE ]; then
 	case "$XKBLAYOUT" in
-	    *,*) XKBOPTIONS="grp:alt_shift_toggle,grp_led:scroll";;
+	    *,*) XKBOPTIONS="grp_led:scroll";;
 	    us) XKBOPTIONS="";;
 	    *) XKBOPTIONS="lv3:ralt_switch";;
 	esac
@@ -1116,7 +1154,7 @@ fi
 
 # Compute debconf_* variables based on the value of $XKBOPTIONS.  The
 # values of these variables are human-friendly text.
-debconf_toggle='Alt+Shift'
+debconf_toggle='No toggling'
 debconf_switch='No temporary switch'
 debconf_altgr='The default for the keyboard layout'
 debconf_compose='No compose key'
@@ -1223,17 +1261,6 @@ db_default keyboard-configuration/altgr
 db_default keyboard-configuration/compose "$debconf_compose"
 db_default keyboard-configuration/ctrl_alt_bksp "$debconf_ctrl_alt_bksp"
 
-# Compute a default value for the xkb-keymap question used by the
-# Debian installer (one question listing all supported layouts instead
-# of one question for the layout only and another for the variant).
-# Store the value in the debconf db.
-if [ -n "$debconf_variant" ]; then
-    debconf_keymap="$debconf_layout($debconf_variant)"
-else
-    debconf_keymap="$debconf_layout"
-fi
-db_default keyboard-configuration/xkb-keymap "$debconf_keymap"
-
 #######################################################################
 #     Ask the Debconf questions starting from STATE=1.
 #######################################################################
@@ -1276,17 +1303,65 @@ while :; do
 	    ;;
 	2)
 	    if \
-                [ "$unsupported_layout" = yes -a "$is_not_debian_installer" ]
-            then
-                # We use two different Debconf templates for the
-                # question about unsupported configuration.  One for
-                # the case when the unsupported layout/variant
-                # combination has been taken from existing
-                # configuration file (obviously in this case the admin
-                # is responsible) and another for the case when it has
-                # been computed based on the system configuration such
-                # as the locale or xorg.conf (in which case the user
-                # may be unaware).
+		$detect_keyboard \
+		&& [ "$XKBMODEL" != SKIP ] \
+		&& [ -e "/usr/share/console-setup-mini/$XKBMODEL.tree" ]
+	    then
+		db_input high console-setup/ask_detect || true
+		if db_go; then
+		    STATE=$(($STATE + 1))
+		else
+		    STATE=$(($STATE - 1))
+		fi
+	    else
+		STATE=$(($STATE + $STATE - $old_state))
+	    fi
+	    ;;
+	3)
+	    if \
+		[ "$STATE" -ge "$old_state" ] \
+		&& $detect_keyboard \
+		&& [ "$XKBMODEL" != SKIP ] \
+		&& [ -e "/usr/share/console-setup-mini/$XKBMODEL.tree" ] \
+		&& db_get console-setup/ask_detect \
+		&& [ "$RET" = true ]
+	    then
+		db_subst console-setup/detect FILENAME \
+		    "/usr/share/console-setup-mini/$XKBMODEL.tree"
+		if db_input critical console-setup/detect && db_go; then
+		    db_get console-setup/detect
+		    detected_keyboard="$RET"
+		    # TODO: produce human-readable layout name
+		    db_subst console-setup/detected LAYOUT "$detected_keyboard"
+		    db_input high console-setup/detected || true
+		    if db_go; then
+			unsupported_layout=no
+			STATE=$(($STATE + 1))
+		    else
+			detected_keyboard=
+			STATE=$(($STATE - 1))
+		    fi
+		else
+		    STATE=$(($STATE - 1))
+		fi
+	    else
+		detected_keyboard=
+		STATE=$(($STATE + $STATE - $old_state))
+	    fi
+	    ;;
+	4)
+	    if [ "$detected_keyboard" ] || [ "$XKBMODEL" = SKIP ]; then
+		STATE=$(( $STATE + $STATE - $old_state ))
+	    elif [ "$unsupported_layout" = yes ]; then
+                # For the question about the keeping of the
+                # unsupported configuration we use two different
+                # Debconf templates depending on whether the
+                # unsupported layout/variant combination has been
+                # taken from existing configuration file (obviously in
+                # this case the admin is responsible) or it has been
+                # computed based on the system configuration such as
+                # the locale or xorg.conf (in which case the user may
+                # be unaware).
 		if [ -f $CONFIGFILE ]; then
                     template=keyboard-configuration/unsupported_config_layout
                 else
@@ -1339,27 +1414,16 @@ while :; do
 		STATE=$(( $STATE + $STATE - $old_state ))
 	    fi
 	    ;;
-	3)
-	    if [ "$is_debian_installer" ]; then
-		# ask simplified layout question in Debian installer
-		db_input critical keyboard-configuration/xkb-keymap || true
-		if db_go; then
-		    db_fset keyboard-configuration/layout seen true
-		    db_fset keyboard-configuration/variant seen true
-		    db_get keyboard-configuration/xkb-keymap
-		    keymap="$RET"
-		    debconf_layout="${keymap%\(*}"
-		    debconf_variant="${keymap#$debconf_layout}"
-		    debconf_variant="${debconf_variant%\)}"
-		    debconf_variant="${debconf_variant#\(}"
-		    STATE=$(($STATE + 1))
-		else
-		    STATE=$(($STATE - 1))
-		fi
-	    elif [ "$unsupported_layout" = yes ]; then
+	5)
+	    if [ "$detected_keyboard" ]; then
+		XKBLAYOUT="${detected_keyboard%%:*}"
+		debconf_layout="$XKBLAYOUT"
+		db_set keyboard-configuration/layoutcode "$XKBLAYOUT"
 		# skip the question without making Debconf loop
 		STATE=$(( $STATE + $STATE - $old_state ))
-	    elif [ "$debconf_variant" != other ]; then
+	    elif [ "$XKBMODEL" = SKIP ]; then
+		STATE=$(( $STATE + $STATE - $old_state ))
+	    elif [ "$unsupported_layout" = yes ]; then
 		# skip the question without making Debconf loop
 		STATE=$(( $STATE + $STATE - $old_state ))
 	    elif \
@@ -1373,38 +1437,44 @@ while :; do
 		STATE=$(($STATE + 1))
 	    fi
 	    ;;
-	4)
-	    db_metaget keyboard-configuration/other description
-	    othertext="$RET"
-	    if [ "$unsupported_layout" = yes ]; then
+	6)
+	    adjust_layout=false
+	    if [ "$detected_keyboard" ]; then
+		case $detected_keyboard in
+		    *:*)
+			variant="${detected_keyboard#*:}"
+			;;
+		    *)
+			variant=
+			;;
+		esac
+		debconf_variant="$variant"
+		adjust_layout=:
 		# skip the question without making Debconf loop
 		STATE=$(( $STATE + $STATE - $old_state ))
-            elif [ "$is_debian_installer" ]; then
-		# skip the question without making Debconf loop
+	    elif [ "$XKBMODEL" = SKIP ]; then
 		STATE=$(( $STATE + $STATE - $old_state ))
-            else
-                if \
-		    ! ask_debconf keyboard-configuration/variant \
-                                  "$layout_priority" \
-                                  "variant*${debconf_layout}" \
-                                  "$debconf_variant" \
-                                  "variant*${debconf_layout}*other*$othertext"
-                then
-		    # skip the previous question
-		    starting_state=$(($STATE - 1))
-		    STATE=$(($STATE - 2))
-                elif [ "$RET" = other ]; then
-                    debconf_variant="$RET"
-		    STATE=$(($STATE - 1))
-                else
-                    debconf_variant="$RET"
-	            STATE=$(($STATE + 1))
-                fi
-            fi
+	    elif [ "$unsupported_layout" = yes ]; then
+		STATE=$(( $STATE + $STATE - $old_state ))
+	    elif \
+		! ask_debconf keyboard-configuration/variant \
+			"$layout_priority" \
+			"variant*${debconf_layout}" \
+			"$debconf_variant"
+	    then
+		# skip the previous question
+		starting_state=$(($STATE - 1))
+		STATE=$(($STATE - 2))
+	    else
+		debconf_variant="$RET"
+		variant="$RET"
+		adjust_layout=:
+		STATE=$(($STATE + 1))
+	    fi
 
             # Compute $XKBLAYOUT and $XKBVARIANT and store their
             # values in debconf db.
-	    if [ "$unsupported_layout" != yes ]; then
+	    if $adjust_layout; then
 		case "$debconf_layout" in
 		    rs)
 			case "$debconf_variant" in
@@ -1418,7 +1488,7 @@ while :; do
 			;;
 		    jp)
 			case "$debconf_variant" in
-			    106|common|OADG109A|'')
+			    106|common|OADG109A|nicola_f_bs|'')
 				XKBLAYOUT=$debconf_layout
 				;;
 			    *)
@@ -1429,9 +1499,16 @@ while :; do
 		    lt)
 			XKBLAYOUT=lt,us
 			;;
-                        # TODO: make s.t. to not forget to update this
-		        # list.  Do not forget to update also the
-		        # nonlatin list in kbdcompiler
+		    me)
+			case "$debconf_variant" in
+			    basic|latin*)
+				XKBLAYOUT=$debconf_layout
+				;;
+			    *)
+				XKBLAYOUT=me,me
+				;;
+			esac
+			;;
 		    af|am|ara|ben|bd|bg|bt|by|et|ge|gh|gr|guj|guru|il|'in'|iq|ir|iku|kan|kh|kz|la|lao|lk|kg|ma|mk|mm|mn|mv|mal|np|ori|pk|ru|scc|sy|syr|tel|th|tj|tam|tib|ua|ug|uz)
 	                XKBLAYOUT=us,$debconf_layout
 	                ;;
@@ -1469,7 +1546,7 @@ while :; do
 	    db_set keyboard-configuration/layoutcode "$XKBLAYOUT"
 	    db_set keyboard-configuration/variantcode "$XKBVARIANT"
 	    ;;
-	5)
+	7)
 	    if \
 		[ "$unsupported_options" = yes -a "$is_not_debian_installer" ]
 	    then
@@ -1500,11 +1577,13 @@ while :; do
 		STATE=$(( $STATE + $STATE - $old_state ))
 	    fi
 	    ;;
-	6)
+	8)
 	    if [ "$unsupported_options" = yes ]; then
 		db_set keyboard-configuration/optionscode "$XKBOPTIONS"
 		# skip the questions without making Debconf loop
 		STATE=$(( $STATE + $STATE - $old_state ))
+	    elif [ "$XKBMODEL" = SKIP ]; then
+		STATE=$(( $STATE + $STATE - $old_state ))
 	    else
 		caps_allocated=no
 		lalt_allocated=no
diff -pruN 1.195/debian/keyboard-configuration.postinst 1.195ubuntu1/debian/keyboard-configuration.postinst
--- 1.195/debian/keyboard-configuration.postinst	2018-10-18 15:01:40.000000000 +0000
+++ 1.195ubuntu1/debian/keyboard-configuration.postinst	2020-03-27 14:41:07.000000000 +0000
@@ -79,21 +79,42 @@ if [ "$1" = "configure" -a ! -L "$CONFIG
     db_set keyboard-configuration/store_defaults_in_debconf_db true
 fi
 
-if \
-    [ -d /lib/debian-installer.d ] && keyboard_present
+if [ -d /lib/debian-installer ];
 then
     if [ "$DISPLAY" ] && which setxkbmap >/dev/null; then
-	setxkbmap -option '' -model "$model" "$layout" "$variant" "$options"
+	setxkbmap -option '' -model "$model" "$layout" "$variant" "$options" || true
+	# setting the font corrupts X
+	# setting up the keyboard breaks wayland
+	if type setupcon >/dev/null 2>&1; then
+	    # We redirect the output so that postinst does not block when ScrollLock is on
+	    setupcon --save-only >/dev/null 2>/dev/null || true
+	    cat >&2 <<EOF
+Your console font configuration will be updated the next time your system
+boots. If you want to update it now, run 'setupcon' from a virtual console.
+EOF
+	fi
     else
 	case "`uname`" in
 	    GNU)
 		[ ! -f /var/run/hurd-console.pid ] || kill `cat /var/run/hurd-console.pid`
 		;;
 	    *)
-		setupcon --force --save
+		if type setupcon >/dev/null 2>&1; then
+		    setupcon --force --save >/dev/null 2>/dev/null || true
+		fi
 		;;
 	esac
     fi
+else
+    # Setting the keymap breaks plymouth in raw mode, and setting the
+    # font will currently also break if on vgacon.
+    # Setting the font also corrupts X and postinst may be running with
+    # stripped environment thus we can't even detect X easily.
+    setupcon --save-only >/dev/null 2>/dev/null || true
+    cat >&2 <<EOF
+Your console font configuration will be updated the next time your system
+boots. If you want to update it now, run 'setupcon' from a virtual console.
+EOF
 fi
 
 if ! [ -d /lib/debian-installer.d ]; then
@@ -104,3 +125,9 @@ if ! [ -d /lib/debian-installer.d ]; the
 fi
 
 #DEBHELPER#
+
+if type update-initramfs >/dev/null 2>&1; then
+    update-initramfs -u
+fi
+
+exit 0
diff -pruN 1.195/debian/keyboard-configuration.templates 1.195ubuntu1/debian/keyboard-configuration.templates
--- 1.195/debian/keyboard-configuration.templates	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/keyboard-configuration.templates	2020-03-27 14:41:07.000000000 +0000
@@ -99,7 +99,7 @@ Template: keyboard-configuration/toggle
 Type: select
 # :sl1:
 __Choices: Caps Lock, Right Alt (AltGr), Right Control, Right Shift, Right Logo key, Menu key, Alt+Shift, Control+Shift, Control+Alt, Alt+Caps Lock, Left Control+Left Shift, Left Alt, Left Control, Left Shift, Left Logo key, Scroll Lock key, No toggling
-Default: Alt+Shift
+Default: No toggling
 # :sl1:
 _Description: Method for toggling between national and Latin mode:
  You will need a way to toggle the keyboard between the national
@@ -191,3 +191,23 @@ Template: keyboard-configuration/store_d
 Type: boolean
 Default: true
 Description: for internal use
+
+Template: console-setup/ask_detect
+Type: boolean
+Default: false
+_Description: Detect keyboard layout?
+ You can try to have your keyboard layout detected by pressing a series of
+ keys. If you do not want to do this, you will be able to select your
+ keyboard layout from a list.
+
+Template: console-setup/detect
+Type: detect-keyboard
+Choices: ${FILENAME}
+_Description: Detecting your keyboard layout
+
+Template: console-setup/detected
+Type: note
+_Description: Keyboard layout detection complete
+ Based on the keys you pressed, your keyboard layout appears to be
+ "${LAYOUT}". If this is not correct, you can go back and select your layout
+ from the full list instead.
diff -pruN 1.195/debian/keyboard_present.sh 1.195ubuntu1/debian/keyboard_present.sh
--- 1.195/debian/keyboard_present.sh	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/keyboard_present.sh	2020-03-27 14:41:08.000000000 +0000
@@ -13,6 +13,7 @@ keyboard_present () {
 
     [ -d /sys/bus/usb/devices ] || return 0
     for d in /sys/bus/usb/devices/*:*; do
+	[ -d "$d" ] || continue
 	class=$(cat "$d/bInterfaceClass") # 03 = Human Interface Device
 	subclass=$(cat "$d/bInterfaceSubClass") # 01 = Boot Interface Subclass
 	protocol=$(cat "$d/bInterfaceProtocol") # 01 = Keyboard
diff -pruN 1.195/debian/po/am.po 1.195ubuntu1/debian/po/am.po
--- 1.195/debian/po/am.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/am.po	2020-03-27 14:41:16.000000000 +0000
@@ -1437,3 +1437,42 @@ msgstr "ቪትናምኛ"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "ጥቅም ላይ የሚውልው የፊደል ገበታ፦"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "የፊደል ገበታ አጣጣል፦"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "ለፊደል ገበታው ቀዳሚ አጣጣል"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "የፊደል ገበታ አጣጣል፦"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ar.po 1.195ubuntu1/debian/po/ar.po
--- 1.195/debian/po/ar.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ar.po	2020-03-27 14:41:17.000000000 +0000
@@ -1509,3 +1509,42 @@ msgstr "الفييتنامية"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "خارطة المفاتيح التي ستستخدم:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "تخطيط لوحة المفاتيح:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "تخطيط لوحة المفاتيح الافتراضي"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "تخطيط لوحة المفاتيح:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ast.po 1.195ubuntu1/debian/po/ast.po
--- 1.195/debian/po/ast.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ast.po	2020-03-27 14:41:17.000000000 +0000
@@ -1482,3 +1482,42 @@ msgstr "Vietnamín"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Keymap a usar:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Distribución de tecláu"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "La disposición por defeutu pal tecláu"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Distribución de tecláu"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/be.po 1.195ubuntu1/debian/po/be.po
--- 1.195/debian/po/be.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/be.po	2020-03-27 14:41:16.000000000 +0000
@@ -1478,3 +1478,42 @@ msgstr "В'етнамская"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Ужываць кодавы набор:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Раскладка клавіятуры:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Перадвызначаная раскладка клавіятуры"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Раскладка клавіятуры:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/bg.po 1.195ubuntu1/debian/po/bg.po
--- 1.195/debian/po/bg.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/bg.po	2020-03-27 14:41:16.000000000 +0000
@@ -1499,3 +1499,42 @@ msgstr "Виетнамски"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Клавишна подредба за ползване:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Клавиатурна подредба:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Избиране на клавиатурна подредба"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Клавиатурна подредба:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/bn.po 1.195ubuntu1/debian/po/bn.po
--- 1.195/debian/po/bn.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/bn.po	2020-03-27 14:41:16.000000000 +0000
@@ -96,7 +96,6 @@ msgstr "# সিরিলিক - নন
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# সিরিলিক - নন-স্লাভিক ল্যাংগুয়েজ"
 
@@ -112,7 +111,6 @@ msgstr "# সিরিলিক - স্
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr "# সিরিলিক - স্লাভিক ল্যাংগুয়েজ (বসনিয়া এবং সার্বীয় ল্যাটিনও)"
 
@@ -1515,3 +1513,42 @@ msgstr "ভিয়েতনামী"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "যে কি-ম্যাপ ব্যবহার করা হবে:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "কীবোর্ড লেআউট"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "কীবোর্ডের জন্য ডিফল্ট লেআউট"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "কীবোর্ড লেআউট"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/bo.po 1.195ubuntu1/debian/po/bo.po
--- 1.195/debian/po/bo.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/bo.po	2020-03-27 14:41:17.000000000 +0000
@@ -1433,3 +1433,42 @@ msgstr "ཝེ་ཐེ་ནམ་ག
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "སྤྱོད་དགོས་པའི་མཐེབ་གཞོང་སྒྲིག་བཀོད："
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "མཐེབ་གཞོང་གི་བཀོད་པ："
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "མཐེབ་གཞོང་བཀོད་པ་དེའི་སྔོན་སྒྲིག"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "མཐེབ་གཞོང་གི་བཀོད་པ："
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/bs.po 1.195ubuntu1/debian/po/bs.po
--- 1.195/debian/po/bs.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/bs.po	2020-03-27 14:41:17.000000000 +0000
@@ -90,7 +90,6 @@ msgstr "# Ćirilica - neslavenski jezici
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# Ćirilica - neslavenski jezici"
 
@@ -107,7 +106,6 @@ msgstr ""
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr ""
 "# Ćirilica - Slavenski jezici (uključujući bosanski i latinični srpski)"
@@ -1494,3 +1492,42 @@ msgstr "Vijetnamski"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Raspored tipki za upotrebu:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Raspored tastature:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Standardni izbor za raspored tastature"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Raspored tastature:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ca.po 1.195ubuntu1/debian/po/ca.po
--- 1.195/debian/po/ca.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ca.po	2020-03-27 14:41:16.000000000 +0000
@@ -1486,3 +1486,42 @@ msgstr "Vietnamita"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Mapa de teclat a emprar:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Disposició del teclat:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "El predeterminat per a la disposició de teclat"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Disposició del teclat:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/cs.po 1.195ubuntu1/debian/po/cs.po
--- 1.195/debian/po/cs.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/cs.po	2020-03-27 14:41:17.000000000 +0000
@@ -1474,3 +1474,42 @@ msgstr "vietnamská"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Klávesová mapa:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Rozložení klávesnice:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Výchozí pro klávesové rozložení"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Rozložení klávesnice:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/cy.po 1.195ubuntu1/debian/po/cy.po
--- 1.195/debian/po/cy.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/cy.po	2020-03-27 14:41:17.000000000 +0000
@@ -1482,3 +1482,42 @@ msgstr "Fietnameg"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Map bysell i'w ddefnyddio:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Cynllun bysellfwrdd:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Y dewis diofyn ar gyfer cynllun y bysellfwrdd"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Cynllun bysellfwrdd:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/da.po 1.195ubuntu1/debian/po/da.po
--- 1.195/debian/po/da.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/da.po	2020-03-27 14:41:17.000000000 +0000
@@ -1537,3 +1537,42 @@ msgstr "Vietnamesisk"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Tastaturudlæg der skal bruges:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Tastaturlayout:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Standard for tastaturlayoutet"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Tastaturlayout:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/de.po 1.195ubuntu1/debian/po/de.po
--- 1.195/debian/po/de.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/de.po	2020-03-27 14:41:16.000000000 +0000
@@ -1516,3 +1516,42 @@ msgstr "Vietnamesisch"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Wählen Sie das Layout der Tastatur aus:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Tastaturbelegung:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Der Standard für die Tastenbelegung"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Tastaturbelegung:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/dz.po 1.195ubuntu1/debian/po/dz.po
--- 1.195/debian/po/dz.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/dz.po	2020-03-27 14:41:17.000000000 +0000
@@ -83,7 +83,6 @@ msgstr "# སི་རི་ལིཀ -
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# སི་རི་ལིཀ - སི་ལེ་བིག་སྐད་ཡིག་མ་ཡིན་པ།"
 
@@ -99,7 +98,6 @@ msgstr "# སི་རི་ལིཀ -
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr "# སི་རི་ལིཀ - སི་ལེ་བིག་སྐད་ཡིག་ (མ་ཚད་ བོསི་ནི་ཡཱན་དང་སར་བི་ཡཱན་ལེ་ཊིན)"
 
@@ -1519,3 +1517,42 @@ msgstr ". ལེ་ཊིན་ - ཝེ
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "ལག་ལེན་འཐབ་ནིའི་དོན་ལུ་ས་ཁྲ་གཙོ་བོ :"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "ལྡེ་སྒྲོམ་སྒྲིག་བཀོད་སེལ་འཐུ་འབད།"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "ལྡེ་སྒྲོམ་སྒྲིག་བཀོད་ཀྱི་དོན་ལུ་སྔོན་སྒྲིག་"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "ལྡེ་སྒྲོམ་སྒྲིག་བཀོད་སེལ་འཐུ་འབད།"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/el.po 1.195ubuntu1/debian/po/el.po
--- 1.195/debian/po/el.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/el.po	2020-03-27 14:41:16.000000000 +0000
@@ -1508,3 +1508,42 @@ msgstr "Βιετναμέζικα"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Απεικόνιση πληκτρολογίου για χρήση:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Διάταξη πληκτρολογίου:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Η προκαθορισμένη επιλογή για τη διάταξη πληκτρολογίου"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Διάταξη πληκτρολογίου:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/eo.po 1.195ubuntu1/debian/po/eo.po
--- 1.195/debian/po/eo.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/eo.po	2020-03-27 14:41:18.000000000 +0000
@@ -1479,3 +1479,42 @@ msgstr "Vjetnama"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Uzota klavmapo :"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Klavar-aranĝo:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "La originalo por la klavar-aranĝo"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Klavar-aranĝo:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/es.po 1.195ubuntu1/debian/po/es.po
--- 1.195/debian/po/es.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/es.po	2020-03-27 14:41:17.000000000 +0000
@@ -1531,3 +1531,42 @@ msgstr "Vietnamita"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Mapa de teclado a usar:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Distribución de teclado:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Distribución por omisión del teclado"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Distribución de teclado:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/et.po 1.195ubuntu1/debian/po/et.po
--- 1.195/debian/po/et.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/et.po	2020-03-27 14:41:18.000000000 +0000
@@ -1483,3 +1483,42 @@ msgstr "Vietnami"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Kasutatav klahvide asetus:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Klaviatuuripaigutus:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Vaikimisi klaviatuuripaigutus"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Klaviatuuripaigutus:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/eu.po 1.195ubuntu1/debian/po/eu.po
--- 1.195/debian/po/eu.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/eu.po	2020-03-27 14:41:16.000000000 +0000
@@ -90,7 +90,6 @@ msgstr "# Zirilikoa - hizkuntza ez-eslav
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# Zirilikoa - hizkuntza ez-eslaviarrak"
 
@@ -106,7 +105,6 @@ msgstr "# Zirilikoa - Hizkuntza eslaviar
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr "# Zirilikoa - Hizkuntza eslaviarrak (Bosnia eta Serbiar Latina barne)"
 
@@ -1495,3 +1493,42 @@ msgstr "Vietnamera"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Erabiliko den teklatu-mapa:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Teklatuaren diseinua:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Teklatuaren diseinu lehenetsia"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Teklatuaren diseinua:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/fa.po 1.195ubuntu1/debian/po/fa.po
--- 1.195/debian/po/fa.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/fa.po	2020-03-27 14:41:16.000000000 +0000
@@ -88,7 +88,6 @@ msgstr "# سایلیریک - زبان‌
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# سایلیریک - زبان‌های غیر اسلاوی"
 
@@ -104,7 +103,6 @@ msgstr "# سایلیریک - زبان‌
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr "# سایلیریک - زبان‌های اسلاوی (همچنین بوسنیایی و لاتین صربستانی)"
 
@@ -1480,3 +1478,42 @@ msgstr "ویتنامی"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "چینش کلید مورد استفاده:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "طرح بندی صفحه کلید:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "طرح بندی پیش فرض صفحه کلید"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "طرح بندی صفحه کلید:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/fi.po 1.195ubuntu1/debian/po/fi.po
--- 1.195/debian/po/fi.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/fi.po	2020-03-27 14:41:17.000000000 +0000
@@ -1521,3 +1521,42 @@ msgstr "vietnamilainen"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Käytettävä näppäinkartta:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Näppäinasettelu:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Valitse näppäinasettelun oletusarvo"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Näppäinasettelu:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/fr.po 1.195ubuntu1/debian/po/fr.po
--- 1.195/debian/po/fr.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/fr.po	2020-03-27 14:41:16.000000000 +0000
@@ -1509,3 +1509,42 @@ msgstr "Vietnamien"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Disposition de clavier à utiliser :"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Disposition du clavier :"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Disposition par défaut pour le clavier"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Disposition du clavier :"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ga.po 1.195ubuntu1/debian/po/ga.po
--- 1.195/debian/po/ga.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ga.po	2020-03-27 14:41:16.000000000 +0000
@@ -1495,3 +1495,42 @@ msgstr "Vítneamach"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Eochairmhapáil le húsáid:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Leagan amach an mhéarchláir:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Leagan amach réamhshocraithe"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Leagan amach an mhéarchláir:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/gl.po 1.195ubuntu1/debian/po/gl.po
--- 1.195/debian/po/gl.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/gl.po	2020-03-27 14:41:17.000000000 +0000
@@ -1482,3 +1482,42 @@ msgstr "Vietnamita"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Esquema de teclado a empregar:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Disposición do teclado:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "A disposición de teclado predeterminada"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Disposición do teclado:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/gu.po 1.195ubuntu1/debian/po/gu.po
--- 1.195/debian/po/gu.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/gu.po	2020-03-27 14:41:17.000000000 +0000
@@ -1471,3 +1471,42 @@ msgstr "વિયેતનામી"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "ઉપયોગ કરવાનો કીમેપ:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "કીબોર્ડ દેખાવ:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "કીબોર્ડ દેખાવ માટે મૂળભૂત"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "કીબોર્ડ દેખાવ:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/he.po 1.195ubuntu1/debian/po/he.po
--- 1.195/debian/po/he.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/he.po	2020-03-27 14:41:16.000000000 +0000
@@ -1506,3 +1506,42 @@ msgstr "וייטנאמית"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "מפת תווים לשימוש:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "פריסת מקלדת:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "ברירת המחדל עבור פריסת המקלדת"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "פריסת מקלדת:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/hi.po 1.195ubuntu1/debian/po/hi.po
--- 1.195/debian/po/hi.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/hi.po	2020-03-27 14:41:16.000000000 +0000
@@ -1507,3 +1507,42 @@ msgstr "वियेतनामी"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "कुंजीपट खाका जिसे इस्तेमाल करना है:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "कुंजीपट का अभिन्यास:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "कुंजीपटल का डिफॉल्ट अभिन्यास"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "कुंजीपट का अभिन्यास:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/hr.po 1.195ubuntu1/debian/po/hr.po
--- 1.195/debian/po/hr.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/hr.po	2020-03-27 14:41:16.000000000 +0000
@@ -1496,3 +1496,42 @@ msgstr "Vijetnamska"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Raspored tipkovnice:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Raspored tipkovnice:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Izbor zadane tipkovnice"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Raspored tipkovnice:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/hu.po 1.195ubuntu1/debian/po/hu.po
--- 1.195/debian/po/hu.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/hu.po	2020-03-27 14:41:17.000000000 +0000
@@ -1532,3 +1532,45 @@ msgstr "vietnami"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Használni kívánt billentyűkiosztás:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Billentyűkiosztás:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+# Type: select
+# Choices
+# :sl2:
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Alapértelmezés a billentyűzetkiosztáshoz"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Billentyűkiosztás:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/hy.po 1.195ubuntu1/debian/po/hy.po
--- 1.195/debian/po/hy.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/hy.po	2020-03-27 14:41:16.000000000 +0000
@@ -1410,3 +1410,39 @@ msgstr ""
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr ""
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid "Detect keyboard layout?"
+msgstr ""
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+msgid "Detecting your keyboard layout"
+msgstr ""
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid "Keyboard layout detection complete"
+msgstr ""
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/id.po 1.195ubuntu1/debian/po/id.po
--- 1.195/debian/po/id.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/id.po	2020-03-27 14:41:16.000000000 +0000
@@ -1490,3 +1490,42 @@ msgstr "Vietnam"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Peta tombol yang dipakai:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Pola keyboard:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Pola keyboard standar"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Pola keyboard:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/is.po 1.195ubuntu1/debian/po/is.po
--- 1.195/debian/po/is.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/is.po	2020-03-27 14:41:17.000000000 +0000
@@ -1490,3 +1490,42 @@ msgstr "Víetnamskt"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Lyklaborðsvörpun sem á að nota:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Skipulag lyklaborðs:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Sjálfgefið í lyklaborðsuppsetningu"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Skipulag lyklaborðs:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/it.po 1.195ubuntu1/debian/po/it.po
--- 1.195/debian/po/it.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/it.po	2020-03-27 14:41:16.000000000 +0000
@@ -1507,3 +1507,42 @@ msgstr "Vietnamita"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Mappa della tastiera da usare:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Disposizione della tastiera:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "La disposizione predefinita della tastiera"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Disposizione della tastiera:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ja.po 1.195ubuntu1/debian/po/ja.po
--- 1.195/debian/po/ja.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ja.po	2020-03-27 14:41:16.000000000 +0000
@@ -1521,3 +1521,42 @@ msgstr "ベトナム語"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "利用するキーマップ:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "キーボードのレイアウト:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "キーボード配置のデフォルト"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "キーボードのレイアウト:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ka.po 1.195ubuntu1/debian/po/ka.po
--- 1.195/debian/po/ka.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ka.po	2020-03-27 14:41:17.000000000 +0000
@@ -89,7 +89,6 @@ msgstr "# კირილიცა - ა
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# კირილიცა - არასლავური ენები"
 
@@ -105,7 +104,6 @@ msgstr "# კირილიცა - ს
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr "# კირილიცა - სლავური ენები (ასევე ბოსნიური და სერბული ლათინური)"
 
@@ -1470,3 +1468,42 @@ msgstr ". ლათინური - ვ
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "სასურველი განლაგება:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "კლავიატურის განლაგების ამორჩევა"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "კლავიატურის განლაგების ამორჩევა"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "კლავიატურის განლაგების ამორჩევა"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/kk.po 1.195ubuntu1/debian/po/kk.po
--- 1.195/debian/po/kk.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/kk.po	2020-03-27 14:41:17.000000000 +0000
@@ -1479,3 +1479,42 @@ msgstr "Вьетнам"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Қолданылатын пернетақта жаймасы:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Пернетақта жаймасы:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Пернетақта жаймасы үшін бастапқы"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Пернетақта жаймасы:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/km.po 1.195ubuntu1/debian/po/km.po
--- 1.195/debian/po/km.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/km.po	2020-03-27 14:41:17.000000000 +0000
@@ -78,7 +78,6 @@ msgstr "# ស៊ីរីលីក - ម
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# ស៊ីរីលីក - មិនមែន​ភាសា​ស្លូវ៉ាគី"
 
@@ -94,7 +93,6 @@ msgstr "# ស៊ីរីលីក - ភ
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr "# ស៊ីរីលីក - ភាសាស្លូវ៉ាគី (ប៊ូស្នី និង​ស៊ែរប៊ី​ឡាតាំង)"
 
@@ -1461,3 +1459,42 @@ msgstr "វៀតណាម"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "ផែនទី​គ្រាប់ចុច​ត្រូវ​ប្រើ ៖"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "​ប្លង់​ក្ដារចុច ៖"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "លំនាំដើម​សម្រាប់​ប្លង់​ក្ដារចុច"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "​ប្លង់​ក្ដារចុច ៖"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/kn.po 1.195ubuntu1/debian/po/kn.po
--- 1.195/debian/po/kn.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/kn.po	2020-03-27 14:41:16.000000000 +0000
@@ -1476,3 +1476,42 @@ msgstr "ವಿಯೆಟ್ನಾಮೀ
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "ಉಪಯೇಗಿಸುವ ಕೀಲಿ ಗಾತ್ರ::"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "ಕೀಲಿಮಣೆಯ ವಿನ್ಯಾಸವನ್ನು ಸೂಚಿಸು"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "ಅಕ್ಷರಫಲಕದ ಪೂರ್ವನಿರ್ಧಾರಿತ ವಿನ್ಯಾಸ"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "ಕೀಲಿಮಣೆಯ ವಿನ್ಯಾಸವನ್ನು ಸೂಚಿಸು"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ko.po 1.195ubuntu1/debian/po/ko.po
--- 1.195/debian/po/ko.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ko.po	2020-03-27 14:41:16.000000000 +0000
@@ -1469,3 +1469,42 @@ msgstr "베트남어"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "사용할 키맵:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "키보드 배치:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "기본 키보드 배치"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "키보드 배치:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ku.po 1.195ubuntu1/debian/po/ku.po
--- 1.195/debian/po/ku.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ku.po	2020-03-27 14:41:17.000000000 +0000
@@ -84,7 +84,6 @@ msgstr "# Kîrîlî - zimanên neslavî"
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# Kîrîlî - zimanên neslavî"
 
@@ -100,7 +99,6 @@ msgstr "# Kîrîlî - zimanên slavî (b
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr "# Kîrîlî - zimanên slavî (bosnî û sirbî ya latînî jî)"
 
@@ -1483,3 +1481,42 @@ msgstr "vîyetnamî"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Plana bişkojan a dê were bikaranîn:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Rengê klavyeyê"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Standarda cureyê klavyeyê"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Rengê klavyeyê"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/lo.po 1.195ubuntu1/debian/po/lo.po
--- 1.195/debian/po/lo.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/lo.po	2020-03-27 14:41:17.000000000 +0000
@@ -77,7 +77,6 @@ msgstr "ຊີຣິລລິກ-ພາ
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "ຊີຣິລລິກ-ພາສາທີ່ບໍ່ແມ່ນພາສາສະລາບ "
 
@@ -93,7 +92,6 @@ msgstr "ຊີຣິລລິກ-ພາ
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr "ຊີຣິລລິກ-ພາສາສະລາບ(ຍັງບອສເນຍແລະລາຕິນເຊີເບຍ)"
 
@@ -1440,3 +1438,42 @@ msgstr "ພາສາຫວຽດ"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "ຜັງແປ້ນພິມທີ່ໃຊ້:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "ໂຄງຮ່າງແປ້ນພິມ"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "ຄ່າເລີ່ມຕົ້ນຂອງຜັງແປ້ນພິມ"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "ໂຄງຮ່າງແປ້ນພິມ"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/lt.po 1.195ubuntu1/debian/po/lt.po
--- 1.195/debian/po/lt.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/lt.po	2020-03-27 14:41:17.000000000 +0000
@@ -1493,3 +1493,42 @@ msgstr "Vietnamiečių"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Naudotinas klavišų išdėstymas:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Klaviatūros išdėstymas:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Numatytasis klaviatūros išdėstyme"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Klaviatūros išdėstymas:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/lv.po 1.195ubuntu1/debian/po/lv.po
--- 1.195/debian/po/lv.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/lv.po	2020-03-27 14:41:18.000000000 +0000
@@ -1487,3 +1487,42 @@ msgstr "Vjetnamiešu"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Izklājums:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Tastatūras izkārtojums:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Tastatūras izklājuma noklusējuma vērtība"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Tastatūras izkārtojums:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/mk.po 1.195ubuntu1/debian/po/mk.po
--- 1.195/debian/po/mk.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/mk.po	2020-03-27 14:41:17.000000000 +0000
@@ -88,7 +88,6 @@ msgstr "# Кирилица - несло
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# Кирилица - несловенски јазици"
 
@@ -105,7 +104,6 @@ msgstr ""
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr ""
 "# Кирилица - словенски јазици (исто така и латиница на босански и српски)"
@@ -1493,3 +1491,42 @@ msgstr "Виетнамски"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Распоред на тастатура кој ќе се користи:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Распоред на тастатура:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Основен избор за распоредот на тастатурата"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Распоред на тастатура:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ml.po 1.195ubuntu1/debian/po/ml.po
--- 1.195/debian/po/ml.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ml.po	2020-03-27 14:41:17.000000000 +0000
@@ -467,8 +467,8 @@ msgid ""
 "The current keyboard options in the configuration file /etc/default/keyboard "
 "are defined as XKBOPTIONS=\"${XKBOPTIONS}\"."
 msgstr ""
-"/etc/default/keyboard ക്രമീകരണ ഫയലിലെ ഇപ്പോഴത്തെ കീബോര്‍ഡ് ക്രമീകരണം നിര്‍"
-"വ്വചിച്ചിരിക്കുന്നത് XKBOPTIONS=\"${XKBOPTIONS}\" എന്നാണ്."
+"/etc/default/keyboard ക്രമീകരണ ഫയലിലെ ഇപ്പോഴത്തെ കീബോര്‍ഡ് ക്രമീകരണം "
+"നിര്‍വ്വചിച്ചിരിക്കുന്നത് XKBOPTIONS=\"${XKBOPTIONS}\" എന്നാണ്."
 
 #. Type: boolean
 #. Description
@@ -767,8 +767,8 @@ msgid ""
 "That key may also be used to input national letters when the keyboard is in "
 "Latin mode."
 msgstr ""
-"കീബോര്‍ഡ് ദേശീയ ദശയിലായിരിയ്ക്കുമ്പോള്‍ ചില ലാറ്റിന്‍ അക്ഷരങ്ങള്‍ മാത്രം ടൈപ്പ് ചെയ്യേണ്ട സന്ദര്‍"
-"ഭങ്ങളില്‍ താത്കാലികമായി ലാറ്റിന്‍ ദശയിലേയ്ക്കു് മാറുന്നതായിരിയ്ക്കാം കൂടുതല്‍ അനുയോജ്യം. "
+"കീബോര്‍ഡ് ദേശീയ ദശയിലായിരിയ്ക്കുമ്പോള്‍ ചില ലാറ്റിന്‍ അക്ഷരങ്ങള്‍ മാത്രം ടൈപ്പ് ചെയ്യേണ്ട "
+"സന്ദര്‍ഭങ്ങളില്‍ താത്കാലികമായി ലാറ്റിന്‍ ദശയിലേയ്ക്കു് മാറുന്നതായിരിയ്ക്കാം കൂടുതല്‍ അനുയോജ്യം. "
 "തിരഞ്ഞെടുത്ത കീ അമര്‍ത്തിയിരിയ്ക്കുന്നിടത്തോളം ആ ദശയിലിരിയ്ക്കും. അതേ കീ തന്നെ ലാറ്റിന്‍ "
 "ദശയിലായിരിയ്ക്കുമ്പോള്‍ ദേശീയ അക്ഷരങ്ങള്‍ ഇന്‍പുട്ട് ചെയ്യാന്‍ ഉപയോഗിയ്ക്കാം."
 
@@ -863,8 +863,8 @@ msgid ""
 "Unicode mode, regardless of what you choose here, you can always also use "
 "the Control+period combination as a Compose key."
 msgstr ""
-"അടുത്ത കണ്‍സോളില്‍ കോമ്പോസ് കീ യൂണിക്കോഡ് മോഡില്‍ പ്രവര്‍ത്തിക്കില്ല. യൂണിക്കോഡ് മോഡിലല്ലെങ്കില്‍ കണ്‍"
-"ട്രോ‌‌ള്‍ + പിരീഡ് കോമ്പിനേഷന്‍ ഒരു കോമ്പോസ് കീ ആയി ഉപയോഗിക്കാവുന്നതാണ്. ഇവിടെ താങ്കള്‍ "
+"അടുത്ത കണ്‍സോളില്‍ കോമ്പോസ് കീ യൂണിക്കോഡ് മോഡില്‍ പ്രവര്‍ത്തിക്കില്ല. യൂണിക്കോഡ് മോഡിലല്ലെങ്കില്‍ "
+"കണ്‍ട്രോ‌‌ള്‍ + പിരീഡ് കോമ്പിനേഷന്‍ ഒരു കോമ്പോസ് കീ ആയി ഉപയോഗിക്കാവുന്നതാണ്. ഇവിടെ താങ്കള്‍ "
 "തിരഞ്ഞെടുത്തത് അതിനെ ബാധിക്കില്ല"
 
 #. Type: boolean
@@ -1505,3 +1505,42 @@ msgstr "വിയറ്റ്നാമ
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "ഉപയോഗിയ്ക്കേണ്ട കീമാപ്:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "കീബോര്‍ഡ് വിന്യാസം:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "ഒരു കീബോര്‍ഡ് വിന്യാസത്തിന്റെ സഹജവില"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "കീബോര്‍ഡ് വിന്യാസം:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/mr.po 1.195ubuntu1/debian/po/mr.po
--- 1.195/debian/po/mr.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/mr.po	2020-03-27 14:41:16.000000000 +0000
@@ -1464,3 +1464,42 @@ msgstr "विएतनामिज"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "वापरायचा कीमॅप:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "कळफलकाचा आरखडा:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "कळफलकाचा मूलनिर्धारित आरखडा"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "कळफलकाचा आरखडा:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/nb.po 1.195ubuntu1/debian/po/nb.po
--- 1.195/debian/po/nb.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/nb.po	2020-03-27 14:41:17.000000000 +0000
@@ -1488,3 +1488,42 @@ msgstr "Vietnamesisk"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Tasteoppsett som skal brukes:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Tastaturutforming:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Standarden for tastaturutformingen"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Tastaturutforming:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ne.po 1.195ubuntu1/debian/po/ne.po
--- 1.195/debian/po/ne.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ne.po	2020-03-27 14:41:17.000000000 +0000
@@ -1461,3 +1461,42 @@ msgstr "भियेतनमिज"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "प्रयोग गर्नका लागि कुञ्जी मानचित्र:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "एउटा कुञ्जीपाटी सजावट चयन गर्नुहोस् "
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "एउटा कुञ्जीपाटी सजावट चयन गर्नुहोस् "
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "एउटा कुञ्जीपाटी सजावट चयन गर्नुहोस् "
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/nl.po 1.195ubuntu1/debian/po/nl.po
--- 1.195/debian/po/nl.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/nl.po	2020-03-27 14:41:16.000000000 +0000
@@ -1497,3 +1497,42 @@ msgstr "Vietnamees"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Te gebruiken toetsenbordindeling:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Toetsenbordindeling:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "De standaard voor de toetsenbordindeling"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Toetsenbordindeling:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/nn.po 1.195ubuntu1/debian/po/nn.po
--- 1.195/debian/po/nn.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/nn.po	2020-03-27 14:41:17.000000000 +0000
@@ -90,7 +90,6 @@ msgstr "# Kyrillisk – ikkje-slaviske s
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# Kyrillisk – ikkje-slaviske språk"
 
@@ -108,7 +107,6 @@ msgstr ""
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr ""
 "# Kyrillisk – slaviske språk (også bosnisk og serbisk med det latinske "
@@ -1507,3 +1505,42 @@ msgstr "Vietnamesisk"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Tasteoppsett som skal brukast:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Vel eit tastaturoppsett"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Vel eit tastaturoppsett"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Vel eit tastaturoppsett"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/pa.po 1.195ubuntu1/debian/po/pa.po
--- 1.195/debian/po/pa.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/pa.po	2020-03-27 14:41:18.000000000 +0000
@@ -1463,3 +1463,42 @@ msgstr "ਵੀਅਤਨਾਮੀ"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "ਵਰਤਣ ਲਈ ਕੀਮੈਪ:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "ਆਪਣਾ ਕੀ-ਬੋਰਡ ਲੇਆਉਟ ਚੁਣੋ"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "ਆਪਣਾ ਕੀ-ਬੋਰਡ ਲੇਆਉਟ ਚੁਣੋ"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "ਆਪਣਾ ਕੀ-ਬੋਰਡ ਲੇਆਉਟ ਚੁਣੋ"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/pl.po 1.195ubuntu1/debian/po/pl.po
--- 1.195/debian/po/pl.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/pl.po	2020-03-27 14:41:16.000000000 +0000
@@ -1497,3 +1497,42 @@ msgstr "Wietnamski"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Układ klawiatury:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Układ klawiatury:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Domyślne ustawienie dla danego układu klawiatury"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Układ klawiatury:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/pt_BR.po 1.195ubuntu1/debian/po/pt_BR.po
--- 1.195/debian/po/pt_BR.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/pt_BR.po	2020-03-27 14:41:17.000000000 +0000
@@ -1485,3 +1485,42 @@ msgstr "Vietnamita"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Mapa de teclado a ser usado:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Layout do teclado:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "O padrão para o layout de teclado"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Layout do teclado:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/pt.po 1.195ubuntu1/debian/po/pt.po
--- 1.195/debian/po/pt.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/pt.po	2020-03-27 14:41:17.000000000 +0000
@@ -1482,3 +1482,42 @@ msgstr "Vietnamita"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Mapa de teclado a utilizar:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Disposição do teclado:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "O predefinido para a disposição do teclado"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Disposição do teclado:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ro.po 1.195ubuntu1/debian/po/ro.po
--- 1.195/debian/po/ro.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ro.po	2020-03-27 14:41:16.000000000 +0000
@@ -1500,3 +1500,42 @@ msgstr "Vietnameză"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Configurația de taste utilizată:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Aranjamentul de tastatură:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Valoarea implicită a aranjamentului de tastatură"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Aranjamentul de tastatură:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ru.po 1.195ubuntu1/debian/po/ru.po
--- 1.195/debian/po/ru.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ru.po	2020-03-27 14:41:17.000000000 +0000
@@ -1492,3 +1492,42 @@ msgstr "Вьетнамская"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Выберите клавиатурную раскладку:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Раскладка клавиатуры:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Раскладка клавиатуры по умолчанию"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Раскладка клавиатуры:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/se.po 1.195ubuntu1/debian/po/se.po
--- 1.195/debian/po/se.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/se.po	2020-03-27 14:41:18.000000000 +0000
@@ -1446,3 +1446,42 @@ msgstr ""
 #, fuzzy
 msgid "Keymap to use:"
 msgstr "Nammabálvváid čujuhusat:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Vállje boallobeavdehápmi"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Vállje boallobeavdehápmi"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Vállje boallobeavdehápmi"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/si.po 1.195ubuntu1/debian/po/si.po
--- 1.195/debian/po/si.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/si.po	2020-03-27 14:41:15.000000000 +0000
@@ -82,7 +82,6 @@ msgstr "# සිරිලික් - ස
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# සිරිලික් - සැල්වික් නොවන භාශා"
 
@@ -98,7 +97,6 @@ msgstr "# සිරිලික් - ස
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr "# සිරිලික් - සැල්වික් භාශා (තවද බොස්නියානු හා සර්බියානු ලතින්)"
 
@@ -1464,3 +1462,42 @@ msgstr "වියෙට්නාම"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "භාවිත යතුරු සැකැස්ම:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "යතුරුපුවරු ආකෘතිය:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "යතුරුපුවරු ආකෘතිය සඳහා සම්මතය"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "යතුරුපුවරු ආකෘතිය:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/sk.po 1.195ubuntu1/debian/po/sk.po
--- 1.195/debian/po/sk.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/sk.po	2020-03-27 14:41:16.000000000 +0000
@@ -1485,3 +1485,42 @@ msgstr "vietnamská"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Klávesová mapa:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Rozloženie klávesnice:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Predvolené rozloženie klávesnice"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Rozloženie klávesnice:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/sl.po 1.195ubuntu1/debian/po/sl.po
--- 1.195/debian/po/sl.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/sl.po	2020-03-27 14:41:17.000000000 +0000
@@ -99,7 +99,6 @@ msgstr "# Cirilica- ne-slovanski jeziki"
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# Cirilica- ne-slovanski jeziki"
 
@@ -116,7 +115,6 @@ msgstr ""
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr ""
 "# Cirilica - Slovanski jeziki (vključno z bosanščino in srbsko latinico)"
@@ -1503,3 +1501,42 @@ msgstr "Vietnamščina"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Postavitev tipkovnice, ki jo želite uporabljati:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Postavitev tipkovnice:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Privzeta postavitev tipkovnice"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Postavitev tipkovnice:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/sq.po 1.195ubuntu1/debian/po/sq.po
--- 1.195/debian/po/sq.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/sq.po	2020-03-27 14:41:16.000000000 +0000
@@ -86,7 +86,6 @@ msgstr "# Cirilike - gjuhët jo-sllave"
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# Cirilike - gjuhët jo-sllave"
 
@@ -103,7 +102,6 @@ msgstr ""
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr ""
 "# Cirilike - Gjuhët sllave (gjithashtu Bosnjisht dhe Serbishtja Latine)"
@@ -1490,3 +1488,42 @@ msgstr "Vietnamisht"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Lloji i tastierës për tu përdorur:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Zgjidh një tastierë"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Zgjidh një tastierë"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Zgjidh një tastierë"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/sr@latin.po 1.195ubuntu1/debian/po/sr@latin.po
--- 1.195/debian/po/sr@latin.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/sr@latin.po	2020-03-27 14:41:17.000000000 +0000
@@ -76,7 +76,6 @@ msgstr "# ćirilica - neslovenski jezici
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# ćirilica - neslovenski jezici"
 
@@ -92,7 +91,6 @@ msgstr "# ćirilica - slovenski jezici (
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr "# ćirilica - slovenski jezici (takođe srpska latinica i bosanski)"
 
@@ -293,9 +291,6 @@ msgstr "Veličina fonta:"
 #. :sl3:
 #: ../console-setup.templates:7001
 #, fuzzy
-#| msgid ""
-#| "Please select the size of the font for the Linux console. For reference, "
-#| "the font used when the computer boots has size 16."
 msgid ""
 "Please select the size of the font for the console. For reference, the font "
 "used when the computer boots has size 8x16."
@@ -308,9 +303,6 @@ msgstr ""
 #. :sl3:
 #: ../console-setup.templates:8001
 #, fuzzy
-#| msgid ""
-#| "Please select the size of the font for the Linux console. For reference, "
-#| "the font used when the computer boots has size 16."
 msgid ""
 "Please select the size of the font for the console.  For reference, the font "
 "used when the computer boots has size 8x16.  Some font sizes require the kbd "
@@ -492,9 +484,9 @@ msgid ""
 "\"${XKBOPTIONS}\".  It is based on the currently defined language/region and "
 "the settings in /etc/X11/xorg.conf."
 msgstr ""
-"Podrazumevana vrednost za opcije rasporeda tastature je "
-"XKBOPTIONS=„${XKBOPTIONS}“.  Bazirana je na trenutno definisanim jeziku/"
-"regionu i podešavanjima u /etc/X11/xorg.conf."
+"Podrazumevana vrednost za opcije rasporeda tastature je XKBOPTIONS="
+"„${XKBOPTIONS}“.  Bazirana je na trenutno definisanim jeziku/regionu i "
+"podešavanjima u /etc/X11/xorg.conf."
 
 #. Type: boolean
 #. Description
@@ -906,7 +898,6 @@ msgstr ""
 #. :sl1:
 #: ../keyboard-configuration.templates:16001
 #, fuzzy
-#| msgid ". Arabic"
 msgid "Arabic"
 msgstr ". arapski"
 
@@ -1076,7 +1067,6 @@ msgstr ""
 #. :sl1:
 #: ../keyboard-configuration.templates:16001
 #, fuzzy
-#| msgid ". Ethiopic"
 msgid "Ethiopian"
 msgstr ". etiopski"
 
@@ -1099,7 +1089,6 @@ msgstr ""
 #. :sl1:
 #: ../keyboard-configuration.templates:16001
 #, fuzzy
-#| msgid "# Georgian"
 msgid "Georgian"
 msgstr "# gruzijski"
 
@@ -1115,7 +1104,6 @@ msgstr ""
 #. :sl1:
 #: ../keyboard-configuration.templates:16001
 #, fuzzy
-#| msgid "# Greek"
 msgid "Greek"
 msgstr "# grčki"
 
@@ -1138,7 +1126,6 @@ msgstr ""
 #. :sl1:
 #: ../keyboard-configuration.templates:16001
 #, fuzzy
-#| msgid "# Hebrew"
 msgid "Hebrew"
 msgstr "# hebrejski"
 
@@ -1238,7 +1225,6 @@ msgstr ""
 #. :sl1:
 #: ../keyboard-configuration.templates:16001
 #, fuzzy
-#| msgid "# Lao"
 msgid "Lao"
 msgstr "# lao"
 
@@ -1296,7 +1282,6 @@ msgstr ""
 #. :sl1:
 #: ../keyboard-configuration.templates:16001
 #, fuzzy
-#| msgid "# Georgian"
 msgid "Norwegian"
 msgstr "# gruzijski"
 
@@ -1438,7 +1423,6 @@ msgstr ""
 #. :sl1:
 #: ../keyboard-configuration.templates:16001
 #, fuzzy
-#| msgid "# Thai"
 msgid "Thai"
 msgstr "# tai"
 
@@ -1482,7 +1466,6 @@ msgstr ""
 #. :sl1:
 #: ../keyboard-configuration.templates:16001
 #, fuzzy
-#| msgid ". Latin - Vietnamese"
 msgid "Vietnamese"
 msgstr ". Latin - vijetnamski"
 
@@ -1492,6 +1475,45 @@ msgstr ". Latin - vijetnamski"
 msgid "Keymap to use:"
 msgstr ""
 
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Raspored tastature:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Podrazumevani raspored tastature"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Raspored tastature:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
+
 #~ msgid ""
 #~ "Please select the size of the font for the Linux console. Simple integers "
 #~ "corresponding to fonts can be used with all console drivers. The number "
diff -pruN 1.195/debian/po/sr.po 1.195ubuntu1/debian/po/sr.po
--- 1.195/debian/po/sr.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/sr.po	2020-03-27 14:41:17.000000000 +0000
@@ -496,9 +496,9 @@ msgid ""
 "\"${XKBOPTIONS}\".  It is based on the currently defined language/region and "
 "the settings in /etc/X11/xorg.conf."
 msgstr ""
-"Подразумевана вредност за опције распореда тастатуре је "
-"XKBOPTIONS=„${XKBOPTIONS}“.  Базирана је на тренутно дефинисаним језику/"
-"региону и подешавањима у /etc/X11/xorg.conf."
+"Подразумевана вредност за опције распореда тастатуре је XKBOPTIONS="
+"„${XKBOPTIONS}“.  Базирана је на тренутно дефинисаним језику/региону и "
+"подешавањима у /etc/X11/xorg.conf."
 
 #. Type: boolean
 #. Description
@@ -1477,3 +1477,42 @@ msgstr "вијетнамски"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Распоред тастатуре за употребу:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Распоред тастатуре:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Подразумевани распоред тастатуре"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Распоред тастатуре:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/sv.po 1.195ubuntu1/debian/po/sv.po
--- 1.195/debian/po/sv.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/sv.po	2020-03-27 14:41:17.000000000 +0000
@@ -1492,3 +1492,42 @@ msgstr "Vietnamesisk"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Tangentuppsättning som ska användas:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Tangentbordslayout:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Standardvärdet för tangentbordslayouten"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Tangentbordslayout:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ta.po 1.195ubuntu1/debian/po/ta.po
--- 1.195/debian/po/ta.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ta.po	2020-03-27 14:41:17.000000000 +0000
@@ -1513,3 +1513,42 @@ msgstr "வியட்னாம்"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "பயன் படுத்த விசைப் பலகை அமைப்பு:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "விசைப்பலகை இடஅமைவு:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "முன்னிருப்பு விசைப்பலகை இடஅமைவு "
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "விசைப்பலகை இடஅமைவு:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/templates.pot 1.195ubuntu1/debian/po/templates.pot
--- 1.195/debian/po/templates.pot	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/templates.pot	2020-03-27 14:41:08.000000000 +0000
@@ -1403,3 +1403,39 @@ msgstr ""
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr ""
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid "Detect keyboard layout?"
+msgstr ""
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+msgid "Detecting your keyboard layout"
+msgstr ""
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid "Keyboard layout detection complete"
+msgstr ""
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/te.po 1.195ubuntu1/debian/po/te.po
--- 1.195/debian/po/te.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/te.po	2020-03-27 14:41:16.000000000 +0000
@@ -1457,3 +1457,42 @@ msgstr "వియత్నాంసీ"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "ఉపయోగించాల్సిన కీమ్యాప్:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "కీబోర్డు లేఔటు:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "ఒక కీబోర్డు లేఔటు  ఎంచుకోకపోతే  తీసుకొనేది"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "కీబోర్డు లేఔటు:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/tg.po 1.195ubuntu1/debian/po/tg.po
--- 1.195/debian/po/tg.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/tg.po	2020-03-27 14:41:17.000000000 +0000
@@ -1486,3 +1486,42 @@ msgstr "Ветнамӣ"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Тарҳбандии ҳарфкалид барои истифода:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Тарҳбандии клавиатура:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Тарҳбандии пешфарз барои клавиатура"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Тарҳбандии клавиатура:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/th.po 1.195ubuntu1/debian/po/th.po
--- 1.195/debian/po/th.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/th.po	2020-03-27 14:41:16.000000000 +0000
@@ -86,7 +86,6 @@ msgstr "# ซีริลลิก - ภ
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# ซีริลลิก - ภาษาที่ไม่ใช่ตระกูลสลาฟ"
 
@@ -102,7 +101,6 @@ msgstr "# ซีริลลิก - ภ
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr "# ซีริลลิก - ภาษาตระกูลสลาฟ (รวมถึงบอสเนียและละตินเซอร์เบีย)"
 
@@ -1465,3 +1463,42 @@ msgstr "เวียดนาม"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "ผังแป้นพิมพ์ที่จะใช้:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "ผังแป้นพิมพ์แบบย่อย:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "ค่าปริยายของผังแป้นพิมพ์"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "ผังแป้นพิมพ์แบบย่อย:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/tl.po 1.195ubuntu1/debian/po/tl.po
--- 1.195/debian/po/tl.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/tl.po	2020-03-27 14:41:16.000000000 +0000
@@ -1493,3 +1493,42 @@ msgstr ""
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Anyo ng tiklado na gamitin:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Pumili ng tamang pagkakalatag ng tiklado"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Pumili ng tamang pagkakalatag ng tiklado"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Pumili ng tamang pagkakalatag ng tiklado"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/tr.po 1.195ubuntu1/debian/po/tr.po
--- 1.195/debian/po/tr.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/tr.po	2020-03-27 14:41:18.000000000 +0000
@@ -1534,3 +1534,42 @@ msgstr "Vietnamca"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Kullanılacak klavye düzeni:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Klavye düzeni:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Öntanımlı klavye düzeni"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Klavye düzeni:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/ug.po 1.195ubuntu1/debian/po/ug.po
--- 1.195/debian/po/ug.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/ug.po	2020-03-27 14:41:16.000000000 +0000
@@ -82,7 +82,6 @@ msgstr "# سلاۋيانچە - غەير
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - non-Slavic languages"
 msgid ". Cyrillic - non-Slavic languages (for blind users)"
 msgstr "# سلاۋيانچە - غەيرى سلاۋيان تىللىرى"
 
@@ -100,7 +99,6 @@ msgstr ""
 #. :sl3:
 #: ../console-setup.templates:5001
 #, fuzzy
-#| msgid "# Cyrillic - Slavic languages (also Bosnian and Serbian Latin)"
 msgid ". Cyrillic - Slavic languages (for blind users)"
 msgstr ""
 "# سلاۋيانچە - سلاۋيان تىللىرى (بوسنىيە ۋە سىربىيە لاتىنچىنىمۇ ئۆز ئىچىگە "
@@ -881,8 +879,8 @@ msgid ""
 "the Control+period combination as a Compose key."
 msgstr ""
 "تېكىست تىزگىن سۇپىسىدا بىرىكمە كۇنۇپكا يۇنىكود ھالەتتە ئىشلىمەيدۇ. ئەگەر "
-"يۇنىكود ھالەتتە بولمىسا، مەيلى سىز قانداق تاللىماڭ، Control + . "
-"(چېكىت)بىرىكمە كۇنۇپكىسى قىلىپ  ئىشلەتكىلى بولىدۇ."
+"يۇنىكود ھالەتتە بولمىسا، مەيلى سىز قانداق تاللىماڭ، Control + . (چېكىت)"
+"بىرىكمە كۇنۇپكىسى قىلىپ  ئىشلەتكىلى بولىدۇ."
 
 #. Type: boolean
 #. Description
@@ -1490,3 +1488,42 @@ msgstr "ۋىيېتنامچە"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "ئىشلىتىدىغان ھەرپتاختا خەرىتىسى:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "ھەرپتاختا جايلاشتۇرۇلۇشى:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "ھەرپتاختا جايلاشتۇرۇشنىڭ كۆڭۈلدىكى قىممىتى"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "ھەرپتاختا جايلاشتۇرۇلۇشى:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/uk.po 1.195ubuntu1/debian/po/uk.po
--- 1.195/debian/po/uk.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/uk.po	2020-03-27 14:41:16.000000000 +0000
@@ -1490,3 +1490,42 @@ msgstr "В'єтнамська"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Розкладка клавіатури:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Розкладка клавіатури:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Звична для даної розкладки клавіатури"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Розкладка клавіатури:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/vi.po 1.195ubuntu1/debian/po/vi.po
--- 1.195/debian/po/vi.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/vi.po	2020-03-27 14:41:16.000000000 +0000
@@ -1472,3 +1472,42 @@ msgstr "Tiếng Việt"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "Bàn phím cần dùng:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "Bố trí bàn phím:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "Giá trị mặc định cho bố trí bàn phím"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "Bố trí bàn phím:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/zh_CN.po 1.195ubuntu1/debian/po/zh_CN.po
--- 1.195/debian/po/zh_CN.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/zh_CN.po	2020-03-27 14:41:16.000000000 +0000
@@ -1464,3 +1464,42 @@ msgstr "越南语"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "请选择键盘映射："
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "键盘布局："
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "键盘布局默认值"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "键盘布局："
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/po/zh_TW.po 1.195ubuntu1/debian/po/zh_TW.po
--- 1.195/debian/po/zh_TW.po	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/po/zh_TW.po	2020-03-27 14:41:16.000000000 +0000
@@ -1504,3 +1504,42 @@ msgstr "越南語"
 #: ../keyboard-configuration.templates:16002
 msgid "Keymap to use:"
 msgstr "要使用的鍵盤對應:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+#, fuzzy
+msgid "Detect keyboard layout?"
+msgstr "鍵盤排列方式:"
+
+#. Type: boolean
+#. Description
+#: ../keyboard-configuration.templates:22001
+msgid ""
+"You can try to have your keyboard layout detected by pressing a series of "
+"keys. If you do not want to do this, you will be able to select your "
+"keyboard layout from a list."
+msgstr ""
+
+#. Type: detect-keyboard
+#. Description
+#: ../keyboard-configuration.templates:23001
+#, fuzzy
+msgid "Detecting your keyboard layout"
+msgstr "鍵盤排列方式的預設值"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+#, fuzzy
+msgid "Keyboard layout detection complete"
+msgstr "鍵盤排列方式:"
+
+#. Type: note
+#. Description
+#: ../keyboard-configuration.templates:24001
+msgid ""
+"Based on the keys you pressed, your keyboard layout appears to be "
+"\"${LAYOUT}\". If this is not correct, you can go back and select your "
+"layout from the full list instead."
+msgstr ""
diff -pruN 1.195/debian/preprocessor 1.195ubuntu1/debian/preprocessor
--- 1.195/debian/preprocessor	2018-10-18 15:01:40.000000000 +0000
+++ 1.195ubuntu1/debian/preprocessor	2020-03-27 14:41:07.000000000 +0000
@@ -64,12 +64,6 @@ awk '
    print;
 }' "$file" >$tmp && cat $tmp >"$file"
 
-if [ "$udeb" ]; then
-    # the following cryptic command is equivalent to sed "s/\(.*\*\)[^*]*/\1K/"
-    rmkbdnames=' | sed \"s/\\(.*\\*\\)[^*]*/\\1K/\" '
-else
-    rmkbdnames=''
-fi
 if [ "$mini" ]; then
     awk '
 /## *KBDNAMES *##/ {
diff -pruN 1.195/debian/rules 1.195ubuntu1/debian/rules
--- 1.195/debian/rules	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/debian/rules	2020-03-27 14:41:07.000000000 +0000
@@ -54,52 +54,21 @@ debian/kbdnames.gz: $./Keyboard/Keyboard
 	&& ./kbdnames-maker ./KeyboardNames.pl \
 		| grep -v '^C[*]' | grep -v '[*]model[*]' | sort | gzip -9n ) >$@
 
-models := amiga ataritt macintosh_old pc105 sun4 sun5
-
-di-gzipped-ekmaps := $(addprefix $./, $(addsuffix .ekmap.gz, $(models)))
-
-di-gzipped-ekbds := $./pc105.ekbd.gz
-
-# di-kbdnames = us al ara es(ast) bd by in(ben) be ba br gb bg bg(phonetic)...
-di-kbdnames := $(shell grep -A 2 keyboard-configuration/xkb-keymap debian/console-setup-udeb.templates | tail -n 1 | cut -d ' ' -f 2- | tr -d , | tr ' ' '\n' | grep -v skip-config)
-
-$./%.ekmap : model = $(notdir $(@:%.ekmap=%))
-$./%.ekmap :
-	(cd Keyboard \
-	&& ./kbdcompiler $(model) ./KeyboardNames.pl $(xkbdir) \
-		"$(di-kbdnames)") >$@
-
-$./%.ekbd : model = $(notdir $(@:%.ekbd=%))
-$./%.ekbd :
-	(cd Keyboard \
-	&& ./kbdcompiler freebsd-$(model) ./KeyboardNames.pl $(xkbdir) \
-		"$(di-kbdnames)") >$@
-
-# The following rules ensure that kbdcompiler is not run
-# simultaneously for normal and udeb kmaps
-$(foreach i,$(gzipped-ekmaps:%.gz=%) $(gzipped-ekbds:%.gz=%),\
-	$(eval $i: $(maindir)/$(notdir $i)))
-
-# A hack so that KeyboardNames.pl is recomputed using the files in
-# /usr/share/X11/xkb instead of the files shipped with console-setup
-$(gzipped-ekmaps:%.gz=%) $(gzipped-ekbds:%.gz=%) $(di-gzipped-ekmaps:%.gz=%) $(di-gzipped-ekbds:%.gz=%) : $./Keyboard/KeyboardNames.pl
-$./Keyboard/KeyboardNames.pl : building_debian
-building_debian :
-	touch building_debian
-
-build: debian/kbdnames.gz $(di-gzipped-ekmaps) $(di-gzipped-ekbds)
+build: debian/kbdnames.gz
 
 clean : maintainer-clean
 	dh_testdir
 	-rm -f *.ekmap *.ekbd *.ekmap.gz *.ekbd.gz
 	debconf-updatepo
+	$(MAKE) maintainer-clean
 	-rm -f build main_build building_debian
 	-rm -f debian/kbdnames.gz
 	-rm -f debian/*~
 	dh_clean
+	ln -sf debian/copyright COPYRIGHT
 
 .PHONY : deb-udeb-install
-deb-udeb-install: deb-install-linux deb-install-freebsd deb-install-main deb-install-bdf2psf udeb-install-linux udeb-install-freebsd udeb-install
+deb-udeb-install: deb-install-linux deb-install-main deb-install-bdf2psf udeb-install-linux udeb-install
 
 .PHONY : deb-install-linux
 deb-install-linux: build
@@ -118,14 +87,20 @@ deb-install-linux: build
 		--name keyboard-setup
 	dh_systemd_enable -p console-setup-linux \
 		--name console-setup
+	dh_systemd_enable -p console-setup-linux \
+		--name setvtrgb
 	dh_installinit -p console-setup-linux \
 		--no-start --name keyboard-setup.sh
 	dh_installinit -p console-setup-linux \
 		--no-start --name console-setup.sh
+	dh_installinit -p console-setup-linux \
+		--no-start --name setvtrgb
 	dh_systemd_start -p console-setup-linux \
 		--no-start --name keyboard-setup
 	dh_systemd_start -p console-setup-linux \
 		--no-start --name console-setup
+	dh_systemd_start -p console-setup-linux \
+		--no-start --name setvtrgb
 	sed -i 's/RUNLEVEL/2 3 4 5/' \
 		debian/console-setup-linux/etc/init.d/console-setup.sh
 
@@ -166,6 +141,12 @@ deb-install-main: build
 		prefix=debian/console-setup/usr install-common
 	$(MAKE) etcdir=debian/console-setup/etc \
 		prefix=debian/console-setup/usr install-ckbcomp
+	dh_install -pconsole-setup Keyboard/pc105.tree \
+		usr/share/console-setup
+ifneq (,$(filter console-setup-linux, $(shell dh_listpackages)))
+	install -m 644 debian/vtrgb debian/console-setup-linux/etc/console-setup/
+	install -m 644 debian/vtrgb.vga debian/console-setup-linux/etc/console-setup/
+endif
 	$(MAKE) etcdir=debian/console-setup-mini/etc \
 		prefix=debian/console-setup-mini/usr install-common
 	$(MAKE) etcdir=debian/console-setup-mini/etc \
@@ -193,6 +174,20 @@ deb-install-main: build
 		usr/share/console-setup/
 	dh_link -pkeyboard-configuration usr/share/X11/xkb/rules/xorg.lst \
 		usr/share/doc/keyboard-configuration/xorg.lst
+	install -d debian/keyboard-configuration/usr/share/initramfs-tools/hooks \
+		debian/keyboard-configuration/usr/share/initramfs-tools/scripts/init-top \
+		debian/keyboard-configuration/usr/share/initramfs-tools/scripts/panic
+	install -m755 debian/console-setup.initramfs-hook \
+		debian/keyboard-configuration/usr/share/initramfs-tools/hooks/console_setup
+	install -m755 debian/console-setup.initramfs-top \
+		debian/keyboard-configuration/usr/share/initramfs-tools/scripts/init-top/console_setup
+	sed -e "/^OPTION=/d" \
+		< debian/console-setup.initramfs-top \
+		> debian/keyboard-configuration/usr/share/initramfs-tools/scripts/panic/console_setup
+	chmod 755 debian/keyboard-configuration/usr/share/initramfs-tools/scripts/panic/console_setup
+	install -d debian/keyboard-configuration/usr/share/apport/package-hooks
+	install -m644 debian/console-setup.apport \
+		debian/keyboard-configuration/usr/share/apport/package-hooks/source_console-setup.py
 
 .PHONY : deb-install-bdf2psf
 deb-install-bdf2psf: build
@@ -278,22 +273,26 @@ udeb-install: build
 	install -m0755 debian/console-setup-udeb.base-installer \
 		debian/console-setup-udeb/usr/lib/base-installer.d/20console-setup
 	$(pre) --udeb debian/console-setup-udeb/usr/lib/base-installer.d/20console-setup
+	install -m 644 debian/vtrgb debian/console-setup-udeb/etc/
+	install -m 644 debian/vtrgb.vga debian/console-setup-udeb/etc/
 # console-setup-*-ekmap
 	dh_movefiles -p console-setup-amiga-ekmap --sourcedir=debian/console-setup-udeb usr/share/console-setup/amiga.ekmap.gz
-	cat amiga.ekmap.gz >debian/console-setup-amiga-ekmap/usr/share/console-setup/amiga.ekmap.gz
+	#cat amiga.ekmap.gz >debian/console-setup-amiga-ekmap/usr/share/console-setup/amiga.ekmap.gz
 	dh_movefiles -p console-setup-ataritt-ekmap --sourcedir=debian/console-setup-udeb usr/share/console-setup/ataritt.ekmap.gz
-	cat ataritt.ekmap.gz >debian/console-setup-ataritt-ekmap/usr/share/console-setup/ataritt.ekmap.gz
+	#cat ataritt.ekmap.gz >debian/console-setup-ataritt-ekmap/usr/share/console-setup/ataritt.ekmap.gz
 	dh_movefiles -p console-setup-macintoshold-ekmap --sourcedir=debian/console-setup-udeb usr/share/console-setup/macintosh_old.ekmap.gz
-	cat macintosh_old.ekmap.gz >debian/console-setup-macintoshold-ekmap/usr/share/console-setup/macintosh_old.ekmap.gz
+	#cat macintosh_old.ekmap.gz >debian/console-setup-macintoshold-ekmap/usr/share/console-setup/macintosh_old.ekmap.gz
 	dh_movefiles -p console-setup-pc-ekmap --sourcedir=debian/console-setup-udeb usr/share/console-setup/pc105.ekmap.gz
-	cat pc105.ekmap.gz >debian/console-setup-pc-ekmap/usr/share/console-setup/pc105.ekmap.gz
+	#cat pc105.ekmap.gz >debian/console-setup-pc-ekmap/usr/share/console-setup/pc105.ekmap.gz
+	dh_install -pconsole-setup-pc-ekmap Keyboard/pc105.tree \
+		usr/share/console-setup-mini
 	dh_movefiles -p console-setup-sun4-ekmap --sourcedir=debian/console-setup-udeb usr/share/console-setup/sun4.ekmap.gz
-	cat sun4.ekmap.gz >debian/console-setup-sun4-ekmap/usr/share/console-setup/sun4.ekmap.gz
+	#cat sun4.ekmap.gz >debian/console-setup-sun4-ekmap/usr/share/console-setup/sun4.ekmap.gz
 	dh_movefiles -p console-setup-sun5-ekmap --sourcedir=debian/console-setup-udeb usr/share/console-setup/sun5.ekmap.gz
-	cat sun5.ekmap.gz >debian/console-setup-sun5-ekmap/usr/share/console-setup/sun5.ekmap.gz
+	#cat sun5.ekmap.gz >debian/console-setup-sun5-ekmap/usr/share/console-setup/sun5.ekmap.gz
 # console-setup-pc-ekbd
 	dh_movefiles -p console-setup-pc-ekbd --sourcedir=debian/console-setup-udeb usr/share/console-setup/pc105.ekbd.gz
-	cat pc105.ekbd.gz >debian/console-setup-pc-ekbd/usr/share/console-setup/pc105.ekbd.gz
+	#cat pc105.ekbd.gz >debian/console-setup-pc-ekbd/usr/share/console-setup/pc105.ekbd.gz
 
 # Build architecture-independent files here.
 .PHONY : binary-indep
@@ -304,7 +303,6 @@ binary-indep: build deb-udeb-install
 	dh_installdocs -pkeyboard-configuration \
 		FAQ copyright.fonts copyright.xkb
 	dh_installdocs -p console-setup-linux --link-doc=keyboard-configuration
-	dh_installdocs -pconsole-setup-freebsd --link-doc=keyboard-configuration
 	dh_installdocs -p console-setup-mini --link-doc=keyboard-configuration
 	dh_installdocs -p console-setup --link-doc=keyboard-configuration
 	dh_lintian
diff -pruN 1.195/debian/vtrgb 1.195ubuntu1/debian/vtrgb
--- 1.195/debian/vtrgb	1970-01-01 00:00:00.000000000 +0000
+++ 1.195ubuntu1/debian/vtrgb	2019-11-27 14:34:42.000000000 +0000
@@ -0,0 +1,3 @@
+1,222,57,255,0,118,44,204,128,255,0,255,0,255,0,255
+1,56,181,199,111,38,181,204,128,0,255,255,0,0,255,255
+1,43,74,6,184,113,233,204,128,0,0,0,255,255,255,255
diff -pruN 1.195/debian/vtrgb.vga 1.195ubuntu1/debian/vtrgb.vga
--- 1.195/debian/vtrgb.vga	1970-01-01 00:00:00.000000000 +0000
+++ 1.195ubuntu1/debian/vtrgb.vga	2019-11-27 14:34:42.000000000 +0000
@@ -0,0 +1,3 @@
+0,170,0,170,0,170,0,170,85,255,85,255,85,255,85,255
+0,0,170,85,0,0,170,170,85,85,255,255,85,85,255,255
+0,0,0,0,170,170,170,170,85,85,85,85,255,255,255,255
diff -pruN 1.195/Keyboard/ckbcomp 1.195ubuntu1/Keyboard/ckbcomp
--- 1.195/Keyboard/ckbcomp	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/Keyboard/ckbcomp	2020-03-27 14:41:08.000000000 +0000
@@ -4789,9 +4789,9 @@ if ($freebsd) {
         my $file1 = "/etc/console-setup/dkey.${charmap}.inc";
         my $file2 = "$installdir/etc/console-setup/dkey.${charmap}.inc";
         if (-f $file1) {
-            system("cat $file1");
+            system("cat", $file1);
         } elsif (-f $file2) {
-            system("cat $file2");
+            system("cat", $file2);
         }
     }
 } else {
@@ -4801,18 +4801,18 @@ if ($freebsd) {
         my $file1 = "/etc/console-setup/compose.${charmap}.inc";
         my $file2 = "$installdir/etc/console-setup/compose.${charmap}.inc";
         if (-f $file1) {
-            system("cat $file1");
+            system("cat", $file1);
         } elsif (-f $file2) {
-            system("cat $file2");
+            system("cat", $file2);
         }
     }
 }
 my $file1 = "/etc/console-setup/remap.inc";
 my $file2 = "$installdir/etc/console-setup/remap.inc";
 if (-f $file1) {
-    system("cat $file1");
+    system("cat", $file1);
 } elsif (-f $file2) {
-    system("cat $file2");
+    system("cat", $file2);
 }
 
 exit 0;
diff -pruN 1.195/Keyboard/kbdnames-maker 1.195ubuntu1/Keyboard/kbdnames-maker
--- 1.195/Keyboard/kbdnames-maker	2020-03-26 13:32:07.000000000 +0000
+++ 1.195ubuntu1/Keyboard/kbdnames-maker	2020-03-27 14:41:08.000000000 +0000
@@ -30,6 +30,13 @@ for my $layout (sort keys %KeyboardNames
     }
 }
 
+# Use a custom-generated locale. Taken from lintian.
+chop(my $cwd = `pwd`);
+my $locale_path = "$cwd/build-locale";
+system("mkdir $locale_path");
+system("localedef -i en_US -c -f UTF-8 -A /usr/share/locale/locale.alias --quiet $locale_path/en_US.UTF-8");
+$ENV{'LOCPATH'} = "$locale_path";
+
 # Make sure we output UTF-8
 $ENV{'LC_ALL'} = "en_US.UTF-8";
 binmode STDOUT, ":utf8";
@@ -46,6 +53,7 @@ for my $mo (</usr/share/locale/*/LC_MESS
     $lang =~ s:__Latn:__latin:; # special fixup for sr
 
     my $d = Locale::gettext->domain("xkeyboard-config");
+    my $iso3166 = Locale::gettext->domain("iso_3166");
 
     for my $model (sort keys %KeyboardNames::models) {
 	my $name = $KeyboardNames::models{$model};
@@ -54,6 +62,11 @@ for my $mo (</usr/share/locale/*/LC_MESS
     for my $layout (sort keys %KeyboardNames::layouts) {
 	my $name = $KeyboardNames::layouts{$layout};
 	my $local_layout = $d->get($layout);
+        if ($layout eq 'Switzerland') {
+            $local_layout = $iso3166->get($layout);
+        } else {
+            $local_layout = $d->get($layout);
+        }
 	print "$lang*layout*$name*$local_layout\n";
 	print "$lang*variant*$name**$local_layout\n";
 	for my $variant (sort keys %{$KeyboardNames::variants{$name}}) {
@@ -62,3 +75,4 @@ for my $mo (</usr/share/locale/*/LC_MESS
 	}
     }
 }
+system("rm -rf $locale_path");
diff -pruN 1.195/Keyboard/KeyboardNames.pl 1.195ubuntu1/Keyboard/KeyboardNames.pl
--- 1.195/Keyboard/KeyboardNames.pl	2020-03-26 13:34:12.000000000 +0000
+++ 1.195ubuntu1/Keyboard/KeyboardNames.pl	2020-03-27 14:41:08.000000000 +0000
@@ -9,17 +9,17 @@ package KeyboardNames;
     'Acer AirKey V' => 'airkey',
     'Acer C300' => 'acer_c300',
     'Acer Ferrari 4000' => 'acer_ferrari4k',
-    'Acer Laptop' => 'acer_laptop',
+    'Acer laptop' => 'acer_laptop',
     'Advance Scorpius KI' => 'scorpius',
     'Amiga' => 'amiga',
     'Apple' => 'apple',
-    'Apple Aluminium Keyboard (ANSI)' => 'applealu_ansi',
-    'Apple Aluminium Keyboard (ISO)' => 'applealu_iso',
-    'Apple Aluminium Keyboard (JIS)' => 'applealu_jis',
-    'Apple Laptop' => 'apple_laptop',
-    'Asus Laptop' => 'asus_laptop',
+    'Apple Aluminium (ANSI)' => 'applealu_ansi',
+    'Apple Aluminium (ISO)' => 'applealu_iso',
+    'Apple Aluminium (JIS)' => 'applealu_jis',
+    'Apple laptop' => 'apple_laptop',
+    'Asus laptop' => 'asus_laptop',
     'Atari TT' => 'ataritt',
-    'Azona RF2300 wireless Internet Keyboard' => 'azonaRF2300',
+    'Azona RF2300 wireless Internet' => 'azonaRF2300',
     'BTC 5090' => 'btc5090',
     'BTC 5113RF Multimedia' => 'btc5113rf',
     'BTC 5126T' => 'btc5126t',
@@ -32,65 +32,69 @@ package KeyboardNames;
     'BenQ X-Touch' => 'benqx',
     'BenQ X-Touch 730' => 'benqx730',
     'BenQ X-Touch 800' => 'benqx800',
-    'Brother Internet Keyboard' => 'brother',
+    'Brother Internet' => 'brother',
     'Cherry B.UNLIMITED' => 'cherrybunlim',
     'Cherry Blue Line CyBo@rd' => 'cherryblue',
-    'Cherry Blue Line CyBo@rd (alternate option)' => 'cherrybluea',
+    'Cherry Blue Line CyBo@rd (alt.)' => 'cherrybluea',
     'Cherry CyBo@rd USB-Hub' => 'cherrycyboard',
     'Cherry CyMotion Expert' => 'cherrycmexpert',
     'Cherry CyMotion Master Linux' => 'cymotionlinux',
     'Cherry CyMotion Master XPress' => 'cherryblueb',
-    'Chicony Internet Keyboard' => 'chicony',
+    'Chicony Internet' => 'chicony',
     'Chicony KB-9885' => 'chicony9885',
     'Chicony KU-0108' => 'chicony0108',
     'Chicony KU-0420' => 'chicony0420',
+    'Chromebook' => 'chromebook',
     'Classmate PC' => 'classmate',
-    'Compaq Easy Access Keyboard' => 'compaqeak8',
-    'Compaq Internet Keyboard (13 keys)' => 'compaqik13',
-    'Compaq Internet Keyboard (18 keys)' => 'compaqik18',
-    'Compaq Internet Keyboard (7 keys)' => 'compaqik7',
-    'Compaq iPaq Keyboard' => 'ipaq',
+    'Compaq Armada laptop' => 'armada',
+    'Compaq Easy Access' => 'compaqeak8',
+    'Compaq Internet (13 keys)' => 'compaqik13',
+    'Compaq Internet (18 keys)' => 'compaqik18',
+    'Compaq Internet (7 keys)' => 'compaqik7',
+    'Compaq Presario laptop' => 'presario',
+    'Compaq iPaq' => 'ipaq',
     'Creative Desktop Wireless 7000' => 'creativedw7000',
     'DTK2000' => 'dtk2000',
     'Dell' => 'dell',
     'Dell 101-key PC' => 'dell101',
-    'Dell Laptop/notebook Inspiron 6xxx/8xxx' => 'inspiron',
-    'Dell Laptop/notebook Precision M series' => 'precision_m',
-    'Dell Latitude series laptop' => 'latitude',
-    'Dell Precision M65' => 'dellm65',
+    'Dell Inspiron 6000/8000 laptop' => 'inspiron',
+    'Dell Latitude laptop' => 'latitude',
+    'Dell Precision M laptop' => 'precision_m',
+    'Dell Precision M65 laptop' => 'dellm65',
     'Dell SK-8125' => 'dellsk8125',
     'Dell SK-8135' => 'dellsk8135',
-    'Dell USB Multimedia Keyboard' => 'dellusbmm',
-    'Dexxa Wireless Desktop Keyboard' => 'dexxa',
-    'Diamond 9801 / 9802 series' => 'diamond',
+    'Dell USB Multimedia' => 'dellusbmm',
+    'Dexxa Wireless Desktop' => 'dexxa',
+    'Diamond 9801/9802' => 'diamond',
+    'Do not configure keyboard; keep kernel keymap' => 'SKIP',
     'Ennyah DKB-1008' => 'ennyah_dkb1008',
     'Everex STEPnote' => 'everex',
     'FL90' => 'compalfl90',
-    'Fujitsu-Siemens Computers AMILO laptop' => 'fscaa1667g',
+    'Fujitsu-Siemens Amilo laptop' => 'fscaa1667g',
     'Generic 101-key PC' => 'pc101',
-    'Generic 102-key (Intl) PC' => 'pc102',
+    'Generic 102-key PC (intl.)' => 'pc102',
     'Generic 104-key PC' => 'pc104',
-    'Generic 105-key (Intl) PC' => 'pc105',
+    'Generic 105-key PC (intl.)' => 'pc105',
     'Genius Comfy KB-12e' => 'geniuscomfy',
-    'Genius Comfy KB-16M / Genius MM Keyboard KWD-910' => 'genius',
+    'Genius Comfy KB-16M/Multimedia KWD-910' => 'genius',
     'Genius Comfy KB-21e-Scroll' => 'geniuscomfy2',
     'Genius KB-19e NB' => 'geniuskb19e',
     'Genius KKB-2050HS' => 'geniuskkb2050hs',
     'Gyration' => 'gyration',
     'HTC Dream' => 'htcdream',
-    'Happy Hacking Keyboard' => 'hhk',
-    'Happy Hacking Keyboard for Mac' => 'macintosh_hhk',
-    'Hewlett-Packard Internet Keyboard' => 'hpi6',
-    'Hewlett-Packard Mini 110 Notebook' => 'hpmini110',
+    'Happy Hacking' => 'hhk',
+    'Happy Hacking for Mac' => 'macintosh_hhk',
+    'Hewlett-Packard Internet' => 'hpi6',
+    'Hewlett-Packard Mini 110 laptop' => 'hpmini110',
+    'Hewlett-Packard NEC SK-2500 Multimedia' => 'hp250x',
+    'Hewlett-Packard Omnibook 500' => 'hp5xx',
     'Hewlett-Packard Omnibook 500 FA' => 'hp500fa',
-    'Hewlett-Packard Omnibook 5xx' => 'hp5xx',
     'Hewlett-Packard Omnibook 6000/6100' => 'hp6000',
     'Hewlett-Packard Omnibook XE3 GC' => 'hpxe3gc',
     'Hewlett-Packard Omnibook XE3 GF' => 'hpxe3gf',
     'Hewlett-Packard Omnibook XT1000' => 'hpxt1000',
-    'Hewlett-Packard Pavilion ZT11xx' => 'hpzt11xx',
+    'Hewlett-Packard Pavilion ZT1100' => 'hpzt11xx',
     'Hewlett-Packard Pavilion dv5' => 'hpdv5',
-    'Hewlett-Packard SK-250x Multimedia Keyboard' => 'hp250x',
     'Hewlett-Packard nx9020' => 'hpnx9020',
     'Honeywell Euroboard' => 'honeywell_euroboard',
     'Htc Dream phone' => 'htcdream',
@@ -102,712 +106,810 @@ package KeyboardNames;
     'IBM ThinkPad Z60m/Z60t/Z61m/Z61t' => 'thinkpadz60',
     'Keytronic FlexPro' => 'flexpro',
     'Kinesis' => 'kinesis',
-    'Laptop/notebook Compaq (eg. Armada) Laptop Keyboard' => 'armada',
-    'Laptop/notebook Compaq (eg. Presario) Internet Keyboard' => 'presario',
-    'Laptop/notebook eMachines m68xx' => 'emachines',
-    'Logitech Access Keyboard' => 'logiaccess',
+    'Logitech' => 'logitech_base',
+    'Logitech Access' => 'logiaccess',
     'Logitech Cordless Desktop' => 'logicd',
-    'Logitech Cordless Desktop (alternate option)' => 'logicda',
+    'Logitech Cordless Desktop (alt.)' => 'logicda',
     'Logitech Cordless Desktop EX110' => 'logiex110',
     'Logitech Cordless Desktop LX-300' => 'logiclx300',
     'Logitech Cordless Desktop Navigator' => 'logicdn',
     'Logitech Cordless Desktop Optical' => 'logicd_opt',
-    'Logitech Cordless Desktop Pro (alternate option 2)' => 'logicdpa2',
+    'Logitech Cordless Desktop Pro (2nd alt.)' => 'logicdpa2',
     'Logitech Cordless Desktop iTouch' => 'logicd_it',
     'Logitech Cordless Freedom/Desktop Navigator' => 'logicfn',
     'Logitech G15 extra keys via G15daemon' => 'logitech_g15',
-    'Logitech Generic Keyboard' => 'logitech_base',
-    'Logitech Internet 350 Keyboard' => 'logii350',
-    'Logitech Internet Keyboard' => 'logiik',
-    'Logitech Internet Navigator Keyboard' => 'logicink',
-    'Logitech Media Elite Keyboard' => 'logimel',
-    'Logitech Ultra-X Cordless Media Desktop Keyboard' => 'logiultraxc',
-    'Logitech Ultra-X Keyboard' => 'logiultrax',
-    'Logitech diNovo Edge Keyboard' => 'logidinovoedge',
-    'Logitech diNovo Keyboard' => 'logidinovo',
+    'Logitech Internet' => 'logiik',
+    'Logitech Internet 350' => 'logimel',
+    'Logitech Internet Navigator' => 'logicink',
+    'Logitech Ultra-X' => 'logiultrax',
+    'Logitech Ultra-X Cordless Media Desktop' => 'logiultraxc',
+    'Logitech diNovo' => 'logidinovo',
+    'Logitech diNovo Edge' => 'logidinovoedge',
     'Logitech iTouch' => 'itouch',
-    'Logitech iTouch Cordless Keyboard (model Y-RB6)' => 'logiitc',
-    'Logitech iTouch Internet Navigator Keyboard SE' => 'logiinkse',
-    'Logitech iTouch Internet Navigator Keyboard SE (USB)' => 'logiinkseusb',
+    'Logitech iTouch Cordless Y-RB6' => 'logiitc',
+    'Logitech iTouch Internet Navigator SE' => 'logiinkse',
+    'Logitech iTouch Internet Navigator SE USB' => 'logiinkseusb',
     'MacBook/MacBook Pro' => 'macbook78',
-    'MacBook/MacBook Pro (Intl)' => 'macbook79',
+    'MacBook/MacBook Pro (intl.)' => 'macbook79',
     'Macintosh' => 'macintosh',
     'Macintosh Old' => 'macintosh_old',
     'Memorex MX1998' => 'mx1998',
-    'Memorex MX2500 EZ-Access Keyboard' => 'mx2500',
+    'Memorex MX2500 EZ-Access' => 'mx2500',
     'Memorex MX2750' => 'mx2750',
-    'Microsoft Comfort Curve Keyboard 2000' => 'microsoftccurve2k',
-    'Microsoft Internet Keyboard' => 'microsoftinet',
-    'Microsoft Internet Keyboard Pro, Swedish' => 'microsoftprose',
+    'Microsoft Comfort Curve 2000' => 'microsoftccurve2k',
+    'Microsoft Internet' => 'microsoftinet',
+    'Microsoft Internet Pro (Swedish)' => 'microsoftprose',
     'Microsoft Natural' => 'microsoft',
-    'Microsoft Natural Keyboard Elite' => 'microsoftelite',
-    'Microsoft Natural Keyboard Pro / Microsoft Internet Keyboard Pro' => 'microsoftpro',
-    'Microsoft Natural Keyboard Pro OEM' => 'microsoftprooem',
-    'Microsoft Natural Keyboard Pro USB / Microsoft Internet Keyboard Pro' => 'microsoftprousb',
-    'Microsoft Natural Wireless Ergonomic Keyboard 7000' => 'microsoft7000',
+    'Microsoft Natural Elite' => 'microsoftelite',
+    'Microsoft Natural Ergonomic 4000' => 'microsoft4000',
+    'Microsoft Natural Pro OEM' => 'microsoftprooem',
+    'Microsoft Natural Pro USB/Internet Pro' => 'microsoftprousb',
+    'Microsoft Natural Pro/Internet Pro' => 'microsoftpro',
+    'Microsoft Natural Wireless Ergonomic 7000' => 'microsoft7000',
     'Microsoft Office Keyboard' => 'microsoftoffice',
-    'Microsoft Wireless Multimedia Keyboard 1.0A' => 'microsoftmult',
+    'Microsoft Wireless Multimedia 1.0A' => 'microsoftmult',
+    'NEC SK-1300' => 'sk1300',
+    'NEC SK-2500' => 'sk2500',
+    'NEC SK-6200' => 'sk6200',
+    'NEC SK-7100' => 'sk7100',
     'Northgate OmniKey 101' => 'omnikey101',
     'OLPC' => 'olpc',
-    'Ortek MCK-800 MM/Internet keyboard' => 'oretec',
-    'PC-98xx Series' => 'pc98',
-    'Propeller Voyager (KTEZ-1000)' => 'propeller',
+    'Ortek Multimedia/Internet MCK-800' => 'oretec',
+    'PC-98' => 'pc98',
+    'Propeller Voyager KTEZ-1000' => 'propeller',
     'QTronix Scorpius 98N+' => 'qtronix',
-    'SILVERCREST Multimedia Wireless Keyboard' => 'silvercrest',
-    'SK-1300' => 'sk1300',
-    'SK-2500' => 'sk2500',
-    'SK-6200' => 'sk6200',
-    'SK-7100' => 'sk7100',
     'SVEN Ergonomic 2500' => 'sven',
     'SVEN Slim 303' => 'sven303',
     'Samsung SDM 4500P' => 'samsung4500',
     'Samsung SDM 4510P' => 'samsung4510',
     'Sanwa Supply SKB-KG3' => 'sanwaskbkg3',
+    'Silvercrest Multimedia Wireless' => 'silvercrest',
+    'SteelSeries Apex 300 (Apex RAW)' => 'apex300',
     'Sun Type 4' => 'sun4',
     'Sun Type 5' => 'sun5',
-    'Sun Type 5/6' => 'sun6',
-    'Super Power Multimedia Keyboard' => 'sp_inet',
-    'Symplon PaceBook (tablet PC)' => 'symplon',
+    'Sun Type 6 (Japanese)' => 'sun_type6_jp',
+    'Sun Type 6 USB (Japanese)' => 'sun_type6_jp_usb',
+    'Sun Type 6 USB (Unix)' => 'sun_type6_unix_usb',
+    'Sun Type 6/7 USB' => 'sun_type6_usb',
+    'Sun Type 6/7 USB (European)' => 'sun_type6_euro_usb',
+    'Sun Type 7 USB' => 'sun_type7_usb',
+    'Sun Type 7 USB (European)' => 'sun_type7_euro_usb',
+    'Sun Type 7 USB (Japanese)/Japanese 106-key' => 'sun_type7_jp_usb',
+    'Sun Type 7 USB (Unix)' => 'sun_type7_unix_usb',
+    'Super Power Multimedia' => 'sp_inet',
+    'Symplon PaceBook tablet' => 'symplon',
     'Targa Visionary 811' => 'targa_v811',
     'Toshiba Satellite S3000' => 'toshiba_s3000',
-    'Trust Direct Access Keyboard' => 'trustda',
+    'Truly Ergonomic 227' => 'teck227',
+    'Truly Ergonomic 229' => 'teck229',
+    'Truly Ergonomic Computer Keyboard Model 227 (Wide Alt keys)' => 'teck227',
+    'Truly Ergonomic Computer Keyboard Model 229 (Standard sized Alt keys, additional Super and Menu key)' => 'teck229',
+    'Trust Direct Access' => 'trustda',
     'Trust Slimline' => 'trust_slimline',
-    'Trust Wireless Keyboard Classic' => 'trust',
+    'Trust Wireless Classic' => 'trust',
     'TypeMatrix EZ-Reach 2020' => 'tm2020',
     'TypeMatrix EZ-Reach 2030 PS2' => 'tm2030PS2',
     'TypeMatrix EZ-Reach 2030 USB' => 'tm2030USB',
     'TypeMatrix EZ-Reach 2030 USB (102/105:EU mode)' => 'tm2030USB-102',
     'TypeMatrix EZ-Reach 2030 USB (106:JP mode)' => 'tm2030USB-106',
     'Unitek KB-1925' => 'unitekkb1925',
-    'ViewSonic KU-306 Internet Keyboard' => 'vsonku306',
+    'ViewSonic KU-306 Internet' => 'vsonku306',
     'Winbook Model XP5' => 'winbook',
-    'Yahoo! Internet Keyboard' => 'yahoo',
+    'Yahoo! Internet' => 'yahoo',
+    'eMachines m6800 laptop' => 'emachines',
 );
 
 %layouts = (
-    'Afghanistan' => 'af',
-    'Albania' => 'al',
-    'Andorra' => 'ad',
+    'Afghani' => 'af',
+    'Albanian' => 'al',
+    'Amharic' => 'et',
     'Arabic' => 'ara',
-    'Armenia' => 'am',
-    'Austria' => 'at',
-    'Azerbaijan' => 'az',
-    'Bangladesh' => 'bd',
-    'Belarus' => 'by',
-    'Belgium' => 'be',
-    'Bhutan' => 'bt',
-    'Bosnia and Herzegovina' => 'ba',
-    'Botswana' => 'bw',
+    'Arabic (Morocco)' => 'ma',
+    'Arabic (Syria)' => 'sy',
+    'Armenian' => 'am',
+    'Azerbaijani' => 'az',
+    'Bambara' => 'ml',
+    'Bangla' => 'bd',
+    'Belarusian' => 'by',
+    'Belgian' => 'be',
+    'Berber (Algeria, Latin)' => 'dz',
+    'Bosnian' => 'ba',
     'Braille' => 'brai',
-    'Brazil' => 'br',
-    'Bulgaria' => 'bg',
-    'Cambodia' => 'kh',
-    'Canada' => 'ca',
-    'China' => 'cn',
-    'Congo, Democratic Republic of the' => 'cd',
-    'Croatia' => 'hr',
-    'Czechia' => 'cz',
-    'Denmark' => 'dk',
+    'Bulgarian' => 'bg',
+    'Burmese' => 'mm',
+    'Chinese' => 'cn',
+    'Croatian' => 'hr',
+    'Czech' => 'cz',
+    'Danish' => 'dk',
+    'Dhivehi' => 'mv',
+    'Dutch' => 'nl',
+    'Dzongkha' => 'bt',
+    'English (Australian)' => 'au',
+    'English (Cameroon)' => 'cm',
+    'English (Ghana)' => 'gh',
+    'English (Nigeria)' => 'ng',
+    'English (South Africa)' => 'za',
+    'English (UK)' => 'gb',
+    'English (US)' => 'us',
     'Esperanto' => 'epo',
-    'Estonia' => 'ee',
-    'Ethiopia' => 'et',
-    'Faroe Islands' => 'fo',
-    'Finland' => 'fi',
-    'France' => 'fr',
-    'Georgia' => 'ge',
-    'Germany' => 'de',
-    'Ghana' => 'gh',
-    'Greece' => 'gr',
-    'Guinea' => 'gn',
-    'Hungary' => 'hu',
-    'Iceland' => 'is',
-    'India' => 'in',
-    'Iran' => 'ir',
-    'Iraq' => 'iq',
-    'Ireland' => 'ie',
-    'Israel' => 'il',
-    'Italy' => 'it',
-    'Japan' => 'jp',
-    'Japan (PC-98xx Series)' => 'nec_vndr/jp',
-    'Kazakhstan' => 'kz',
-    'Kenya' => 'ke',
-    'Korea, Republic of' => 'kr',
-    'Kyrgyzstan' => 'kg',
-    'Laos' => 'la',
-    'Latin American' => 'latam',
-    'Latvia' => 'lv',
-    'Lithuania' => 'lt',
-    'Macedonia' => 'mk',
-    'Maldives' => 'mv',
-    'Mali' => 'ml',
-    'Malta' => 'mt',
+    'Estonian' => 'ee',
+    'Faroese' => 'fo',
+    'Filipino' => 'ph',
+    'Finnish' => 'fi',
+    'French' => 'fr',
+    'French (Canada)' => 'ca',
+    'French (Democratic Republic of the Congo)' => 'cd',
+    'French (Guinea)' => 'gn',
+    'French (Togo)' => 'tg',
+    'Georgian' => 'ge',
+    'German' => 'de',
+    'German (Austria)' => 'at',
+    'Greek' => 'gr',
+    'Hebrew' => 'il',
+    'Hungarian' => 'hu',
+    'Icelandic' => 'is',
+    'Indian' => 'in',
+    'Indonesian (Jawi)' => 'id',
+    'Iraqi' => 'iq',
+    'Irish' => 'ie',
+    'Italian' => 'it',
+    'Japanese' => 'jp',
+    'Japanese (PC-98)' => 'nec_vndr/jp',
+    'Kazakh' => 'kz',
+    'Khmer (Cambodia)' => 'kh',
+    'Korean' => 'kr',
+    'Kyrgyz' => 'kg',
+    'Lao' => 'la',
+    'Latvian' => 'lv',
+    'Lithuanian' => 'lt',
+    'Macedonian' => 'mk',
+    'Malay (Jawi, Arabic Keyboard)' => 'my',
+    'Maltese' => 'mt',
     'Maori' => 'mao',
-    'Mongolia' => 'mn',
-    'Montenegro' => 'me',
-    'Morocco' => 'ma',
-    'Myanmar' => 'mm',
-    'Nepal' => 'np',
-    'Netherlands' => 'nl',
-    'Nigeria' => 'ng',
-    'Norway' => 'no',
-    'Pakistan' => 'pk',
-    'Philippines' => 'ph',
-    'Poland' => 'pl',
-    'Portugal' => 'pt',
-    'Romania' => 'ro',
-    'Russia' => 'ru',
-    'Senegal' => 'sn',
-    'Serbia' => 'rs',
-    'Slovakia' => 'sk',
-    'Slovenia' => 'si',
-    'South Africa' => 'za',
-    'Spain' => 'es',
-    'Sri Lanka' => 'lk',
-    'Sweden' => 'se',
+    'Moldavian' => 'md',
+    'Mongolian' => 'mn',
+    'Montenegrin' => 'me',
+    'Nepali' => 'np',
+    'Norwegian' => 'no',
+    'Persian' => 'ir',
+    'Polish' => 'pl',
+    'Portuguese' => 'pt',
+    'Portuguese (Brazil)' => 'br',
+    'Romanian' => 'ro',
+    'Russian' => 'ru',
+    'Serbian' => 'rs',
+    'Sinhala (phonetic)' => 'lk',
+    'Slovak' => 'sk',
+    'Slovenian' => 'si',
+    'Spanish' => 'es',
+    'Spanish (Latin American)' => 'latam',
+    'Swahili (Kenya)' => 'ke',
+    'Swahili (Tanzania)' => 'tz',
+    'Swedish' => 'se',
     'Switzerland' => 'ch',
-    'Syria' => 'sy',
-    'Tajikistan' => 'tj',
-    'Tanzania' => 'tz',
-    'Thailand' => 'th',
-    'Turkey' => 'tr',
-    'Turkmenistan' => 'tm',
-    'USA' => 'us',
-    'Ukraine' => 'ua',
-    'United Kingdom' => 'gb',
-    'Uzbekistan' => 'uz',
-    'Vietnam' => 'vn',
+    'Taiwanese' => 'tw',
+    'Tajik' => 'tj',
+    'Thai' => 'th',
+    'Tswana' => 'bw',
+    'Turkish' => 'tr',
+    'Turkmen' => 'tm',
+    'Ukrainian' => 'ua',
+    'Urdu (Pakistan)' => 'pk',
+    'Uzbek' => 'uz',
+    'Vietnamese' => 'vn',
+    'Wolof' => 'sn',
 );
 
 %variants = (
     'af' => {
-	'OLPC Dari' => 'olpc-fa',
-	'OLPC Pashto' => 'olpc-ps',
-	'OLPC Southern Uzbek' => 'olpc-uz',
 	'Pashto' => 'ps',
-	'Southern Uzbek' => 'uz',
+	'Pashto (Afghanistan, OLPC)' => 'olpc-ps',
+	'Persian (Afghanistan, Dari OLPC)' => 'fa-olpc',
+	'Uzbek (Afghanistan)' => 'uz',
+	'Uzbek (Afghanistan, OLPC)' => 'uz-olpc',
+    },
+    'al' => {
+	'Albanian (Plisi)' => 'plisi',
     },
     'am' => {
-	'Alternative Eastern' => 'eastern-alt',
-	'Alternative Phonetic' => 'phonetic-alt',
-	'Eastern' => 'eastern',
-	'Phonetic' => 'phonetic',
-	'Western' => 'western',
+	'Armenian (alt. eastern)' => 'eastern-alt',
+	'Armenian (alt. phonetic)' => 'phonetic-alt',
+	'Armenian (eastern)' => 'eastern',
+	'Armenian (phonetic)' => 'phonetic',
+	'Armenian (western)' => 'western',
     },
     'ara' => {
-	'Buckwalter' => 'buckwalter',
-	'azerty' => 'azerty',
-	'azerty/digits' => 'azerty_digits',
-	'digits' => 'digits',
-	'qwerty' => 'qwerty',
-	'qwerty/digits' => 'qwerty_digits',
+	'Arabic (AZERTY)' => 'azerty',
+	'Arabic (AZERTY/digits)' => 'azerty_digits',
+	'Arabic (Buckwalter)' => 'buckwalter',
+	'Arabic (Macintosh)' => 'mac',
+	'Arabic (OLPC)' => 'olpc',
+	'Arabic (QWERTY)' => 'qwerty',
+	'Arabic (digits)' => 'digits',
+	'Arabic (qwerty/digits)' => 'qwerty_digits',
     },
     'at' => {
-	'Eliminate dead keys' => 'nodeadkeys',
-	'Macintosh' => 'mac',
-	'Sun dead keys' => 'sundeadkeys',
+	'German (Austria, Macintosh)' => 'mac',
+	'German (Austria, no dead keys)' => 'nodeadkeys',
+	'German (Austria, with Sun dead keys)' => 'sundeadkeys',
     },
     'az' => {
-	'Cyrillic' => 'cyrillic',
+	'Azerbaijani (Cyrillic)' => 'cyrillic',
     },
     'ba' => {
-	'US keyboard with Bosnian digraphs' => 'unicodeus',
-	'US keyboard with Bosnian letters' => 'us',
-	'Use Bosnian digraphs' => 'unicode',
-	'Use guillemets for quotes' => 'alternatequotes',
+	'Bosnian (US, with Bosnian digraphs)' => 'unicodeus',
+	'Bosnian (US, with Bosnian letters)' => 'us',
+	'Bosnian (with Bosnian digraphs)' => 'unicode',
+	'Bosnian (with guillemets)' => 'alternatequotes',
     },
     'bd' => {
-	'Probhat' => 'probhat',
+	'Bangla (Probhat)' => 'probhat',
     },
     'be' => {
-	'Alternative' => 'oss',
-	'Alternative, Sun dead keys' => 'oss_sundeadkeys',
-	'Alternative, latin-9 only' => 'oss_latin9',
-	'Eliminate dead keys' => 'nodeadkeys',
-	'ISO Alternate' => 'iso-alternate',
-	'Sun dead keys' => 'sundeadkeys',
-	'Wang model 724 azerty' => 'wang',
+	'Belgian (Wang 724 AZERTY)' => 'wang',
+	'Belgian (alt. ISO)' => 'iso-alternate',
+	'Belgian (alt.)' => 'oss',
+	'Belgian (alt., Latin-9 only)' => 'oss_latin9',
+	'Belgian (alt., with Sun dead keys)' => 'oss_sundeadkeys',
+	'Belgian (no dead keys)' => 'nodeadkeys',
+	'Belgian (with Sun dead keys)' => 'sundeadkeys',
     },
     'bg' => {
-	'New phonetic' => 'bas_phonetic',
-	'Traditional phonetic' => 'phonetic',
+	'Bulgarian (new phonetic)' => 'bas_phonetic',
+	'Bulgarian (traditional phonetic)' => 'phonetic',
     },
     'br' => {
-	'Dvorak' => 'dvorak',
-	'Eliminate dead keys' => 'nodeadkeys',
-	'Nativo' => 'nativo',
-	'Nativo for Esperanto' => 'nativo-epo',
-	'Nativo for USA keyboards' => 'nativo-us',
+	'Esperanto (Brazil, Nativo)' => 'nativo-epo',
+	'Portuguese (Brazil, Dvorak)' => 'dvorak',
+	'Portuguese (Brazil, IBM/Lenovo ThinkPad)' => 'thinkpad',
+	'Portuguese (Brazil, Nativo for US keyboards)' => 'nativo-us',
+	'Portuguese (Brazil, Nativo)' => 'nativo',
+	'Portuguese (Brazil, no dead keys)' => 'nodeadkeys',
     },
     'brai' => {
-	'Left hand' => 'left_hand',
-	'Right hand' => 'right_hand',
+	'Braille (left-handed inverted thumb)' => 'left_hand_invert',
+	'Braille (left-handed)' => 'left_hand',
+	'Braille (right-handed inverted thumb)' => 'right_hand_invert',
+	'Braille (right-handed)' => 'right_hand',
     },
     'by' => {
-	'Latin' => 'latin',
-	'Legacy' => 'legacy',
+	'Belarusian (Latin)' => 'latin',
+	'Belarusian (legacy)' => 'legacy',
     },
     'ca' => {
-	'English' => 'eng',
-	'French (legacy)' => 'fr-legacy',
-	'French Dvorak' => 'fr-dvorak',
+	'Canadian Multilingual' => 'multix',
+	'Canadian Multilingual (1st part)' => 'multi',
+	'Canadian Multilingual (2nd part)' => 'multi-2gr',
+	'English (Canada)' => 'eng',
+	'French (Canada, Dvorak)' => 'fr-dvorak',
+	'French (Canada, legacy)' => 'fr-legacy',
 	'Inuktitut' => 'ike',
-	'Ktunaxa' => 'kut',
-	'Multilingual' => 'multix',
-	'Multilingual, first part' => 'multi',
-	'Multilingual, second part' => 'multi-2gr',
-	'Secwepemctsin' => 'shs',
     },
     'ch' => {
-	'French' => 'fr',
-	'French (Macintosh)' => 'fr_mac',
-	'French, Sun dead keys' => 'fr_sundeadkeys',
-	'French, eliminate dead keys' => 'fr_nodeadkeys',
-	'German (Macintosh)' => 'de_mac',
-	'German, Sun dead keys' => 'de_sundeadkeys',
-	'German, eliminate dead keys' => 'de_nodeadkeys',
-	'Legacy' => 'legacy',
+	'French (Switzerland)' => 'fr',
+	'French (Switzerland, Macintosh)' => 'fr_mac',
+	'French (Switzerland, no dead keys)' => 'fr_nodeadkeys',
+	'French (Switzerland, with Sun dead keys)' => 'fr_sundeadkeys',
+	'German (Switzerland, Macintosh)' => 'de_mac',
+	'German (Switzerland, legacy)' => 'legacy',
+	'German (Switzerland, no dead keys)' => 'de_nodeadkeys',
+	'German (Switzerland, with Sun dead keys)' => 'de_sundeadkeys',
+    },
+    'cm' => {
+	'Cameroon Multilingual (AZERTY)' => 'azerty',
+	'Cameroon Multilingual (Dvorak)' => 'dvorak',
+	'Cameroon Multilingual (QWERTY)' => 'qwerty',
+	'French (Cameroon)' => 'french',
+	'Mmuock' => 'mmuock',
     },
     'cn' => {
+	'Hanyu Pinyin (altgr)' => 'altgr-pinyin',
 	'Tibetan' => 'tib',
 	'Tibetan (with ASCII numerals)' => 'tib_asciinum',
-	'Uyghur' => 'uig',
+	'Uyghur' => 'ug',
     },
     'cz' => {
-	'UCW layout (accented letters only)' => 'ucw',
-	'US Dvorak with CZ UCW support' => 'dvorak-ucw',
-	'With <\|> key' => 'bksl',
-	'qwerty' => 'qwerty',
-	'qwerty, extended Backslash' => 'qwerty_bksl',
+	'Czech (QWERTY)' => 'qwerty',
+	'Czech (QWERTY, extended backslash)' => 'qwerty_bksl',
+	'Czech (UCW, only accented letters)' => 'ucw',
+	'Czech (US, Dvorak, UCW support)' => 'dvorak-ucw',
+	'Czech (with <\|> key)' => 'bksl',
+	'Russian (Czech, phonetic)' => 'rus',
     },
     'de' => {
-	'Dead acute' => 'deadacute',
-	'Dead grave acute' => 'deadgraveacute',
-	'Dvorak' => 'dvorak',
-	'Eliminate dead keys' => 'nodeadkeys',
+	'German (Dvorak)' => 'dvorak',
+	'German (Macintosh)' => 'mac',
+	'German (Macintosh, no dead keys)' => 'mac_nodeadkeys',
+	'German (Neo 2)' => 'neo',
+	'German (QWERTY)' => 'qwerty',
+	'German (T3)' => 'T3',
+	'German (dead acute)' => 'deadacute',
+	'German (dead grave acute)' => 'deadgraveacute',
+	'German (dead tilde)' => 'deadtilde',
+	'German (no dead keys)' => 'nodeadkeys',
+	'German (with Sun dead keys)' => 'sundeadkeys',
 	'Lower Sorbian' => 'dsb',
-	'Lower Sorbian (qwertz)' => 'dsb_qwertz',
-	'Macintosh' => 'mac',
-	'Macintosh, eliminate dead keys' => 'mac_nodeadkeys',
-	'Neo 2' => 'neo',
-	'Romanian keyboard with German letters' => 'ro',
-	'Romanian keyboard with German letters, eliminate dead keys' => 'ro_nodeadkeys',
-	'Russian phonetic' => 'ru',
-	'Sun dead keys' => 'sundeadkeys',
-	'qwerty' => 'qwerty',
+	'Lower Sorbian (QWERTZ)' => 'dsb_qwertz',
+	'Romanian (Germany)' => 'ro',
+	'Romanian (Germany, no dead keys)' => 'ro_nodeadkeys',
+	'Russian (Germany, phonetic)' => 'ru',
+	'Turkish (Germany)' => 'tr',
     },
     'dk' => {
-	'Dvorak' => 'dvorak',
-	'Eliminate dead keys' => 'nodeadkeys',
-	'Macintosh' => 'mac',
-	'Macintosh, eliminate dead keys' => 'mac_nodeadkeys',
+	'Danish (Dvorak)' => 'dvorak',
+	'Danish (Macintosh)' => 'mac',
+	'Danish (Macintosh, no dead keys)' => 'mac_nodeadkeys',
+	'Danish (Win keys)' => 'winkeys',
+	'Danish (no dead keys)' => 'nodeadkeys',
+    },
+    'dz' => {
+	'Arabic (Algeria)' => 'ar',
+	'Berber (Algeria, Tifinagh)' => 'ber',
     },
     'ee' => {
-	'Dvorak' => 'dvorak',
-	'Eliminate dead keys' => 'nodeadkeys',
-	'US keyboard with Estonian letters' => 'us',
+	'Estonian (Dvorak)' => 'dvorak',
+	'Estonian (US, with Estonian letters)' => 'us',
+	'Estonian (no dead keys)' => 'nodeadkeys',
     },
     'epo' => {
-	'displaced semicolon and quote (obsolete)' => 'legacy',
+	'Esperanto (displaced semicolon and quote, obsolete)' => 'legacy',
     },
     'es' => {
-	'Asturian variant with bottom-dot H and bottom-dot L' => 'ast',
-	'Catalan variant with middle-dot L' => 'cat',
-	'Dvorak' => 'dvorak',
-	'Eliminate dead keys' => 'nodeadkeys',
-	'Include dead tilde' => 'deadtilde',
-	'Macintosh' => 'mac',
-	'Sun dead keys' => 'sundeadkeys',
+	'Asturian (Spain, with bottom-dot H and bottom-dot L)' => 'ast',
+	'Catalan (Spain, with middle-dot L)' => 'cat',
+	'Spanish (Dvorak)' => 'dvorak',
+	'Spanish (Macintosh)' => 'mac',
+	'Spanish (Win keys)' => 'winkeys',
+	'Spanish (dead tilde)' => 'deadtilde',
+	'Spanish (no dead keys)' => 'nodeadkeys',
+	'Spanish (with Sun dead keys)' => 'sundeadkeys',
     },
     'fi' => {
-	'Classic' => 'classic',
-	'Classic, eliminate dead keys' => 'nodeadkeys',
-	'Macintosh' => 'mac',
-	'Northern Saami' => 'smi',
+	'Finnish (Macintosh)' => 'mac',
+	'Finnish (Winkeys)' => 'winkeys',
+	'Finnish (classic)' => 'classic',
+	'Finnish (classic, no dead keys)' => 'nodeadkeys',
+	'Northern Saami (Finland)' => 'smi',
     },
     'fo' => {
-	'Eliminate dead keys' => 'nodeadkeys',
+	'Faroese (no dead keys)' => 'nodeadkeys',
     },
     'fr' => {
-	'(Legacy) Alternative' => 'latin9',
-	'(Legacy) Alternative, Sun dead keys' => 'latin9_sundeadkeys',
-	'(Legacy) Alternative, eliminate dead keys' => 'latin9_nodeadkeys',
-	'Alternative' => 'oss',
-	'Alternative, Sun dead keys' => 'oss_sundeadkeys',
-	'Alternative, eliminate dead keys' => 'oss_nodeadkeys',
-	'Alternative, latin-9 only' => 'oss_latin9',
-	'Bepo, ergonomic, Dvorak way' => 'bepo',
-	'Bepo, ergonomic, Dvorak way, latin-9 only' => 'bepo_latin9',
-	'Breton' => 'bre',
-	'Dvorak' => 'dvorak',
-	'Eliminate dead keys' => 'nodeadkeys',
-	'Georgian AZERTY Tskapo' => 'geo',
-	'Macintosh' => 'mac',
+	'French (AZERTY)' => 'azerty',
+	'French (Bepo, ergonomic, Dvorak way)' => 'bepo',
+	'French (Bepo, ergonomic, Dvorak way, Latin-9 only)' => 'bepo_latin9',
+	'French (Breton)' => 'bre',
+	'French (Dvorak)' => 'dvorak',
+	'French (Macintosh)' => 'mac',
+	'French (US, with French letters)' => 'us',
+	'French (alt.)' => 'oss',
+	'French (alt., Latin-9 only)' => 'oss_latin9',
+	'French (alt., no dead keys)' => 'oss_nodeadkeys',
+	'French (alt., with Sun dead keys)' => 'oss_sundeadkeys',
+	'French (legacy, alt.)' => 'latin9',
+	'French (legacy, alt., no dead keys)' => 'latin9_nodeadkeys',
+	'French (legacy, alt., with Sun dead keys)' => 'latin9_sundeadkeys',
+	'French (no dead keys)' => 'nodeadkeys',
+	'French (with Sun dead keys)' => 'sundeadkeys',
+	'Georgian (France, AZERTY Tskapo)' => 'geo',
 	'Occitan' => 'oci',
-	'Sun dead keys' => 'sundeadkeys',
     },
     'gb' => {
-	'Colemak' => 'colemak',
-	'Dvorak' => 'dvorak',
-	'Dvorak (UK Punctuation)' => 'dvorakukp',
-	'Extended - Winkeys' => 'extd',
-	'International (with dead keys)' => 'intl',
-	'Macintosh' => 'mac',
-	'Macintosh (International)' => 'mac_intl',
+	'English (UK, Colemak)' => 'colemak',
+	'English (UK, Dvorak)' => 'dvorak',
+	'English (UK, Dvorak, with UK punctuation)' => 'dvorakukp',
+	'English (UK, Macintosh)' => 'mac',
+	'English (UK, extended, with Win keys)' => 'extd',
+	'English (UK, intl., Macintosh)' => 'mac_intl',
+	'English (UK, intl., with dead keys)' => 'intl',
+	'Polish (British keyboard)' => 'pl',
     },
     'ge' => {
-	'Ergonomic' => 'ergonomic',
-	'MESS' => 'mess',
-	'Ossetian' => 'os',
-	'Russian' => 'ru',
+	'Georgian (MESS)' => 'mess',
+	'Georgian (ergonomic)' => 'ergonomic',
+	'Ossetian (Georgia)' => 'os',
+	'Russian (Georgia)' => 'ru',
     },
     'gh' => {
 	'Akan' => 'akan',
 	'Avatime' => 'avn',
+	'English (Ghana, GILLBT)' => 'gillbt',
+	'English (Ghana, multilingual)' => 'generic',
 	'Ewe' => 'ewe',
 	'Fula' => 'fula',
-	'GILLBT' => 'gillbt',
 	'Ga' => 'ga',
-	'Hausa' => 'hausa',
-	'Multilingual' => 'generic',
+	'Hausa (Ghana)' => 'hausa',
     },
     'gr' => {
-	'Eliminate dead keys' => 'nodeadkeys',
-	'Extended' => 'extended',
-	'Polytonic' => 'polytonic',
-	'Simple' => 'simple',
+	'Greek (extended)' => 'extended',
+	'Greek (no dead keys)' => 'nodeadkeys',
+	'Greek (polytonic)' => 'polytonic',
+	'Greek (simple)' => 'simple',
     },
     'hr' => {
-	'US keyboard with Croatian digraphs' => 'unicodeus',
-	'US keyboard with Croatian letters' => 'us',
-	'Use Croatian digraphs' => 'unicode',
-	'Use guillemets for quotes' => 'alternatequotes',
+	'Croatian (US, with Croatian digraphs)' => 'unicodeus',
+	'Croatian (US, with Croatian letters)' => 'us',
+	'Croatian (with Croatian digraphs)' => 'unicode',
+	'Croatian (with guillemets)' => 'alternatequotes',
     },
     'hu' => {
-	'101/qwerty/comma/Dead keys' => '101_qwerty_comma_dead',
-	'101/qwerty/comma/Eliminate dead keys' => '101_qwerty_comma_nodead',
-	'101/qwerty/dot/Dead keys' => '101_qwerty_dot_dead',
-	'101/qwerty/dot/Eliminate dead keys' => '101_qwerty_dot_nodead',
-	'101/qwertz/comma/Dead keys' => '101_qwertz_comma_dead',
-	'101/qwertz/comma/Eliminate dead keys' => '101_qwertz_comma_nodead',
-	'101/qwertz/dot/Dead keys' => '101_qwertz_dot_dead',
-	'101/qwertz/dot/Eliminate dead keys' => '101_qwertz_dot_nodead',
-	'102/qwerty/comma/Dead keys' => '102_qwerty_comma_dead',
-	'102/qwerty/comma/Eliminate dead keys' => '102_qwerty_comma_nodead',
-	'102/qwerty/dot/Dead keys' => '102_qwerty_dot_dead',
-	'102/qwerty/dot/Eliminate dead keys' => '102_qwerty_dot_nodead',
-	'102/qwertz/comma/Dead keys' => '102_qwertz_comma_dead',
-	'102/qwertz/comma/Eliminate dead keys' => '102_qwertz_comma_nodead',
-	'102/qwertz/dot/Dead keys' => '102_qwertz_dot_dead',
-	'102/qwertz/dot/Eliminate dead keys' => '102_qwertz_dot_nodead',
-	'Eliminate dead keys' => 'nodeadkeys',
-	'Standard' => 'standard',
-	'qwerty' => 'qwerty',
+	'Hungarian (101/QWERTY/comma/dead keys)' => '101_qwerty_comma_dead',
+	'Hungarian (101/QWERTY/comma/no dead keys)' => '101_qwerty_comma_nodead',
+	'Hungarian (101/QWERTY/dot/dead keys)' => '101_qwerty_dot_dead',
+	'Hungarian (101/QWERTY/dot/no dead keys)' => '101_qwerty_dot_nodead',
+	'Hungarian (101/QWERTZ/comma/dead keys)' => '101_qwertz_comma_dead',
+	'Hungarian (101/QWERTZ/comma/no dead keys)' => '101_qwertz_comma_nodead',
+	'Hungarian (101/QWERTZ/dot/dead keys)' => '101_qwertz_dot_dead',
+	'Hungarian (101/QWERTZ/dot/no dead keys)' => '101_qwertz_dot_nodead',
+	'Hungarian (102/QWERTY/comma/dead keys)' => '102_qwerty_comma_dead',
+	'Hungarian (102/QWERTY/comma/no dead keys)' => '102_qwerty_comma_nodead',
+	'Hungarian (102/QWERTY/dot/dead keys)' => '102_qwerty_dot_dead',
+	'Hungarian (102/QWERTY/dot/no dead keys)' => '102_qwerty_dot_nodead',
+	'Hungarian (102/QWERTZ/comma/dead keys)' => '102_qwertz_comma_dead',
+	'Hungarian (102/QWERTZ/comma/no dead keys)' => '102_qwertz_comma_nodead',
+	'Hungarian (102/QWERTZ/dot/dead keys)' => '102_qwertz_dot_dead',
+	'Hungarian (102/QWERTZ/dot/no dead keys)' => '102_qwertz_dot_nodead',
+	'Hungarian (QWERTY)' => 'qwerty',
+	'Hungarian (no dead keys)' => 'nodeadkeys',
+	'Hungarian (standard)' => 'standard',
     },
     'ie' => {
 	'CloGaelach' => 'CloGaelach',
+	'Irish (UnicodeExpert)' => 'UnicodeExpert',
 	'Ogham' => 'ogam',
-	'Ogham IS434' => 'ogam_is434',
-	'UnicodeExpert' => 'UnicodeExpert',
+	'Ogham (IS434)' => 'ogam_is434',
     },
     'il' => {
-	'Biblical Hebrew (Tiro)' => 'biblical',
-	'Phonetic' => 'phonetic',
-	'lyx' => 'lyx',
+	'Hebrew (Biblical, Tiro)' => 'biblical',
+	'Hebrew (lyx)' => 'lyx',
+	'Hebrew (phonetic)' => 'phonetic',
     },
     'in' => {
-	'Bengali' => 'ben',
-	'Bengali Probhat' => 'ben_probhat',
-	'English with RupeeSign' => 'eng',
+	'Bangla (India)' => 'ben',
+	'Bangla (India, Baishakhi Inscript)' => 'ben_inscript',
+	'Bangla (India, Baishakhi)' => 'ben_baishakhi',
+	'Bangla (India, Bornona)' => 'ben_bornona',
+	'Bangla (India, Probhat)' => 'ben_probhat',
+	'Bangla (India, Uni Gitanjali)' => 'ben_gitanjali',
+	'English (India, with rupee)' => 'eng',
 	'Gujarati' => 'guj',
-	'Gurmukhi' => 'guru',
-	'Gurmukhi Jhelum' => 'jhelum',
-	'Hindi Bolnagri' => 'bolnagri',
-	'Hindi Wx' => 'hin-wx',
+	'Hindi (Bolnagri)' => 'bolnagri',
+	'Hindi (KaGaPa phonetic)' => 'hin-kagapa',
+	'Hindi (Wx)' => 'hin-wx',
 	'Kannada' => 'kan',
+	'Kannada (KaGaPa phonetic)' => 'kan-kagapa',
 	'Malayalam' => 'mal',
-	'Malayalam Lalitha' => 'mal_lalitha',
+	'Malayalam (Lalitha)' => 'mal_lalitha',
+	'Malayalam (enhanced Inscript, with rupee)' => 'mal_enhanced',
+	'Manipuri (Eeyek)' => 'eeyek',
+	'Marathi (KaGaPa phonetic)' => 'mar-kagapa',
+	'Ol Chiki' => 'olck',
 	'Oriya' => 'ori',
-	'Tamil' => 'tam',
-	'Tamil Keyboard with Numerals' => 'tam_keyboard_with_numerals',
-	'Tamil TAB Typewriter' => 'tam_TAB',
-	'Tamil TSCII Typewriter' => 'tam_TSCII',
-	'Tamil Unicode' => 'tam_unicode',
+	'Punjabi (Gurmukhi Jhelum)' => 'jhelum',
+	'Punjabi (Gurmukhi)' => 'guru',
+	'Sanskrit (KaGaPa phonetic)' => 'san-kagapa',
+	'Tamil (Inscript)' => 'tam',
+	'Tamil (TamilNet 99 with Tamil numerals)' => 'tam_tamilnet_with_tam_nums',
+	'Tamil (TamilNet 99)' => 'tam_tamilnet',
+	'Tamil (TamilNet 99, TAB encoding)' => 'tam_tamilnet_TAB',
+	'Tamil (TamilNet 99, TSCII encoding)' => 'tam_tamilnet_TSCII',
 	'Telugu' => 'tel',
-	'Urdu, Alternative phonetic' => 'urd-phonetic3',
-	'Urdu, Phonetic' => 'urd-phonetic',
-	'Urdu, Winkeys' => 'urd-winkeys',
+	'Telugu (KaGaPa phonetic)' => 'tel-kagapa',
+	'Telugu (Sarala)' => 'tel-sarala',
+	'Urdu (Win keys)' => 'urd-winkeys',
+	'Urdu (alt. phonetic)' => 'urd-phonetic3',
+	'Urdu (phonetic)' => 'urd-phonetic',
     },
     'iq' => {
-	'Kurdish, (F)' => 'ku_f',
-	'Kurdish, Arabic-Latin' => 'ku_ara',
-	'Kurdish, Latin Alt-Q' => 'ku_alt',
-	'Kurdish, Latin Q' => 'ku',
+	'Kurdish (Iraq, Arabic-Latin)' => 'ku_ara',
+	'Kurdish (Iraq, F)' => 'ku_f',
+	'Kurdish (Iraq, Latin Alt-Q)' => 'ku_alt',
+	'Kurdish (Iraq, Latin Q)' => 'ku',
     },
     'ir' => {
-	'Kurdish, (F)' => 'ku_f',
-	'Kurdish, Arabic-Latin' => 'ku_ara',
-	'Kurdish, Latin Alt-Q' => 'ku_alt',
-	'Kurdish, Latin Q' => 'ku',
-	'Persian, with Persian Keypad' => 'pes_keypad',
+	'Kurdish (Iran, Arabic-Latin)' => 'ku_ara',
+	'Kurdish (Iran, F)' => 'ku_f',
+	'Kurdish (Iran, Latin Alt-Q)' => 'ku_alt',
+	'Kurdish (Iran, Latin Q)' => 'ku',
+	'Persian (with Persian keypad)' => 'pes_keypad',
     },
     'is' => {
-	'Dvorak' => 'dvorak',
-	'Eliminate dead keys' => 'nodeadkeys',
-	'Macintosh' => 'mac',
-	'Sun dead keys' => 'Sundeadkeys',
+	'Icelandic (Dvorak)' => 'dvorak',
+	'Icelandic (Macintosh)' => 'mac',
+	'Icelandic (Macintosh, legacy)' => 'mac_legacy',
+	'Icelandic (no dead keys)' => 'nodeadkeys',
+	'Icelandic (with Sun dead keys)' => 'Sundeadkeys',
     },
     'it' => {
-	'Eliminate dead keys' => 'nodeadkeys',
-	'Georgian' => 'geo',
-	'Macintosh' => 'mac',
-	'US keyboard with Italian letters' => 'us',
+	'Georgian (Italy)' => 'geo',
+	'Italian (IBM 142)' => 'ibm',
+	'Italian (Macintosh)' => 'mac',
+	'Italian (US, with Italian letters)' => 'us',
+	'Italian (Winkeys)' => 'winkeys',
+	'Italian (intl., with dead keys)' => 'intl',
+	'Italian (no dead keys)' => 'nodeadkeys',
+	'Sicilian' => 'scn',
     },
     'jp' => {
-	'Kana' => 'kana',
-	'Kana 86' => 'kana86',
-	'Macintosh' => 'mac',
-	'OADG 109A' => 'OADG109A',
+	'Japanese (Dvorak)' => 'dvorak',
+	'Japanese (Kana 86)' => 'kana86',
+	'Japanese (Kana)' => 'kana',
+	'Japanese (Macintosh)' => 'mac',
+	'Japanese (OADG 109A)' => 'OADG109A',
     },
     'ke' => {
 	'Kikuyu' => 'kik',
     },
     'kg' => {
-	'Phonetic' => 'phonetic',
+	'Kyrgyz (phonetic)' => 'phonetic',
     },
     'kr' => {
-	'101/104 key Compatible' => 'kr104',
+	'Korean (101/104 key compatible)' => 'kr104',
     },
     'kz' => {
-	'Kazakh with Russian' => 'kazrus',
-	'Russian with Kazakh' => 'ruskaz',
+	'Kazakh (Latin)' => 'latin',
+	'Kazakh (extended)' => 'ext',
+	'Kazakh (with Russian)' => 'kazrus',
+	'Russian (Kazakhstan, with Kazakh)' => 'ruskaz',
+    },
+    'la' => {
+	'Lao (STEA proposed standard layout)' => 'stea',
     },
     'latam' => {
-	'Eliminate dead keys' => 'nodeadkeys',
-	'Include dead tilde' => 'deadtilde',
-	'Sun dead keys' => 'sundeadkeys',
+	'Spanish (Latin American, Colemak for gaming)' => 'colemak-gaming',
+	'Spanish (Latin American, Colemak)' => 'colemak',
+	'Spanish (Latin American, Dvorak)' => 'dvorak',
+	'Spanish (Latin American, dead tilde)' => 'deadtilde',
+	'Spanish (Latin American, no dead keys)' => 'nodeadkeys',
+	'Spanish (Latin American, with Sun dead keys)' => 'sundeadkeys',
     },
     'lk' => {
-	'Tamil TAB Typewriter' => 'tam_TAB',
-	'Tamil Unicode' => 'tam_unicode',
+	'Sinhala (US, with Sinhala letters)' => 'us',
+	'Tamil (Sri Lanka, TamilNet 99)' => 'tam_unicode',
+	'Tamil (Sri Lanka, TamilNet 99, TAB encoding)' => 'tam_TAB',
     },
     'lt' => {
-	'IBM (LST 1205-92)' => 'ibm',
-	'LEKP' => 'lekp',
-	'LEKPa' => 'lekpa',
-	'Standard' => 'std',
-	'US keyboard with Lithuanian letters' => 'us',
+	'Lithuanian (IBM LST 1205-92)' => 'ibm',
+	'Lithuanian (LEKP)' => 'lekp',
+	'Lithuanian (LEKPa)' => 'lekpa',
+	'Lithuanian (US, with Lithuanian letters)' => 'us',
+	'Lithuanian (standard)' => 'std',
     },
     'lv' => {
-	'Apostrophe () variant' => 'apostrophe',
-	'F-letter (F) variant' => 'fkey',
-	'Tilde (~) variant' => 'tilde',
+	'Latvian (F)' => 'fkey',
+	'Latvian (adapted)' => 'adapted',
+	'Latvian (apostrophe)' => 'apostrophe',
+	'Latvian (ergonomic, ŪGJRMV)' => 'ergonomic',
+	'Latvian (modern)' => 'modern',
+	'Latvian (tilde)' => 'tilde',
     },
     'ma' => {
-	'French' => 'french',
-	'Tifinagh' => 'tifinagh',
-	'Tifinagh alternative' => 'tifinagh-alt',
-	'Tifinagh alternative phonetic' => 'tifinagh-alt-phonetic',
-	'Tifinagh extended' => 'tifinagh-extended',
-	'Tifinagh extended phonetic' => 'tifinagh-extended-phonetic',
-	'Tifinagh phonetic' => 'tifinagh-phonetic',
+	'Berber (Morocco, Tifinagh alt. phonetic)' => 'tifinagh-alt-phonetic',
+	'Berber (Morocco, Tifinagh alt.)' => 'tifinagh-alt',
+	'Berber (Morocco, Tifinagh extended phonetic)' => 'tifinagh-extended-phonetic',
+	'Berber (Morocco, Tifinagh extended)' => 'tifinagh-extended',
+	'Berber (Morocco, Tifinagh phonetic)' => 'tifinagh-phonetic',
+	'Berber (Morocco, Tifinagh)' => 'tifinagh',
+	'French (Morocco)' => 'french',
+    },
+    'md' => {
+	'Moldavian (Gagauz)' => 'gag',
     },
     'me' => {
-	'Cyrillic' => 'cyrillic',
-	'Cyrillic with guillemets' => 'cyrillicalternatequotes',
-	'Cyrillic, Z and ZHE swapped' => 'cyrillicyz',
-	'Latin qwerty' => 'latinyz',
-	'Latin unicode' => 'latinunicode',
-	'Latin unicode qwerty' => 'latinunicodeyz',
-	'Latin with guillemets' => 'latinalternatequotes',
+	'Montenegrin (Cyrillic with guillemets)' => 'cyrillicalternatequotes',
+	'Montenegrin (Cyrillic)' => 'cyrillic',
+	'Montenegrin (Cyrillic, ZE and ZHE swapped)' => 'cyrillicyz',
+	'Montenegrin (Latin with guillemets)' => 'latinalternatequotes',
+	'Montenegrin (Latin, QWERTY)' => 'latinyz',
+	'Montenegrin (Latin, Unicode)' => 'latinunicode',
+	'Montenegrin (Latin, Unicode, QWERTY)' => 'latinunicodeyz',
     },
     'mk' => {
-	'Eliminate dead keys' => 'nodeadkeys',
+	'Macedonian (no dead keys)' => 'nodeadkeys',
     },
     'ml' => {
-	'English (USA International)' => 'us-intl',
-	'English (USA Macintosh)' => 'us-mac',
-	'Franais (France Alternative)' => 'fr-oss',
+	'English (Mali, US, Macintosh)' => 'us-mac',
+	'English (Mali, US, intl.)' => 'us-intl',
+	'French (Mali, alt.)' => 'fr-oss',
+    },
+    'mm' => {
+	'Burmese Zawgyi' => 'zawgyi',
     },
     'mt' => {
-	'Maltese keyboard with US layout' => 'us',
+	'Maltese (with US layout)' => 'us',
+    },
+    'my' => {
+	'Malay (Jawi, phonetic)' => 'phonetic',
     },
     'ng' => {
-	'Hausa' => 'hausa',
+	'Hausa (Nigeria)' => 'hausa',
 	'Igbo' => 'igbo',
 	'Yoruba' => 'yoruba',
     },
     'nl' => {
-	'Macintosh' => 'mac',
-	'Standard' => 'std',
-	'Sun dead keys' => 'sundeadkeys',
+	'Dutch (Macintosh)' => 'mac',
+	'Dutch (standard)' => 'std',
+	'Dutch (with Sun dead keys)' => 'sundeadkeys',
     },
     'no' => {
-	'Dvorak' => 'dvorak',
-	'Eliminate dead keys' => 'nodeadkeys',
-	'Macintosh' => 'mac',
-	'Macintosh, eliminate dead keys' => 'mac_nodeadkeys',
-	'Northern Saami' => 'smi',
-	'Northern Saami, eliminate dead keys' => 'smi_nodeadkeys',
+	'Northern Saami (Norway)' => 'smi',
+	'Northern Saami (Norway, no dead keys)' => 'smi_nodeadkeys',
+	'Norwegian (Colemak)' => 'colemak',
+	'Norwegian (Dvorak)' => 'dvorak',
+	'Norwegian (Macintosh)' => 'mac',
+	'Norwegian (Macintosh, no dead keys)' => 'mac_nodeadkeys',
+	'Norwegian (Win keys)' => 'winkeys',
+	'Norwegian (no dead keys)' => 'nodeadkeys',
     },
     'ph' => {
-	'Capewell-Dvorak (Baybayin)' => 'capewell-dvorak-bay',
-	'Capewell-Dvorak (Latin)' => 'capewell-dvorak',
-	'Capewell-QWERF 2006 (Baybayin)' => 'capewell-qwerf2k6-bay',
-	'Capewell-QWERF 2006 (Latin)' => 'capewell-qwerf2k6',
-	'Colemak (Baybayin)' => 'colemak-bay',
-	'Colemak (Latin)' => 'colemak',
-	'Dvorak (Baybayin)' => 'dvorak-bay',
-	'Dvorak (Latin)' => 'dvorak',
-	'QWERTY (Baybayin)' => 'qwerty-bay',
+	'Filipino (Capewell-Dvorak, Baybayin)' => 'capewell-dvorak-bay',
+	'Filipino (Capewell-Dvorak, Latin)' => 'capewell-dvorak',
+	'Filipino (Capewell-QWERF 2006, Baybayin)' => 'capewell-qwerf2k6-bay',
+	'Filipino (Capewell-QWERF 2006, Latin)' => 'capewell-qwerf2k6',
+	'Filipino (Colemak, Baybayin)' => 'colemak-bay',
+	'Filipino (Colemak, Latin)' => 'colemak',
+	'Filipino (Dvorak, Baybayin)' => 'dvorak-bay',
+	'Filipino (Dvorak, Latin)' => 'dvorak',
+	'Filipino (QWERTY, Baybayin)' => 'qwerty-bay',
     },
     'pk' => {
-	'Arabic' => 'ara',
-	'CRULP' => 'urd-crulp',
-	'NLA' => 'urd-nla',
+	'Arabic (Pakistan)' => 'ara',
 	'Sindhi' => 'snd',
+	'Urdu (Pakistan, CRULP)' => 'urd-crulp',
+	'Urdu (Pakistan, NLA)' => 'urd-nla',
     },
     'pl' => {
-	'Dvorak' => 'dvorak',
-	'Dvorak, Polish quotes on key 1' => 'dvorak_altquotes',
-	'Dvorak, Polish quotes on quotemark key' => 'dvorak_quotes',
 	'Kashubian' => 'csb',
-	'Programmer Dvorak' => 'dvp',
-	'Russian phonetic Dvorak' => 'ru_phonetic_dvorak',
-	'qwertz' => 'qwertz',
+	'Polish (Dvorak)' => 'dvorak',
+	'Polish (Dvorak, with Polish quotes on key 1)' => 'dvorak_altquotes',
+	'Polish (Dvorak, with Polish quotes on quotemark key)' => 'dvorak_quotes',
+	'Polish (QWERTZ)' => 'qwertz',
+	'Polish (legacy)' => 'legacy',
+	'Polish (programmer Dvorak)' => 'dvp',
+	'Russian (Poland, phonetic Dvorak)' => 'ru_phonetic_dvorak',
+	'Silesian' => 'szl',
     },
     'pt' => {
-	'Eliminate dead keys' => 'nodeadkeys',
-	'Macintosh' => 'mac',
-	'Macintosh, Sun dead keys' => 'mac_sundeadkeys',
-	'Macintosh, eliminate dead keys' => 'mac_nodeadkeys',
-	'Nativo' => 'nativo',
-	'Nativo for Esperanto' => 'nativo-epo',
-	'Nativo for USA keyboards' => 'nativo-us',
-	'Sun dead keys' => 'sundeadkeys',
+	'Esperanto (Portugal, Nativo)' => 'nativo-epo',
+	'Portuguese (Macintosh)' => 'mac',
+	'Portuguese (Macintosh, no dead keys)' => 'mac_nodeadkeys',
+	'Portuguese (Macintosh, with Sun dead keys)' => 'mac_sundeadkeys',
+	'Portuguese (Nativo for US keyboards)' => 'nativo-us',
+	'Portuguese (Nativo)' => 'nativo',
+	'Portuguese (no dead keys)' => 'nodeadkeys',
+	'Portuguese (with Sun dead keys)' => 'sundeadkeys',
     },
     'ro' => {
-	'Cedilla' => 'cedilla',
-	'Crimean Tatar (Dobruca-1 Q)' => 'crh_dobruca1',
-	'Crimean Tatar (Dobruca-2 Q)' => 'crh_dobruca2',
-	'Crimean Tatar (Turkish Alt-Q)' => 'crh_alt',
-	'Crimean Tatar (Turkish F)' => 'crh_f',
-	'Standard' => 'std',
-	'Standard (Cedilla)' => 'std_cedilla',
-	'Winkeys' => 'winkeys',
+	'Romanian (Win keys)' => 'winkeys',
+	'Romanian (cedilla)' => 'cedilla',
+	'Romanian (standard cedilla)' => 'std_cedilla',
+	'Romanian (standard)' => 'std',
     },
     'rs' => {
-	'Latin' => 'latin',
-	'Latin Unicode' => 'latinunicode',
-	'Latin Unicode qwerty' => 'latinunicodeyz',
-	'Latin qwerty' => 'latinyz',
-	'Latin with guillemets' => 'latinalternatequotes',
-	'Pannonian Rusyn Homophonic' => 'rue',
-	'With guillemets' => 'alternatequotes',
-	'Z and ZHE swapped' => 'yz',
+	'Pannonian Rusyn' => 'rue',
+	'Serbian (Cyrillic with guillemets)' => 'alternatequotes',
+	'Serbian (Cyrillic, ZE and ZHE swapped)' => 'yz',
+	'Serbian (Latin with guillemets)' => 'latinalternatequotes',
+	'Serbian (Latin)' => 'latin',
+	'Serbian (Latin, QWERTY)' => 'latinyz',
+	'Serbian (Latin, Unicode)' => 'latinunicode',
+	'Serbian (Latin, Unicode, QWERTY)' => 'latinunicodeyz',
     },
     'ru' => {
 	'Bashkirian' => 'bak',
 	'Chuvash' => 'cv',
-	'Chuvash Latin' => 'cv_latin',
-	'DOS' => 'dos',
+	'Chuvash (Latin)' => 'cv_latin',
 	'Kalmyk' => 'xal',
 	'Komi' => 'kom',
-	'Legacy' => 'legacy',
 	'Mari' => 'chm',
-	'Ossetian, Winkeys' => 'os_winkeys',
-	'Ossetian, legacy' => 'os_legacy',
-	'Phonetic' => 'phonetic',
-	'Phonetic Winkeys' => 'phonetic_winkeys',
-	'Serbian' => 'srp',
+	'Ossetian (Win keys)' => 'os_winkeys',
+	'Ossetian (legacy)' => 'os_legacy',
+	'Russian (DOS)' => 'dos',
+	'Russian (Macintosh)' => 'mac',
+	'Russian (legacy)' => 'legacy',
+	'Russian (phonetic yazherty)' => 'phonetic_yazherty',
+	'Russian (phonetic)' => 'phonetic',
+	'Russian (phonetic, AZERTY)' => 'phonetic_azerty',
+	'Russian (phonetic, Dvorak)' => 'phonetic_dvorak',
+	'Russian (phonetic, French)' => 'phonetic_fr',
+	'Russian (phonetic, with Win keys)' => 'phonetic_winkeys',
+	'Russian (typewriter)' => 'typewriter',
+	'Russian (typewriter, legacy)' => 'typewriter-legacy',
+	'Serbian (Russia)' => 'srp',
 	'Tatar' => 'tt',
-	'Typewriter' => 'typewriter',
-	'Typewriter, legacy' => 'typewriter-legacy',
 	'Udmurt' => 'udm',
 	'Yakut' => 'sah',
     },
     'se' => {
-	'Dvorak' => 'dvorak',
-	'Eliminate dead keys' => 'nodeadkeys',
-	'Macintosh' => 'mac',
-	'Northern Saami' => 'smi',
-	'Russian phonetic' => 'rus',
-	'Russian phonetic, eliminate dead keys' => 'rus_nodeadkeys',
-	'Svdvorak' => 'svdvorak',
+	'Northern Saami (Sweden)' => 'smi',
+	'Russian (Sweden, phonetic)' => 'rus',
+	'Russian (Sweden, phonetic, no dead keys)' => 'rus_nodeadkeys',
+	'Swedish (Dvorak)' => 'dvorak',
+	'Swedish (Macintosh)' => 'mac',
+	'Swedish (Svdvorak)' => 'svdvorak',
+	'Swedish (US, with Swedish letters)' => 'us',
+	'Swedish (based on US Intl. Dvorak)' => 'us_dvorak',
+	'Swedish (no dead keys)' => 'nodeadkeys',
+	'Swedish Sign Language' => 'swl',
     },
     'si' => {
-	'US keyboard with Slovenian letters' => 'us',
-	'Use guillemets for quotes' => 'alternatequotes',
+	'Slovenian (US, with Slovenian letters)' => 'us',
+	'Slovenian (with guillemets)' => 'alternatequotes',
     },
     'sk' => {
-	'Extended Backslash' => 'bksl',
-	'qwerty' => 'qwerty',
-	'qwerty, extended Backslash' => 'qwerty_bksl',
+	'Slovak (QWERTY)' => 'qwerty',
+	'Slovak (QWERTY, extended backslash)' => 'qwerty_bksl',
+	'Slovak (extended backslash)' => 'bksl',
     },
     'sy' => {
-	'Kurdish, (F)' => 'ku_f',
-	'Kurdish, Latin Alt-Q' => 'ku_alt',
-	'Kurdish, Latin Q' => 'ku',
+	'Kurdish (Syria, F)' => 'ku_f',
+	'Kurdish (Syria, Latin Alt-Q)' => 'ku_alt',
+	'Kurdish (Syria, Latin Q)' => 'ku',
 	'Syriac' => 'syc',
-	'Syriac phonetic' => 'syc_phonetic',
+	'Syriac (phonetic)' => 'syc_phonetic',
     },
     'th' => {
-	'Pattachote' => 'pat',
-	'TIS-820.2538' => 'tis',
+	'Thai (Pattachote)' => 'pat',
+	'Thai (TIS-820.2538)' => 'tis',
     },
     'tj' => {
-	'Legacy' => 'legacy',
+	'Tajik (legacy)' => 'legacy',
     },
     'tm' => {
-	'Alt-Q' => 'alt',
+	'Turkmen (Alt-Q)' => 'alt',
     },
     'tr' => {
-	'(F)' => 'f',
-	'Alt-Q' => 'alt',
 	'Crimean Tatar (Turkish Alt-Q)' => 'crh_alt',
 	'Crimean Tatar (Turkish F)' => 'crh_f',
 	'Crimean Tatar (Turkish Q)' => 'crh',
-	'International (with dead keys)' => 'intl',
-	'Kurdish, (F)' => 'ku_f',
-	'Kurdish, Latin Alt-Q' => 'ku_alt',
-	'Kurdish, Latin Q' => 'ku',
-	'Sun dead keys' => 'sundeadkeys',
+	'Kurdish (Turkey, F)' => 'ku_f',
+	'Kurdish (Turkey, Latin Alt-Q)' => 'ku_alt',
+	'Kurdish (Turkey, Latin Q)' => 'ku',
+	'Turkish (Alt-Q)' => 'alt',
+	'Turkish (F)' => 'f',
+	'Turkish (intl., with dead keys)' => 'intl',
+	'Turkish (with Sun dead keys)' => 'sundeadkeys',
+    },
+    'tw' => {
+	'Saisiyat (Taiwan)' => 'saisiyat',
+	'Taiwanese (indigenous)' => 'indigenous',
     },
     'ua' => {
-	'Crimean Tatar (Turkish Alt-Q)' => 'crh_alt',
-	'Crimean Tatar (Turkish F)' => 'crh_f',
-	'Crimean Tatar (Turkish Q)' => 'crh',
-	'Homophonic' => 'homophonic',
-	'Legacy' => 'legacy',
-	'Phonetic' => 'phonetic',
-	'Standard RSTU' => 'rstu',
-	'Standard RSTU on Russian layout' => 'rstu_ru',
-	'Typewriter' => 'typewriter',
-	'Winkeys' => 'winkeys',
+	'Russian (Ukraine, standard RSTU)' => 'rstu_ru',
+	'Ukrainian (Win keys)' => 'winkeys',
+	'Ukrainian (homophonic)' => 'homophonic',
+	'Ukrainian (legacy)' => 'legacy',
+	'Ukrainian (phonetic)' => 'phonetic',
+	'Ukrainian (standard RSTU)' => 'rstu',
+	'Ukrainian (typewriter)' => 'typewriter',
     },
     'us' => {
-	'Alternative international' => 'alt-intl',
 	'Cherokee' => 'chr',
-	'Classic Dvorak' => 'dvorak-classic',
-	'Colemak' => 'colemak',
-	'Dvorak' => 'dvorak',
-	'Dvorak alternative international (no dead keys)' => 'dvorak-alt-intl',
-	'Dvorak international (with dead keys)' => 'dvorak-intl',
-	'International (AltGr dead keys)' => 'altgr-intl',
-	'International (with dead keys)' => 'intl',
-	'Layout toggle on multiply/divide key' => 'olpc2',
-	'Left handed Dvorak' => 'dvorak-l',
-	'Macintosh' => 'mac',
-	'Programmer Dvorak' => 'dvp',
-	'Right handed Dvorak' => 'dvorak-r',
-	'Russian phonetic' => 'rus',
-	'Serbo-Croatian' => 'hbs',
-	'With EuroSign on 5' => 'euro',
+	'English (Colemak)' => 'colemak',
+	'English (Dvorak)' => 'dvorak',
+	'English (Dvorak, alt. intl.)' => 'dvorak-alt-intl',
+	'English (Dvorak, intl., with dead keys)' => 'dvorak-intl',
+	'English (Dvorak, left-handed)' => 'dvorak-l',
+	'English (Dvorak, right-handed)' => 'dvorak-r',
+	'English (Macintosh)' => 'mac',
+	'English (US, alt. intl.)' => 'alt-intl',
+	'English (US, euro on 5)' => 'euro',
+	'English (US, intl., with dead keys)' => 'intl',
+	'English (Workman)' => 'workman',
+	'English (Workman, intl., with dead keys)' => 'workman-intl',
+	'English (classic Dvorak)' => 'dvorak-classic',
+	'English (intl., with AltGr dead keys)' => 'altgr-intl',
+	'English (programmer Dvorak)' => 'dvp',
+	'English (the divide/multiply keys toggle the layout)' => 'olpc2',
+	'Russian (US, phonetic)' => 'rus',
+	'Serbo-Croatian (US)' => 'hbs',
     },
     'uz' => {
-	'Crimean Tatar (Turkish Alt-Q)' => 'crh_alt',
-	'Crimean Tatar (Turkish F)' => 'crh_f',
-	'Crimean Tatar (Turkish Q)' => 'crh',
-	'Latin' => 'latin',
+	'Uzbek (Latin)' => 'latin',
+    },
+    'vn' => {
+	'Vietnamese (French, with Vietnamese letters)' => 'fr',
+	'Vietnamese (US, with Vietnamese letters)' => 'us',
     },
 );
 
diff -pruN 1.195/Keyboard/keymaptree 1.195ubuntu1/Keyboard/keymaptree
--- 1.195/Keyboard/keymaptree	1970-01-01 00:00:00.000000000 +0000
+++ 1.195ubuntu1/Keyboard/keymaptree	2019-11-27 14:34:42.000000000 +0000
@@ -0,0 +1,126 @@
+#!/bin/sh
+set -e
+
+#     keymaptree -- build decision trees covering every keymap we can think of
+#     Copyright (C) 2006, 2007 Canonical Ltd.; written by Colin Watson.
+
+#     This program is free software; you can redistribute it and/or modify
+#     it under the terms of the GNU General Public License as published by
+#     the Free Software Foundation; either version 2 of the License, or
+#     (at your option) any later version.
+
+#     This program is distributed in the hope that it will be useful,
+#     but WITHOUT ANY WARRANTY; without even the implied warranty of
+#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#     GNU General Public License for more details.
+
+#     If you have not received a copy of the GNU General Public License
+#     along with this program, write to the Free Software Foundation, Inc.,
+#     59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+# Default values:
+output=''
+models=''
+useonly="$(< keymaptree.use grep -v '^#' | xargs | sed 's/ /,/g')"
+skip=''
+names='KeyboardNames.pl'
+
+while [ "$1" ]; do
+    case "$1" in
+	-output)
+	    shift
+	    output="$1"
+	    ;;
+	-useonly)
+	    shift
+	    useonly="$1"
+	    ;;
+	-skip)
+	    shift
+	    skip="$1"
+	    ;;
+	-names)
+	    shift
+	    names="$1"
+	    ;;
+	-\?|-help|--help)
+	    cat >&2 <<EOF
+Usage: keymaptree [options] <model> [...]
+Legal options are:
+-?,-help,--help     Print this message
+-output             Write decision tree to file (default: stdout)
+-useonly            Include only these keymaps in the decision tree
+                    (comma-separated)
+-skip               Exclude these keymaps from the decision tree
+                    (comma-separated)
+-names              Use this file instead of KeyboardNames.pl
+EOF
+	    exit 0
+	    ;;
+	-*)
+	    echo "keymaptree: Unrecognised option $1" >&2
+	    exit 1
+	    ;;
+	*)
+	    models="${models:+$models }$1"
+	    ;;
+    esac
+    shift
+done
+
+if [ -z "$models" ]; then
+    echo "keymaptree: Need at least one model" >&2
+    exit 1
+fi
+
+for model in $models; do
+    case $model in
+	amiga|ataritt|macintosh_old|pc105|sun4|sun5)
+	    ;;
+	*)
+	    echo "keymaptree: Unrecognised model $model" >&2
+	    exit 1
+	    ;;
+    esac
+done
+
+variantpairs="$(./kbdnames-maker "$names" | grep '^C\*' | grep 'variant\*' | \
+    sort -t '*' | cut -d'*' --output-delimiter=: -f3,4 | sed 's/:$//' | \
+    egrep -v '^(nec|nec_vndr)/jp')"
+
+rm -rf tree-keymaps
+gkincludeopts=''
+gkfiles=''
+
+for model in $models; do
+    mkdir -p "tree-keymaps/$model"
+    for variantpair in $variantpairs; do
+	case $variantpair in
+	    *:*)
+		layout="${variantpair%%:*}"
+		variant="${variantpair#*:}"
+		;;
+	    *)
+		layout="$variantpair"
+		variant=''
+		;;
+	esac
+	./ckbcomp-mini -I. -model "$model" -layout "$layout" ${variant:+-variant "$variant"} | \
+	    perl -ne '
+		if (/^keycode ([0-9]+)/) {
+		    $keycodes{$1} = $_;
+		} else {
+		    for $code (sort { $a <=> $b } keys %keycodes) {
+			print $keycodes{$code};
+		    }
+		    %keycodes = ();
+		    print;
+		}' \
+	    > "tree-keymaps/$model/$layout${variant:+:$variant}"
+    done
+    gkincludeopts="${gkincludeopts:+$gkincludeopts }-I tree-keymaps/$model"
+    echo "$variantpairs" > "tree-keymaps/$model.list"
+    gkfiles="${gkfiles:+$gkfiles }tree-keymaps/$model.list"
+done
+gen_keymap ${output:+-o $output} -v $gkincludeopts \
+    ${useonly:+-u $useonly} ${skip:+-s $skip} $gkfiles
diff -pruN 1.195/Keyboard/keymaptree.use 1.195ubuntu1/Keyboard/keymaptree.use
--- 1.195/Keyboard/keymaptree.use	1970-01-01 00:00:00.000000000 +0000
+++ 1.195ubuntu1/Keyboard/keymaptree.use	2019-11-27 14:34:42.000000000 +0000
@@ -0,0 +1,48 @@
+# This list was generated by taking the list of i386 and powerpc keymaps
+# offered by console-keymaps-tree from console-data and converting them to X
+# keymap layouts and variants. Feel free to add more keymaps to this list,
+# as long as gen_keymap (called from keymaptree) still thinks they're
+# distinguishable.
+
+be
+bg
+br
+by
+ca
+ch
+cs
+cz
+de:nodeadkeys
+dk
+ee
+es
+fi
+fr
+fr:latin9
+fr:oss
+gb
+gr
+hr
+hu
+il
+is
+it
+latam
+lt
+lv
+mk
+no
+pl
+pt
+ro
+ro:std
+ru
+se
+sk:qwerty
+th:tis
+tr
+tr:f
+ua
+us
+us:dvorak
+us:intl
diff -pruN 1.195/Keyboard/Makefile 1.195ubuntu1/Keyboard/Makefile
--- 1.195/Keyboard/Makefile	2018-10-18 15:01:40.000000000 +0000
+++ 1.195ubuntu1/Keyboard/Makefile	2020-03-27 14:41:08.000000000 +0000
@@ -12,7 +12,11 @@ gzipped-ekmaps := $./amiga.ekmap.gz $./a
 
 gzipped-ekbds := $./pc105.ekbd.gz
 
-xkbdir ?= $(kbddir)/ckb
+xkbdir ?= /usr/share/X11/xkb
+
+%.tree : %.ekmap.gz $./keymaptree.use
+	(cd $(kbddir) && set -x && \
+		./keymaptree -output $@ -useonly "$$(cat $./Keyboard/keymaptree.use | grep -v '^#' | xargs | sed 's/ /,/g')" -names ./KeyboardNames.pl $(notdir $(@:%.tree=%)))
 
 $./%.ekmap : model = $(notdir $(@:%.ekmap=%))
 $./%.ekmap :
@@ -61,7 +65,7 @@ $(dkey_files) : $(kbddir)/dkey_sequences
 build-common .PHONY : compose-files dkey-files
 compose-files : $(compose_files)
 dkey-files : $(dkey_files)
-build-mini-linux : gzipped-ekmaps $./charmap_functions.sh
+build-mini-linux : gzipped-ekmaps $./charmap_functions.sh $./pc105.tree
 .PHONY : gzipped-ekmaps
 gzipped-ekmaps : $(gzipped-ekmaps)
 build-mini-freebsd : gzipped-ekbds $./charmap_functions.sh
@@ -77,10 +81,11 @@ kbdcleanfiles := $(wildcard $./*~ $./*.e
 clean .PHONY : $~clean
 $~clean:
 	-rm -rf $(kbdcleanfiles)
+	-rm -f *.tree
 
 maintainer-clean .PHONY : $~maintainer-clean
 $~maintainer-clean: $~clean
-	cd $(kbddir) && ./xmlreader >KeyboardNames.pl
+	cd $(kbddir) && ./xmlreader $(xkbdir)/rules/xorg.xml >KeyboardNames.pl
 
-$./KeyboardNames.pl:
+KeyboardNames.pl $./KeyboardNames.pl:
 	$(kbddir)/xmlreader $(xkbdir)/rules/xorg.xml >$@
diff -pruN 1.195/Keyboard/pc105.tree 1.195ubuntu1/Keyboard/pc105.tree
--- 1.195/Keyboard/pc105.tree	1970-01-01 00:00:00.000000000 +0000
+++ 1.195ubuntu1/Keyboard/pc105.tree	2019-11-27 14:34:42.000000000 +0000
@@ -0,0 +1,448 @@
+STEP 0
+PRESS )
+PRESS у
+PRESS υ
+PRESS г
+PRESS n
+PRESS γ
+PRESS u
+PRESS ה
+PRESS v
+PRESS y
+PRESS ν
+CODE 10 1
+CODE 11 39
+CODE 12 76
+CODE 17 44
+CODE 18 63
+CODE 20 40
+CODE 21 83
+CODE 22 104
+CODE 23 2
+CODE 27 108
+CODE 30 2
+CODE 33 40
+CODE 34 41
+CODE 35 44
+CODE 38 40
+CODE 39 2
+CODE 41 44
+CODE 43 91
+CODE 44 106
+CODE 45 68
+CODE 46 2
+CODE 47 104
+CODE 49 104
+CODE 52 40
+STEP 1
+PRESS b
+PRESS ß
+PRESS y
+PRESS v
+PRESS u
+PRESS ה
+PRESS n
+CODE 39 2
+CODE 40 3
+CODE 44 6
+CODE 12 9
+CODE 46 2
+CODE 47 11
+CODE 48 11
+CODE 49 11
+CODE 51 2
+CODE 21 12
+CODE 22 11
+CODE 23 2
+CODE 30 2
+CODE 31 34
+STEP 3
+FINDP ö
+YES 5
+NO 4
+STEP 11
+PRESS z
+CODE 44 12
+CODE 21 6
+STEP 12
+FINDP ö
+YES 26
+NO 13
+STEP 13
+FINDP ç
+YES 21
+NO 14
+STEP 14
+FINDP æ
+YES 18
+NO 15
+STEP 15
+FINDP ñ
+YES 17
+NO 16
+STEP 6
+FINDP ö
+YES 7
+NO 4
+STEP 34
+PRESS z
+CODE 44 35
+CODE 21 8
+STEP 35
+FINDP ö
+YES 38
+NO 36
+STEP 36
+FINDP ç
+YES 21
+NO 37
+STEP 37
+PRESS æ
+CODE 40 19
+CODE 30 17
+CODE 39 20
+STEP 38
+PRESS ö
+CODE 12 28
+CODE 39 31
+STEP 39
+PRESS r
+PRESS у
+PRESS υ
+PRESS г
+PRESS n
+PRESS γ
+PRESS u
+PRESS ה
+PRESS v
+PRESS y
+PRESS ν
+CODE 33 40
+CODE 34 41
+CODE 35 44
+CODE 38 40
+CODE 17 44
+CODE 47 45
+CODE 49 45
+CODE 18 63
+CODE 19 45
+CODE 20 40
+CODE 21 45
+CODE 22 45
+CODE 24 40
+CODE 52 40
+STEP 45
+FINDP ș
+YES 75
+NO 46
+STEP 46
+FINDP é
+YES 74
+NO 47
+STEP 47
+FINDP ç
+YES 73
+NO 48
+STEP 48
+FINDP š
+YES 72
+NO 49
+STEP 83
+PRESS ω
+PRESS w
+CODE 16 84
+CODE 17 94
+CODE 44 76
+CODE 30 80
+CODE 47 42
+STEP 84
+PRESS q
+CODE 16 85
+CODE 30 81
+STEP 41
+FINDP ч
+YES 43
+NO 42
+STEP 2
+MAP tr:f
+STEP 104
+PRESS ω
+PRESS w
+CODE 16 105
+CODE 17 109
+CODE 44 76
+CODE 30 80
+CODE 47 42
+STEP 105
+PRESS z
+CODE 17 81
+CODE 44 85
+CODE 21 106
+STEP 85
+FINDP ö
+YES 92
+NO 86
+STEP 86
+FINDP ç
+YES 21
+NO 87
+STEP 87
+FINDP å
+YES 18
+NO 88
+STEP 88
+FINDP ä
+YES 91
+NO 89
+STEP 89
+FINDP ñ
+YES 17
+NO 90
+STEP 90
+PRESS @
+CODE 16 71
+CODE 40 71
+CODE 3 62
+STEP 21
+PRESS ç
+CODE 43 22
+CODE 39 23
+STEP 23
+FINDP è
+YES 25
+NO 24
+STEP 92
+PRESS ö
+CODE 51 27
+CODE 12 28
+CODE 39 93
+STEP 93
+FINDP ü
+YES 30
+NO 32
+STEP 109
+PRESS z
+PRESS ζ
+CODE 44 94
+CODE 21 106
+STEP 94
+FINDP ö
+YES 26
+NO 95
+STEP 95
+FINDP é
+YES 103
+NO 96
+STEP 96
+FINDP ç
+YES 101
+NO 97
+STEP 97
+FINDP æ
+YES 18
+NO 98
+STEP 98
+FINDP ș
+YES 75
+NO 99
+STEP 99
+FINDP š
+YES 72
+NO 100
+STEP 100
+FINDP ñ
+YES 17
+NO 49
+STEP 49
+FINDP £
+YES 71
+NO 50
+STEP 50
+FINDP ¨
+YES 70
+NO 51
+STEP 51
+FINDP ѝ
+YES 44
+NO 52
+STEP 52
+FINDP ș
+YES 69
+NO 53
+STEP 53
+FINDP ψ
+YES 42
+NO 54
+STEP 54
+FINDP ב
+YES 16
+NO 55
+STEP 55
+FINDP љ
+YES 43
+NO 56
+STEP 56
+FINDP ภ
+YES 68
+NO 57
+STEP 57
+FINDP ч
+YES 63
+NO 58
+STEP 58
+FINDP ə
+YES 62
+NO 59
+STEP 59
+FINDP š
+YES 61
+NO 60
+STEP 60
+MAP us
+STEP 61
+MAP lv
+STEP 62
+MAP pl
+STEP 63
+FINDP ы
+YES 65
+NO 64
+STEP 64
+MAP ua
+STEP 65
+FINDP и
+YES 67
+NO 66
+STEP 66
+MAP by
+STEP 67
+MAP ru
+STEP 68
+MAP th:tis
+STEP 43
+MAP mk
+STEP 16
+MAP il
+STEP 69
+MAP ro
+STEP 44
+MAP bg
+STEP 70
+MAP us:intl
+STEP 71
+MAP gb
+STEP 17
+MAP latam
+STEP 72
+MAP lt
+STEP 75
+MAP ro:std
+STEP 18
+PRESS æ
+CODE 40 19
+CODE 39 20
+STEP 19
+MAP no
+STEP 20
+MAP dk
+STEP 101
+PRESS º
+CODE 40 24
+CODE 41 22
+CODE 50 102
+CODE 43 73
+CODE 86 73
+STEP 102
+PRESS ç
+CODE 43 22
+CODE 39 24
+STEP 22
+MAP es
+STEP 24
+MAP pt
+STEP 73
+MAP br
+STEP 103
+PRESS é
+CODE 26 25
+CODE 11 91
+CODE 53 74
+STEP 25
+MAP it
+STEP 91
+MAP sk:qwerty
+STEP 74
+MAP ca
+STEP 26
+PRESS ö
+CODE 51 27
+CODE 12 28
+CODE 39 29
+STEP 27
+MAP tr
+STEP 28
+MAP is
+STEP 29
+FINDP å
+YES 31
+NO 30
+STEP 30
+MAP ee
+STEP 31
+FINDP ə
+YES 33
+NO 32
+STEP 32
+MAP se
+STEP 33
+MAP fi
+STEP 106
+FINDP ö
+YES 7
+NO 107
+STEP 107
+PRESS š
+CODE 26 4
+CODE 4 108
+STEP 4
+MAP hr
+STEP 108
+MAP cz
+STEP 7
+PRESS ö
+CODE 11 5
+CODE 39 8
+STEP 5
+MAP hu
+STEP 8
+FINDP é
+YES 10
+NO 9
+STEP 9
+MAP de:nodeadkeys
+STEP 10
+MAP ch
+STEP 76
+FINDP œ
+YES 82
+NO 77
+STEP 77
+FINDP º
+YES 79
+NO 78
+STEP 78
+MAP fr:oss
+STEP 79
+FINDP œ
+YES 81
+NO 80
+STEP 81
+MAP be
+STEP 82
+MAP fr:latin9
+STEP 80
+MAP fr
+STEP 42
+MAP gr
+STEP 40
+MAP us:dvorak
diff -pruN 1.195/Keyboard/xmlreader 1.195ubuntu1/Keyboard/xmlreader
--- 1.195/Keyboard/xmlreader	2018-10-18 15:01:40.000000000 +0000
+++ 1.195ubuntu1/Keyboard/xmlreader	2020-03-27 14:41:08.000000000 +0000
@@ -199,6 +199,15 @@ sub parse_layout {
 	my $arg = shift @{$tree};
 	if ($tag eq 'configItem') {
 	    ($name, $description) = parse_configItem $arg;
+            if ($name eq 'ch') {
+                # "German (Switzerland)" is an unhelpful layout description,
+                # as this layout includes variants such as "French
+                # (Switzerland)".  Override the description to something
+                # more generic.  Be careful to ensure that a translation for
+                # this string is available somewhere; if not in iso_3166,
+                # then amend Keyboard/kbdnames-maker appropriately.
+                $description = 'Switzerland';
+            }
 	    if ($name ne "") {
 		$layouts{$description} = $name;
 	    }
@@ -278,6 +287,9 @@ if (not exists $modelvalues{sun4}) {
 if (not exists $modelvalues{sun5}) {
     $models{'Sun Type 5'} = 'sun5';
 }
+if (not exists $modelvalues{SKIP}) {
+    $models{'Do not configure keyboard; keep kernel keymap'} = 'SKIP';
+}
 
 print <<'EOT';
 #!/usr/bin/perl -w
diff -pruN 1.195/setupcon 1.195ubuntu1/setupcon
--- 1.195/setupcon	2018-10-18 15:01:40.000000000 +0000
+++ 1.195ubuntu1/setupcon	2020-03-27 14:41:07.000000000 +0000
@@ -60,11 +60,8 @@ trap 'rm -f $tempfiles >/dev/null 2>&1'
 trap "exit 2" 1 2 3 13 15
 tempfile () {
     if \
-        TMPFILE=`mktemp /tmp/tmpkbd.XXXXXX 2>/dev/null` \
-            || TMPFILE=`mktemp /run/tmpkbd.XXXXXX 2>/dev/null` \
-            || TMPFILE=`mktemp /dev/.tmpkbd.XXXXXX 2>/dev/null` \
-            || TMPFILE=`mktemp /lib/init/rw/tmpkbd.XXXXXX 2>/dev/null` \
-            || TMPFILE=`mktemp 2>/dev/null`
+        TMPFILE=`mktemp /run/tmpkbd.XXXXXX 2>/dev/null` \
+            || TMPFILE=`mktemp /tmp/tmpkbd.XXXXXX 2>/dev/null`
     then
         tempfiles="$tempfiles $TMPFILE"
         return 0
@@ -675,12 +672,19 @@ esac
 CONSOLE_MAP=${CONSOLE_MAP:-$ACM}
 [ -z "$CONSOLE_MAP" ] || CONSOLE_MAP=`findfile $mapdir "$CONSOLE_MAP"`
 [ -n "$CONSOLE_MAP" -o "$CHARMAP" = UTF-8 ] || CONSOLE_MAP=`findfile $mapdir $stdmap`
+[ -n "$CONSOLE_MAP" -o "$CHARMAP" = UTF-8 ] || CONSOLE_MAP=`findfile $mapdir ${stdmap%.gz}`
 
 # FONTFILES
 FONTFILES=''
 if [ "$FONT" ]; then
     for f in $FONT; do
         FONTFILES="$FONTFILES `findfile $fontdir $f`"
+        RES=`findfile $fontdir $f`
+        if [ -z "$RES" ]; then
+            fdec="${f%.gz}"
+            RES=`findfile $fontdir $fdec`
+        fi
+        FONTFILES="$FONTFILES $RES"
     done
 fi
 FONTFILES=`echo $FONTFILES` # remove extra spaces
@@ -735,6 +739,11 @@ then
 fi
 [ -n "$XKBMODEL" -o -z "$savekbdfile" ] || exit 1
 
+# Backwards-compatibility with Ubuntu-specific preseeding
+if [ "$XKBMODEL" = SKIP ]; then
+    XKBMODEL=
+fi
+
 # do_kbd
 [ "$XKBMODEL$KMAP" ] || do_kbd=''
 if [ "$do_kbd" ]; then
@@ -859,6 +868,31 @@ for i in /etc/console-setup $CONSOLE_MAP
     fi
 done
 
+if [ -n "$do_save" ]; then
+    case "$CONSOLE_MAP" in
+        /etc/console-setup/*) ;;
+        ?*)
+            console_map_dec="${CONSOLE_MAP%.gz}"
+            if [ "$console_map_dec" = "$CONSOLE_MAP" ]; then
+                cp "$CONSOLE_MAP" /etc/console-setup/
+            else
+                gunzip -c "$CONSOLE_MAP" >"/etc/console-setup/${console_map_dec##*/}"
+            fi
+            rm -f "/etc/console-setup/${console_map_dec##*/}.gz"
+            ;;
+    esac
+    for font in $FONTFILES; do
+        case "$font" in
+            /etc/console-setup/*) ;;
+            ?*) cp "$font" /etc/console-setup/ ;;
+        esac
+    done
+    case "$FONTMAPFILE" in
+        /etc/console-setup/*) ;;
+        ?*) cp "$FONTMAPFILE" /etc/console-setup/ ;;
+    esac
+fi
+
 if [ "$savekbdfile" ]; then
     case "$kernel" in
         linux)
@@ -1263,3 +1297,5 @@ if [ "$setupdir" ]; then
     echo exit 0 >>"$setupdir"/bin/setupcon
     sort $TMPFILE | uniq | grep -v 'printf$' >"$setupdir"/morefiles
 fi
+
+exit 0
